'Goodies (11/18/2001 8:34:48 am)'.!


View subclass: #DisplayView
	instanceVariableNames: 'scrollAmount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Display'!

!DisplayView methodsFor: 'controller access'!
defaultControllerClass
	^DisplayController! !


!DisplayView methodsFor: 'displaying'!
displayView
	self model
		displayOn: Display
		at: self insetDisplayBox origin - self scrollAmount
		clippingBox: self insetDisplayBox! !


!DisplayView methodsFor: 'scrolling'!
scrollAmount
	scrollAmount isNil ifTrue: [scrollAmount := 0 @ 0].
	^scrollAmount! !

!DisplayView methodsFor: 'scrolling'!
scrollAmount: aPoint
	scrollAmount := aPoint.
	scrollAmount := scrollAmount max: self scrollingRectangle origin.
	scrollAmount := scrollAmount min: self scrollingRectangle corner! !

!DisplayView methodsFor: 'scrolling'!
scrollTo: aPoint
	self scrollAmount = aPoint
		ifFalse:
			[self scrollAmount: aPoint.
			self display]! !


!DisplayView methodsFor: 'updating'!
update: aParameter 
	self clearInside.
	self display! !


!DisplayView methodsFor: 'private'!
boundingRectangle
	^0 @ 0 extent: self model boundingBox extent! !

!DisplayView methodsFor: 'private'!
scrollingRectangle
	| width height |
	self boundingRectangle width > self viewingRectangle width
		ifTrue: [width := self boundingRectangle width - self viewingRectangle width]
		ifFalse: [width := 0].
	self boundingRectangle height > self viewingRectangle height
		ifTrue: [height := self boundingRectangle height - self viewingRectangle height]
		ifFalse: [height := 0].
	^0 @ 0 extent: width @ height! !

!DisplayView methodsFor: 'private'!
viewingRectangle
	^self scrollAmount extent: self insetDisplayBox extent! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DisplayView class
	instanceVariableNames: ''!

!DisplayView class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved.'! !

!DisplayView class methodsFor: 'copyright'!
system
	^'Goodies'! !

!DisplayView class methodsFor: 'copyright'!
version
	^'002'! !


!DisplayView class methodsFor: 'instance creation'!
model: displayModel
	| displayView |
	displayView := self new.
	displayView model: displayModel.
	displayView borderWidth: 1.
	^displayView! !
