'Goodies (11/18/2001 8:34:49 am)'.!


Model subclass: #PluggableYAListModel
	instanceVariableNames: 'selectionMenu list selection listIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pluggable-Support'!
!PluggableYAListModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
PluggableYAListModel (Pluggable-StringHolderMVC)
Goodies for Squeak 2.0
!


!PluggableYAListModel methodsFor: 'accessing' stamp: 'nishis 4/30/98 22:46'!
list
	^list! !

!PluggableYAListModel methodsFor: 'accessing' stamp: 'nishis 4/30/98 22:48'!
list: aColection
	list := aColection.
	listIndex := 0.
	self changed: #list! !

!PluggableYAListModel methodsFor: 'accessing' stamp: 'nishis 4/30/98 22:48'!
listIndex
	^listIndex! !

!PluggableYAListModel methodsFor: 'accessing' stamp: 'nishis 4/30/98 22:48'!
selection
	^ listIndex = 0 
		ifFalse: [list at: listIndex]
		ifTrue: [nil]! !

!PluggableYAListModel methodsFor: 'accessing' stamp: 'nishis 5/3/98 09:06'!
selection: aSelection
	| index |
	(index _ list indexOf: aSelection) = 0 
		ifFalse: [listIndex == index 
					ifFalse: [self toggleListIndex: index]
		ifTrue: [self changed: #listIndex]].! !


!PluggableYAListModel methodsFor: 'example' stamp: 'nishis 5/3/98 08:19'!
example
	"PluggableYAListModel example"

	| model listView1 topView listView2 |
	model _ self new initialize.
	listView1 _
		PluggableYAListView on: model
			list: #musicTypes
			selected: #musicType
			changeSelected: #musicType:
			menu: #musicTypeMenu
			keystroke: #musicTypeKeystroke:.

	listView2 _
		PluggableYAListView on: model
			list: #artists
			selected: #artist
			changeSelected: #artist:
			menu: nil
			keystroke: #artistKeystroke:.

	topView _ StandardSystemView new
		label: 'Pluggable Test';
		minimumSize: 300@200;
		borderWidth: 1;
		addSubView: listView1;
		addSubView: listView2 toRightOf: listView1.
	topView controller open.! !


!PluggableYAListModel methodsFor: 'pluggable messages' stamp: 'nishis 5/3/98 08:57'!
menu
	| collection |
	selectionMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'update' -> #update.
			collection add: 'update:' -> #update:.
			collection add: 'update:with:' -> #update:with:.
			collection add: 'update:with:with:' -> #update:with:with:.
			selectionMenu := self makeSelectionMenu: collection].
	^selectionMenu! !


!PluggableYAListModel methodsFor: 'private' stamp: 'nishis 5/3/98 08:23'!
makeSelectionMenu: aCollection
	| labels lines selectors |
	aCollection isEmpty ifTrue: [^nil].
	labels := OrderedCollection new.
	lines := OrderedCollection new.
	selectors := OrderedCollection new.
	aCollection do: [:association |
		association isNil
			ifTrue: [lines add: labels size]
			ifFalse:
				[labels add: association key.
				selectors add: association value]].
	^SelectionMenu 
		labelList: labels asArray
		lines: lines asArray
		selections: selectors asArray! !

!PluggableYAListModel methodsFor: 'private' stamp: 'nishis 5/3/98 08:29'!
musicBands
	^#('Hatfield and the North' 'National Health' 'Soft Machine' 'Gong').
! !


!PluggableYAListModel methodsFor: 'list' stamp: 'nishis 5/3/98 08:25'!
changed: what
	super changed: what! !

!PluggableYAListModel methodsFor: 'list' stamp: 'nishis 5/3/98 08:25'!
toggleListIndex: aNumber
	"What to do when the user chooses an item"
	listIndex == aNumber ifTrue: [listIndex _ 0]
		ifFalse: [listIndex _ aNumber].
	self changed: #listIndex! !


!PluggableYAListModel methodsFor: 'initialize-release' stamp: 'nishis 5/3/98 08:26'!
initialize
	list := nil.
	selection := nil.
	listIndex := 0! !


!PluggableYAListModel methodsFor: 'menu messages' stamp: 'nishis 5/3/98 09:11'!
update
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString! !

!PluggableYAListModel methodsFor: 'menu messages' stamp: 'nishis 5/3/98 09:11'!
update: selectedString
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString! !

!PluggableYAListModel methodsFor: 'menu messages' stamp: 'nishis 5/3/98 09:12'!
update: selectedString with: wholeString
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString.
	Transcript cr; tab; show: '2nd argument is ' , wholeString printString! !

!PluggableYAListModel methodsFor: 'menu messages' stamp: 'nishis 5/3/98 09:12'!
update: selectedString with: wholeString with: aController
	Transcript cr; show: thisContext printString.
	Transcript cr; tab; show: 'selection is ' , self selection printString.
	Transcript cr; tab; show: '1st argument is ' , selectedString printString.
	Transcript cr; tab; show: '2nd argument is ' , wholeString printString.
	Transcript cr; tab; show: '3rd argument is ' , aController printString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PluggableYAListModel class
	instanceVariableNames: ''!

!PluggableYAListModel class methodsFor: 'instance creation' stamp: 'nishis 4/30/98 23:26'!
new
	^super new initialize! !


!PluggableYAListModel class methodsFor: 'example' stamp: 'nishis 5/3/98 09:00'!
example
	"PluggableYAListModel example."

	| model listView topView |
	model := self new initialize.
	model list: model musicBands.
	listView :=
		PluggableYAListView on: model
			list: #musicBands
			selected: #selection
			changeSelected: #selection:
			menu: #menu.
	topView := StandardSystemView new
		label: 'PluggableYAListModel Test';
		minimumSize: 200@200;
		borderWidth: 1;
		addSubView: listView.
	topView controller open.! !


!PluggableYAListModel class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:42'!
save
	"PluggableYAListModel save."

	| fileName classCollection aStream timeStamp |
	fileName := self saveFilename.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!PluggableYAListModel class methodsFor: 'saving' stamp: 'nishis 5/3/98 11:29'!
saveAllClasses
	"PluggableYAListModel saveAllClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !

!PluggableYAListModel class methodsFor: 'saving' stamp: 'nishis 5/3/98 11:26'!
saveClasses
	"PluggableYAListModel saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Pluggable*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !

!PluggableYAListModel class methodsFor: 'saving' stamp: 'nishis 5/3/98 12:27'!
saveFilename
	^'Plugable.st'! !
