'Goodies (11/18/2001 8:34:52 am)'.!


MouseMenuController subclass: #DisplayController
	instanceVariableNames: 'verticalScrollBar verticalMarker verticalSavedArea horizontalScrollBar horizontalMarker horizontalSavedArea '
	classVariableNames: 'HorizontalDownCursor HorizontalJumpCursor HorizontalUpCursor MenuCursor VerticalDownCursor VerticalJumpCursor VerticalUpCursor '
	poolDictionaries: ''
	category: 'Goodies-Display'!

!DisplayController methodsFor: 'basic control sequence'!
controlInitialize
	super controlInitialize.
	verticalScrollBar := self newVerticalScrollBar.
	verticalMarker := self newVerticalMarker.
	verticalSavedArea isNil ifTrue: [verticalSavedArea := Form fromDisplay: verticalScrollBar].
	self displayVerticalScrollBar.
	self displayVerticalMarker.
	horizontalScrollBar := self newHorizontalScrollBar.
	horizontalMarker := self newHorizontalMarker.
	horizontalSavedArea isNil ifTrue: [horizontalSavedArea := Form fromDisplay: horizontalScrollBar].
	self displayHorizontalScrollBar.
	self displayHorizontalMarker
! !

!DisplayController methodsFor: 'basic control sequence'!
controlTerminate
	super controlTerminate.
	verticalSavedArea notNil ifTrue: [verticalSavedArea displayOn: Display at: verticalScrollBar topLeft].
	verticalScrollBar := nil.
	verticalMarker := nil.
	verticalSavedArea := nil.
	horizontalSavedArea notNil ifTrue: [horizontalSavedArea displayOn: Display at: horizontalScrollBar topLeft].
	horizontalScrollBar := nil.
	horizontalMarker := nil.
	horizontalSavedArea := nil! !


!DisplayController methodsFor: 'control defaults'!
controlActivity
	self verticalScrollBarContainsCursor ifTrue: [^self verticalScroll].
	self horizontalScrollBarContainsCursor ifTrue: [^self horizontalScroll].
	super controlActivity! !

!DisplayController methodsFor: 'control defaults'!
isControlActive 
	| aRectangle |
	view isNil ifTrue: [^false].
	aRectangle := view insetDisplayBox merge: verticalScrollBar inside.
	(aRectangle containsPoint: sensor cursorPoint) ifTrue: [^true].
	aRectangle := view insetDisplayBox merge: horizontalScrollBar inside.
	(aRectangle containsPoint: sensor cursorPoint) ifTrue: [^true].
	^false! !

!DisplayController methodsFor: 'control defaults'!
isControlWanted
	^self viewHasCursor! !


!DisplayController methodsFor: 'scrolling'!
anyButtonActivity
	self yellowButtonActivity! !

!DisplayController methodsFor: 'scrolling'!
horizontalScroll
	| savedCursor |
	savedCursor := sensor currentCursor.
	[self horizontalScrollBarContainsCursor]
		whileTrue: 
			[Processor yield.
			sensor cursorPoint y >= self horizontalDownLine
				ifTrue: [self horizontalScrollDown]
				ifFalse: [sensor cursorPoint y >= self horizontalUpLine
					ifTrue: [self horizontalScrollJump]
					ifFalse: [sensor cursorPoint y >= self horizontalYellowLine
						ifTrue: [self horizontalScrollUp]
						ifFalse: [sensor cursorPoint y >= horizontalScrollBar top
							ifTrue:
								[self changeCursor: self class menuCursor.
								sensor anyButtonPressed 
									ifTrue:
										[self changeCursor: savedCursor. 
										self anyButtonActivity]]]]]].
	savedCursor show! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollAmount
	| amount |
	amount := horizontalMarker left - horizontalScrollBar inside left.
	amount := amount / horizontalScrollBar inside width.
	amount := amount * view boundingRectangle width.
	amount := amount rounded.
	^amount! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollDelta
	| delta |
	delta := sensor cursorPoint x - horizontalScrollBar inside left.
	delta := delta / horizontalScrollBar inside width.
	delta := delta * view boundingRectangle width.
	delta := delta rounded.
	^delta! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollDown
	| firstTime |
	self changeCursor: self class horizontalDownCursor.
	firstTime := true.
	[sensor anyButtonPressed]
		whileTrue:
			[self horizontalScrollViewDown.
	  		self displayHorizontalMarker.
			firstTime
				ifTrue:
					[(Delay forMilliseconds: 250) wait.
					firstTime := false]
				ifFalse: [(Delay forMilliseconds: 50) wait]]! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollJump
	| markerOutline oldX markerForm |
	self changeCursor: self class horizontalJumpCursor.
	oldX := -1.
	sensor anyButtonPressed
		ifTrue: 
			[markerOutline := horizontalMarker deepCopy.
			markerForm := Form fromDisplay: horizontalMarker.
			Display fill: horizontalMarker fillColor: horizontalScrollBar insideColor.
			Display border: markerOutline width: 1 fillColor: Color gray.
			markerForm 
				follow: 
					[oldX ~= sensor cursorPoint x
						ifTrue: 
							[oldX := sensor cursorPoint x.
							horizontalMarker := horizontalMarker translateBy: 
					  			((oldX - horizontalMarker center x 
								min: horizontalScrollBar inside right - horizontalMarker right) 
								max: horizontalScrollBar inside left - horizontalMarker left) @ 0.
							self horizontalScrollViewJump].
					horizontalMarker origin] 
				while: [sensor anyButtonPressed].
			Display fill: markerOutline fillColor: horizontalScrollBar insideColor.
			self displayHorizontalMarker]! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollUp
	| firstTime |
	self changeCursor: self class horizontalUpCursor.
	firstTime := true.
	[sensor anyButtonPressed]
		whileTrue:
			[self horizontalScrollViewUp.
	  		self displayHorizontalMarker.
			firstTime
				ifTrue:
					[(Delay forMilliseconds: 250) wait.
					firstTime := false]
				ifFalse: [(Delay forMilliseconds: 50) wait]]! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollViewDown
	self scrollViewBy: self horizontalScrollDelta negated @ 0! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollViewJump
	self scrollViewTo: self horizontalScrollAmount @ 0! !

!DisplayController methodsFor: 'scrolling'!
horizontalScrollViewUp
	self scrollViewBy: self horizontalScrollDelta @ 0! !

!DisplayController methodsFor: 'scrolling'!
scrollViewBy: deltaPoint
	self scrollViewTo: view scrollAmount + deltaPoint! !

!DisplayController methodsFor: 'scrolling'!
scrollViewTo: aPoint
	| scrollAmount |
	scrollAmount := aPoint.
	scrollAmount := scrollAmount max: view scrollingRectangle origin.
	scrollAmount := scrollAmount min: view scrollingRectangle corner.	
	view scrollTo: scrollAmount! !

!DisplayController methodsFor: 'scrolling'!
verticalScroll
	| savedCursor |
	savedCursor := sensor currentCursor.
	[self verticalScrollBarContainsCursor]
		whileTrue: 
			[Processor yield.
			sensor cursorPoint x <= self verticalDownLine
				ifTrue: [self verticalScrollDown]
				ifFalse: [sensor cursorPoint x <= self verticalUpLine
					ifTrue: [self verticalScrollJump]
					ifFalse: [sensor cursorPoint x <= self verticalYellowLine
						ifTrue: [self verticalScrollUp]
						ifFalse: [sensor cursorPoint x <= verticalScrollBar right
							ifTrue:
								[self changeCursor: self class menuCursor.
								sensor anyButtonPressed 
									ifTrue:
										[self changeCursor: savedCursor. 
										self anyButtonActivity]]]]]].
	savedCursor show! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollAmount
	| amount |
	amount := verticalMarker top - verticalScrollBar inside top.
	amount := amount / verticalScrollBar inside height.
	amount := amount * view boundingRectangle height.
	amount := amount rounded.
	^amount! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollDelta
	| delta |
	delta := sensor cursorPoint y - verticalScrollBar inside top.
	delta := delta / verticalScrollBar inside height.
	delta := delta * view boundingRectangle height.
	delta := delta rounded.
	^delta! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollDown
	| firstTime |
	self changeCursor: self class verticalDownCursor.
	firstTime := true.
	[sensor anyButtonPressed]
		whileTrue:
			[self verticalScrollViewDown.
	  		self displayVerticalMarker.
			firstTime
				ifTrue:
					[(Delay forMilliseconds: 250) wait.
					firstTime := false]
				ifFalse: [(Delay forMilliseconds: 50) wait]]! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollJump
	| markerOutline oldY markerForm |
	self changeCursor: self class verticalJumpCursor.
	oldY := -1.
	sensor anyButtonPressed
		ifTrue: 
			[markerOutline := verticalMarker deepCopy.
			markerForm := Form fromDisplay: verticalMarker.
			Display fill: verticalMarker fillColor: verticalScrollBar insideColor.
			Display border: markerOutline width: 1 fillColor: Color gray.
			markerForm 
				follow: 
					[oldY ~= sensor cursorPoint y
						ifTrue: 
							[oldY := sensor cursorPoint y.
							verticalMarker := verticalMarker translateBy: 
					  			0 @ ((oldY - verticalMarker center y 
								min: verticalScrollBar inside bottom - verticalMarker bottom) 
								max: verticalScrollBar inside top - verticalMarker top).
							self verticalScrollViewJump].
					verticalMarker origin] 
				while: [sensor anyButtonPressed].
			Display fill: markerOutline fillColor: verticalScrollBar insideColor.
			self displayVerticalMarker]! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollUp
	| firstTime |
	self changeCursor: self class verticalUpCursor.
	firstTime := true.
	[sensor anyButtonPressed]
		whileTrue:
			[self verticalScrollViewUp.
	  		self displayVerticalMarker.
			firstTime
				ifTrue:
					[(Delay forMilliseconds: 250) wait.
					firstTime := false]
				ifFalse: [(Delay forMilliseconds: 50) wait]]! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollViewDown
	self scrollViewBy: 0 @ self verticalScrollDelta negated! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollViewJump
	self scrollViewTo: 0 @ self verticalScrollAmount! !

!DisplayController methodsFor: 'scrolling'!
verticalScrollViewUp
	self scrollViewBy: 0 @ self verticalScrollDelta! !


!DisplayController methodsFor: 'cursor'!
changeCursor: aCursor 
	sensor currentCursor ~~ aCursor ifTrue: [aCursor show]! !

!DisplayController methodsFor: 'cursor'!
horizontalDownLine
	^horizontalScrollBar bottom - 6! !

!DisplayController methodsFor: 'cursor'!
horizontalScrollBarContainsCursor
	^horizontalScrollBar containsPoint: sensor cursorPoint! !

!DisplayController methodsFor: 'cursor'!
horizontalUpDownLine
	^horizontalScrollBar bottom - 12! !

!DisplayController methodsFor: 'cursor'!
horizontalUpLine
	^horizontalScrollBar bottom - 12! !

!DisplayController methodsFor: 'cursor'!
horizontalYellowLine
	^horizontalScrollBar bottom - 18! !

!DisplayController methodsFor: 'cursor'!
verticalDownLine
	^verticalScrollBar left + 6! !

!DisplayController methodsFor: 'cursor'!
verticalScrollBarContainsCursor
	^verticalScrollBar containsPoint: sensor cursorPoint! !

!DisplayController methodsFor: 'cursor'!
verticalUpDownLine
	^verticalScrollBar left + 12! !

!DisplayController methodsFor: 'cursor'!
verticalUpLine
	^verticalScrollBar left + 12! !

!DisplayController methodsFor: 'cursor'!
verticalYellowLine
	^verticalScrollBar left + 18! !


!DisplayController methodsFor: 'scroll bar'!
displayHorizontalScrollBar
	horizontalScrollBar displayOn: Display! !

!DisplayController methodsFor: 'scroll bar'!
displayVerticalScrollBar
	verticalScrollBar displayOn: Display! !

!DisplayController methodsFor: 'scroll bar'!
newHorizontalScrollBar
	| newHorizontalScrollBar |
	newHorizontalScrollBar := Quadrangle new.
	newHorizontalScrollBar borderWidthLeft: 2 right: 2 top: 0 bottom: 2.
	newHorizontalScrollBar region: (0 @ 0 extent: view apparentDisplayBox width @ 24).
	newHorizontalScrollBar insideColor: view backgroundColor.
	newHorizontalScrollBar := newHorizontalScrollBar
		align: newHorizontalScrollBar topLeft
		with: view apparentDisplayBox bottomLeft.
	^newHorizontalScrollBar! !

!DisplayController methodsFor: 'scroll bar'!
newVerticalScrollBar
	| newVerticalScrollBar |
	newVerticalScrollBar := Quadrangle new.
	newVerticalScrollBar borderWidthLeft: 2 right: 0 top: 2 bottom: 2.
	newVerticalScrollBar region: (0 @ 0 extent: 24 @ view apparentDisplayBox height).
	newVerticalScrollBar insideColor: view backgroundColor.
	newVerticalScrollBar := newVerticalScrollBar
		align: newVerticalScrollBar topRight
		with: view apparentDisplayBox topLeft.
	^newVerticalScrollBar! !


!DisplayController methodsFor: 'scroll marker'!
computeHorizontalMarkerRegion
	| width height |
	width := view viewingRectangle width / view boundingRectangle width.
	width := width * horizontalScrollBar inside width.
	width := width rounded min: horizontalScrollBar inside width.
	height := Preferences scrollBarWidth.
	^0 @ 0 extent: width @ height! !

!DisplayController methodsFor: 'scroll marker'!
computeVerticalMarkerRegion
	| width height |
	width := Preferences scrollBarWidth.
	height := view viewingRectangle height / view boundingRectangle height.
	height := height * verticalScrollBar inside height.
	height := height rounded min: verticalScrollBar inside height.
	^0 @ 0 extent: width @ height! !

!DisplayController methodsFor: 'scroll marker'!
displayHorizontalMarker
	| delta |
	Display fill: horizontalMarker fillColor: horizontalScrollBar insideColor.
	delta := view viewingRectangle left - view boundingRectangle left.
	delta := delta / view boundingRectangle width.
	delta := delta * horizontalScrollBar inside width.
	delta := delta rounded.
	horizontalMarker := self newHorizontalMarker translateBy: delta @ 0.
	horizontalMarker displayOn: Display! !

!DisplayController methodsFor: 'scroll marker'!
displayVerticalMarker
	| delta |
	Display fill: verticalMarker fillColor: verticalScrollBar insideColor.
	delta := view viewingRectangle top - view boundingRectangle top.
	delta := delta / view boundingRectangle height.
	delta := delta * verticalScrollBar inside height.
	delta := delta rounded.
	verticalMarker := self newVerticalMarker translateBy: 0 @ delta.
	verticalMarker displayOn: Display! !

!DisplayController methodsFor: 'scroll marker'!
newHorizontalMarker
	| newHorizontalMarker |
	newHorizontalMarker := Quadrangle new.
	newHorizontalMarker insideColor: Preferences scrollBarColor.
	newHorizontalMarker region: self computeHorizontalMarkerRegion.
	newHorizontalMarker := newHorizontalMarker
		align: newHorizontalMarker leftCenter
		with: (horizontalScrollBar left + 2) @ self horizontalUpDownLine.
	^newHorizontalMarker! !

!DisplayController methodsFor: 'scroll marker'!
newVerticalMarker
	| newVerticalMarker |
	newVerticalMarker := Quadrangle new.
	newVerticalMarker insideColor: Preferences scrollBarColor.
	newVerticalMarker region: self computeVerticalMarkerRegion.
	newVerticalMarker := newVerticalMarker
		align: newVerticalMarker topCenter
		with: self verticalUpDownLine @ (verticalScrollBar top + 2).
	^newVerticalMarker! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DisplayController class
	instanceVariableNames: ''!

!DisplayController class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved.'! !

!DisplayController class methodsFor: 'copyright'!
system
	^'Goodies'! !

!DisplayController class methodsFor: 'copyright'!
version
	^'002'! !


!DisplayController class methodsFor: 'class initialization'!
flushCursors
	"DisplayController flushCursors."

	VerticalDownCursor := nil.
	VerticalUpCursor := nil.
	VerticalJumpCursor := nil.
	HorizontalDownCursor := nil.
	HorizontalUpCursor := nil.
	HorizontalJumpCursor := nil.
	MenuCursor := nil.
! !


!DisplayController class methodsFor: 'cursors'!
horizontalDownCursor
	"DisplayController horizontalDownCursor."

	HorizontalDownCursor notNil ifTrue: [^HorizontalDownCursor].
	HorizontalDownCursor := self verticalDownCursor deepCopy rotateBy: #left centerAt: 0 @ 0.
	HorizontalDownCursor offset: 0 @ -15.
	^HorizontalDownCursor
! !

!DisplayController class methodsFor: 'cursors'!
horizontalJumpCursor
	"DisplayController horizontalJumpCursor."

	HorizontalJumpCursor notNil ifTrue: [^HorizontalJumpCursor].
	HorizontalJumpCursor := self verticalJumpCursor deepCopy rotateBy: #left centerAt: 0 @ 0.
	HorizontalJumpCursor offset: -2 @ -15.
	^HorizontalJumpCursor
! !

!DisplayController class methodsFor: 'cursors'!
horizontalUpCursor
	"DisplayController horizontalUpCursor."

	HorizontalUpCursor notNil ifTrue: [^HorizontalUpCursor].
	HorizontalUpCursor := self verticalUpCursor deepCopy rotateBy: #left centerAt: 0 @ 0.
	HorizontalUpCursor offset: 0 @ -15.
	^HorizontalUpCursor
! !

!DisplayController class methodsFor: 'cursors'!
menuCursor
	"DisplayController menuCursor."

	MenuCursor notNil ifTrue: [^MenuCursor].
	MenuCursor := Cursor
		extent: 16@16
		fromArray: #(
			2r1111111111100000
			2r1000000000100000
			2r1010011000100000
			2r1000000000100000
			2r1011001010100000
			2r1000000000100000
			2r1010110010100000
			2r1000000000100000
			2r1010010100100000
			2r1000000000100000
			2r1111111111100000
			2r1101001101100000
			2r1111111111100000
			2r1000000000100000
			2r1010101100100000
			2r1111111111100000)
		offset: 0 @ -7.
	^MenuCursor! !

!DisplayController class methodsFor: 'cursors'!
verticalDownCursor
	"DisplayController verticalDownCursor."

	VerticalDownCursor notNil ifTrue: [^VerticalDownCursor].
	VerticalDownCursor := Cursor
		extent: 16@16
		fromArray: #(
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r1111110000000000
			2r0111100000000000
			2r0011000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000)
		offset: 0 @ 0.
	^VerticalDownCursor! !

!DisplayController class methodsFor: 'cursors'!
verticalJumpCursor
	"DisplayController verticalJumpCursor."

	VerticalJumpCursor notNil ifTrue: [^VerticalJumpCursor].
	VerticalJumpCursor := Cursor
		extent: 16@16
		fromArray: #(
			2r0000100000000000
			2r0000111000000000
			2r1111111110000000
			2r0000111000000000
			2r0000100000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000)
		offset: 0 @ -2.
	^VerticalJumpCursor! !

!DisplayController class methodsFor: 'cursors'!
verticalUpCursor
	"DisplayController verticalUpCursor."

	VerticalUpCursor notNil ifTrue: [^VerticalUpCursor].
	VerticalUpCursor := Cursor
		extent: 16@16
		fromArray: #(
			2r0011000000000000
			2r0111100000000000
			2r1111110000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0011000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000
			2r0000000000000000)
		offset: 0 @ 0.
	^VerticalUpCursor! !
