'Goodies (11/18/2001 8:34:53 am)'.!


Object variableSubclass: #LispTable
	instanceVariableNames: 'properties '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Lisp'!

!LispTable methodsFor: 'initialize-release'!
initialize
	properties := Dictionary new! !


!LispTable methodsFor: 'accessing'!
at: symbol 
	^self getprop: symbol key: #apval! !

!LispTable methodsFor: 'accessing'!
at: symbol put: value 
	self intern: symbol.
	^self
		putprop: symbol
		key: #apval
		value: value! !

!LispTable methodsFor: 'accessing'!
identifiers
	^properties keys asSortedCollection! !


!LispTable methodsFor: 'adding'!
add: symbol 
	self intern: symbol! !


!LispTable methodsFor: 'removing'!
remove: symbol
	^properties removeKey: symbol ifAbsent: [^nil]! !


!LispTable methodsFor: 'property access'!
getprop: identifier key: key 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property at: key ifAbsent: [^nil]! !

!LispTable methodsFor: 'property access'!
putprop: identifier key: key value: value 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property at: key put: value! !

!LispTable methodsFor: 'property access'!
remprop: identifier key: key 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property removeKey: key ifAbsent: [^nil]! !


!LispTable methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:01'!
error: labelString with: contentsString
	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !


!LispTable methodsFor: 'private' stamp: 'nishis 4/25/98 04:09'!
errorSymbolNotFound
	self error: 'symbol not found' with: 'symbol not found'! !

!LispTable methodsFor: 'private'!
intern: symbol 
	(properties includesKey: symbol)
		ifFalse: [properties at: symbol put: Dictionary new].
	^symbol! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispTable class
	instanceVariableNames: ''!

!LispTable class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispTable class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispTable class methodsFor: 'copyright'!
version
	^'003'! !


!LispTable class methodsFor: 'instance creation'!
new
	^super new initialize! !
