'Goodies (11/18/2001 8:34:53 am)'.!


Model subclass: #ClockModel
	instanceVariableNames: 'clockProcess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Clocks'!
!ClockModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Analog Clock and Digital Clock
Goodies for Squeak 1.31, Squeak 2.0

This goodies is a modification for Squeak from Mr. AOKI's 
example in  
"Smalltalk Software Development"
	#9 "Smalltalk Programming Manners 2"
Copyright (C) 1991-1996

http://www.sra.co.jp/people/aoki/SuperAsciiJ/SAscii09.html
http://www.sra.co.jp/people/aoki/SuperAsciiJ/List0901.txt
http://www.sra.co.jp/people/aoki/SuperAsciiJ/List0902.txt
http://www.sra.co.jp/people/aoki/SuperAsciiJ/List0903.txt
http://www.sra.co.jp/people/aoki/SuperAsciiJ/List0904.txt
http://www.sra.co.jp/people/aoki/SuperAsciiJ/List0905.txt

##########################################################

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!ClockModel methodsFor: 'initialize-release' stamp: 'nishis 5/21/98 01:37'!
initialize
	| currentValue nextValue |
	clockProcess notNil ifTrue: [clockProcess terminate].
	clockProcess := [
			[currentValue := Time millisecondClockValue.
			nextValue := self nextMillisecondClockValue.
			(Delay forMilliseconds: nextValue - currentValue) wait.
			true]
				whileTrue: 
					[self changed: self currentTime]] newProcess.
	clockProcess priority: Processor userInterruptPriority.
	clockProcess resume! !

!ClockModel methodsFor: 'initialize-release'!
release
	clockProcess notNil ifTrue: [clockProcess terminate].
	clockProcess := nil! !


!ClockModel methodsFor: 'accessing'!
currentDate
	^Date today! !

!ClockModel methodsFor: 'accessing'!
currentDateString
	| today stream |
	today := self currentDate.
	stream := WriteStream on: (String new: 20).
	stream nextPutAll: ' '.
	stream nextPutAll: today dayOfMonth printString.
	stream nextPutAll: ' '.
	stream nextPutAll: (today monthName copyFrom: 1 to: 3).
	stream nextPutAll: ' '.
	stream nextPutAll: today year printString.
	stream nextPutAll: ' ('.
	stream nextPutAll: (today weekday copyFrom: 1 to: 3).
	stream nextPutAll: ')'.
	stream nextPutAll: ' '.
	^stream contents! !

!ClockModel methodsFor: 'accessing'!
currentTime
	^Time now! !

!ClockModel methodsFor: 'accessing'!
currentTimeString
	| now stream |
	now := self currentTime.
	stream := WriteStream on: (String new: 20).
	stream nextPutAll: ' '.
	stream nextPutAll: now printString.
	stream nextPutAll: ' '.
	^stream contents! !


!ClockModel methodsFor: 'updating' stamp: 'nishis 5/21/98 02:20'!
update: aSymbol 
	"this is for further use."
	(aSymbol = #prologue or: [aSymbol = #login])
		ifTrue: [self initialize].
	(aSymbol = #epilogue or: [aSymbol = #logout])
		ifTrue: [self release]! !


!ClockModel methodsFor: 'private'!
nextMillisecondClockValue
	^Time millisecondClockValue + 1000 truncateTo: 1000! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClockModel class
	instanceVariableNames: 'soleClock '!

!ClockModel class methodsFor: 'class initialization'!
flushClock
	"ClockModel flushClock."

	soleClock notNil
		ifTrue: 
			[soleClock release.
			soleClock := nil]! !


!ClockModel class methodsFor: 'instance creation'!
new
	soleClock isNil ifTrue: [soleClock := super new initialize].
	^soleClock! !


!ClockModel class methodsFor: 'saving' stamp: 'nishis 5/19/98 14:34'!
save
	"ClockModel save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Clocks.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!ClockModel class methodsFor: 'saving' stamp: 'nishis 5/19/98 14:30'!
saveClasses
	"ClockModel saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Clock*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	classCollection add: ScheduledView.
	classCollection add: ScheduledController.
	^classCollection! !


!ClockModel class methodsFor: 'examples'!
example1
	"ClockModel example1."

	ClockDigitalView openOn: ClockModel new! !

!ClockModel class methodsFor: 'examples'!
example2
	"ClockModel example2."

	ClockAnalogView openOn: ClockModel new! !
