'Goodies (11/18/2001 8:34:53 am)'.!


Object subclass: #Progress
	instanceVariableNames: 'progressValue progressMessage stopCondition progressBarFrame messageFrame savedArea hasStopButton stopButtonFrame watchingProcess accessProtect '
	classVariableNames: 'ProgressScale QuartersCursor '
	poolDictionaries: ''
	category: 'Goodies-Progress'!
!Progress commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Progress
Goodies for Squeak

Broken English description

Progress
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (C) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Progress.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Progress.txt


Summary:

So called "Progress Bar" goodies.  If you want to show 
the condition of progressing, simply you put it in a 
BlockContext and ask to show it.  Progress receives 
messages or normalized values from a BlockContext 
and show it on a gauge.


Installing:

FileIn this goodies and makes a class "Progress" in a 
category "Goodies-Progress". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"Progress" from your system, simply.


how to use:

Make an instance of Progress and send it a message "do:" to it.
Argument of this message is a BlockContext that you want to 
show progressing.  An instance of Progress can understand 
"message:" and "value:", you can tell him the condition of 
progressing as a normalized value or message.

Progress new 
	do: [:progress | 
		(0 to: 1 by: 0.01) do: [:n | 
			progress message: n printString. 
			progress value: n]].

If you want to add a stop button, you can do below, 

Progress new 
	doWithStopButton: [:progress | 
		(0 to: 1 by: 0.01) do: [:n | 
			progress message: n printString. 
			progress value: n.
			progress stopButtonPressed ifTrue: [progress close]]].


##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Progress.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Progress.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!Progress methodsFor: 'initialize-release' stamp: 'nishis 1/4/1999 08:53'!
initialize
	accessProtect := false.
	self value: 0.
	self message: Character space asString! !


!Progress methodsFor: 'accessing' stamp: 'nishis 12/16/1998 03:32'!
message
	^progressMessage! !

!Progress methodsFor: 'accessing' stamp: 'nishis 12/18/1998 15:12'!
message: aString 
	| oldString |
	oldString := progressMessage.
	progressMessage := aString.
	oldString ~= progressMessage 
		ifTrue: 
			[self displayMessage]! !

!Progress methodsFor: 'accessing'!
value
	^progressValue! !

!Progress methodsFor: 'accessing' stamp: 'nishis 12/18/1998 15:12'!
value: normalizedNumber 
	| oldValue |
	(0 <= normalizedNumber and: [normalizedNumber <= 1])
		ifTrue: 
			[oldValue := progressValue.
			progressValue := normalizedNumber.
			oldValue ~= progressValue 
				ifTrue: 
					[self displayValue]]! !


!Progress methodsFor: 'testing' stamp: 'nishis 12/16/1998 17:53'!
hasStopButton
	^hasStopButton! !

!Progress methodsFor: 'testing' stamp: 'nishis 12/18/1998 21:07'!
isDragging
	| box |
	box := self messageFrame origin extent: savedArea extent.
	^(box containsPoint: Sensor cursorPoint) and: [Sensor anyButtonPressed].
! !

!Progress methodsFor: 'testing' stamp: 'nishis 12/16/1998 17:53'!
isOpen
	^self progressBarFrame notNil and: [self messageFrame notNil]! !

!Progress methodsFor: 'testing' stamp: 'nishis 12/16/1998 18:06'!
stopButtonPressed
	| box bool point |
	stopCondition = true ifTrue: [^true].
	box := self stopButtonFrame.
	box isNil ifTrue: [^false].
	self isOpen ifFalse: [^false].
	bool := false.
	point := Sensor cursorPoint.
	[(box containsPoint: point) and: [Sensor anyButtonPressed]]
		whileTrue: 
			[bool ifFalse: [self displayStopButton: true].
			bool := true.
			point := Sensor cursorPoint].
	point := Sensor cursorPoint.
	bool ifTrue: [self displayStopButton: false].
	(bool and: [box containsPoint: point])
		ifTrue: 
			[stopCondition := true.
			^true].
	^false! !


!Progress methodsFor: 'moving' stamp: 'nishis 1/4/1999 10:13'!
move	
	| box point offset bool delta |
	savedArea isNil ifTrue: [^false].
	self stopButtonPressed ifTrue: [^false].
	accessProtect ifTrue: [^false].
	box := self messageFrame origin extent: (self progressBarFrame merge: self messageFrame) extent.
	box isNil ifTrue: [^false].
	point := Sensor cursorPoint.
	bool := (box containsPoint: point) and: [Sensor anyButtonPressed].
	[(box containsPoint: point) and: [Sensor anyButtonPressed]]
		whileTrue: 
			[self quartersCursor 
				showWhile: 
					[offset := box origin - point.
					box := self newRectFrom: box trackingBlock: [:ignored | Sensor cursorPoint + offset extent: savedArea extent].
					point := Sensor cursorPoint]].
	bool ifFalse: [^false].
	savedArea displayOn: Display at: self messageFrame origin.
	delta := box origin - self messageFrame origin.
	self progressBarFrame: (self progressBarFrame translateBy: delta).
	self messageFrame: (self messageFrame translateBy: delta).
	savedArea := Form fromDisplay: box.
	self displayFrameOutline.
	self displayValue.
	self displayMessage.
	^true! !


!Progress methodsFor: 'enumerating' stamp: 'nishis 12/18/1998 20:41'!
do: aBlock 
	"
	Progress new 
		do: [:progress | 
			(0 to: 1 by: 0.01) do: [:n | 
				progress message: n printString. 
				progress value: n]].
	"

	| result |
	self openWithStopButton: false.
	[self prologue.
	watchingProcess resume.
	Cursor execute 
		showWhile: 
			[aBlock numArgs = 0
				ifTrue: [result := aBlock value]
				ifFalse: [result := aBlock value: self]].
	self epilogue.
	self close] 
		ifError: 
			[:msg :rec | 
			self debug: [Transcript cr; show: msg printString , '>' , rec printString].
			self epilogue.
			self close].
	^result! !

!Progress methodsFor: 'enumerating' stamp: 'nishis 12/18/1998 20:41'!
doWithStopButton: aBlock 
	"
	Progress new 
		doWithStopButton: [:progress | 
			(0 to: 1 by: 0.01) do: [:n | 
				progress message: n printString. 
				progress value: n.
				progress stopButtonPressed ifTrue: [progress close]]].
	"

	| result |
	self openWithStopButton: true.
	[self prologue.
	watchingProcess resume.
	Cursor execute 
		showWhile: 
			[aBlock numArgs = 0
				ifTrue: [result := aBlock value]
				ifFalse: [result := aBlock value: self]].
	self epilogue.
	self close] 
		ifError: 
			[:msg :rec | 
			self debug: [Transcript cr; show: msg printString , '>' , rec printString].
			self epilogue.
			self close].
	^result! !


!Progress methodsFor: 'interface opening' stamp: 'nishis 12/18/1998 20:30'!
createFrames
	| delta captionText textFrame barFrame outerFrame barFrameWidth barFrameHeight |
	barFrameWidth := self hasStopButton 
						ifTrue: [226 + self stopButtonFrameWidth] 
						ifFalse: [226].
	barFrameHeight := 40.
	barFrame := Sensor cursorPoint - ((barFrameWidth @ barFrameHeight) // 2) 
						corner: Sensor cursorPoint + ((barFrameWidth @ barFrameHeight) // 2).
	captionText := self message isNil ifTrue: ['dummy'] ifFalse: [self message].
	captionText := DisplayText text: captionText asText allBold.
	captionText
		foregroundColor: Color black
		backgroundColor: Color white.
	textFrame := (0 @ 0 extent: barFrame extent) 
					withHeight: (captionText boundingBox insetBy: (captionText boundingBox height // -2)) height.
	textFrame := textFrame align: textFrame bottomCenter
					with: barFrame topCenter + (0@2).
	outerFrame := barFrame merge: textFrame.
	delta := outerFrame amountToTranslateWithin: Display boundingBox.
	barFrame := barFrame translateBy: delta.
	textFrame := textFrame translateBy: delta.
	outerFrame := outerFrame translateBy: delta.
	savedArea := Form fromDisplay: outerFrame.
	self progressBarFrame: barFrame.
	self messageFrame: textFrame.

	^outerFrame! !

!Progress methodsFor: 'interface opening' stamp: 'nishis 12/18/1998 18:31'!
openWithStopButton: aBoolean 
	stopCondition := false.
	hasStopButton := aBoolean.
	self createFrames.
	self displayFrameOutline.
	self displayMessage! !


!Progress methodsFor: 'interface closing' stamp: 'nishis 12/21/1998 05:47'!
close
	self isOpen ifFalse: [^nil].
	stopCondition := true.
	savedArea displayOn: Display at: self messageFrame origin.
	self progressBarFrame: nil.
	self messageFrame: nil! !


!Progress methodsFor: 'schedulering' stamp: 'nishis 12/18/1998 18:30'!
epilogue
	(watchingProcess isMemberOf: Process)
		ifTrue: [watchingProcess terminate].
	watchingProcess := nil! !

!Progress methodsFor: 'schedulering' stamp: 'nishis 1/4/1999 09:15'!
prologue
	watchingProcess := 
		[[self isOpen] 
			whileTrue: 
				[(Delay forMilliseconds: 100) wait.
				self move]] newProcess.
	watchingProcess priority: Processor userInterruptPriority! !


!Progress methodsFor: 'debugging' stamp: 'nishis 1/4/1999 09:00'!
debug: aBlock
	"aBlock value"! !


!Progress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:05'!
fakeStopButton: aBoolean
	| aFrame stopButtonFrameWidth spaceLeft |
	aBoolean 
		ifTrue: 
			[stopButtonFrameWidth := self stopButtonFrameWidth.
			self messageFrame: (self messageFrame withWidth: (savedArea width - stopButtonFrameWidth)).
			self progressBarFrame: (self progressBarFrame withWidth: (savedArea width - stopButtonFrameWidth)).
			aFrame := self messageFrame topRight extent: stopButtonFrameWidth @ (savedArea height // 2).
			spaceLeft := self messageFrame topRight extent: stopButtonFrameWidth @ (savedArea height).
			aFrame := aFrame align: aFrame center with: spaceLeft center.
			self stopButtonFrame: aFrame.
			self displayStopButton: false]
		ifFalse: 
			[self stopButtonFrame: nil]! !

!Progress methodsFor: 'private' stamp: 'nishis 5/16/98 15:56'!
messageFrame
	^messageFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 5/16/98 15:57'!
messageFrame: aFrame
	messageFrame := aFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 5/16/98 15:56'!
progressBarFrame
	^progressBarFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 5/16/98 15:57'!
progressBarFrame: aFrame
	progressBarFrame := aFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 12/19/1998 01:24'!
progressScale
	^self class progressScale! !

!Progress methodsFor: 'private' stamp: 'nishis 12/21/1998 06:01'!
quartersCursor
	^self class quartersCursor! !

!Progress methodsFor: 'private' stamp: 'nishis 12/16/1998 17:55'!
stopButtonFrame
	^stopButtonFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 12/14/1998 07:11'!
stopButtonFrame: aFrame
	stopButtonFrame := aFrame! !

!Progress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:15'!
stopButtonFrameWidth
	^self stopButtonLabel width + 32! !

!Progress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:15'!
stopButtonLabel
	^DisplayText text: 'stop' asText allBold! !


!Progress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:36'!
displayFrameOutline
	| aRectengle |
	aRectengle := self messageFrame origin extent: savedArea extent.
	Display fillBlack: aRectengle; fillWhite: (aRectengle insetBy: 2).
	self fakeStopButton: self hasStopButton! !

!Progress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 09:01'!
displayMessage
	| displayText displayRectangle scaleRectangle clippingRectangle |
	self messageFrame isNil ifTrue: [^nil].
	accessProtect := true.
	displayText := DisplayText text: self message asText allBold.
	"do not send message 'boundingBox' directly to displayText."
	displayRectangle := displayText copy boundingBox.
	scaleRectangle := 0 @ 0 extent: 200 + 1 @ displayRectangle height.
	clippingRectangle := self messageFrame insetBy: 4.
	scaleRectangle := scaleRectangle align: scaleRectangle center with: clippingRectangle center.
	displayRectangle := displayRectangle align: displayRectangle bottomLeft with: scaleRectangle bottomLeft.
	Display fillWhite: clippingRectangle.
	displayText foregroundColor: Color black backgroundColor: Color white;
		displayOn: Display at: displayRectangle origin clippingBox: clippingRectangle.
	accessProtect := false! !

!Progress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 08:52'!
displayProgressBar
	| gaugeRectangle pointArray displayRectangle clippingRectangle |
	self progressBarFrame isNil ifTrue: [^nil].
	gaugeRectangle := 0 @ 0 extent: 6 @ 12.
	displayRectangle := 0 @ 0 extent: 200 + 1 @ 10.
	clippingRectangle := (0 @ (self progressBarFrame height // 2 * 0) corner: self progressBarFrame width @ (self progressBarFrame height // 2 * 1)) insetBy: 2.
	clippingRectangle := clippingRectangle align: clippingRectangle bottomCenter with: self progressBarFrame center.
	displayRectangle := displayRectangle align: displayRectangle bottomCenter with: clippingRectangle bottomCenter.
	gaugeRectangle := gaugeRectangle align: gaugeRectangle bottomCenter with: displayRectangle bottomLeft.
	gaugeRectangle := (gaugeRectangle translateBy: self value * 200 @ -1) rounded.
	Display fillWhite: clippingRectangle.
	pointArray := Array new: 5.
	pointArray at: 1 put: gaugeRectangle topCenter.
	pointArray at: 2 put: gaugeRectangle rightCenter.
	pointArray at: 3 put: gaugeRectangle bottomCenter.
	pointArray at: 4 put: gaugeRectangle leftCenter.
	pointArray at: 5 put: gaugeRectangle topCenter.
	self displayPolygonOn: Display points: pointArray at: 0 @ 0! !

!Progress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:31'!
displayScale
	| displayRectangle clippingRectangle |
	displayRectangle := 0 @ 0 extent: self progressScale extent.
	clippingRectangle := (0 @ (self progressBarFrame height // 2 * 1) corner: self progressBarFrame width @ (self progressBarFrame height // 2 * 2)) insetBy: 2.
	clippingRectangle := clippingRectangle align: clippingRectangle topCenter with: self progressBarFrame center.
	displayRectangle := displayRectangle align: displayRectangle topCenter with: clippingRectangle topCenter.
	self progressScale displayOn: Display at: displayRectangle origin! !

!Progress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:45'!
displayStopButton: aBoolean
	| aFrame stopLabel dropFrame backgroundColor stopLabelRectangle |
	aFrame := self stopButtonFrame insetBy: 4.
	dropFrame := aFrame insetBy: 3.
	backgroundColor := Color lightGray.
	Display fillBlack: aFrame; fill: (aFrame insetBy: 2) rule: Form over fillColor: backgroundColor.
	Display fill: dropFrame rule: Form over fillColor: backgroundColor.
	aBoolean 
		ifTrue: 
			[self displayLineOn: Display from: dropFrame bottomLeft to: dropFrame bottomRight color: Color white.
			self displayLineOn: Display from: dropFrame bottomRight to: dropFrame topRight color: Color white.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame bottomLeft color: Color black.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame topRight color: Color black]
		ifFalse: 
			[self displayLineOn: Display from: dropFrame bottomLeft to: dropFrame bottomRight color: Color black.
			self displayLineOn: Display from: dropFrame bottomRight to: dropFrame topRight color: Color black.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame bottomLeft color: Color white.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame topRight color: Color white].
	stopLabel := self stopButtonLabel.
	stopLabelRectangle := 0 @ 0 extent: stopLabel computeBoundingBox extent.
	stopLabelRectangle := stopLabelRectangle align: stopLabelRectangle center with: aFrame center.
	stopLabel
		foregroundColor: Color black backgroundColor: backgroundColor;
		displayOn: Display at: stopLabelRectangle origin! !

!Progress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 08:53'!
displayValue 
	self progressBarFrame isNil ifTrue: [^nil].
	accessProtect := true.
	self displayScale.
	self displayProgressBar.
	accessProtect := false
! !


!Progress methodsFor: 'private transforming' stamp: 'nishis 1/4/1999 10:16'!
newRectFrom: originalRect trackingBlock: newRectBlock 
	"Track the outline of a new rectangle until mouse button changes.
	newFrameBlock produces each new rectangle from the previous"
	"copied and modified from below"
	"Browser fullOnClass: Rectangle selector: #newRectFrom:."

	| rect newRect buttonStart buttonNow mutex delta |
	mutex := Semaphore forMutualExclusion.
	mutex critical: 
		[buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originalRect.
		Display border: rect width: 2 rule: Form reverse fillColor: Color gray.
		[buttonNow == buttonStart] whileTrue: 
			["Give other Processes at the current priority NO chance to run."
			"Processor yield."
			buttonNow := Sensor anyButtonPressed.
			newRect := newRectBlock value: rect.
			"keep new frame within anDisplay boundingBox."
			delta := newRect amountToTranslateWithin: Display boundingBox.
			newRect = rect ifFalse:
				[newRect := newRect translateBy: delta.
				Display border: rect width: 2 rule: Form reverse fillColor: Color gray.
				Display border: newRect width: 2 rule: Form reverse fillColor: Color gray.
				rect := newRect]].
		Display border: rect width: 2 rule: Form reverse fillColor: Color gray].
	^ rect! !


!Progress methodsFor: 'private displaying-generic' stamp: 'nishis 12/19/1998 01:30'!
displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color
	self class displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color! !

!Progress methodsFor: 'private displaying-generic' stamp: 'nishis 12/18/1998 00:23'!
displayPolygonOn: aDisplayMedium points: points at: offsetPoint 
	"not implemented yet."

	| aLinearFit aForm |
	aLinearFit := LinearFit new.
	aForm := Form extent: 1 @ 1.
	aForm fillColor: Color black.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: aDisplayMedium at: offsetPoint clippingBox: aDisplayMedium boundingBox "rule: Form and fillColor: nil"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Progress class
	instanceVariableNames: ''!

!Progress class methodsFor: 'copyright' stamp: 'nishis 12/14/1998 08:25'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!Progress class methodsFor: 'copyright' stamp: 'nishis 12/14/1998 08:25'!
system
	^'Goodies'! !

!Progress class methodsFor: 'copyright' stamp: 'nishis 12/14/1998 08:25'!
version
	^'003'! !


!Progress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
flushCursors
	"Progress flushCursors."

	QuartersCursor := nil! !

!Progress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:08'!
initialize
	"Progress initialize."

	self install! !

!Progress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
install
	"Progress install."

	self progressScale.
	self quartersCursor! !

!Progress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
uninstall
	"Progress uninstall."

	self flushCursors.
	ProgressScale := nil ! !


!Progress class methodsFor: 'instance creation' stamp: 'nishis 12/16/1998 02:32'!
new
	^super new initialize! !


!Progress class methodsFor: 'accessing' stamp: 'nishis 12/19/1998 01:26'!
progressScale
	"Progress progressScale."

	| displayRectangle x p color |
	ProgressScale notNil ifTrue: [^ProgressScale]. 
	ProgressScale := Form extent: 200 + 1 @ 10.
	displayRectangle := 0 @ 0 extent: 200 + 1 @ 10.
	color := Color black.
	x := displayRectangle left.
	0 to: 100 
		do: 
			[:n | 
			n \\ 5 = 0
				ifTrue: [n \\ 10 = 0
						ifTrue: [n \\ 50 = 0
								ifTrue: 
									[p := x @ displayRectangle top.
									self displayLineOn: ProgressScale from: p to: p + (0 @ 10) color: color]
								ifFalse: 
									[p := x @ (displayRectangle top + 2).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 6) color: color]]
						ifFalse: [n \\ 25 = 0
								ifTrue: [p := x @ (displayRectangle top + 4).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 6) color: color]
								ifFalse: 
									[p := x @ (displayRectangle top + 4).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 4) color: color]]]
				ifFalse: 
					[p := x @ (displayRectangle top + 6).
					self displayLineOn: ProgressScale from: p to: p + (0 @ 2) color: color].
			x := x + 2].
	^ProgressScale! !

!Progress class methodsFor: 'accessing' stamp: 'nishis 12/21/1998 06:00'!
quartersCursor
	"Progress quartersCursor."
	"
	Progress quartersCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Progress flushCursors."

	QuartersCursor notNil ifTrue: [^QuartersCursor].
	QuartersCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0010000000000100
2r0111110001111110
2r0010000000000100
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000001110000000
2r0010001110000100
2r0111111011111110
2r1111110001111111
2r0111111011111110
2r0010001110000100
2r0000001110000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
)
				offset: 7 @ 7.
	^QuartersCursor! !


!Progress class methodsFor: 'saving' stamp: 'nishis 12/14/1998 08:22'!
save
	"Progress save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Progress.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!Progress class methodsFor: 'saving' stamp: 'nishis 12/14/1998 08:22'!
saveClasses
	"Progress saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Progress*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := ChangeSet superclassOrder: classCollection.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!Progress class methodsFor: 'private' stamp: 'nishis 12/19/1998 01:13'!
displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color
	| aForm aLine |
	aForm := Form extent: 1 @ 1 depth: Display depth.
	aForm fillColor: color.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: aDisplayMedium! !

!Progress class methodsFor: 'private' stamp: 'nishis 12/17/1998 23:34'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!Progress class methodsFor: 'private' stamp: 'nishis 12/17/1998 23:34'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1! !


!Progress class methodsFor: 'examples' stamp: 'nishis 7/5/1998 07:08'!
example1
	"Progress example1."

	| collection size count value |
	collection := 1 to: 100.
	size := collection size.
	Progress new
		do: 
			[:progress | 
			count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					(Delay forMilliseconds: 100) wait.
					count := count + 1]]! !

!Progress class methodsFor: 'examples' stamp: 'nishis 12/17/1998 17:42'!
example2
	"Progress example2."

	| collection size count value |
	collection := 1 to: 100.
	size := collection size.
	Progress new
		doWithStopButton: 
			[:progress | 
			count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]]! !

!Progress class methodsFor: 'examples' stamp: 'nishis 7/4/1998 18:20'!
example3
	"Progress example3."

	| collection size count value progress block |
	collection := 1 to: 100.
	size := collection size.
	progress := Progress new.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					(Delay forMilliseconds: 100) wait.
					count := count + 1]].
	progress openWithStopButton: false.
	block value.
	progress close! !

!Progress class methodsFor: 'examples' stamp: 'nishis 12/18/1998 14:45'!
example4
	"Progress example4."

	| collection size progress block count value |
	collection := 1 to: 100.
	size := collection size.
	progress := Progress new.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					progress hasStopButton
						ifTrue: [value := 1 - (count / size)]
						ifFalse: [value := count / size].
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]].
	progress do: block.
	progress doWithStopButton: block! !

!Progress class methodsFor: 'examples' stamp: 'nishis 1/4/1999 08:58'!
example5
	"Progress example5."

	| collection size progress count value cursorAnimatorClass cursorAnimator block |
	collection := 1 to: 100.
	size := collection size.
	progress := Progress new.
	progress message: 'computing...'.
	cursorAnimatorClass := Smalltalk at: #CursorAnimator ifAbsent: [^self error: 'need CursorAnimator.'].
	cursorAnimator := cursorAnimatorClass handCursors.
	cursorAnimator tick: 300.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					progress hasStopButton
						ifTrue: [value := 1 - (count / size)]
						ifFalse: [value := count / size].
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]].
	cursorAnimator showWhile: [progress do: block].
	cursorAnimator showWhile: [progress doWithStopButton: block]! !


Progress initialize!
