'Goodies (11/18/2001 8:34:55 am)'.!


Model subclass: #HistogramModel
	instanceVariableNames: 'sample min max rank histogram vertical horizontal color '
	classVariableNames: 'HistogramMenu '
	poolDictionaries: ''
	category: 'Goodies-Histogram'!
!HistogramModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Histogram
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Histogram
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/30
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Histgram.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Histgram.txt


Summary:

You input sample (collection of numerical value) and you can get 
frequency, average, deviation and bar graph (histogram).


How to install:

FileIn this goodies and makes classes below in a category 
"Goodies-Histogram". 

HistogramController
HistogramModel
HistogramView
HistogramFakeDialog

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove these classes 
"HistogramController", "HistogramModel", "HistogramView", 
"HistogramFakeDialog", from your system, simply.


how to use:

sample is between X1 to Xn:

| aCollection aModel |
aCollection := OrderedCollection new.
aCollection add: X1.
             :
             :
aCollection add: Xn.
aModel := HistogramModel sample: aCollection.
aModel open

Evaluate above, you can get a histogram, average, deviation etc.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Histgram.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Histgram.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!HistogramModel methodsFor: 'accessing'!
color
	color isNil ifTrue: [color := Color orange].
	^color! !

!HistogramModel methodsFor: 'accessing'!
color: colorValue 
	color := colorValue.
	self changed: #histogram! !

!HistogramModel methodsFor: 'accessing'!
flush
	histogram := nil! !

!HistogramModel methodsFor: 'accessing'!
horizontal
	^horizontal! !

!HistogramModel methodsFor: 'accessing'!
horizontal: aString
	horizontal := aString.
	self changed: #description! !

!HistogramModel methodsFor: 'accessing'!
max
	| value |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	max isNil
		ifTrue: 
			[value := nil.
			self sample do: [:each | value isNil
					ifTrue: [value := each]
					ifFalse: [value := value max: each]].
			max := value].
	^max! !

!HistogramModel methodsFor: 'accessing'!
max: maxValue 
	max := maxValue.
	self flush.
	self changed: #histogram! !

!HistogramModel methodsFor: 'accessing'!
min
	| value |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	min isNil
		ifTrue: 
			[value := nil.
			self sample do: [:each | value isNil
					ifTrue: [value := each]
					ifFalse: [value := value min: each]].
			min := value].
	^min! !

!HistogramModel methodsFor: 'accessing'!
min: minValue 
	min := minValue.
	self flush.
	self changed: #histogram! !

!HistogramModel methodsFor: 'accessing'!
rank
	rank isNil ifTrue: [rank := 10].
	^rank! !

!HistogramModel methodsFor: 'accessing'!
rank: rankValue 
	rank := rankValue.
	self flush.
	self changed: #histogram! !

!HistogramModel methodsFor: 'accessing'!
sample
	^sample! !

!HistogramModel methodsFor: 'accessing'!
sample: aCollection 
	sample := aCollection.
	self flush.
	self changed: #sample! !

!HistogramModel methodsFor: 'accessing'!
vertical
	^vertical! !

!HistogramModel methodsFor: 'accessing'!
vertical: aString 
	vertical := aString.
	self changed: #description! !


!HistogramModel methodsFor: 'functions'!
average
	| count |
	count := self count.
	count = 0 ifTrue: [^0].
	^self total / count! !

!HistogramModel methodsFor: 'functions'!
count
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	^self sample size! !

!HistogramModel methodsFor: 'functions'!
deviation
	| average count value v |
	average := self average.
	count := self count.
	count = 0 ifTrue: [^0].
	value := 0.
	self sample
		do: 
			[:each | 
			v := each.
			v := v - average.
			v := v * v.
			value := value + v].
	^(value / (count - 1)) sqrt! !

!HistogramModel methodsFor: 'functions'!
histogram
	| maximum section |
	histogram notNil ifTrue: [^histogram].
	(self sample isNil or: [self sample isEmpty])
		ifTrue: 
			[histogram := OrderedCollection new.
			^histogram].
	histogram := OrderedCollection new.
	self sections do: [:each | histogram add: each -> 0].
	maximum := self max.
	self sample do: [:each | each = maximum
			ifTrue: [histogram last value: histogram last value + 1]
			ifFalse: [histogram
					do: 
						[:assoc | 
						section := assoc key.
						(section first <= each and: [each < section last])
							ifTrue: [assoc value: assoc value + 1]]]].
	^histogram! !

!HistogramModel methodsFor: 'functions'!
maximum
	| maximum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	maximum := nil.
	self sample do: [:each | maximum isNil
			ifTrue: [maximum := each]
			ifFalse: [maximum := maximum max: each]].
	^maximum! !

!HistogramModel methodsFor: 'functions'!
minimum
	| minimum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	minimum := nil.
	self sample do: [:each | minimum isNil
			ifTrue: [minimum := each]
			ifFalse: [minimum := minimum min: each]].
	^minimum! !

!HistogramModel methodsFor: 'functions'!
sections
	| collection maximum minimum width start end |
	collection := OrderedCollection new.
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^collection].
	maximum := self max.
	minimum := self min.
	maximum = minimum ifTrue: [^collection].
	width := maximum - minimum / self rank.
	start := minimum.
	end := minimum + width.
	self rank
		timesRepeat: 
			[collection add: (Array with: start with: end).
			start := start + width.
			end := end + width].
	^collection! !

!HistogramModel methodsFor: 'functions'!
total
	| total |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	total := 0.
	self sample do: [:each | total := total + each].
	^total! !


!HistogramModel methodsFor: 'menu messages'!
changeMax
	| answer |
	answer := FillInTheBlank request: 'max of range?' initialAnswer: self max printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self max ifTrue: [^self].
	self max: answer! !

!HistogramModel methodsFor: 'menu messages'!
changeMin
	| answer |
	answer := FillInTheBlank request: 'min of range?' initialAnswer: self min printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self min ifTrue: [^self].
	self min: answer! !

!HistogramModel methodsFor: 'menu messages'!
changeRank
	| answer |
	answer := FillInTheBlank request: 'number of ranks?' initialAnswer: self rank printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self rank ifTrue: [^self].
	self rank: answer! !

!HistogramModel methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 02:15'!
showClasses: interval 
	| first last value collection |
	(self sample respondsTo: #associationsDo:)
		ifFalse: [^self].
	first := interval first.
	last := interval last.
	collection := SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key].
	self sample
		associationsDo: 
			[:assoc | 
			value := assoc value.
			last = self max
				ifTrue: [(first <= value and: [value <= last])
						ifTrue: [collection add: assoc]]
				ifFalse: [(first <= value and: [value < last])
						ifTrue: [collection add: assoc]]].
	collection isEmpty ifTrue: [^self].
	HistogramFakeDialog
				model: self
				choose: 'Which of these classes do you browse?'
				fromList: (collection collect: [:assoc | assoc key asString , ' (' , assoc value printString , ')'])
				values: (collection collect: [:assoc | assoc key])
				lines: 10
				cancel: [nil]! !

!HistogramModel methodsFor: 'menu messages'!
showItem: target 
	"do nothing"

	Transcript cr; show: target printString! !

!HistogramModel methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 02:14'!
showItems: interval 
	| first last value collection target |
	(self sample isKindOf: Dictionary)
		ifFalse: [^self].
	first := interval first.
	last := interval last.
	collection := SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key].
	self sample
		associationsDo: 
			[:assoc | 
			value := assoc value.
			last = self max
				ifTrue: [(first <= value and: [value <= last])
						ifTrue: [collection add: assoc]]
				ifFalse: [(first <= value and: [value < last])
						ifTrue: [collection add: assoc]]].
	collection isEmpty ifTrue: [^self].
	target := HistogramFakeDialog
				model: self
				choose: 'Which of these classes do you browse?'
				fromList: (collection collect: [:assoc | assoc key asString , ' (' , assoc value printString , ')'])
				values: (collection collect: [:assoc | assoc key])
				lines: 10
				cancel: [nil].
	target isNil ifTrue: [^self].
	self showItem: target! !


!HistogramModel methodsFor: 'pluggable messages' stamp: 'nishis 7/19/1998 02:27'!
yellowButtonMenu
	"HistogramModel flushMenus."

	| collection menu |
	HistogramMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'min' -> #changeMin.
			collection add: 'max' -> #changeMax.
			collection add:  'rank' -> #changeRank.
			menu := self makeSelectionMenu: collection.
			HistogramMenu := menu].
	^HistogramMenu! !


!HistogramModel methodsFor: 'interface opening'!
histogramView
	| aView |
	aView := HistogramView new.
	aView model: self.
	^aView! !

!HistogramModel methodsFor: 'interface opening' stamp: 'nishis 5/24/98 07:39'!
open
	"HistogramModel new open"
	| topView view |
	view := self histogramView.
	view  borderWidth: 1.
	topView := StandardSystemView new.
	topView
			model: view model;
			label: 'Histogram';
			borderWidth: 1;
			minimumSize: 300 @ 200;
			backgroundColor: Color white.
	topView addSubView: view.
	topView controller open! !


!HistogramModel methodsFor: 'printing'!
printOn: aStream 
	| collection section count |
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' ('.
	aStream cr.
	aStream nextPutAll: '  histogram:'.
	aStream cr.
	collection := self histogram.
	collection
		do: 
			[:assoc | 
			section := assoc key.
			count := assoc value.
			aStream space; space; space; space.
			aStream nextPutAll: '(over '.
			aStream nextPutAll: section first asFloat printString.
			assoc = collection last
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream nextPutAll: section last asFloat printString.
					aStream nextPutAll: ' and under']
				ifFalse: 
					[aStream nextPutAll: ', '.
					aStream nextPutAll: 'under '.
					aStream nextPutAll: section last asFloat printString].
			aStream nextPutAll: '): '.
			aStream nextPutAll: count printString.
			aStream cr].
	aStream nextPutAll: '  count:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self count printString.
	aStream cr.
	aStream nextPutAll: '  average:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self average asFloat printString.
	aStream cr.
	aStream nextPutAll: '  deviation:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self deviation asFloat printString.
	aStream cr.
	aStream nextPutAll: ')'! !


!HistogramModel methodsFor: 'private' stamp: 'nishis 7/19/1998 02:25'!
makeSelectionMenu: aCollection
	| labels lines selectors |
	aCollection isEmpty ifTrue: [^nil].
	labels := OrderedCollection new.
	lines := OrderedCollection new.
	selectors := OrderedCollection new.
	aCollection do: [:association |
		association isNil
			ifTrue: [lines add: labels size]
			ifFalse:
				[labels add: association key.
				selectors add: association value]].
	^SelectionMenu 
		labelList: labels asArray
		lines: lines asArray
		selections: selectors asArray! !

!HistogramModel methodsFor: 'private'!
sample: aCollection min: minValue max: maxValue rank: rankValue 
	sample := aCollection.
	min := minValue.
	max := maxValue.
	rank := rankValue.
	self flush! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HistogramModel class
	instanceVariableNames: ''!

!HistogramModel class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!HistogramModel class methodsFor: 'copyright'!
system
	^'Goodies'! !

!HistogramModel class methodsFor: 'copyright'!
version
	^'003'! !


!HistogramModel class methodsFor: 'class initialization' stamp: 'nishis 7/19/1998 02:28'!
flushMenus
	"HistogramModel flushMenus."

	HistogramMenu := nil! !


!HistogramModel class methodsFor: 'instance creation'!
sample: aCollection
	^(self new)
		sample: aCollection
		min: nil
		max: nil
		rank: nil; yourself! !

!HistogramModel class methodsFor: 'instance creation'!
sample: aCollection min: minValue max: maxValue rank: rankValue 
	^(self new)
		sample: aCollection
		min: minValue
		max: maxValue
		rank: rankValue; yourself! !

!HistogramModel class methodsFor: 'instance creation'!
sample: aCollection rank: rankValue 
	^(self new)
		sample: aCollection
		min: nil
		max: nil
		rank: rankValue; yourself! !


!HistogramModel class methodsFor: 'saving'!
save
	"HistogramModel save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Histgram.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!HistogramModel class methodsFor: 'saving'!
saveClasses
	"HistogramModel saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Histogram*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!HistogramModel class methodsFor: 'examples'!
example1
	"HistogramModel example1."

	| collection histogram |
	collection := OrderedCollection new.
	collection add: 0.
	collection add: 10.
	collection add: 20.
	collection add: 30.
	collection add: 35.
	collection add: 40.
	collection add: 45.
	collection add: 48.
	collection add: 50.
	collection add: 52.
	collection add: 55.
	collection add: 60.
	collection add: 65.
	collection add: 70.
	collection add: 80.
	collection add: 90.
	collection add: 100.
	histogram := HistogramModel sample: collection.
	Transcript cr; show: histogram printString.
	^histogram! !

!HistogramModel class methodsFor: 'examples'!
example2
	"HistogramModel example2."

	| classes dictionary size histogram |
	classes := Object withAllSubclasses.
	dictionary := Dictionary new.
	classes do: [:each | each isMeta
			ifFalse: 
				[size := each selectors size + each class selectors size.
				dictionary add: each name -> size]].
	histogram := HistogramModel sample: dictionary.
	Transcript cr; show: histogram printString.
	^histogram! !

!HistogramModel class methodsFor: 'examples'!
example3
	"HistogramModel example3."

	^(HistogramModel example1) open; yourself! !

!HistogramModel class methodsFor: 'examples'!
example4
	"HistogramModel example4."

	^(HistogramModel example2) open; yourself! !
