'Goodies (11/18/2001 8:34:56 am)'.!


View subclass: #HistogramView
	instanceVariableNames: 'xScale yScale numericalInfo xLabel yLabel boxCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Histogram'!

!HistogramView methodsFor: 'area accessing' stamp: 'nishis 5/23/98 01:59'!
boxCollection
	| size histogram min max area width point count height box |
	boxCollection isNil ifTrue: [(size := (histogram := self model histogram) size) < 1
			ifTrue: [boxCollection := OrderedCollection new]
			ifFalse: [Cursor wait
					showWhile: 
						[boxCollection := OrderedCollection new: size.
						min := 0.
						max := 0.
						histogram do: [:assoc | max := max max: assoc value].
						area := self histogramArea.
						width := (area width / size) asInteger.
						point := area bottomLeft.
						histogram
							do: 
								[:assoc | 
								count := assoc value.
								height := (area height / (max - min) * count) rounded.
								box := 0 @ 0 extent: width @ height.
								box := box align: box bottomLeft with: point.
								boxCollection add: box.
								point := point x + width @ point y]]]].
	^boxCollection! !

!HistogramView methodsFor: 'area accessing' stamp: 'nishis 5/24/98 07:28'!
histogramArea
	| margin left top right bottom area |
	margin := self marginRectangle.
	left := 0.
	self yScale do: [:each | left := left max: each value width].
	left := margin left + left + 4.
	top := margin top + self numericalInfo boundingBox height + 4.
	right := margin right.
	bottom := 0.
	self xScale do: [:each | bottom := bottom max: each height].
	bottom := margin bottom + bottom + 4.
	area := (0 @ 0 extent: self insetDisplayBox extent) insetBy: (left @ top corner: right @ bottom).
	^area! !

!HistogramView methodsFor: 'area accessing'!
marginRectangle
	^Rectangle
		left: 8 + self yLabel width
		right: 4
		top: 4
		bottom: 8 + self xLabel height! !


!HistogramView methodsFor: 'bounds accessing' stamp: 'nishis 5/23/98 02:11'!
computeInsetDisplayBox
	"for resizing"
	boxCollection := nil.
	^super computeInsetDisplayBox! !


!HistogramView methodsFor: 'controller accessing'!
defaultControllerClass
	^HistogramController! !


!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/24/98 07:30'!
displayHistogramOn: graphicsContext 
	| clip |
	clip := (0 @ 0 extent: self insetDisplayBox extent).
	false ifTrue: [^nil].
	self boxCollection do: [:rect | (clip intersects: (rect expandBy: (0 @ 0 corner: 1 @ 1)))
			ifTrue: 
				[self displayBoxOn: graphicsContext box: rect lineWidth: 1 color: self model color.
				self displayBorderOn: graphicsContext box: rect lineWidth: 1 color: Color black]]! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/24/98 07:30'!
displayNumericalInfoOn: graphicsContext 
	| info |
	info := self numericalInfo.
	info displayOn: graphicsContext at: self histogramArea right - info width @ self marginRectangle top! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/23/98 00:50'!
displayOn: graphicsContext 
	| visibleAreas |
	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/24/98 07:31'!
displayView
	| graphicsContext |
	graphicsContext := Form extent: self insetDisplayBox extent depth: Display depth.
	graphicsContext fillWithColor: self backgroundColor.
	self displayYScaleOn: graphicsContext.
	self displayXScaleOn: graphicsContext.
	self displayHistogramOn: graphicsContext.
	self displayNumericalInfoOn: graphicsContext.
	self displayYLabelOn: graphicsContext.
	self displayXLabelOn: graphicsContext.
	self displayOn: graphicsContext! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 7/18/1998 19:25'!
displayXLabelOn: graphicsContext 
	| label box |
	label := self xLabel.
	box := label boundingBox.
	box := box align: box bottomCenter with: self histogramArea center x @ (self bounds bottom - 4).
	label displayOn: graphicsContext at: box origin! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/24/98 07:31'!
displayXScaleOn: graphicsContext 
	| size area width point box |
	(size := self model histogram size) < 1 ifTrue: [^self].
	area := self histogramArea.
	width := (area width / size) asInteger.
	self displayLineOn: graphicsContext from: area bottomLeft to: area bottomLeft + (width * size @ 0) lineWidth: 1 color: Color black.
	point := area bottomLeft + (width // 2 @ 4).
	self xScale
		do: 
			[:each | 
			box := each boundingBox.
			box := box align: box topCenter with: point.
			each displayOn: graphicsContext at: box origin.
			point := point x + width @ point y]! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/23/98 00:43'!
displayYLabelOn: graphicsContext 
	| label box |
	label := self yLabel.
	box := label boundingBox.
	box := box align: box leftCenter with: 4 @ (self histogramArea center y).
	label displayOn: graphicsContext at: box origin! !

!HistogramView methodsFor: 'displaying' stamp: 'nishis 5/24/98 07:31'!
displayYScaleOn: graphicsContext 
	| area point box |
	area := self histogramArea.
	self displayLineOn: graphicsContext from: area topLeft to: area bottomLeft lineWidth: 1 color: Color black.
	self yScale
		do: 
			[:assoc | 
			point := area bottomLeft - (0 @ (area height * assoc key)) rounded.
			self displayLineOn: graphicsContext from: point - (2 @ 0) to: point lineWidth: 1 color: Color black.
			box := assoc value boundingBox.
			box := box align: box rightCenter with: point - (4 @ 0).
			assoc value displayOn: graphicsContext at: box origin]! !


!HistogramView methodsFor: 'updating' stamp: 'nishis 5/24/98 07:26'!
update: aspectSymbol 
	(aspectSymbol = #histogram or: [aspectSymbol = #sample])
		ifTrue: 
			[xScale := nil.
			yScale := nil.
			numericalInfo := nil.
			boxCollection := nil].
	(aspectSymbol = #description or: [aspectSymbol = #sample])
		ifTrue: 
			[xLabel := nil.
			yLabel := nil].
	self display! !


!HistogramView methodsFor: 'private' stamp: 'nishis 7/18/1998 19:25'!
bounds
	^0 @ 0 extent: self insetDisplayBox extent! !

!HistogramView methodsFor: 'private'!
numericalInfo
	| stream |
	numericalInfo isNil ifTrue: [Cursor wait
			showWhile: 
				[stream := WriteStream on: (String new: 64).
				stream nextPutAll: 'total: ' , self model total printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'count: ' , self model count printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'min: ' , self model minimum printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'max: ' , self model maximum printString.
				stream cr.
				stream nextPutAll: 'average: ' , (self model average asFloat truncateTo: 0.01) printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'deviation: ' , (self model deviation asFloat truncateTo: 0.01) printString.
				numericalInfo := Paragraph withText: stream contents asText style: self textStyle.
				numericalInfo rightFlush]].
	^numericalInfo! !

!HistogramView methodsFor: 'private' stamp: 'nishis 5/24/98 07:32'!
textStyle
	^TextStyle default copy! !

!HistogramView methodsFor: 'private' stamp: 'nishis 5/24/98 07:32'!
xLabel
	| string text pixmap image |
	xLabel isNil ifTrue: [Cursor wait
			showWhile: 
				[(string := self model horizontal) isNil
					ifTrue: [text := Paragraph withText: Text new style: self textStyle]
					ifFalse: [text := Paragraph withText: string asText style: self textStyle].
				text boundingBox area > 0
					ifTrue: 
						[pixmap := Form extent: text boundingBox extent depth: Display depth.
						
						text displayOn: pixmap.
						image := pixmap]
					ifFalse: [image := Form
									extent: 0 @ 0
									depth: 1].
				xLabel := image]].
	^xLabel! !

!HistogramView methodsFor: 'private' stamp: 'nishis 11/18/2001 05:34'!
xScale
	| mark mark2 images range pixmap image first last gc size index markBlock rotateImage |
	markBlock := [:form :fromPoint :toPoint | self displayLineOn: form from: fromPoint to: toPoint lineWidth: 1 color: Color black].
	xScale isNil ifTrue: [Cursor wait
			showWhile: 
				[mark := Form extent: 8 @ 8. 
					markBlock value: mark value: 2 @ 4 value: 6 @ 4.
					markBlock value: mark value: 3 @ 3 value: 3 @ 5.
					markBlock value: mark value: 5 @ 3 value: 5 @ 5.
				mark2 := Form extent: 8 @ 8.
					markBlock value: mark2 value: 2 @ 4 value: 6 @ 4.
					markBlock value: mark2 value: 3 @ 3 value: 3 @ 5.
					markBlock value: mark2 value: 6 @ 3 value: 6 @ 5.
				images := OrderedCollection new.
				size := self model histogram size.
				index := 1.
				self model histogram
					do: 
						[:assoc | 
						range := assoc key.
						first := Paragraph withText: ((range first isKindOf: Integer)
										ifTrue: [range first]
										ifFalse: [range first asFloat]) printString asText style: self textStyle.
						last := Paragraph withText: ((range last isKindOf: Integer)
										ifTrue: [range last]
										ifFalse: [range last asFloat]) printString asText style: self textStyle.
						pixmap := Form extent: first boundingBox extent + (8 + last boundingBox width @ 0) depth: Display depth.
						gc := pixmap.
						gc fillWhite.
						first displayOn: gc.
						index = size
							ifTrue: [mark2 displayOn: gc at: first width @ (first height // 2 - 4)]
							ifFalse: [mark displayOn: gc at: first width @ (first height // 2 - 4)].
						last displayOn: gc at: pixmap boundingBox topRight - (last width @ 0).
						image := pixmap.
						image boundingBox area > 0 
							ifTrue: 
								[rotateImage := Form extent: image height @ image width depth: Display depth.
								(image rotateBy: #left centerAt: 0@0) displayOn: rotateImage.
								image := rotateImage].
						images add: image.
						index := index + 1].
				xScale := images]].
	^xScale! !

!HistogramView methodsFor: 'private' stamp: 'nishis 7/18/1998 18:56'!
yLabel
	| string text pixmap image rotateImage |
	yLabel isNil ifTrue: [Cursor wait
			showWhile: 
				[(string := self model vertical) isNil
					ifTrue: [text := Paragraph withText: Text new style: self textStyle]
					ifFalse: [text := Paragraph withText: string asText style: self textStyle].
				text boundingBox area > 0
					ifTrue: 
						[pixmap := Form extent: text boundingBox extent depth: Display depth.
						
						text displayOn: pixmap.
						image := pixmap.
						image boundingBox area > 0 
							ifTrue: 
								[rotateImage := Form extent: image height @ image width depth: Display depth.
								(image rotateBy: #left centerAt: 0@0) displayOn: rotateImage.
								image := rotateImage]]
					 ifFalse: [image := Form
									extent: 0 @ 0
									depth: 1].
				yLabel := image]].
	^yLabel! !

!HistogramView methodsFor: 'private' stamp: 'nishis 5/24/98 07:34'!
yScale
	| histogram min max inc collection range pixmap image ratio interval |
	yScale isNil ifTrue: [Cursor wait
			showWhile: 
				[histogram := self model histogram.
				min := 0.
				max := 0.
				histogram do: [:assoc | max := max max: assoc value].
				collection := OrderedCollection new.
				max - min > 0
					ifTrue: 
						[inc := (10 raisedTo: (max - min)) printString size / 100 max: 1.
						interval := min to: max by: inc.
						[interval size > 10]
							whileTrue: 
								[inc := inc * 2.
								interval := min to: max by: inc].
						interval
							do: 
								[:each | 
								ratio := each / (max - min).
								range := Paragraph withText: ((each isKindOf: Integer)
												ifTrue: [each]
												ifFalse: [each asFloat]) printString asText style: self textStyle.
								pixmap := Form extent: range boundingBox extent depth: Display depth.
								
								range displayOn: pixmap.
								image := pixmap.
								collection add: ratio -> image]].
				yScale := collection]].
	^yScale! !


!HistogramView methodsFor: 'private diplaying' stamp: 'nishis 5/23/98 01:10'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext! !

!HistogramView methodsFor: 'private diplaying' stamp: 'nishis 5/23/98 01:11'!
displayBoxOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
					borderWidth: lineWidth 
					borderColor: aColor 
					insideColor: aColor.
	quadrangle displayOn: graphicsContext! !

!HistogramView methodsFor: 'private diplaying' stamp: 'nishis 5/23/98 01:00'!
displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: lineWidth color: aColor 
	| aForm aLine |
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: graphicsContext! !

!HistogramView methodsFor: 'private diplaying' stamp: 'nishis 5/23/98 01:13'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HistogramView class
	instanceVariableNames: ''!

!HistogramView class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!HistogramView class methodsFor: 'copyright'!
system
	^'Goodies'! !

!HistogramView class methodsFor: 'copyright'!
version
	^'003'! !
