'Goodies (11/18/2001 8:34:56 am)'.!


Model subclass: #DisplayModel
	instanceVariableNames: 'displayObject boundingBox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Display'!
!DisplayModel commentStamp: '<historical>' prior: 0!
Scheduled View and Scheduled Controller
Goodies for Squeak (Smalltalk-80)
Copyright (c) 1986-1998 AOKI Atsushi
1998/01/13

TvF

Squeak̕\̂߂MVCłB̃XN[ɉāC
̃XN[\ɂ܂B

CXg[@F

Display.stoCi[hŃ_E[hCt@CC
(fileIn)ĉBGoodies-DisplayƂJeSɉL̃N
XCXg[܂B

DisplayController
DisplayModel
DisplayView

gF

ʂ؂摜\̂߂MVC̒ɓăEBhE
JvÔ͎悤ɂȂ܂B

| displayModel scheduledView displayView |
displayModel := DisplayModel visual: Form fromUser.
scheduledView := ScheduledView
	model: displayModel
	label: 'Display'
	minimumSize: 300 @ 200.
displayView := DisplayView model: displayModel.
scheduledView addSubView: displayView.
scheduledView controller openAt: 100 @ 100

\̂߂̃fɎw肷IuWFNgɂ́CIuWF
Ngwł܂BƂ΁CVXẽJeS\\
߂MVC̒ɓăEBhEJvÔ͎悤ɂ
܂B

| displayModel scheduledView displayView |
displayModel := DisplayModel visual: SystemOrganization.
scheduledView := ScheduledView
	model: displayModel
	label: 'Display'
	minimumSize: 300 @ 200.
displayView := DisplayView model: displayModel.
scheduledView addSubView: displayView.
scheduledView controller openAt: 100 @ 100

------------------------------------------------------------
 ؏~(AOKI Atsushi)      http://www.sra.co.jp/people/aoki 
 Software Research Associates, Inc.   mailto:aoki@sra.co.jp 
 Marusho-Bldg.5F, 3-12 Yotsuya,            Tel:03-3357-9361 
 Shinjuku-ku, Tokyo 160-0004, JAPAN        Fax:03-3351-0880 
------------------------------------------------------------
!


!DisplayModel methodsFor: 'accessing'!
visual
	displayObject isNil ifTrue: [self visual: String new asParagraph].
	^displayObject! !

!DisplayModel methodsFor: 'accessing'!
visual: anObject 
	| visual |
	(anObject respondsTo: #value)
		ifTrue: [visual := anObject value]
		ifFalse: [visual := anObject].
	visual = displayObject
		ifFalse: 
			[((visual respondsTo: #boundingBox) and: [visual respondsTo: #displayOn:])
				ifTrue: [displayObject := visual]
				ifFalse:
					[visual isNil
						ifTrue: [displayObject := nil]
						ifFalse:
							[(visual isKindOf: String)
								ifTrue: [displayObject := Paragraph
											withText: visual asText
											style: TextStyle default copy]
								ifFalse: [displayObject := Paragraph
											withText: visual printString asText
											style: TextStyle default copy]]].
			self visualIsChanged]! !


!DisplayModel methodsFor: 'displaying'!
display
	self displayOn: Display! !

!DisplayModel methodsFor: 'displaying'!
displayOn: aDisplayMedium
	self displayOn: aDisplayMedium at: 0 @ 0! !

!DisplayModel methodsFor: 'displaying'!
displayOn: aDisplayMedium at: aDisplayPoint 
	self
		displayOn: aDisplayMedium
		at: aDisplayPoint
		clippingBox: aDisplayMedium boundingBox! !

!DisplayModel methodsFor: 'displaying'!
displayOn: aDisplayMedium at: aDisplayPoint clippingBox: clipRectangle 
	self visual
		displayOn: aDisplayMedium
		at: aDisplayPoint
		clippingBox: clipRectangle ! !


!DisplayModel methodsFor: 'display box access'!
boundingBox
	boundingBox isNil ifTrue: [boundingBox := self computeBoundingBox].
	^boundingBox! !

!DisplayModel methodsFor: 'display box access'!
computeBoundingBox
	^self visual boundingBox! !

!DisplayModel methodsFor: 'display box access'!
flushBoundingBox
	boundingBox := nil! !


!DisplayModel methodsFor: 'private'!
visualIsChanged
	self changed: #visual! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DisplayModel class
	instanceVariableNames: ''!

!DisplayModel class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved.'! !

!DisplayModel class methodsFor: 'copyright'!
system
	^'Goodies'! !

!DisplayModel class methodsFor: 'copyright'!
version
	^'002'! !


!DisplayModel class methodsFor: 'instance creation'!
visual: anObject 
	^self new visual: anObject! !


!DisplayModel class methodsFor: 'saving'!
save
	"DisplayModel save."

	| patternCollection fileName classCollection fileStream |
	patternCollection := #('*Display*').
	fileName := 'Display.st'.
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection select: [:aClass |
		(patternCollection detect: [:it | it match: aClass name asString] ifNone: [nil]) notNil].
	classCollection add: ScheduledView.
	classCollection add: ScheduledController.
	fileStream := FileStream newFileNamed: fileName.
	Cursor write showWhile: [
		fileStream nextPut: $'.
		fileStream nextPutAll: Date today printString.
		fileStream space.
		fileStream nextPutAll: Time now printString.
		fileStream nextPut: $'.
		fileStream nextChunkPut: String new.
		fileStream cr.
		fileStream cr.
		classCollection
			do: [:aClass |
				fileStream nextChunkPut: aClass definition.
				fileStream cr.
				fileStream cr].
		classCollection
			do: [:aClass |
				fileStream nextPut: Character newPage.
				aClass sharedPools size > 0
					ifTrue: [aClass shouldFileOutPools
						ifTrue: [aClass fileOutSharedPoolsOn: fileStream]].
				aClass fileOutOn: fileStream moveSource: false toFile: 0.
				fileStream cr.
				fileStream cr]].
	fileStream close! !


!DisplayModel class methodsFor: 'examples'!
example1
	"DisplayModel example1."

	| displayModel savedDisplay |
	displayModel := DisplayModel visual: Form fromUser.
	savedDisplay := Form fromDisplay: displayModel boundingBox.
	displayModel display.
	Cursor crossHair showWhile: [InputSensor default waitClickButton].
	savedDisplay display.
	^displayModel! !

!DisplayModel class methodsFor: 'examples'!
example2
	"DisplayModel example2."

	| displayModel savedDisplay |
	displayModel := DisplayModel visual: (DisplayModel class sourceCodeAt: thisContext selector).
	savedDisplay := Form fromDisplay: displayModel boundingBox.
	displayModel display.
	Cursor crossHair showWhile: [InputSensor default waitClickButton].
	savedDisplay display.
	^displayModel! !

!DisplayModel class methodsFor: 'examples'!
example3
	"DisplayModel example3."

	| displayModel scheduledView displayView |
	displayModel := DisplayModel visual: Form fromUser.
	scheduledView := ScheduledView
		model: displayModel
		label: 'Display'
		minimumSize: 300 @ 200.
	displayView := DisplayView model: displayModel.
	scheduledView addSubView: displayView.
	scheduledView controller openAt: 100 @ 100! !

!DisplayModel class methodsFor: 'examples'!
example4
	"DisplayModel example4."

	| displayModel scheduledView displayView |
	displayModel := DisplayModel visual: (DisplayModel class sourceCodeAt: thisContext selector).
	scheduledView := ScheduledView
		model: displayModel
		label: 'Display'
		minimumSize: 300 @ 200.
	displayView := DisplayView model: displayModel.
	scheduledView addSubView: displayView.
	scheduledView controller openAt: 100 @ 100! !

!DisplayModel class methodsFor: 'examples'!
example5
	"DisplayModel example5."

	| displayModel scheduledView displayView displayView2 |
	displayModel := DisplayModel visual: (Form fromDisplay: (0 @ 0 extent: 300 @ 200)).
	scheduledView := ScheduledView
		model: displayModel
		label: 'Display'
		minimumSize: 300 @ 200.
	displayView := DisplayView model: displayModel.
	scheduledView addSubView: displayView.
	displayView2 := DisplayView model: displayModel.
	scheduledView addSubView: displayView2 below: displayView.
	scheduledView controller openAt: 100 @ 100! !
