'Goodies (11/18/2001 8:34:57 am)'.!


Object subclass: #ClassReview
	instanceVariableNames: 'reviewClass allBehaviors allImplementedMessages allUndeclaredAssociations methodReviews '
	classVariableNames: 'ProgressFlag '
	poolDictionaries: ''
	category: 'Goodies-Review'!

!ClassReview methodsFor: 'accessing'!
reviewClass
	^reviewClass! !


!ClassReview methodsFor: 'retrieving'!
allBehaviors
	"ClassReview new allBehaviors."

	allBehaviors isNil
		ifTrue: 
			[allBehaviors := IdentitySet new.
			Smalltalk allBehaviorsDo: [:aBehavior | allBehaviors add: aBehavior]].
	^allBehaviors! !

!ClassReview methodsFor: 'retrieving'!
allClasses
	"ClassReview new allClasses."

	^self allBehaviors select: [:each | each isMeta not]! !

!ClassReview methodsFor: 'retrieving' stamp: 'nishis 6/22/1998 14:56'!
allImplementedMessages
	"ClassReview new allImplementedMessages."

	allImplementedMessages isNil
		ifTrue: 
			[allImplementedMessages := IdentitySet new: Symbol allInstances size.
			Smalltalk allBehaviorsDo: [:class | class selectors do: [:selector | allImplementedMessages add: selector]]].
	^allImplementedMessages! !

!ClassReview methodsFor: 'retrieving' stamp: 'nishis 6/23/1998 12:54'!
allUndeclaredAssociations
	"ClassReview new allUndeclaredAssociations."

	allUndeclaredAssociations isNil
		ifTrue: 
			[allUndeclaredAssociations := IdentitySet new: Undeclared size.
			Undeclared associationsDo: [:assoc | allUndeclaredAssociations add: assoc]].
	^allUndeclaredAssociations! !


!ClassReview methodsFor: 'method reviewing'!
methodReviews
	| dictionary methodReview |
	methodReviews isNil ifFalse: [^methodReviews].
	self progress: String new tabs: 0.
	self progress: self reviewClass name asString tabs: 0.
	self progress: 'revewing methods...' asString tabs: 1.
	dictionary := OrderedCollection new: self reviewClass selectors size.
	self reviewClass selectors asSortedCollection
		do: 
			[:reviewSelector | 
			self progress: reviewSelector asString tabs: 2.
			methodReview := MethodReview class: self reviewClass selector: reviewSelector.
			dictionary add: methodReview].
	methodReviews := dictionary.
	^methodReviews! !


!ClassReview methodsFor: 'variable reviewing'!
argumentVariables
	| collection |
	self progress: 'argument variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review argumentVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
classVariables
	| collection |
	self progress: 'class variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review classVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
globalVariables
	| collection |
	self progress: 'global variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review globalVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
instanceVariables
	| collection |
	self progress: 'instance variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review instanceVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing' stamp: 'nishis 6/22/1998 13:39'!
notAssignedVariables
	| collection selector set |
	self progress: 'not assigned variables...' tabs: 1.
	collection := Dictionary new.
	self methodReviews
		do: 
			[:review | 
			selector := review methodSelector.
			review notAssignedVariables
				do: 
					[:each | 
					set := collection at: selector ifAbsent: [Set new].
					(set includes: each)
						ifFalse: [set add: each].
					collection add: selector -> set]].
	^(self associations: collection) asSet! !

!ClassReview methodsFor: 'variable reviewing' stamp: 'nishis 6/26/1998 13:09'!
notDeclaredVariables
	| collection method selector set |
	self progress: 'not declared variables...' tabs: 1.
	collection := Dictionary new.
	self reviewClass selectors
		do: 
			[:theSelector | 
			method := self reviewClass compiledMethodAt: theSelector.
			set := Set new.
			method literals do:  [:literal | ((literal isKindOf: Association) and:
					[self allUndeclaredAssociations includes: literal])
						ifTrue: [set add: literal key asString]].
			set isEmpty ifFalse: [collection add: theSelector -> set]].
	self methodReviews
		do: 
			[:review | 
			selector := review methodSelector.
			review notDeclaredVariables
				do: 
					[:each | 
					set := collection at: selector ifAbsent: [Set new].
					(set includes: each)
						ifFalse: [set add: each].
					collection add: selector -> set]].
	^(self associations: collection) asSet! !

!ClassReview methodsFor: 'variable reviewing' stamp: 'nishis 6/22/1998 18:33'!
notUsedClassVariables
	| collection class classes size |
	self progress: 'not used class variables...' tabs: 1.
	collection := Set new.
	self reviewClass isMeta
		ifTrue: [class := self reviewClass soleInstance]
		ifFalse: [class := self reviewClass].
	classes := class withAllSuperclasses reversed , class allSubclasses asOrderedCollection.
	(self associations: class classPool) asSortedCollection do: [:variableBinding | classes
			detect: 
				[:each | 
				size := (each whichSelectorsReferTo: variableBinding) size.
				size := size + (each class whichSelectorsReferTo: variableBinding) size.
				size > 0]
			ifNone: [collection add: variableBinding key asString]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing' stamp: 'nishis 6/22/1998 18:32'!
notUsedInstanceVariables
	| collection classes size |
	self progress: 'not used instance variables...' tabs: 1.
	collection := Set new.
	classes := (Array with: self reviewClass)
				, self reviewClass allSubclasses asOrderedCollection.
	self reviewClass instVarNames do: [:instVarName | classes
			detect: 
				[:each | 
				size := (each whichSelectorsAccess: instVarName) size.
				size > 0]
			ifNone: [collection add: instVarName asString]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing' stamp: 'nishis 6/22/1998 13:38'!
notUsedVariables
	| collection selector set |
	self progress: 'not used variables...' tabs: 1.
	collection := Dictionary new.
	self methodReviews
		do: 
			[:review | 
			selector := review methodSelector.
			review notUsedVariables
				do: 
					[:each | 
					set := collection at: selector ifAbsent: [Set new].
					(set includes: each)
						ifFalse: [set add: each].
					collection add: selector -> set]].
	^(self associations: collection) asSet! !

!ClassReview methodsFor: 'variable reviewing'!
poolVariables
	| collection |
	self progress: 'pool variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review poolVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
specialVariables
	| collection |
	self progress: 'special variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review specialVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
temporaryVariables
	| collection |
	self progress: 'temporary variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review temporaryVariables do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'variable reviewing'!
usedVariables
	| collection |
	self progress: 'used variables...' tabs: 1.
	collection := Set new.
	self methodReviews do: [:review | review usedVariables do: [:each | collection add: each]].
	^collection! !


!ClassReview methodsFor: 'message reviewing'!
implementedMessagePatterns
	| collection |
	self progress: 'implemented message patterns...' tabs: 1.
	collection := SortedCollection new: self implementedMessages size.
	self methodReviews do: [:review | collection add: review methodSelector -> review messagePattern].
	collection := collection collect: [:assoc | assoc value].
	^collection! !

!ClassReview methodsFor: 'message reviewing'!
implementedMessages
	self progress: 'implemented messages...' tabs: 1.
	^self reviewClass selectors! !

!ClassReview methodsFor: 'message reviewing' stamp: 'nishis 6/23/1998 11:23'!
notImplementedSendings
	| collection selectors bag scanner message |
	self progress: 'not implemented sendings...' tabs: 1.
	collection := Dictionary new.
	self reviewClass selectors
		do: 
			[:aMessage | 
			bag := Bag new.
			self 
				withAllBlockMethodsDo: 
					[:method | 
					scanner := InstructionStream on: method.
					scanner method messages 
						do: 
							[:selector | 
							(selector notNil and: [(self allImplementedMessages includes: selector) not])
								ifTrue: [bag add: selector]]]
				with: (self reviewClass compiledMethodAt: aMessage).
			bag isEmpty ifFalse: [collection add: aMessage -> bag]].
	selectors := self reviewClass allSelectors.
	self methodReviews
		do: 
			[:review | 
			message := review methodSelector.
			bag := collection at: message ifAbsent: [Bag new].
			review sendingMessagesToMe do: [:aSelector | (selectors includes: aSelector)
					ifFalse: [bag add: aSelector]].
			bag isEmpty ifFalse: [collection add: message -> bag]].
	^(self associations: collection) asSet! !

!ClassReview methodsFor: 'message reviewing'!
sendingMessages
	| collection |
	self progress: 'sending messages...' tabs: 1.
	collection := Bag new.
	self methodReviews do: [:review | review sendingMessages do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'message reviewing'!
sendingMessagesToMe
	| collection |
	self progress: 'sending messages to me...' tabs: 1.
	collection := Bag new.
	self methodReviews do: [:review | review sendingMessagesToMe do: [:each | collection add: each]].
	^collection! !

!ClassReview methodsFor: 'message reviewing'!
sendingMessagesToThem
	| collection |
	self progress: 'sending messages to them...' tabs: 1.
	collection := Bag new.
	self methodReviews do: [:review | review sendingMessagesToThem do: [:each | collection add: each]].
	^collection! !


!ClassReview methodsFor: 'literal reviewing'!
usedLiterals
	| collection |
	self progress: 'used literals...' tabs: 1.
	collection := Bag new.
	self methodReviews do: [:review | review usedLiterals do: [:each | collection add: each]].
	^collection! !


!ClassReview methodsFor: 'number reviewing'!
branchFamilyPercentage
	| denominator |
	self progress: 'branch family percentage...' tabs: 1.
	denominator := self numberOfSendingMessages.
	denominator = 0 ifTrue: [^0].
	^(self sendingMessagesToThem size / denominator * 100) rounded! !

!ClassReview methodsFor: 'number reviewing'!
mainFamilyPercentage
	| denominator |
	self progress: 'main family percentage...' tabs: 1.
	denominator := self numberOfSendingMessages.
	denominator = 0 ifTrue: [^0].
	^(self sendingMessagesToMe size / denominator * 100) rounded! !

!ClassReview methodsFor: 'number reviewing'!
numberOfAssignments
	| count |
	self progress: 'number of assignments...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfAssignments].
	^count! !

!ClassReview methodsFor: 'number reviewing'!
numberOfBlocks
	| count |
	self progress: 'number of blocks...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfBlocks].
	^count! !

!ClassReview methodsFor: 'number reviewing'!
numberOfCascades
	| count |
	self progress: 'number of cascades...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfCascades].
	^count! !

!ClassReview methodsFor: 'number reviewing'!
numberOfReturns
	| count |
	self progress: 'number of returns...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfReturns].
	^count! !

!ClassReview methodsFor: 'number reviewing'!
numberOfSendingMessages
	| count |
	self progress: 'number of sending messages...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfSendingMessages].
	^count! !

!ClassReview methodsFor: 'number reviewing'!
numberOfStatements
	| count |
	self progress: 'number of statements...' tabs: 1.
	count := 0.
	self methodReviews do: [:review | count := count + review numberOfStatements].
	^count! !


!ClassReview methodsFor: 'category reviewing' stamp: 'nishis 7/19/1998 02:09'!
emptyCategories
	| set organization |
	self progress: 'empty categories...' tabs: 1.
	set := Set new.
	organization := self reviewClass organization.
	organization categories 
		do: [:category | 
			((organization listAtCategoryNamed: category) isEmpty and: 
					[(category = 'no messages' asSymbol) not]) 
				ifTrue: [set add: category asString]].
	^set! !


!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:12'!
report
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	Cursor wait showWhile: [self reportOn: aStream].
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Class Review'! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/28/1998 22:28'!
reportHtml
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	self reportHtmlOn: aStream.
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Class Review (HTML)'! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/26/1998 13:12'!
reportHtmlOn: aStream 
	aStream nextPutAll: '<HTML>'.
	aStream cr.
	aStream nextPutAll: '<BODY BGCOLOR="#FFFFFF">'.
	aStream cr.
	aStream nextPutAll: '<FONT SIZE=+1>'.
	aStream cr.
	aStream nextPutAll: '<B>'.
	aStream nextPutAll: self reviewClass printString.
	aStream nextPutAll: '</B>'.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	aStream nextPutAll: '</FONT>'.
	aStream cr.
	aStream nextPutAll: '<DL>'.
	aStream cr.
	self outputForVariables2: aStream
		value: 'not declared variables:'
		value: self notDeclaredVariables
		value: 1.
	self outputForVariables: aStream
		value: 'not used instance variables:'
		value: self notUsedInstanceVariables
		value: 1.
	self reviewClass isMeta ifFalse: [self outputForVariables: aStream
			value: 'not used class variables:'
			value: self notUsedClassVariables
			value: 1].
	self outputForVariables2: aStream
		value: 'not used variables:'
		value: self notUsedVariables
		value: 1.
	self outputForVariables2: aStream
		value: 'not assigned variables:'
		value: self notAssignedVariables
		value: 1.
	self outputForMessages: aStream
		value: 'not implemented sendings:'
		value: self notImplementedSendings
		value: 1.
	self outputForVariables: aStream
		value: 'empty categories:'
		value: self emptyCategories
		value: 1.
	self outputForVariables: aStream
		value: 'used special variables:'
		value: self specialVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used argument variables:'
		value: self argumentVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used temporary variables:'
		value: self temporaryVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used instance variables:'
		value: self instanceVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used class variables:'
		value: self classVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used pool variables:'
		value: self poolVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used global variables:'
		value: self globalVariables
		value: 1.
	self outputForMessages2: aStream
		value: 'implemented messages:'
		value: self implementedMessagePatterns
		value: 1.
	self outputForMessages3: aStream
		value: 'sending messages to me:'
		value: self sendingMessagesToMe
		value: 1.
	self outputForMessages3: aStream
		value: 'sending messages to them:'
		value: self sendingMessagesToThem
		value: 1.
	self outputForLiterals: aStream
		value: 'used literals:'
		value: self usedLiterals
		value: 1.
	self outputForNumber: aStream
		value: 'number of sending messages:'
		value: self numberOfSendingMessages
		value: 1.
	self outputForNumber: aStream
		value: 'number of assignments:'
		value: self numberOfAssignments
		value: 1.
	self outputForNumber: aStream
		value: 'number of blocks:'
		value: self numberOfBlocks
		value: 1.
	self outputForNumber: aStream
		value: 'number of cascades:'
		value: self numberOfCascades
		value: 1.
	self outputForNumber: aStream
		value: 'number of returns:'
		value: self numberOfReturns
		value: 1.
	self outputForNumber: aStream
		value: 'number of statements:'
		value: self numberOfStatements
		value: 1.
	self outputForPercentage: aStream
		value: 'main family percentage:'
		value: self mainFamilyPercentage
		value: 1.
	self outputForPercentage: aStream
		value: 'branch family percentage:'
		value: self branchFamilyPercentage
		value: 1.
	aStream nextPutAll: '</DL>'.
	aStream cr.
	aStream nextPutAll: '<!!-- This Document was generated by ' , self class name , '. -->'.
	aStream cr.
	aStream nextPutAll: '<!!-- ' , self class name , ' was developed by AOKI Atsushi. -->'.
	aStream cr.
	aStream nextPutAll: '</BODY>'.
	aStream cr.
	aStream nextPutAll: '</HTML>'.
	aStream cr! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:45'!
reportHtmlToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	self reportHtmlOn: aStream.
	aStream close! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:13'!
reportOn: aStream 
	aStream nextPutAll: self reviewClass printString.
	aStream cr.
	aStream cr.
	self outputForVariables2: aStream
		value: 'not declared variables:'
		value: self notDeclaredVariables
		value: 1.
	self outputForVariables: aStream
		value: 'not used instance variables:'
		value: self notUsedInstanceVariables
		value: 1.
	self reviewClass isMeta ifFalse: [self outputForVariables: aStream
			value: 'not used class variables:'
			value: self notUsedClassVariables
			value: 1].
	self outputForVariables2: aStream
		value: 'not used variables:'
		value: self notUsedVariables
		value: 1.
	self outputForVariables2: aStream
		value: 'not assigned variables:'
		value: self notAssignedVariables
		value: 1.
	self outputForMessages: aStream
		value: 'not implemented sendings:'
		value: self notImplementedSendings
		value: 1.
	self outputForVariables: aStream
		value: 'empty categories:'
		value: self emptyCategories
		value: 1.
	self outputForVariables: aStream
		value: 'used special variables:'
		value: self specialVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used argument variables:'
		value: self argumentVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used temporary variables:'
		value: self temporaryVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used instance variables:'
		value: self instanceVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used class variables:'
		value: self classVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used pool variables:'
		value: self poolVariables
		value: 1.
	self outputForVariables: aStream
		value: 'used global variables:'
		value: self globalVariables
		value: 1.
	self outputForMessages2: aStream
		value: 'implemented messages:'
		value: self implementedMessagePatterns
		value: 1.
	self outputForMessages3: aStream
		value: 'sending messages to me:'
		value: self sendingMessagesToMe
		value: 1.
	self outputForMessages3: aStream
		value: 'sending messages to them:'
		value: self sendingMessagesToThem
		value: 1.
	self outputForLiterals: aStream
		value: 'used literals:'
		value: self usedLiterals
		value: 1.
	self outputForNumber: aStream
		value: 'number of sending messages:'
		value: self numberOfSendingMessages
		value: 1.
	self outputForNumber: aStream
		value: 'number of assignments:'
		value: self numberOfAssignments
		value: 1.
	self outputForNumber: aStream
		value: 'number of blocks:'
		value: self numberOfBlocks
		value: 1.
	self outputForNumber: aStream
		value: 'number of cascades:'
		value: self numberOfCascades
		value: 1.
	self outputForNumber: aStream
		value: 'number of returns:'
		value: self numberOfReturns
		value: 1.
	self outputForNumber: aStream
		value: 'number of statements:'
		value: self numberOfStatements
		value: 1.
	self outputForPercentage: aStream
		value: 'main family percentage:'
		value: self mainFamilyPercentage
		value: 1.
	self outputForPercentage: aStream
		value: 'branch family percentage:'
		value: self branchFamilyPercentage
		value: 1! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:45'!
reportToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	Cursor wait showWhile: [self reportOn: aStream].
	aStream close! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:13'!
shortReport
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	Cursor wait showWhile: [self shortReportOn: aStream].
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Class Short Review'! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:14'!
shortReportOn: aStream 
	| outputForVariables outputForVariables2 outputForMessages count aSelector aSet aBag |
	outputForVariables := 
			[:title :set :level | 
			level timesRepeat: [aStream tab].
			aStream nextPutAll: title.
			aStream space; space; space.
			aStream nextPutAll: set size printString.
			aStream cr.
			set asSortedCollection
				do: 
					[:each | 
					level timesRepeat: [aStream tab].
					aStream tab.
					aStream nextPutAll: each.
					aStream cr]].
	outputForVariables2 := 
			[:title :collection :level | 
			count := 0.
			collection do: [:assoc | count := count + assoc value size].
			level timesRepeat: [aStream tab].
			aStream nextPutAll: title.
			aStream space; space; space.
			aStream nextPutAll: count printString.
			aStream cr.
			collection asSortedCollection
				do: 
					[:assoc | 
					aSelector := assoc key.
					aSet := assoc value.
					level timesRepeat: [aStream tab].
					aStream tab.
					aStream nextPutAll: aSelector.
					aStream cr.
					aSet
						do: 
							[:each | 
							level timesRepeat: [aStream tab].
							aStream tab; tab.
							aStream nextPutAll: each asString.
							aStream cr]]].
	outputForMessages := 
			[:title :collection :level | 
			count := 0.
			collection do: [:assoc | count := count + assoc value size].
			level timesRepeat: [aStream tab].
			aStream nextPutAll: title.
			aStream space; space; space.
			aStream nextPutAll: count printString.
			aStream cr.
			collection asSortedCollection
				do: 
					[:assoc | 
					aSelector := assoc key.
					aBag := assoc value.
					level timesRepeat: [aStream tab].
					aStream tab.
					aStream nextPutAll: aSelector.
					aStream cr.
					aBag asSet asSortedCollection
						do: 
							[:it | 
							count := aBag occurrencesOf: it.
							level timesRepeat: [aStream tab].
							aStream tab; tab.
							aStream nextPutAll: it.
							aStream space; space; space.
							aStream nextPutAll: '(' , count printString , ')'.
							aStream cr]]].

	aStream nextPutAll: self reviewClass printString.
	aStream cr.
	aStream cr.
	outputForVariables2
		value: 'not declared variables:'
		value: self notDeclaredVariables
		value: 1.
	outputForVariables
		value: 'not used instance variables:'
		value: self notUsedInstanceVariables
		value: 1.
	self reviewClass isMeta ifFalse: [outputForVariables
			value: 'not used class variables:'
			value: self notUsedClassVariables
			value: 1].
	outputForVariables2
		value: 'not used variables:'
		value: self notUsedVariables
		value: 1.
	outputForVariables2
		value: 'not assigned variables:'
		value: self notAssignedVariables
		value: 1.
	outputForMessages
		value: 'not implemented sendings:'
		value: self notImplementedSendings
		value: 1.
	outputForVariables
		value: 'empty categories:'
		value: self emptyCategories
		value: 1! !

!ClassReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:45'!
shortReportToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	Cursor wait showWhile: [self shortReportOn: aStream].
	aStream close! !


!ClassReview methodsFor: 'private' stamp: 'nishis 6/22/1998 13:37'!
associations: aCollection
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!ClassReview methodsFor: 'private'!
progress: aString tabs: anInteger 
	self class progressFlag = true
		ifTrue: 
			[Transcript cr.
			anInteger timesRepeat: [Transcript tab].
			Transcript show: aString]! !

!ClassReview methodsFor: 'private'!
setClass: aClass 
	reviewClass := aClass.
	methodReviews := nil.
	self methodReviews.
	^self! !

!ClassReview methodsFor: 'private' stamp: 'nishis 6/23/1998 09:07'!
withAllBlockMethodsDo: aBlock with: aCompileMethod
	| literalClass |
	aBlock value: aCompileMethod.
	aCompileMethod literals do:
		[:literal | 
		literalClass := literal class.
		literalClass == CompiledMethod
			ifTrue: [self withAllBlockMethodsDo: aBlock with: literal]
			ifFalse:
				[literalClass == BlockContext
					ifTrue: [self withAllBlockMethodsDo: aBlock with: literal method]]]! !


!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:11'!
outputForHtml: aStream string: string 
	string do: [:char | char = $<
			ifTrue: [aStream nextPutAll: '&lt;']
			ifFalse: [char = $>
					ifTrue: [aStream nextPutAll: '&gt;']
					ifFalse: [aStream nextPut: char]]]
! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:14'!
outputForLiterals: aStream value: title value: bag value: level
	| count |
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: bag size printString.
	aStream cr.
	(bag asSet asSortedCollection: [:x :y | (x = self class proxyNil
			ifTrue: ['nil']
			ifFalse: [x printString])
			< (y = self class proxyNil
					ifTrue: ['nil']
					ifFalse: [y printString])])
		do: 
			[:each | 
			count := bag occurrencesOf: each.
			level timesRepeat: [aStream tab].
			aStream tab.
			each = self class proxyNil
				ifTrue: [aStream nextPutAll: 'nil']
				ifFalse: [aStream nextPutAll: each printString].
			aStream space; space; space.
			aStream nextPutAll: '(' , count printString , ')'.
			aStream cr]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:55'!
outputForLiteralsHtml: aStream value: title value: bag value: level
	| count |
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: bag size printString.
	aStream cr.
	(bag asSet asSortedCollection: [:x :y | (x = self class proxyNil
			ifTrue: ['nil']
			ifFalse: [x printString])
			< (y = self class proxyNil
					ifTrue: ['nil']
					ifFalse: [y printString])])
		do: 
			[:each | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			count := bag occurrencesOf: each.
			level timesRepeat: [aStream tab].
			aStream tab.
			each = self class proxyNil
				ifTrue: [aStream nextPutAll: 'nil']
				ifFalse: [self outputForHtml: aStream string: each printString].
			aStream space; space; space.
			aStream nextPutAll: '(' , count printString , ')'.
			aStream cr.
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:14'!
outputForMessages2: aStream value: title value: collection value: level
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: collection size printString.
	aStream cr.
	collection
		do: 
			[:pattern | 
			level timesRepeat: [aStream tab].
			aStream tab.
			1
				to: pattern size
				by: 2
				do: 
					[:index | 
					aStream nextPutAll: (pattern at: index).
					index + 1 > pattern size ifFalse: [aStream space].
					index < pattern size ifTrue: [aStream nextPutAll: (pattern at: index + 1)].
					index + 1 >= pattern size ifFalse: [aStream space]].
			aStream cr]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:55'!
outputForMessages2Html: aStream value: title value: collection value: level
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: collection size printString.
	aStream cr.
	collection
		do: 
			[:pattern | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			level timesRepeat: [aStream tab].
			aStream tab.
			1
				to: pattern size
				by: 2
				do: 
					[:index | 
					aStream nextPutAll: '<B>'.
					self outputForHtml: aStream string: (pattern at: index).
					aStream nextPutAll: '</B>'.
					index + 1 > pattern size ifFalse: [aStream space].
					index < pattern size ifTrue: [self outputForHtml: aStream string: (pattern at: index + 1)].
					index + 1 >= pattern size ifFalse: [aStream space]].
			aStream cr.
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForMessages3: aStream value: title value: bag value: level
	| count |
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: bag size printString.
	aStream cr.
	bag asSet asSortedCollection
		do: 
			[:each | 
			count := bag occurrencesOf: each.
			level timesRepeat: [aStream tab].
			aStream tab.
			aStream nextPutAll: each.
			aStream space; space; space.
			aStream nextPutAll: '(' , count printString , ')'.
			aStream cr]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:55'!
outputForMessages3Html: aStream value: title value: bag value: level
	| count |
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: bag size printString.
	aStream cr.
	bag asSet asSortedCollection
		do: 
			[:each | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			count := bag occurrencesOf: each.
			level timesRepeat: [aStream tab].
			aStream tab.
			self outputForHtml: aStream string: each.
			aStream space; space; space.
			aStream nextPutAll: '(' , count printString , ')'.
			aStream cr.
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForMessages: aStream value: title value: collection value: level
	| count selector bag |
	count := 0.
	collection do: [:assoc | count := count + assoc value size].
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: count printString.
	aStream cr.
	collection asSortedCollection
		do: 
			[:assoc | 
			selector := assoc key.
			bag := assoc value.
			level timesRepeat: [aStream tab].
			aStream tab.
			aStream nextPutAll: selector.
			aStream cr.
			bag asSet asSortedCollection
				do: 
					[:it | 
					count := bag occurrencesOf: it.
					level timesRepeat: [aStream tab].
					aStream tab; tab.
					aStream nextPutAll: it.
					aStream space; space; space.
					aStream nextPutAll: '(' , count printString , ')'.
					aStream cr]]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:56'!
outputForMessagesHtml: aStream value: title value: collection value: level
	| count selector bag |
	count := 0.
	collection do: [:assoc | count := count + assoc value size].
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: count printString.
	aStream cr.
	collection asSortedCollection
		do: 
			[:assoc | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			selector := assoc key.
			bag := assoc value.
			level timesRepeat: [aStream tab].
			aStream tab.
			self outputForHtml: aStream string: selector.
			aStream cr.
			bag asSet asSortedCollection
				do: 
					[:it | 
					count := bag occurrencesOf: it.
					level timesRepeat: [aStream tab].
					aStream tab; tab.
					self outputForHtml: aStream string: it.
					aStream space; space; space.
					aStream nextPutAll: '(' , count printString , ')'.
					aStream cr].
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForNumber: aStream value: title value: number value: level
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: number printString.
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:57'!
outputForNumberHtml: aStream value: title value: number value: level
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: number printString.
	aStream cr.
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForPercentage: aStream value: title value: number value: level
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: number printString , '%'.
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:57'!
outputForPercentageHtml: aStream value: title value: number value: level
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: number printString , '%'.
	aStream cr.
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForVariables2: aStream value: title value: collection value: level
	| count selector set |
	count := 0.
	collection do: [:assoc | count := count + assoc value size].
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: count printString.
	aStream cr.
	collection asSortedCollection
		do: 
			[:assoc | 
			selector := assoc key.
			set := assoc value.
			level timesRepeat: [aStream tab].
			aStream tab.
			aStream nextPutAll: selector.
			aStream cr.
			set
				do: 
					[:each | 
					level timesRepeat: [aStream tab].
					aStream tab; tab.
					aStream nextPutAll: each asString.
					aStream cr]]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:58'!
outputForVariables2Html: aStream value: title value: collection value: level
	| count selector set |
	count := 0.
	collection do: [:assoc | count := count + assoc value size].
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: count printString.
	aStream cr.
	collection asSortedCollection
		do: 
			[:assoc | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			selector := assoc key.
			set := assoc value.
			level timesRepeat: [aStream tab].
			aStream tab.
			self outputForHtml: aStream string: selector.
			aStream cr.
			set
				do: 
					[:each | 
					aStream nextPutAll: '<DL>'.
					aStream cr.
					level timesRepeat: [aStream tab].
					aStream tab; tab.
					self outputForHtml: aStream string: each asString.
					aStream cr.
					aStream nextPutAll: '</DL>'.
					aStream cr].
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/30/1998 14:15'!
outputForVariables: aStream value: title value: set value: level
	level timesRepeat: [aStream tab].
	aStream nextPutAll: title.
	aStream space; space; space.
	aStream nextPutAll: set size printString.
	aStream cr.
	set asSortedCollection
		do: 
			[:each | 
			level timesRepeat: [aStream tab].
			aStream tab.
			aStream nextPutAll: each.
			aStream cr]! !

!ClassReview methodsFor: 'private reporting' stamp: 'nishis 6/22/1998 16:58'!
outputForVariablesHtml: aStream value: title value: set value: level
	level timesRepeat: [aStream nextPutAll: '<DL>'].
	aStream cr.
	level timesRepeat: [aStream tab].
	aStream nextPutAll: '<B><I>'.
	aStream nextPutAll: title.
	aStream nextPutAll: '</I></B>'.
	aStream space; space; space.
	aStream nextPutAll: set size printString.
	aStream cr.
	set asSortedCollection
		do: 
			[:each | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			level timesRepeat: [aStream tab].
			aStream tab.
			self outputForHtml: aStream string: each.
			aStream cr.
			aStream nextPutAll: '</DL>'.
			aStream cr].
	level timesRepeat: [aStream nextPutAll: '</DL>'].
	aStream cr! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassReview class
	instanceVariableNames: ''!

!ClassReview class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!ClassReview class methodsFor: 'copyright'!
system
	^'Goodies'! !

!ClassReview class methodsFor: 'copyright'!
version
	^'003'! !


!ClassReview class methodsFor: 'instance creation'!
class: aClass 
	^(self new) setClass: aClass; yourself! !


!ClassReview class methodsFor: 'proxy nil'!
proxyNil
	^MethodReview proxyNil! !


!ClassReview class methodsFor: 'progress flag'!
progressFlag
	ProgressFlag isNil ifTrue: [ProgressFlag := false].
	^ProgressFlag! !

!ClassReview class methodsFor: 'progress flag'!
progressFlag: aBoolean 
	"ClassReview progressFlag: true."
	"ClassReview progressFlag: false."

	ProgressFlag := aBoolean = true! !


!ClassReview class methodsFor: 'examples'!
example1
	"ClassReview example1."

	| classReview |
	classReview := ClassReview class: ClassReview.
	classReview report.
	^classReview! !

!ClassReview class methodsFor: 'examples'!
example2
	"ClassReview example2."

	| classReview |
	classReview := ClassReview class: ClassReview.
	classReview reportHtml.
	^classReview! !

!ClassReview class methodsFor: 'examples' stamp: 'nishis 6/22/1998 19:27'!
example3
	"ClassReview example3."

	| classReview |
	classReview := ClassReview class: ClassReview.
	classReview shortReport.
	^classReview! !

!ClassReview class methodsFor: 'examples' stamp: 'nishis 6/26/1998 13:07'!
example4
	"ClassReview example4."

	| classReview |
	classReview := ClassReview class: Number.
	classReview reportToFile: 'Number.txt'.
	^classReview! !
