'Goodies (11/18/2001 8:34:58 am)'.!


Object subclass: #BitField
	instanceVariableNames: 'size field tags '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Collections'!
!BitField commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Bit Field
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Bit Field
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BitField.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BitField.txt

Summary:

This is a goodies for compact using for On or Off, true or 
false, yes or no, etc.

Usually, we use true and false object for binary expression.
It uses same space as a object pointer.  In a  machine of 
32bit architecture, It requires 4 bytes.  This is a wasteful 
thing for a program which requires many options (binary 
expression).

This goodies expresses true or false for 1 bit.  So you can 
use many options (binary expression) with compact memory.


How to install:

FileIn this goodies and makes a class "BitField" in a 
category "Goodies-Collections". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"BitField" from your system, simply.


How to use:

See examples.


##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BitField.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BitField.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!BitField methodsFor: 'accessing'!
allFalse
	field := 0! !

!BitField methodsFor: 'accessing'!
allTrue
	self allFalse.
	1 to: self size do: [:index | field := field + (self privateAt: index)]! !

!BitField methodsFor: 'accessing'!
at: anIndex 
	| on |
	(1 <= anIndex and: [anIndex <= self size])
		ifTrue: 
			[on := self privateAt: anIndex.
			(field bitAnd: on)
				= 0
				ifTrue: [^false]
				ifFalse: [^true]]
		ifFalse: [^self error: 'unexpected index'].
	^false! !

!BitField methodsFor: 'accessing'!
at: anIndex put: aBoolean 
	| on |
	(1 <= anIndex and: [anIndex <= self size])
		ifTrue: 
			[on := self privateAt: anIndex.
			aBoolean = true
				ifTrue: [field := field bitOr: on]
				ifFalse: [field := field bitAnd: on bitInvert]]
		ifFalse: [^self error: 'unexpected index']! !

!BitField methodsFor: 'accessing'!
falseIndexes
	| set |
	set := Set new.
	1 to: self size do: [:index | (self at: index)
			= false ifTrue: [set add: index]].
	^set! !

!BitField methodsFor: 'accessing'!
falseTags
	| dictionary set |
	dictionary := self reverseTags.
	set := Set new.
	1 to: self size do: [:index | (self at: index)
			= false ifTrue: [set addAll: (dictionary at: index ifAbsent: [Set new])]].
	^set! !

!BitField methodsFor: 'accessing'!
size
	^size! !

!BitField methodsFor: 'accessing'!
tagAt: tagObject 
	| index |
	index := tags at: tagObject ifAbsent: [nil].
	index isNil ifTrue: [^self error: 'unexpected tag'].
	^self at: index! !

!BitField methodsFor: 'accessing'!
tagAt: tagObject put: aBoolean 
	| index |
	index := tags at: tagObject ifAbsent: [nil].
	index isNil ifTrue: [^self error: 'unexpected tag'].
	self at: index put: aBoolean! !

!BitField methodsFor: 'accessing'!
trueIndexes
	| set |
	set := Set new.
	1 to: self size do: [:index | (self at: index)
			= true ifTrue: [set add: index]].
	^set! !

!BitField methodsFor: 'accessing'!
trueTags
	| dictionary set |
	dictionary := self reverseTags.
	set := Set new.
	1 to: self size do: [:index | (self at: index)
			= true ifTrue: [set addAll: (dictionary at: index ifAbsent: [Set new])]].
	^set! !


!BitField methodsFor: 'copying' stamp: 'nishis 5/3/98 05:13'!
shallowCopy
	super shallowCopy.
	size := size copy.
	field := field copy.
	tags := tags copy.
	^self! !


!BitField methodsFor: 'enumerating'!
do: aBlock 
	1 to: self size do: [:index | aBlock value: (self at: index)]! !

!BitField methodsFor: 'enumerating'!
findFirst: aBlock 
	| index |
	index := 1.
	self
		do: 
			[:each | 
			(aBlock value: each)
				ifTrue: [^index].
			index := index + 1].
	^0! !

!BitField methodsFor: 'enumerating'!
findLast: aBlock 
	| index |
	index := self size.
	self
		reverseDo: 
			[:each | 
			(aBlock value: each)
				ifTrue: [^index].
			index := index - 1].
	^0! !

!BitField methodsFor: 'enumerating'!
reverseDo: aBlock 
	self size
		to: 1
		by: -1
		do: [:index | aBlock value: (self at: index)]! !


!BitField methodsFor: 'tagging'!
addTag: tagObject at: anIndex 
	tags at: tagObject put: anIndex! !

!BitField methodsFor: 'tagging'!
removeTag: tagObject 
	^tags removeKey: tagObject ifAbsent: [nil]! !


!BitField methodsFor: 'printing'!
printOn: stream 
	| dictionary set n |
	dictionary := self reverseTags.
	stream nextPutAll: '{'.
	1 to: self size
		do: 
			[:index | 
			stream nextPutAll: index printString.
			set := dictionary at: index ifAbsent: [Set new].
			set isEmpty
				ifFalse: 
					[stream nextPutAll: '('.
					n := 0.
					set
						do: 
							[:each | 
							stream nextPutAll: each printString.
							(n := n + 1) = set size ifFalse: [stream nextPutAll: ',']].
					stream nextPutAll: ')'].
			stream nextPutAll: ':'.
			stream nextPutAll: (self at: index) printString.
			index = self size ifFalse: [stream space]].
	stream nextPutAll: '}'! !


!BitField methodsFor: 'private' stamp: 'nishis 4/12/98 07:35'!
associations: aCollection
	"by nishis, 1998/04/12 07:34"

	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!BitField methodsFor: 'private'!
privateAt: anIndex 
	| value |
	value := 1.
	anIndex - 1 timesRepeat: [value := value * 2].
	^value! !

!BitField methodsFor: 'private'!
privateSize: anInteger 
	size := anInteger asInteger max: 1.
	self allFalse.
	tags := Dictionary new: 1! !

!BitField methodsFor: 'private'!
privateTags: anIndex 
	^self reverseTags at: anIndex! !

!BitField methodsFor: 'private' stamp: 'nishis 4/12/98 07:34'!
reverseTags
	| dictionary set |
	dictionary := Dictionary new.
	(self associations: tags)
		do: 
			[:assoc | 
			set := dictionary at: assoc value ifAbsent: [Set new].
			set add: assoc key.
			dictionary at: assoc value put: set].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BitField class
	instanceVariableNames: ''!

!BitField class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!BitField class methodsFor: 'copyright'!
system
	^'Goodies'! !

!BitField class methodsFor: 'copyright'!
version
	^'003'! !


!BitField class methodsFor: 'instance creation'!
new
	^self new: 1! !

!BitField class methodsFor: 'instance creation'!
new: size 
	^(super new) privateSize: size; yourself! !


!BitField class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:34'!
save
	"BitField save."

	| fileName classCollection aStream timeStamp |
	fileName := 'BitField.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!BitField class methodsFor: 'saving'!
saveClasses
	"BitField saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*BitField*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!BitField class methodsFor: 'examples'!
example1
	"BitField example1."

	| bitField |
	bitField := BitField new: 20.
	bitField at: 1 put: true.
	bitField at: 3 put: true.
	bitField at: 5 put: true.
	bitField at: 7 put: true.
	bitField at: 9 put: true.
	bitField at: 20 put: true.
	Transcript cr; show: bitField printString.
	^bitField! !

!BitField class methodsFor: 'examples'!
example2
	"BitField example2."

	| bitField |
	bitField := BitField new: 5.
	bitField addTag: #first at: 1; addTag: '1st' at: 1.
	bitField addTag: #second at: 2; addTag: '2nd' at: 2.
	bitField addTag: #third at: 3; addTag: '3rd' at: 3.
	bitField addTag: #fourth at: 4; addTag: '4th' at: 4.
	bitField addTag: #fifth at: 5; addTag: '5th' at: 5.
	bitField tagAt: #first put: true.
	bitField tagAt: #third put: true.
	bitField tagAt: '5th' put: true.
	Transcript cr; show: bitField printString.
	^bitField! !
