'Goodies (11/18/2001 8:34:58 am)'.!


Object subclass: #FileNumbering
	instanceVariableNames: 'directory prefix postfix extension start step length '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Files'!
!FileNumbering commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
File Numbering
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
File Numbering
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 by AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/FileNum.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/FileNum.txt


Summary:

This goodies is to re-number for files in a directory you want.


Installing:

FileIn this goodies and makes a class "FileNumbering" in a 
category "Goodies-Files". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"FileNumbering" from your system, simply.


how to use:

See below,

    | fileNumbering |
    fileNumbering := FileNumbering directoryName: './jpegs'.
    fileNumbering prefixString: 'image'.
    fileNumbering postfixString: ''.
    fileNumbering extensionString: '.jpg'.
    fileNumbering startNumber: 1.
    fileNumbering stepNumber: 2.
    fileNumbering numberLength: 3.
    fileNumbering do.
    ^fileNumbering

The target is files in a directory named "./jpegs".  And the files 
are re-numbered below

    image001.jpg
    image003.jpg
    image005.jpg
    image007.jpg
    image009.jpg
    image011.jpg
        :
        :

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/FileNum.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/FileNum.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!FileNumbering methodsFor: 'accessing'!
directoryName
	^directory! !

!FileNumbering methodsFor: 'accessing' stamp: 'nishis 4/10/98 22:19'!
directoryName: directoryName 
	| aDirectory aDirectoryName onRootDirectoryBlock onCurrentDirectoryBlock |
	onRootDirectoryBlock := [:pathname | aDirectory := FileDirectory on: pathname].
	onCurrentDirectoryBlock := [:pathname | aDirectory := FileDirectory default directoryNamed: pathname].
	aDirectoryName := directoryName.
	(aDirectoryName last = FileDirectory pathNameDelimiter)
		ifTrue: [aDirectoryName := aDirectoryName truncateTo: (aDirectoryName size - 1)].
	(directoryName first = FileDirectory pathNameDelimiter) 
		ifTrue: [onRootDirectoryBlock value: aDirectoryName]
		ifFalse: 
			[(FileDirectory root isKindOf: DosFileDirectory) 
				ifTrue: 
					[(directoryName second = $:) 
						ifTrue: [onRootDirectoryBlock value: aDirectoryName]
						ifFalse: [onCurrentDirectoryBlock value: aDirectoryName]]
				ifFalse: 
					[onCurrentDirectoryBlock value: aDirectoryName]].
	(aDirectory containingDirectory directoryNames includes: aDirectory pathName asFileName)
		ifTrue: [directory := aDirectory pathName]
		"ifTrue: [directory := aDirectoryName asString]"
		ifFalse: [self warn: directoryName printString , ' does not exist.'.
			directory := nil]! !

!FileNumbering methodsFor: 'accessing'!
extensionString
	extension isNil ifTrue: [extension := String new].
	^extension! !

!FileNumbering methodsFor: 'accessing'!
extensionString: aString 
	extension := aString! !

!FileNumbering methodsFor: 'accessing'!
numberLength
	length isNil ifTrue: [length := 8].
	^length! !

!FileNumbering methodsFor: 'accessing'!
numberLength: aNumber 
	length := aNumber max: 1! !

!FileNumbering methodsFor: 'accessing'!
postfixString
	postfix isNil ifTrue: [postfix := String new].
	^postfix! !

!FileNumbering methodsFor: 'accessing'!
postfixString: aString 
	postfix := aString! !

!FileNumbering methodsFor: 'accessing'!
prefixString
	prefix isNil ifTrue: [prefix := String new].
	^prefix! !

!FileNumbering methodsFor: 'accessing'!
prefixString: aString
	prefix := aString! !

!FileNumbering methodsFor: 'accessing'!
startNumber
	start isNil ifTrue: [start := 0].
	^start! !

!FileNumbering methodsFor: 'accessing'!
startNumber: aNumber 
	start := aNumber max: 0! !

!FileNumbering methodsFor: 'accessing'!
stepNumber
	step isNil ifTrue: [step := 1].
	^step! !

!FileNumbering methodsFor: 'accessing'!
stepNumber: aNumber 
	step := aNumber max: 1! !


!FileNumbering methodsFor: 'numbering' stamp: 'nishis 4/6/98 14:01'!
check
	| aBag oldFilename newFilename errorCollection |
	Transcript cr; nextPutAll: 'checking ... '.
	Transcript endEntry.
	aBag := Bag new.
	self numbering
		do: 
			[:association | 
			oldFilename := association key asFileName.
			newFilename := association value asFileName.
			aBag add: oldFilename asString.
			aBag add: newFilename asString.
			Transcript cr; tab.
			Transcript nextPutAll: oldFilename asString printString.
			Transcript nextPutAll: ' -> '.
			Transcript nextPutAll: newFilename asString printString.
			Transcript endEntry].
	errorCollection := SortedCollection new.
	self value: aBag valuesAndCountsDo: [:aString :anInteger | anInteger > 1 ifTrue: [errorCollection add: aString]].
	errorCollection isEmpty
		ifTrue: [Transcript cr; nextPutAll: ' ... okay']
		ifFalse: 
			[errorCollection
				do: 
					[:aString | 
					Transcript cr; nextPutAll: 'ERROR: '; nextPutAll: aString.
					Transcript endEntry].
			Transcript cr; nextPutAll: ' ... error'].
	Transcript endEntry! !

!FileNumbering methodsFor: 'numbering' stamp: 'nishis 4/6/98 13:58'!
do
	| oldFilename newFilename |
	Transcript cr; nextPutAll: 'numbering ... '.
	self numbering
		do: 
			[:association | 
			oldFilename := association key asFileName.
			newFilename := association value asFileName.
			Transcript cr; tab.
			Transcript nextPutAll: oldFilename asString printString.
			Transcript nextPutAll: ' -> '.
			Transcript nextPutAll: newFilename asString printString.
			Transcript endEntry.
			(FileDirectory on: self directoryName) rename: oldFilename toBe: newFilename].
	Transcript cr; nextPutAll: ' ... done'.
	Transcript endEntry! !

!FileNumbering methodsFor: 'numbering' stamp: 'nishis 4/10/98 22:20'!
numbering
	| directoryName fileCollection aFilename numberingIndex aString newFilename renameCollection |
	self directoryName isNil ifTrue: [^OrderedCollection new].
	directoryName := self directoryName.
	directoryName last = FileDirectory pathNameDelimiter ifFalse: [directoryName := directoryName , (String with: FileDirectory pathNameDelimiter)].
	fileCollection := OrderedCollection new.
	"self directoryName asFilename directoryContents"
	fileCollection addAll: (FileDirectory on: self directoryName) fileNames.
	fileCollection := fileCollection asSortedCollection.
	renameCollection := OrderedCollection new: fileCollection size.
	numberingIndex := self startNumber.
	fileCollection
		do: 
			[:each | 
			aFilename := each asFileName.
			aString := numberingIndex printString.
			self numberLength - aString size timesRepeat: [aString := '0' , aString].
			aString := self prefixString , aString , self postfixString , self extensionString.
			newFilename := (directoryName , aString) "asFilename".
			renameCollection add: aFilename -> newFilename.
			numberingIndex := numberingIndex + self stepNumber].
	^renameCollection! !


!FileNumbering methodsFor: 'private' stamp: 'nishis 4/6/98 14:00'!
value: aBag valuesAndCountsDo: aBlock 
	| contents element |
	contents := aBag instVarNamed: 'contents'.
	contents 
		do: 
			[:index | ((element := contents at: index ifAbsent: [nil]) ~= nil)
				ifTrue: [aBlock value: element  key value: element value]]! !

!FileNumbering methodsFor: 'private' stamp: 'nishis 4/8/98 12:41'!
warn: queryString
	"FileNumbering new warn: ' does not exist.'."

	| menu choice |
	menu _ SelectionMenu selections: #('OK').
	[true] whileTrue: [
		choice _ menu startUpWithCaption: queryString.
		choice = 'OK' ifTrue: [^ true]]
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FileNumbering class
	instanceVariableNames: ''!

!FileNumbering class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!FileNumbering class methodsFor: 'copyright'!
system
	^'Goodies'! !

!FileNumbering class methodsFor: 'copyright'!
version
	^'003'! !


!FileNumbering class methodsFor: 'instance creation'!
directoryName: directoryName 
	^(super new) directoryName: directoryName; yourself! !


!FileNumbering class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:41'!
save
	"FileNumbering save."

	| fileName classCollection aStream timeStamp |
	fileName := 'FileNum.st'.
	classCollection := self saveClasses.
	aStream := FileStream fileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!FileNumbering class methodsFor: 'saving'!
saveClasses
	"FileNumbering saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*FileNumbering*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!FileNumbering class methodsFor: 'examples' stamp: 'nishis 4/10/98 22:11'!
example1
	"FileNumbering example1."

	| fileNumbering |
	fileNumbering := FileNumbering directoryName: 'zzz'.
	fileNumbering prefixString: 'image'.
	fileNumbering postfixString: 's'.
	fileNumbering extensionString: '.jpg'.
	fileNumbering startNumber: 1.
	fileNumbering stepNumber: 10.
	fileNumbering numberLength: 2.
	fileNumbering check.
	^fileNumbering! !

!FileNumbering class methodsFor: 'examples' stamp: 'nishis 4/10/98 22:11'!
example2
	"FileNumbering example2."

	| fileNumbering |
	fileNumbering := FileNumbering directoryName: 'zzz'.
	fileNumbering extensionString: '.jpg'.
	fileNumbering startNumber: 0.
	fileNumbering numberLength: 2.
	fileNumbering check.
	^fileNumbering! !

!FileNumbering class methodsFor: 'examples' stamp: 'nishis 4/10/98 22:11'!
example3
	"FileNumbering example3."

	| fileNumbering |
	fileNumbering := FileNumbering directoryName: 'zzz'.
	fileNumbering extensionString: '.jpg'.
	fileNumbering startNumber: 0.
	fileNumbering numberLength: 2.
	fileNumbering do.
	^fileNumbering! !
