'Goodies (11/18/2001 8:35:02 am)'.!


Object subclass: #MethodNodeEnumerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Support'!
!MethodNodeEnumerator commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
This is a simulation of ProgramNodeEnumerator.

To begin enumerating, must do first:
	yourInstance nodeDo: anMethodNode

Subclasses must implement below:
	doAssignment:variable:value:
	doBlock:arguments:statements:
	doBrace:elements:
	doCascade:receiver:messages:
	doLiteral:value: 
	doMessage:receiver:selector:arguments:
	doMethod:arguments:block:temporaries:
	doReturn:value:
	doTempVariable:name:
	doVariable:name:

see 
Atsushi AOKI, "Smalltalk Idioms", SRC, 1997, Tokyo, ISBN4-915778-81-9 C3055 P4500E.

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@nifty.ne.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!MethodNodeEnumerator methodsFor: 'initialize-release' stamp: 'nishis 6/26/1998 15:10'!
initialize
	^self! !


!MethodNodeEnumerator methodsFor: 'accessing' stamp: 'nishis 6/26/1998 15:18'!
name: aNode
	(aNode key isKindOf: Association) 
		ifTrue: [^aNode key key]
		ifFalse: [^aNode key]! !


!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/21/1998 09:39'!
doAssignment: aNode variable: variable value: value 
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:03'!
doBlock: aNode arguments: arguments statements: statements
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:04'!
doBrace: aNode elements: elements
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:04'!
doCascade: aNode receiver: receiver messages: messages
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/21/1998 09:40'!
doLiteral: aNode value: value 
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/30/1998 12:29'!
doMessage: aNode receiver: receiver selector: selector arguments: arguments 
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:04'!
doMethod: aNode arguments: arguments block: block temporaries: temporaries
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/30/1998 12:55'!
doParameter: aNode variable: var type: type
	"'Character cr asString' is used for cpmpatibility for 1.31."
	^self notify: thisContext selector, Character cr asString, 
		'aNode is an instance of ', aNode class name, ' ---> ', 
		Character cr asString, aNode printString! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:05'!
doReturn: aNode value: value
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/30/1998 12:56'!
doSequence: aNode temporaries: temps statements: stats
	"'Character cr asString' is used for cpmpatibility for 1.31."
	^self notify: thisContext selector, Character cr asString, 
		'aNode is an instance of ', aNode class name, ' ---> ', 
		Character cr asString, aNode printString! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/21/1998 09:40'!
doTempVariable: aNode name: nameString 
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 6/21/1998 09:40'!
doVariable: aNode name: nameString 
	^self subclassResponsibility! !

!MethodNodeEnumerator methodsFor: 'enumerating' stamp: 'nishis 7/9/1998 01:42'!
nodeDo: aNode
	"self debug: aNode."
	(aNode isMemberOf: MethodNode)
	 	ifTrue: 
			[^self privateDoMethod: aNode].
	(aNode isMemberOf: VariableNode)
	 	ifTrue: 
			[^self doVariable: aNode name: (self name: aNode)].
	(aNode isMemberOf: TempVariableNode)
	 	ifTrue: 
			[^self doTempVariable: aNode name: aNode key].
	(aNode isMemberOf: BlockNode)
	 	ifTrue: 
			[^self privateDoBlock: aNode].
	(aNode isMemberOf: AssignmentNode)
	 	ifTrue: 
			[^self doAssignment: aNode variable: aNode variable value: aNode value].
	(aNode isMemberOf: MessageNode) 
		ifTrue: 
			[^self privateDoMessage: aNode].
	(aNode isMemberOf: ReturnNode)
	 	ifTrue: 
			[^self privateDoReturn: aNode].
	(aNode isMemberOf: LiteralNode)
	 	ifTrue: 
			[^self doLiteral: aNode value: aNode literalValue].
	(aNode isMemberOf: CascadeNode)
	 	ifTrue: 
			[^self privateDoCascade: aNode].
	(aNode isMemberOf: BraceNode)
	 	ifTrue: 
			[^self privateDoBrace: aNode]
! !


!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/2/1998 22:11'!
privateDoBlock: aNode 
	| statements arguments |
	statements := aNode instVarNamed: #statements.
	arguments := aNode instVarNamed: #arguments.
	^self doBlock: aNode arguments: arguments statements: statements! !

!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/2/1998 22:12'!
privateDoBrace: aNode
	| elements |
	elements := aNode instVarNamed: #elements.
	^self doBrace: aNode elements: elements! !

!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/2/1998 22:12'!
privateDoCascade: aNode 
	| receiver messages |
	receiver := aNode instVarNamed: #receiver.
	messages := aNode instVarNamed: #messages.
	^self doCascade: aNode receiver: receiver messages: messages! !

!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/9/1998 01:35'!
privateDoMessage: aNode
	| selector |
	((selector := aNode selector) isKindOf: Symbol)
		ifTrue: [selector := Association key: selector value: selector].
	^self doMessage: aNode receiver: aNode receiver selector: selector arguments: aNode arguments! !

!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/2/1998 22:13'!
privateDoMethod: aNode
	| arguments block temporaries |
	arguments := aNode instVarNamed: #arguments.
	block := aNode instVarNamed: #block.
	temporaries := aNode instVarNamed: #temporaries.
	^self doMethod: aNode arguments: arguments block: block temporaries: temporaries! !

!MethodNodeEnumerator methodsFor: 'private enumerating' stamp: 'nishis 7/2/1998 22:10'!
privateDoReturn: aNode 
	| value |
	value := aNode instVarNamed: #expr.
	^self doReturn: aNode value: value! !


!MethodNodeEnumerator methodsFor: 'private' stamp: 'nishis 6/21/1998 09:38'!
debug: anObject 
	Transcript cr; show: anObject class name, ': ', anObject printString! !

!MethodNodeEnumerator methodsFor: 'private' stamp: 'nishis 6/21/1998 09:38'!
doNode: aNode
	^self nodeDo: aNode! !

!MethodNodeEnumerator methodsFor: 'private' stamp: 'nishis 6/26/1998 15:19'!
doNodes: nodeCollection
	^nodeCollection do: [:aNode | self doNode: aNode]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MethodNodeEnumerator class
	instanceVariableNames: ''!

!MethodNodeEnumerator class methodsFor: 'instance creation'!
new
	^super new initialize! !
