'Goodies (11/18/2001 8:35:02 am)'.!


Object subclass: #PrologScanner
	instanceVariableNames: 'source mark token tokenType typeTable endChar '
	classVariableNames: 'EndChar '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologScanner commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologScanner methodsFor: 'initialize-release'!
initScanner
	typeTable := PrologScannerTable scannerTable.
	endChar := EndChar! !

!PrologScanner methodsFor: 'initialize-release'!
on: inputStream 
	source := inputStream.
	mark := source position! !


!PrologScanner methodsFor: 'scanning'!
multiChar: type 
	self perform: type! !

!PrologScanner methodsFor: 'scanning'!
nextToken
	| char |
	mark := source position.
	char := self peekChar.
	tokenType := typeTable at: char asInteger.
	[tokenType == #xDelimiter]
		whileTrue: 
			[self nextChar.
			char := self peekChar.
			tokenType := typeTable at: char asInteger].
	(tokenType at: 1) = $x
		ifTrue:[self multiChar: tokenType]
		ifFalse:[self singleChar: tokenType].
	^token! !

!PrologScanner methodsFor: 'scanning'!
singleChar: type 
	self nextChar.
	token := type.
	tokenType == #leftBrace ifFalse: [^self].
	tokenType := #object.
	token := PrologObject readFrom: source! !

!PrologScanner methodsFor: 'scanning'!
unNextToken
	source position: mark! !

!PrologScanner methodsFor: 'scanning'!
xBinary
	Debugger
		openContext: thisContext
		label: 'Error'
		contents: 'Syntax error ' , source peek printString , '\' withCRs , source upToEnd! !

!PrologScanner methodsFor: 'scanning'!
xColon
	| char |
	source next.
	char := source peek.
	char = $-
		ifTrue: 
			[tokenType := #neck.
			self singleChar: tokenType]
		ifFalse: 
			[self unNextToken.
			tokenType := #symbol.
			token := PrologSymbol readFrom: source]! !

!PrologScanner methodsFor: 'scanning'!
xComment
	| char |
	[(char := self nextChar) = Character cr]
		whileFalse: [char == endChar
				ifTrue: 
					[tokenType := #eof.
					^self]].
	self nextToken! !

!PrologScanner methodsFor: 'scanning'!
xDigit
	tokenType := #number.
	token := Number readFrom: source! !

!PrologScanner methodsFor: 'scanning'!
xDollar
	self xBinary! !

!PrologScanner methodsFor: 'scanning'!
xDoubleQuote
	tokenType := #string.
	token := PrologString readFrom: source! !

!PrologScanner methodsFor: 'scanning'!
xSign
	| char sign |
	sign := self nextChar.
	char := self peekChar.
	char isDigit
		ifTrue: 
			[tokenType := #number.
			token := Number readFrom: source.
			sign == $- ifTrue: [token := token negated]]
		ifFalse: 
			[self unNextChar.
			tokenType := #symbol.
			token := PrologSymbol readFrom: source]! !

!PrologScanner methodsFor: 'scanning'!
xSingleQuote
	tokenType := #symbol.
	token := PrologSymbol readFrom: source! !

!PrologScanner methodsFor: 'scanning'!
xSymbol
	tokenType := #symbol.
	token := PrologSymbol readFrom: source! !

!PrologScanner methodsFor: 'scanning'!
xVariable
	tokenType := #variable.
	token := PrologVariable readFrom: source! !


!PrologScanner methodsFor: 'error handling' stamp: 'nishis 6/28/1998 05:59'!
error: labelString with: contentsString
	"(PrologScanner new) error: 'error!!' with: 'show must go on'."

	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !


!PrologScanner methodsFor: 'private' stamp: 'nishis 4/21/98 02:27'!
nextChar
	| char |
	char := source next.
	char = Character linefeed ifTrue: [char := Character cr].
	char = Character cr
		ifTrue: 
			[source peek =  Character linefeed ifTrue: [source next].
			char := Character cr].
	char == nil ifTrue: [char := endChar].
	^char! !

!PrologScanner methodsFor: 'private' stamp: 'nishis 4/21/98 02:27'!
peekChar
	| char |
	char := source peek.
	char = Character linefeed ifTrue: [char := Character cr].
	char = Character cr ifTrue: [char := Character cr].
	char == nil ifTrue: [char := endChar].
	^char! !

!PrologScanner methodsFor: 'private'!
unNextChar
	source skip: -1! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologScanner class
	instanceVariableNames: ''!

!PrologScanner class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologScanner class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologScanner class methodsFor: 'copyright'!
version
	^'003'! !


!PrologScanner class methodsFor: 'class initialization'!
initialize
	"PrologScanner initialize"

	EndChar := $^! !


!PrologScanner class methodsFor: 'instance creation'!
new
	^super new initScanner! !


PrologScanner initialize!
