'Goodies (11/18/2001 8:35:11 am)'.!


PluggableStringHolderModel subclass: #PrologInterpreter
	instanceVariableNames: 'systemPredicates userPredicates status definition question questionEnv clause clauseEnv queue queueEnv envCounter valueEnv unbindList cutBack backTrack resolveAction definitionStack tracePredicates traceCounter textValue textCollector verbose listValue predicate '
	classVariableNames: 'EditorMenu PredEditMenu PredListMenu QuestionMenu SystemPredicates '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologInterpreter commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Prolog
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Prolog.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Prolog.txt
!


!PrologInterpreter methodsFor: 'initialize-release' stamp: 'nishis 4/25/98 06:02'!
initialize
	super initialize.
	systemPredicates := Dictionary new.
	userPredicates := Dictionary new.
	tracePredicates := Dictionary new.
	textCollector := TranscriptStream new.
	verbose := false.
	self makeSystemPredicates! !


!PrologInterpreter methodsFor: 'public accessing'!
confirm: messageString 
	^super confirm: messageString! !

!PrologInterpreter methodsFor: 'public accessing'!
refute: stringOrStream
	^self refute: stringOrStream action: [:answer | ^answer]! !

!PrologInterpreter methodsFor: 'public accessing'!
refute: stringOrStream action: aBlock 
	| stream |
	(stringOrStream isKindOf: Stream)
		ifTrue: [stream := ReadStream on: stringOrStream contents]
		ifFalse: [stream := ReadStream on: stringOrStream].
	^self consult: stream action: aBlock! !


!PrologInterpreter methodsFor: 'accessing'!
textCollector
	^textCollector! !

!PrologInterpreter methodsFor: 'accessing'!
textCollector: aTextCollector 
	textCollector := aTextCollector! !


!PrologInterpreter methodsFor: 'copying' stamp: 'nishis 5/3/98 06:49'!
shallowCopy
	super shallowCopy.
	textValue := nil.
	listValue := nil.
	predicate := nil! !


!PrologInterpreter methodsFor: 'resolution'!
resolve: goal 
	^self resolve: goal action: nil! !

!PrologInterpreter methodsFor: 'resolution'!
resolve: goal action: actionBlock
	| result |
	question := clause := goal.
	actionBlock == nil
		ifTrue: [resolveAction := [:dict | self outputVariables: dict]]
		ifFalse: [resolveAction := actionBlock].
	Cursor execute
		showWhile: 
			[self resolveInitialize.
			self resolveLoop.
			result := self resolveTerminate].
	^result! !

!PrologInterpreter methodsFor: 'resolution'!
resolveInitialize
	status := #loop.
	envCounter := 0.
	questionEnv := clauseEnv := self nullEnv.
	queue := queueEnv := valueEnv := nil.
	unbindList := cutBack := backTrack := nil.
	definitionStack := nil.
	traceCounter := 0! !

!PrologInterpreter methodsFor: 'resolution'!
resolveLoop
	| totalTime time answer |
	totalTime := 0.
	time := Time millisecondClockValue.
	[true]
		whileTrue: 
			[status == #loop ifTrue: [self loop].
			status == #next ifTrue: [self next].
			status == #back ifTrue: [self back].
			status == #succ
				ifTrue: 
					[time := Time millisecondClockValue - time.
					self outputTime: (totalTime := totalTime + time).
					answer := self collectVariables.
					answer isEmpty ifTrue: [^true].
					(resolveAction value: answer)
						ifTrue: [^true]
						ifFalse: 
							[status := #back.
							time := Time millisecondClockValue]].
			status == #fail
				ifTrue: 
					[time := Time millisecondClockValue - time.
					self outputTime: (totalTime := totalTime + time).
					^false]]! !

!PrologInterpreter methodsFor: 'resolution'!
resolveTerminate
	Cursor wait
		showWhile: 
			[self deallocateEnv: questionEnv].
	status == #succ
		ifTrue: 
			[textCollector show: 'yes'.
			textCollector cr.
			^true].
	status == #fail
		ifTrue: 
			[textCollector show: 'no'.
			textCollector cr.
			^false].
	self error: 'Unexpected status'! !


!PrologInterpreter methodsFor: 'resolve modules'!
back
	| array |
	backTrack == nil
		ifTrue: 
			[status := #fail.
			^self].
	array := backTrack car.
	backTrack := backTrack cdr.
	clause := array at: 1.
	clauseEnv := array at: 2.
	queue := array at: 3.
	queueEnv := array at: 4.
	cutBack := array at: 5.
	definition := array at: 6.
	array := array at: 7.
	self unbindFrom: unbindList to: array.
	unbindList := array.
	status := #next! !

!PrologInterpreter methodsFor: 'resolve modules'!
loop
	| structure functor |
	clause == nil
		ifTrue: 
			[queue == nil
				ifTrue: 
					[status := #succ.
					^self].
			clause := queue car.
			clauseEnv := queueEnv car.
			queue := queue cdr.
			queueEnv := queueEnv cdr.
			cutBack := cutBack cdr.
			status := #loop.
			^self].
	structure := clause car.
	structure consp
		ifFalse: 
			[structure := PrologStructure functor: structure terms: nil.
			clause car: structure].
	functor := structure car.
	functor isPrologVariable
		ifTrue: 
			[self call: clause car.
			^self].
	functor isBuiltInPredicate
		ifTrue: 
			[self builtInPredicate: functor.
			^self].
	definition := userPredicates at: functor ifAbsent: [systemPredicates at: functor
					ifAbsent: 
						[status := #back.
						^self]].
	status := #next! !

!PrologInterpreter methodsFor: 'resolve modules'!
next
	| definitionEnv saveBackTrack array |
	definitionEnv := self nullEnv.
	definition cdr == nil
		ifTrue: 
			[(self
				unify: clause car cdr
				env: clauseEnv
				and: definition car car cdr
				env: definitionEnv)
				ifFalse: 
					[status := #back.
					^self].
			queue := clause cdr cons: queue.
			queueEnv := clauseEnv cons: queueEnv.
			clause := definition car cdr.
			clauseEnv := definitionEnv.
			cutBack := backTrack cons: cutBack.
			status := #loop.
			^self].
	saveBackTrack := backTrack.
	array := Array new: 7.
	array at: 1 put: clause.
	array at: 2 put: clauseEnv.
	array at: 3 put: queue.
	array at: 4 put: queueEnv.
	array at: 5 put: cutBack.
	array at: 6 put: definition cdr.
	array at: 7 put: unbindList.
	backTrack := array cons: saveBackTrack.
	(self
		unify: clause car cdr
		env: clauseEnv
		and: definition car car cdr
		env: definitionEnv)
		ifFalse: 
			[status := #back.
			^self].
	queue := clause cdr cons: queue.
	queueEnv := clauseEnv cons: queueEnv.
	clause := definition car cdr.
	clauseEnv := definitionEnv.
	cutBack := saveBackTrack cons: cutBack.
	status := #loop! !


!PrologInterpreter methodsFor: 'unification'!
unify: x env: xEnv and: y env: yEnv 
	| xx yy assoc |
	xx := x.
	yy := y.
	[true]
		whileTrue: 
			[xEnv == yEnv ifTrue: [x = y ifTrue: [^true]].
			xx isPrologVariable ifTrue: [(assoc := self binding: xx env: xEnv) ~~ nil
					ifTrue: 
						[valueEnv := xEnv.
						assoc := assoc cdr.
						xx := self fetchValue: assoc car env: assoc cdr.
						^self
							unify: xx
							env: valueEnv
							and: yy
							env: yEnv]
					ifFalse: 
						[yy isPrologVariable ifTrue: [(assoc := self binding: yy env: yEnv) ~~ nil
								ifTrue: 
									[valueEnv := yEnv.
									assoc := assoc cdr.
									yy := self fetchValue: assoc car env: assoc cdr.
									^self
										unify: xx
										env: xEnv
										and: yy
										env: valueEnv]].
						self
							bind: xx
							env: xEnv
							and: yy
							env: yEnv.
						^true]].
			yy isPrologVariable
				ifTrue: 
					[(assoc := self binding: yy env: yEnv) ~~ nil
						ifTrue: 
							[valueEnv := yEnv.
							assoc := assoc cdr.
							yy := self fetchValue: assoc car env: assoc cdr.
							^self
								unify: xx
								env: xEnv
								and: yy
								env: valueEnv].
					self
						bind: yy
						env: yEnv
						and: xx
						env: xEnv.
					^true].
			xx consp ifFalse: [^xx = yy].
			yy consp ifFalse: [^yy = xx].
			(self
				unify: xx car
				env: xEnv
				and: yy car
				env: yEnv)
				ifFalse: [^false].
			xx := xx cdr.
			yy := yy cdr]! !


!PrologInterpreter methodsFor: 'binding and unbinding'!
bind: x env: xEnv and: y env: yEnv 
	| list |
	list := (self fetchValue: y env: yEnv) cons: valueEnv.
	list := (x cons: list) cons: xEnv cdr. 
	xEnv cdr: list. 
	unbindList := xEnv cons: unbindList! !

!PrologInterpreter methodsFor: 'binding and unbinding'!
binding: x env: xEnv 
	| assocList |
	assocList := xEnv cdr.
	assocList == nil ifTrue: [^nil].
	^assocList assoc: x! !

!PrologInterpreter methodsFor: 'binding and unbinding'!
fetchValue: x env: xEnv 
	| xx xxEnv assoc |
	xx := x.
	xxEnv := xEnv.
	[true]
		whileTrue: 
			[valueEnv := xxEnv.
			xx isPrologVariable
				ifTrue: 
					[assoc := self binding: xx env: xxEnv.
					assoc == nil ifTrue: [^xx].
					assoc := assoc cdr.
					xx := assoc car.
					xxEnv := assoc cdr]
				ifFalse: [^xx]]! !

!PrologInterpreter methodsFor: 'binding and unbinding'!
noValue: x env: xEnv 
	| assoc |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^true].
			assoc := assoc cdr.
			^self noValue: assoc car env: assoc cdr].
	^false! !

!PrologInterpreter methodsFor: 'binding and unbinding'!
nullEnv
	envCounter := envCounter + 1.
	^envCounter cons: nil! !

!PrologInterpreter methodsFor: 'binding and unbinding'!
unbindFrom: start to: end 
	| list env assocList |
	list := start.
	[list ~~ end]
		whileTrue: 
			[env := list car.
			assocList := env cdr.
			assocList car cdr cdr: nil.
			env cdr: assocList cdr.
			list := list cdr]! !


!PrologInterpreter methodsFor: 'representation'!
collectVariables
	| dict | 
	dict := Dictionary new.
	self collectVariables: question to: dict.
	^dict! !

!PrologInterpreter methodsFor: 'representation'!
collectVariables: x to: dict
	| key value |  
	(x isPrologVariable and: [(x at: 1) ~= $~])
		ifTrue:
			[key := String fromString: x printPrologString.
			(dict at: key ifAbsent: []) ~~ nil
				ifTrue: [^self]
				ifFalse: 
					[value := self represent: x env: questionEnv.
					dict at: key put: value]].
	(x consp)
		ifFalse: [^self].
	self collectVariables: x car to: dict.
	self collectVariables: x cdr to: dict! !

!PrologInterpreter methodsFor: 'representation'!
expression: x env: xEnv 
	| assoc a d |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^x].
			assoc := assoc cdr.
			^self expression: assoc car env: assoc cdr].
	(x consp) ifFalse: [^x].
	a := self expression: x car env: xEnv.
	d := self expression: x cdr env: xEnv.
	^x class car: a cdr: d! !

!PrologInterpreter methodsFor: 'representation'!
represent: x env: xEnv 
	| assoc a d |
	x isPrologVariable
		ifTrue: 
			[assoc := self binding: x env: xEnv.
			assoc == nil ifTrue: [^self variableRepresent: x env: xEnv].
			assoc := assoc cdr.
			^self represent: assoc car env: assoc cdr].
	(x consp) ifFalse: [^x].
	a := self represent: x car env: xEnv.
	d := self represent: x cdr env: xEnv.
	^x class car: a cdr: d! !

!PrologInterpreter methodsFor: 'representation'!
variableRepresent: x env: xEnv 
	^PrologVariable install: x string , xEnv car printString! !


!PrologInterpreter methodsFor: 'outputting' stamp: 'nishis 4/25/98 07:08'!
outputAnswer: dict 
	| anArray string assoc associations |
	associations := OrderedCollection new.
	dict associationsDo: [:association | associations add: association].
	anArray := associations asSortedCollection.
	1 to: anArray size do: [:i | 
		assoc := anArray at: i.
		i = 1
			ifTrue: [string := '']
			ifFalse: [string := ',\' withCRs].
		string := string , assoc key.
		string := string , ' = '.
		string := string , assoc value printPrologString.
		string := string , ' '.
		textCollector show: string]! !

!PrologInterpreter methodsFor: 'outputting'!
outputTime: msec 
	| goal string |
	verbose
		ifTrue: 
			[goal := envCounter - 1.
			string := '<'.
			string := string , msec printString , ' milliseconds, '.
			string := string , goal printString , ' goals'.
			string := string , '>\' withCRs.
			textCollector show: string asText]! !

!PrologInterpreter methodsFor: 'outputting'!
outputVariables: aDictionary
	| bool |
	self outputAnswer: aDictionary.
	bool := self confirm: 'All right ?'.
	bool
		ifTrue: [textCollector cr]
		ifFalse: [textCollector show: ';\' withCRs].
	^bool! !


!PrologInterpreter methodsFor: 'kernel predicates'!
builtInCut
	backTrack := cutBack car.
	clause := clause cdr.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates'!
builtInFail
	status := #back! !

!PrologInterpreter methodsFor: 'kernel predicates'!
builtInPredicate: functor 
	functor isPrologCut ifTrue: [^self builtInCut].
	functor isPrologTrue ifTrue: [^self builtInTrue].
	functor isPrologFail ifTrue: [^self builtInFail].
	functor isPrologSend ifTrue: [^self builtInSend].
	functor isPrologVar ifTrue: [^self builtInVar].
	self error: 'Unexpected built-in predicate'! !

!PrologInterpreter methodsFor: 'kernel predicates'!
builtInSend
	| list receiverSymbol selectorSymbol argumentList unifyTerm result |
	list := self expression: clause car cdr env: clauseEnv.
	receiverSymbol := list car.
	list := list cdr.
	selectorSymbol := list car.
	list := list cdr.
	argumentList := list car.
	list := list cdr.
	list == nil
		ifTrue: [unifyTerm := nil]
		ifFalse: [list cdr == nil
				ifTrue: [unifyTerm := clause car cdr nth: 4]
				ifFalse: 
					[status := #back.
					^self]].
	result := self
				receiver: receiverSymbol
				selector: selectorSymbol
				arguments: argumentList.
	result = PrologSymbol cut
		ifTrue: 
			[self builtInCut.
			status := #back.
			^self].
	unifyTerm isNil
		ifTrue: 
			[result = false ifFalse: [result := true].
			result
				ifTrue: 
					[clause := clause cdr.
					status := #loop.
					^self]
				ifFalse: 
					[status := #back.
					^self]]
		ifFalse: [(self
				unify: unifyTerm
				env: clauseEnv
				and: result
				env: self nullEnv)
				ifTrue: 
					[clause := clause cdr.
					status := #loop.
					^self]
				ifFalse: 
					[status := #back.
					^self]].
	^self! !

!PrologInterpreter methodsFor: 'kernel predicates'!
builtInTrue
	clause := clause cdr.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates'!
builtInVar
	| var |
	var := clause car cdr car.
	(self noValue: var env: clauseEnv)
		ifTrue: 
			[clause := clause cdr.
			status := #loop]
		ifFalse: [status := #back]! !

!PrologInterpreter methodsFor: 'kernel predicates'!
call: aPrologStructure 
	| structure functor |
	aPrologStructure cdr == nil
		ifTrue: 
			[self callVariable: aPrologStructure car.
			^self].
	structure := self expression: aPrologStructure env: clauseEnv.
	(self
		unify: aPrologStructure
		env: clauseEnv
		and: structure
		env: clauseEnv)
		ifFalse: [self error: 'Unexpected unify structure'].
	functor := structure car.
	functor isPrologVariable
		ifTrue: 
			[status := #back.
			^self].
	clause := clause cdr.
	clause := structure cons: clause.
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates'!
callVariable: aPrologVariable 
	| horn functor |
	horn := self expression: aPrologVariable env: clauseEnv.
	(self
		unify: aPrologVariable
		env: clauseEnv
		and: horn
		env: clauseEnv)
		ifFalse: [self error: 'Unexpected unify horn clause'].
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	functor isPrologVariable
		ifTrue: 
			[status := #back.
			^self].
	clause := clause cdr.
	horn := horn reverse.
	[horn consp]
		whileTrue: 
			[clause := horn car cons: clause.
			horn := horn cdr].
	status := #loop! !

!PrologInterpreter methodsFor: 'kernel predicates'!
receiver: receiverSymbol selector: selectorSymbol arguments: argumentList 
	| receiver size selector arguments list result index |
	((receiverSymbol isKindOf: PrologSymbol)
		and: [receiverSymbol isPrologSelf])
		ifTrue: [receiver := self]
		ifFalse: [receiver := receiverSymbol].
	(receiver isKindOf: PrologObject)
		ifTrue: [receiver := receiver object].
	size := selectorSymbol size.
	selector := String new: size.
	1 to: size do: [:i | selector at: i put: (selectorSymbol at: i)].
	selector := selector asSymbol.
	list := argumentList.
	list == nil
		ifTrue: 
			[arguments := Array new.
			result := receiver perform: selector]
		ifFalse: 
			[size := list length.
			arguments := Array new: size.
			1 to: size
				do: 
					[:i | 
					arguments at: i put: ((list car isKindOf: PrologObject)
							ifTrue: [list car object]
							ifFalse: [list car]).
					list := list cdr].
			result := receiver perform: selector withArguments: arguments].
	((result = true or: [result = false])
		or: [result isPrologEntity])
		ifTrue: [result := result yourself]
		ifFalse: 
			[list := PrologList car: receiverSymbol cdr: argumentList.
			index := (Array with: receiver)
						, arguments findFirst: [:each | each = result].
			index = 0
				ifTrue: [result := PrologObject source: result printString object: result]
				ifFalse: [result := list nth: index]].
	^result! !


!PrologInterpreter methodsFor: 'system predicates'!
asserta: aPrologClause 
	| horn def functor |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [nil].
	def == nil
		ifTrue: 
			[def := PrologDefinition fromList: (horn cons: nil).
			userPredicates at: functor put: def]
		ifFalse: 
			[def := PrologDefinition fromList: (horn cons: def).
			userPredicates at: functor put: def].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
assertz: aPrologClause 
	| horn def functor |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [nil].
	def == nil
		ifTrue: 
			[def := PrologDefinition fromList: (horn cons: nil).
			userPredicates at: functor put: def]
		ifFalse: [def nconc: (PrologDefinition fromList: (horn cons: nil))].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
clause: aPrologClause 
	| count horn def result |
	count := 0.
	horn := aPrologClause.
	horn consp
		ifFalse: 
			[horn := PrologStructure functor: horn terms: nil.
			count := count + 1].
	horn car consp
		ifFalse: 
			[horn := PrologClause head: horn body: nil.
			count := count + 1].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	def := definitionStack car.
	[def consp]
		whileTrue: [(self
				unify: horn
				env: self nullEnv
				and: def car
				env: self nullEnv)
				ifTrue: 
					[result := def car.
					count timesRepeat: [result := result car].
					def := def cdr.
					definitionStack car: def.
					^result]
				ifFalse: 
					[def := def cdr.
					definitionStack car: def]].
	definitionStack := definitionStack cdr.
	^PrologSymbol cut! !

!PrologInterpreter methodsFor: 'system predicates'!
clear
	textCollector clear.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
consult
	| aModel |
	aModel := self copy.
	aModel perform: #consultingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 6/11/1998 22:43'!
consultFile: fileName 
	| aFileStream |
	(fileName respondsTo: #asString)
		ifFalse: [^false].
	(FileStream concreteStream isAFileNamed: fileName) 
		ifTrue: 
			[textCollector show: '<consult from ' , fileName asString , '>\' withCRs.
			aFileStream := FileStream oldFileNamed: fileName.
			self consult: aFileStream action: nil.
			aFileStream close.
			^true]
		ifFalse: [^false]! !

!PrologInterpreter methodsFor: 'system predicates'!
dotp: x 
	^x consp! !

!PrologInterpreter methodsFor: 'system predicates'!
double: x
	^x isKindOf: Float! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
editing
	| aModel |
	aModel := self copy.
	aModel perform: #editingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
float: x
	^x isKindOf: Float! !

!PrologInterpreter methodsFor: 'system predicates'!
fraction: x
	^x isKindOf: Fraction! !

!PrologInterpreter methodsFor: 'system predicates'!
functorArityOf: aPrologStructure 
	aPrologStructure isNil ifTrue: [^nil cons: 0].
	(self number: aPrologStructure)
		ifTrue: [^aPrologStructure cons: 0].
	(aPrologStructure respondsTo: #functor)
		ifFalse: [^nil].
	^aPrologStructure functor cons: aPrologStructure arity! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/21/98 03:21'!
gc
	Transcript cr; show: 'garbage collecting: ', (Smalltalk garbageCollect) asString, ' bytes are available.'.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
integer: x
	^x isKindOf: Integer! !

!PrologInterpreter methodsFor: 'system predicates'!
length: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^0].
	^aPrologDotPair length! !

!PrologInterpreter methodsFor: 'system predicates'!
list: x 
	x == nil ifTrue: [^true].
	^self dotp: x! !

!PrologInterpreter methodsFor: 'system predicates'!
listPrint: aPrologDotPair 
	| list |
	aPrologDotPair consp ifFalse: [^false].
	list := aPrologDotPair.
	[list consp]
		whileTrue: 
			[textCollector show: list car printPrologString , ' '.
			list := list cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:21'!
listing
	| aModel |
	aModel := self copy.
	aModel perform: #listingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
nl
	textCollector cr.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
nospy: aPrologSymbol 
	| def |
	def := tracePredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	userPredicates at: aPrologSymbol put: def.
	tracePredicates removeKey: aPrologSymbol.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
notrace
	userPredicates associationsDo: [:assoc | self nospy: assoc key].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
number: x
	^x isKindOf: Number! !

!PrologInterpreter methodsFor: 'system predicates'!
read
	^self read: 'Type prolog expression followed by carriage return.'! !

!PrologInterpreter methodsFor: 'system predicates'!
read: aMessage 
	| parser stream answer theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: String new.
	answer := FillInTheBlank request: aMessage initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	parser := PrologParser new.
	stream := ReadStream on: answer asString.
	parser init: stream ifFail: [:errorMessage | ^self error: errorMessage].
	^parser scanExpression! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 4/27/98 05:22'!
reconsult
	| aModel |
	aModel := self copy.
	aModel perform: #reconsultingInterface.
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 6/28/1998 05:17'!
reconsultFile: fileName 
	| aFileStream |
	(fileName respondsTo: #asString)
		ifFalse: [^false].
"	aFilename := Filename named: fileName asString.
	aFilename exists
"
	(FileStream concreteStream isAFileNamed: fileName) 
		ifTrue: 
			[textCollector show: '<reconsult from ' , fileName asString , '>\' withCRs.
			aFileStream := FileStream oldFileNamed: fileName.
"			aFileStream := aFilename readStream."
			self reconsult: aFileStream action: nil.
			aFileStream close.
			^true]
		ifFalse: [^false]! !

!PrologInterpreter methodsFor: 'system predicates'!
remove
	userPredicates keys do: 
		[:aPrologSymbol | 
		userPredicates removeKey: aPrologSymbol ifAbsent: [].
		tracePredicates removeKey: aPrologSymbol ifAbsent: []].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
remove: aPrologSymbol
	userPredicates removeKey: aPrologSymbol ifAbsent: [^false].
	tracePredicates removeKey: aPrologSymbol ifAbsent: [].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
retract: aPrologClause 
	| count horn def functor prev result |
	count := 0.
	horn := aPrologClause.
	horn consp
		ifFalse: 
			[horn := PrologStructure functor: horn terms: nil.
			count := count + 1].
	horn car consp
		ifFalse: 
			[horn := PrologClause head: horn body: nil.
			count := count + 1].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	prev := def := userPredicates at: functor ifAbsent: [^PrologSymbol cut].
	[def consp]
		whileTrue: [(self
				unify: horn
				env: self nullEnv
				and: def car
				env: self nullEnv)
				ifTrue: 
					[result := def car.
					count timesRepeat: [result := result car].
					prev == def
						ifTrue: 
							[def cdr isNil
								ifTrue: [userPredicates removeKey: functor ifAbsent: [nil]]
								ifFalse: [userPredicates at: functor put: def cdr].
							^result]
						ifFalse: 
							[prev cdr: def cdr.
							^result]]
				ifFalse: 
					[prev := def.
					def := def cdr]].
	^PrologSymbol cut! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 07:24'!
saving
	| fileName theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	fileName := FillInTheBlank request: 'Please type a name for saving file.' initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	(fileName isNil or: [fileName isEmpty])
		ifTrue: [^false].
	Cursor write showWhile: [self saveOn: fileName asString].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 07:24'!
saving: aPrologSymbol 
	| def fileName theClipboardText |
	def := tracePredicates at: aPrologSymbol ifAbsent: [userPredicates at: aPrologSymbol ifAbsent: []].
	def == nil ifTrue: [^false].
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	fileName := FillInTheBlank request: 'Please type a name for saving file.' initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	(fileName isNil or: [fileName isEmpty])
		ifTrue: [^false].
	self saveOn: fileName predicateName: aPrologSymbol.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
spy: aPrologSymbol 
	| def reverseClone tracedef |
	def := userPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	(tracePredicates at: aPrologSymbol ifAbsent: [nil]) isNil ifFalse: [^true].
	tracePredicates at: aPrologSymbol put: def.
	reverseClone := nil.
	[def consp]
		whileTrue: 
			[reverseClone := def car cons: reverseClone.
			def := def cdr].
	tracedef := nil.
	[reverseClone consp]
		whileTrue: 
			[tracedef := (self traceFailClause: reverseClone car car)
						cons: tracedef.
			tracedef := (self traceExitClause: reverseClone car)
						cons: tracedef.
			reverseClone cdr consp
				ifTrue: [tracedef := (self traceRedoClause: reverseClone car car)
								cons: tracedef]
				ifFalse: [tracedef := (self traceCallClause: reverseClone car car)
								cons: tracedef].
			reverseClone := reverseClone cdr].
	userPredicates at: aPrologSymbol put: (PrologDefinition fromList: tracedef).
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
strToSym: listOrString 
	| stream string token s |
	listOrString consp
		ifTrue: 
			[s := WriteStream on: (String new: 16).
			listOrString do: [:char | s nextPut: (Character value: char)].
			string := s contents]
		ifFalse: [string := listOrString string].
	stream := ReadStream on: string.
	token := (PrologScanner new on: stream) nextToken.
	((self number: token)
		and: [stream atEnd])
		ifTrue: [^token]
		ifFalse: [string = '[]'
				ifTrue: [^nil]
				ifFalse: [^PrologSymbol install: string]]! !

!PrologInterpreter methodsFor: 'system predicates'!
string: x
	^x class == PrologString! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 6/28/1998 06:25'!
symToList: numOrSym 
	| pstring |
	pstring := self symToStr: numOrSym.
	^PrologList list: pstring string asByteArray! !

!PrologInterpreter methodsFor: 'system predicates'!
symToStr: numOrSym 
	numOrSym isNil ifTrue: [^PrologString fromString: '[]'].
	(self number: numOrSym)
		ifTrue: [^PrologString fromString: numOrSym printString].
	^PrologString fromString: numOrSym string! !

!PrologInterpreter methodsFor: 'system predicates'!
symbol: x
	^x class == PrologSymbol! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:09'!
systemListing
	| predicateName |
	(self associations: systemPredicates) asSortedCollection
		do: 
			[:assoc | 
			predicateName := assoc key.
			((predicateName respondsTo: #asString)
				and: [predicateName string isEmpty not and: [predicateName string first = $~]])
				ifFalse: [self systemListing: predicateName]].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
systemListing: aPrologSymbol
	| def |
	def := systemPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	[def consp]
			whileTrue: 
				[textCollector show: def car prettyPrintPrologString , '\' withCRs.
				def := def cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
systemPredicates
	| collection list |
	collection := (self associations: systemPredicates) asSortedCollection.
	list := nil.
	collection reverseDo: [:each | ((each key respondsTo: #asString)
			and: [each key string isEmpty not and: [each key string first = $~]])
			ifTrue: ['not adding: invisible predicate' yourself]
			ifFalse: [list := each key cons: list]].
	^list! !

!PrologInterpreter methodsFor: 'system predicates'!
tab: aNumber 
	| spaces |
	(aNumber isKindOf: Number)
		ifFalse: [^false].
	spaces := String new.
	aNumber asInteger timesRepeat: [spaces := spaces , ' '].
	textCollector show: spaces.
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
trace
	userPredicates associationsDo: [:assoc | self spy: assoc key].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
univ: aPrologList 
	| termv listv termValue termEnv listVal listEnv functor functorEnv terms newterms newStruct car t list |
	termv := PrologVariable install: aPrologList car string.
	listv := PrologVariable install: aPrologList cdr string.
	termValue := self fetchValue: termv env: clauseEnv.
	termEnv := valueEnv.
	listVal := self fetchValue: listv env: clauseEnv.
	listEnv := valueEnv.
	termValue isPrologVariable
		ifTrue: 
			["construct a term from fixed length list."
			listVal isPrologVariable ifTrue: [^false].
			listVal consp ifFalse: [^false].
			functor := self fetchValue: listVal car env: listEnv.
			functorEnv := valueEnv.
			terms := self fetchValue: listVal cdr env: listEnv.
			listEnv := valueEnv.
			(self number: functor)
				ifTrue: 
					[terms isNil ifFalse: [^false].
					self
						bind: termValue
						env: termEnv
						and: functor
						env: listEnv.
					^true].
			functor consp ifTrue: ["It's a structure or a list"
				^false].
			terms isNil
				ifTrue: 
					[self
						bind: termValue
						env: termEnv
						and: functor
						env: functorEnv.
					^true].
			terms consp ifFalse: ["Not a list, but an illegal dot pair."
				^false].
			newterms := nil.
			[terms isNil]
				whileFalse: 
					[car := terms car.
					terms := self fetchValue: terms cdr env: listEnv.
					terms isPrologVariable ifTrue: ["The length of the list has not been fixed yet."
						^false].
					t := PrologTerms car: car cdr: nil.
					newterms isNil
						ifTrue: [newterms := t]
						ifFalse: [newterms := newterms nconc: t]].
			newStruct := PrologStructure functor: functor terms: newterms.
			^self
				unify: termValue
				env: termEnv
				and: newStruct
				env: listEnv]
		ifFalse: 
			["disasemble a term into a list"
			termValue consp
				ifTrue: ["It's a list or a structure."
					list := termValue structureList]
				ifFalse: ["primitive data like symbol, number, nil, or string."
					list := termValue cons: nil].
			^self
				unify: list
				env: termEnv
				and: listVal
				env: listEnv]! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
userListing
	| predicateName |
	((self associations: userPredicates) asSortedCollection)
		do: 
			[:assoc | 
			predicateName := assoc key.
			self userListing: predicateName].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
userListing: aPrologSymbol 
	| def |
	def := userPredicates at: aPrologSymbol ifAbsent: [nil].
	def == nil ifTrue: [^false].
	[def consp]
		whileTrue: 
			[textCollector show: def car prettyPrintPrologString , '\' withCRs.
			def := def cdr].
	^true! !

!PrologInterpreter methodsFor: 'system predicates' stamp: 'nishis 5/3/98 08:08'!
userPredicates
	| collection list |
	collection := (self associations: userPredicates) asSortedCollection.
	list := nil.
	collection reverseDo: [:each | ((each key respondsTo: #string)
			and: [each key string isEmpty not and: [each key string first = $~]])
			ifTrue: ['not adding: invisible predicate' yourself]
			ifFalse: [list := each key cons: list]].
	^list! !

!PrologInterpreter methodsFor: 'system predicates'!
verbose: aPrologSymbol 
	aPrologSymbol isPrologTrue
		ifTrue: [verbose := true]
		ifFalse: [verbose := false].
	^true! !

!PrologInterpreter methodsFor: 'system predicates'!
write: anObject 
	(anObject respondsTo: #asString)
		ifTrue: [textCollector show: anObject asString]
		ifFalse: [textCollector show: anObject printPrologString].
	^true! !


!PrologInterpreter methodsFor: 'system support'!
clauseSet: aPrologClause 
	| horn functor def |
	horn := aPrologClause.
	horn consp ifFalse: [horn := PrologStructure functor: horn terms: nil].
	horn car consp ifFalse: [horn := PrologClause head: horn body: nil].
	horn := PrologClause head: horn car body: (PrologBody fromList: horn cdr).
	functor := horn car car.
	def := userPredicates at: functor ifAbsent: [^false].
	definitionStack := def cons: definitionStack.
	^true! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nishis 5/3/98 06:48'!
consult: readStream action: aBlock
	| condition parser node hornClause program functor stream result |
	condition := self getCondition.
	parser := PrologParser new.
	result := true.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: 
					[stream := WriteStream on: (String new: 20).
					hornClause questionPrintPrologOn: stream.
					textCollector show: stream contents.
					textCollector cr.
					result := self resolve: hornClause action: aBlock]
				ifFalse: 
					[functor := hornClause car car.
					program := tracePredicates at: functor ifAbsent: [userPredicates at: functor ifAbsent: []].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							userPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)]]].
	self putCondition: condition.
	^result! !

!PrologInterpreter methodsFor: 'system support'!
reconsult: readStream action: aBlock
	| condition newPredicates parser node hornClause program functor stream result |
	condition := self getCondition.
	newPredicates := Dictionary new.
	parser := PrologParser new.
	result := true.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: 
					[stream := WriteStream on: (String new: 20).
					hornClause questionPrintPrologOn: stream.
					textCollector show: stream contents.
					textCollector cr.
					result := self resolve: hornClause action: aBlock]
				ifFalse: 
					[functor := hornClause car car.
					program := newPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							newPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)].
					userPredicates at: functor put: program]].
	newPredicates keys
		do: [:eachPredicate |
			userPredicates at: eachPredicate put: (newPredicates at: eachPredicate).
			tracePredicates removeKey: eachPredicate ifAbsent: []].
	self putCondition: condition.
	^result! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nishis 6/11/1998 22:43'!
saveOn: fileName 
	| aFileStream def |
	aFileStream := FileStream fileNamed: fileName.
	(self associations: userPredicates) asSortedCollection
		do: 
			[:assoc | 
			def := assoc value.
			[def consp]
				whileTrue: 
					[aFileStream nextPutAll: def car prettyPrintPrologString , '\' withCRs.
					def := def cdr]].
	aFileStream close! !

!PrologInterpreter methodsFor: 'system support' stamp: 'nishis 6/28/1998 05:17'!
saveOn: fileName predicateName: aPrologSymbol 
	| aFileStream def |
	aFileStream := FileStream fileNamed: fileName.
	def := userPredicates at: aPrologSymbol ifAbsent: [].
	def == nil ifFalse: [[def consp]
			whileTrue: 
				[aFileStream nextPutAll: def car prettyPrintPrologString , '\' withCRs.
				def := def cdr]].
	aFileStream close! !

!PrologInterpreter methodsFor: 'system support'!
systemConsult: readStream 
	| condition parser node hornClause program functor |
	condition := self getCondition.
	parser := PrologParser new.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: [self resolve: hornClause]
				ifFalse: 
					[functor := hornClause car car.
					program := systemPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							systemPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)]]].
	self putCondition: condition.
	^true! !

!PrologInterpreter methodsFor: 'system support'!
systemReconsult: readStream 
	| condition newPredicates parser node hornClause program functor |
	condition := self getCondition.
	newPredicates := Dictionary new.
	parser := PrologParser new.
	[node := parser parse: readStream.
	node == #eof]
		whileFalse: 
			[hornClause := node cdr.
			node car
				ifTrue: [self resolve: hornClause]
				ifFalse: 
					[functor := hornClause car car.
					program := newPredicates at: functor ifAbsent: [].
					program == nil
						ifTrue: 
							[program := PrologDefinition fromList: (hornClause cons: nil).
							newPredicates at: functor put: program]
						ifFalse: [program nconc: (hornClause cons: nil)].
					systemPredicates at: functor put: program]].
	newPredicates keys do: [:eachPredicate | systemPredicates at: eachPredicate put: (newPredicates at: eachPredicate)].
	self putCondition: condition.
	^true! !

!PrologInterpreter methodsFor: 'system support'!
trace: para head: head arguments: terms 
	| headString numberString structure arguString |
	headString := (self expression: head env: clauseEnv) printPrologString.
	para = 0
		ifTrue: 
			[traceCounter := traceCounter + 1.
			numberString := String new: traceCounter withAll: $|.
			structure := PrologStructure functor: head car terms: terms.
			arguString := (self expression: structure env: clauseEnv) printPrologString.
			headString := headString , ' ~ ' , arguString.
			textCollector show: numberString , ' CALL : ' , headString , '\' withCRs.
			^self].
	para = 1
		ifTrue: 
			[traceCounter := traceCounter + 1.
			numberString := String new: traceCounter withAll: $|.
			structure := PrologStructure functor: head car terms: terms.
			arguString := (self expression: structure env: clauseEnv) printPrologString.
			headString := headString , ' ~ ' , arguString.
			textCollector show: numberString , ' REDO : ' , headString , '\' withCRs.
			^self].
	para = 2
		ifTrue: 
			[numberString := String new: traceCounter withAll: $|.
			textCollector show: numberString , ' FAIL : ' , headString , '\' withCRs.
			traceCounter := traceCounter - 1.
			^self].
	para = 3
		ifTrue: 
			[numberString := String new: traceCounter withAll: $|.
			textCollector show: numberString , ' EXIT : ' , headString , '\' withCRs.
			^self]! !

!PrologInterpreter methodsFor: 'system support'!
traceCallClause: head
	^self traceClause: head flag: 0! !

!PrologInterpreter methodsFor: 'system support'!
traceClause: head flag: anInteger 
	| arguVar headStruct failStruct traceStruct |
	arguVar := PrologVariable install: 'Arguments'.
	headStruct := PrologStructure functor: head car terms: arguVar.
	failStruct := PrologStructure functor: (PrologSymbol install: 'fail')
				terms: nil.
	traceStruct := arguVar cons: nil.
	traceStruct := head cons: traceStruct.
	traceStruct := anInteger cons: traceStruct.
	traceStruct := traceStruct cons: nil.
	traceStruct := (PrologSymbol install: 'trace:head:arguments:')
				cons: traceStruct.
	traceStruct := (PrologSymbol install: 'self')
				cons: traceStruct.
	traceStruct := PrologTerms fromList: traceStruct.
	traceStruct := PrologStructure functor: (PrologSymbol install: 'send')
				terms: traceStruct.
	anInteger = 3 ifTrue: [^PrologClause head: headStruct body: (PrologBody fromList: (traceStruct cons: nil))].
	^PrologClause head: headStruct body: (PrologBody fromList: (traceStruct cons: (failStruct cons: nil)))! !

!PrologInterpreter methodsFor: 'system support'!
traceExitClause: exitClause
	| traceExitClause reverseClone| 
	traceExitClause := self traceExitClauseAux: exitClause car.
	traceExitClause := traceExitClause cdr.
	reverseClone := exitClause reverse.
	[reverseClone consp]
		whileTrue:
			[traceExitClause := reverseClone car cons: traceExitClause.
			reverseClone := reverseClone cdr].
	^PrologClause head: traceExitClause car body: (PrologBody fromList: traceExitClause cdr)! !

!PrologInterpreter methodsFor: 'system support'!
traceExitClauseAux: head
	^self traceClause: head flag: 3! !

!PrologInterpreter methodsFor: 'system support'!
traceFailClause: head
	^self traceClause: head flag: 2! !

!PrologInterpreter methodsFor: 'system support'!
traceRedoClause: head
	^self traceClause: head flag: 1! !


!PrologInterpreter methodsFor: 'adaptor'!
acceptConsulting: aText 
	| readStream |
	textCollector show: '<consult from user>\' withCRs.
	readStream := ReadStream on: aText asString.
	self consult: readStream action: nil.
	^true! !

!PrologInterpreter methodsFor: 'adaptor'!
acceptEditing: aText 
	| readStream |
	textCollector show: '<reconsult from editor>\' withCRs.
	readStream := ReadStream on: aText asString.
	Cursor read showWhile: [self reconsult: readStream action: nil].
	self updatePredList.
	^true! !

!PrologInterpreter methodsFor: 'adaptor'!
acceptQuestion: aText 
	^true! !

!PrologInterpreter methodsFor: 'adaptor'!
acceptReconsulting: aText 
	| readStream |
	textCollector show: '<reconsult from user>\' withCRs.
	readStream := ReadStream on: aText asString.
	Cursor read showWhile: [self reconsult: readStream action: nil].
	^true! !

!PrologInterpreter methodsFor: 'adaptor'!
consultingMenu
	^self editingMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:58'!
consultingTextMenu
	^self consultingMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
consultingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 10:56'!
consultingTextValueChange: aText 
	self acceptConsulting: aText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:58'!
editingListMenu
	^self predEditMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 6/20/1998 03:47'!
editingListValue
	listValue isNil ifTrue: [listValue := PluggableYAListModel new list: self predList; parent: self; controller: self].
	^listValue! !

!PrologInterpreter methodsFor: 'adaptor'!
editingListValueChange: aController 
	self pred: self editingListValue selection! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 6/20/1998 03:49'!
editingMenu
	"PrologInterpreter flushMenus."

	EditorMenu == nil ifTrue: [EditorMenu := SelectionMenu
		labelList: ('find...(f)\find again (g)\set search string (h)\do again (j)\undo (z)\copy (c)\cut (x)\paste (v)\\accept (s)\cancel (l)' withCRs findTokens: String cr asArray)
		lines: #(3 5 8)
		selections: #(#find #findAgain #setSearchString #again #undo #copySelection #cut #paste #accept #cancel)].
	^EditorMenu! !

!PrologInterpreter methodsFor: 'adaptor'!
editingText
	| stream def |
	predicate == nil ifTrue: [^Text new].
	stream := WriteStream on: (String new: 200).
	def := userPredicates at: predicate ifAbsent: [^Text new].
	[def consp]
		whileTrue: 
			[def car prettyPrintPrologOn: stream.
			stream cr.
			def := def cdr].
	^stream contents asText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:59'!
editingTextMenu
	^self editingMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
editingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 10:56'!
editingTextValueChange: aText 
	self acceptEditing: aText! !

!PrologInterpreter methodsFor: 'adaptor'!
ignoreMenu
	^nil! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:59'!
listingListMenu
	^self predListMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 6/20/1998 03:47'!
listingListValue
	listValue isNil ifTrue: [listValue := PluggableYAListModel new list: self predList].
	^listValue! !

!PrologInterpreter methodsFor: 'adaptor'!
listingListValueChange: aController 
	self pred: self listingListValue selection! !

!PrologInterpreter methodsFor: 'adaptor'!
listingText
	| stream def |
	predicate == nil ifTrue: [^Text new].
	stream := WriteStream on: (String new: 200).
	def := userPredicates at: predicate ifAbsent: [^Text new].
	[def consp]
		whileTrue: 
			[def car prettyPrintPrologOn: stream.
			stream cr.
			def := def cdr].
	^stream contents asText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:57'!
listingTextMenu
	^self ignoreMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:53'!
listingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor'!
listingTextValueChange: aController
	^self! !

!PrologInterpreter methodsFor: 'adaptor'!
pred
	^predicate! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:58'!
pred: selection 
	selection isNil
		ifTrue: [predicate := nil]
		ifFalse: [predicate := PrologSymbol install: selection].
	textValue := self listingText.
	self changed: #contents! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 6/20/1998 03:49'!
predEditMenu
	"PrologInterpreter flushMenus."

	PredEditMenu == nil ifTrue: [PredEditMenu := SelectionMenu 
		labelList: ('save\remove\update' withCRs findTokens: String cr asArray)
		lines: #()
		selections: #(#savePred #removePred #updatePredList)].
	^PredEditMenu! !

!PrologInterpreter methodsFor: 'adaptor'!
predList
	| collection |
	collection := SortedCollection new.
	userPredicates associationsDo: [:assoc | collection add: assoc key string].
	^collection asArray! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/27/98 05:49'!
predListMenu
	"PrologInterpreter flushMenus."

	PredListMenu == nil ifTrue: [PredListMenu := SelectionMenu 
		labelList: (Array with: 'update') 
		lines: #()
		selections: #(#updatePredList)].
	^PredListMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 11:12'!
questionMenu
	"PrologInterpreter flushMenus."

	| collection |
	QuestionMenu isNil
		ifTrue: 
			[collection := OrderedCollection new.
			collection add: 'find...' -> #find.
			collection add: 'find again' -> #findAgain.
			collection add: 'set search string' -> #setSearchString.
			collection add: nil.
			collection add: 'do again' -> #again.
			collection add: 'undo' -> #undo.
			collection add: nil.
			collection add: 'copy' -> #copySelection.
			collection add: 'cut' -> #cut.
			collection add: 'paste' -> #paste.
			collection add: nil.
			collection add: 'do it' -> #doIt:from:.
			"collection add: 'print it' -> #printIt."
			collection add: 'inspect it' -> #inspectIt:from:.
			collection add: nil.
			collection add: 'accept' -> #accept.
			collection add: 'cancel' -> #cancel.
			collection add: nil.
			collection add: '--- prolog ---' -> #toBeIgnored.	
			collection add: 'listing' -> #listing.
			collection add: 'editing' -> #editing.
			collection add: nil.
			collection add: 'consulting' -> #consulting.
			collection add: 'reconsulting' -> #reconsulting.
			collection add: 'file edit' -> #fileEdit.
			collection add: 'saving' -> #saving.
			collection add: nil.
			collection add: 'gc' -> #gc.
			collection add: 'investigate' -> #investigate.
			QuestionMenu := self makeSelectionMenu: collection].
	^QuestionMenu! !

!PrologInterpreter methodsFor: 'adaptor'!
reconsultingMenu
	^self editingMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:58'!
reconsultingTextMenu
	^self reconsultingMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 06:54'!
reconsultingTextValue
	textValue isNil ifTrue: [textValue := Text new].
	^textValue! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 10:56'!
reconsultingTextValueChange: aText 
	self acceptReconsulting: aText! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 4/26/98 23:59'!
textMenu
	^self questionMenu! !

!PrologInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 11:15'!
textValue
	textValue isNil ifTrue: [textValue := String new].
	^textValue! !


!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 07:23'!
consulting
	| fileName theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	fileName := FillInTheBlank request: 'Please type a name for consulting file.' initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	(fileName isNil or: [fileName asString isEmpty or: [fileName asString = 'user']])
		ifTrue: [^self consult]
		ifFalse: [^self consultFile: fileName asString]! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 10:47'!
doIt: aText from: aController 
	| stream |
	self acceptWith: aText.
	"see BrowserView browseFullForClass: PluggableStringHolderController method: #sendMenuMessageToModel:."
	stream := ReadStream on: aText asString.
	^self consult: stream action: nil! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 4/26/98 23:39'!
fileEdit
	| fileName theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	fileName := FillInTheBlank request: 'Please type a name for editting file.' initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	(fileName isNil or: [fileName isEmpty])
		ifTrue: [^false].
	(FileStream fileNamed: fileName) edit.
	^true! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 10:47'!
inspectIt: aText from: aController 
	| result stream |
	self acceptWith: aText.
	"see BrowserView browseFullForClass: PluggableStringHolderController method: #sendMenuMessageToModel:."
	stream := ReadStream on: aText asString.
	self consult: stream
		action: 
			[:dict | 
			result := dict.
			self outputVariables: dict].
	result inspect.
	^result! !

!PrologInterpreter methodsFor: 'menu messages'!
investigate
	self inspect! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 4/26/98 23:40'!
reconsulting
	| fileName theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	fileName := FillInTheBlank request: 'Please type a name for reconsulting file.' initialAnswer: String new.
	Smalltalk clipboardText: theClipboardText.
	(fileName isNil or: [fileName asString isEmpty or: [fileName asString = 'user']])
		ifTrue: [^self reconsult]
		ifFalse: [^self reconsultFile: fileName asString]! !

!PrologInterpreter methodsFor: 'menu messages'!
removePred
	predicate == nil ifTrue: [^self].
	(self confirm: 'Do you really want to remove?')
		ifTrue: 
			[self remove: predicate.
			self updatePredList]! !

!PrologInterpreter methodsFor: 'menu messages'!
savePred
	predicate == nil ifTrue: [^self].
	self saving: predicate! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 4/25/98 05:49'!
toBeIgnored! !

!PrologInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 07:09'!
updatePredList
	self listingListValue list: self predList.
	self pred isNil
		ifFalse: 
			[self listingListValue selection: self pred string.
			self pred: self pred string]! !


!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 4/27/98 04:33'!
buttonsView: aController
	| baseView doItView inspectItView listingView editingView reconsultingView fileEditView savingView gcView width height |
	width := 250 / 5.
	height := 16.
	baseView := View new 
			model: self;
			backgroundColor: Color white;
			window: (0 @ 0 extent: 250 @ (height * 2));
			borderWidthLeft: 2 right: 2 top: 2 bottom: 0.
	doItView := self 
		buttonView: baseView 
		onAction: [self doIt: aController selection from: aController] 
		label: 'do it' 
		extent: width @ height 
		align: #addSubView:
		targetView: nil.
	inspectItView := self 
		buttonView: baseView 
		onAction: [self inspectIt: aController selection from: aController] 
		label: 'inspect it' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: doItView.
	listingView := self 
		buttonView: baseView 
		onAction: [self perform: #listing] 
		label: 'listing' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: inspectItView.
	editingView := self 
		buttonView: baseView 
		onAction: [self perform: #editing] 
		label: 'editing' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: listingView.
	"consultingView :=" self 
		buttonView: baseView 
		onAction: [self perform: #consulting] 
		label: 'consulting' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: editingView.
	reconsultingView := self 
		buttonView: baseView 
		onAction: [self perform: #reconsulting] 
		label: 'reconsulting' 
		extent: width @ height 
		align: #addSubView:below: 
		targetView: doItView.
	fileEditView := self 
		buttonView: baseView 
		onAction: [self perform: #fileEdit] 
		label: 'file edit' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: reconsultingView.
	savingView := self 
		buttonView: baseView 
		onAction: [self perform: #saving] 
		label: 'saving' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: fileEditView.
	gcView := self 
		buttonView: baseView 
		onAction: [self perform: #gc] 
		label: 'gc' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: savingView.
	self 
		buttonView: baseView 
		onAction: [self perform: #investigate] 
		label: 'investigate' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: gcView.
	^baseView
! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 07:32'!
consultingInterface
	| copySelf topView textView |
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Consultant';
			minimumSize: 300 @ 200.
	textView := PluggableStringHolderView
			on: copySelf
			aspect: #consultingTextValue 
			change: #consultingTextValueChange: 
			menu: #consultingTextMenu.
	textView
			window: (0 @ 0 extent: 300 @ 200);
			borderWidth: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: textView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 6/12/1998 02:35'!
editingInterface
	| copySelf topView listView textView |
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Editor';
			minimumSize: 300 @ 200.
	listView := PluggableYAListView
			on: copySelf 
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #editingListMenu.
	listView
			window: (0 @ 0 extent: 100 @ 200);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	textView := PluggableStringHolderView
			on: copySelf
			aspect: #editingTextValue	"#editingText "
			change: #editingTextValueChange:	"#editingTextValue" 
			menu: #editingTextMenu.
	textView
			window: (100 @ 0 extent: 300 @ 200);
			borderWidthLeft: 0 right: 2 top: 2 bottom: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: listView.
	topView addSubView: textView toRightOf: listView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 01:57'!
fullOpen
	"PrologInterpreter fullOpen."

	| topView questionView transcriptView btns |
	topView := StandardSystemView new
			model: self;
			backgroundColor: Color white;
			label: 'Prolog';
			minimumSize: 250 @ 300.
	questionView := PluggableStringHolderView
			on: self "textValue"
			aspect: #contents
			change: #contents:
			menu: #textMenu.
	questionView
			window: (0 @ 0 extent: 250 @ 100);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	transcriptView := PluggableTextView new
			model: self textCollector;
			window: (0 @ 0 extent: 250 @ 200);
			backgroundColor: Color white;
			borderWidthLeft: 2 right: 2 top: 0 bottom: 2. 

	btns := self buttonsView: questionView controller.
	topView addSubView: btns.
	topView addSubView: questionView below: btns.
	topView addSubView: transcriptView below: questionView.
	^ topView controller open.
! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 6/12/1998 02:35'!
listingInterface
	| copySelf topView listView textView |
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Lister';
			minimumSize: 300 @ 200.
	listView := PluggableYAListView
			on: copySelf 
			list: #predList
			selected: #pred
			changeSelected: #pred:
			menu: #listingListMenu.
	listView
			window: (0 @ 0 extent: 100 @ 200);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	textView := PluggableStringHolderView
			on: copySelf
			aspect: #listingText 
			change: #listingTextValue 
			menu: #listingTextMenu.
	textView
			window: (100 @ 0 extent: 300 @ 200);
			borderWidthLeft: 0 right: 2 top: 2 bottom: 2; 
			backgroundColor: Color lightYellow.
	textView controller: NoController new.
	topView addSubView: listView.
	topView addSubView: textView toRightOf: listView.
	topView  controller open! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 11:13'!
open
	"PrologInterpreter open."

	| topView questionView transcriptView |
	topView := StandardSystemView new
			model: self;
			backgroundColor: Color white;
			label: 'Prolog';
			minimumSize: 250 @ 300.
	questionView := PluggableStringHolderView
			on: self 
			aspect: #contents 
			change: #contents: 
			menu: #textMenu.
	questionView
			window: (0 @ 0 extent: 250 @ 100);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	transcriptView := PluggableTextView new
			model: self textCollector;
			window: (0 @ 0 extent: 250 @ 200);
			backgroundColor: Color white;
			borderWidthLeft: 2 right: 2 top: 0 bottom: 2. 

	topView addSubView: questionView.
	topView addSubView: transcriptView below: questionView.
	^ topView controller open.
! !

!PrologInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 07:34'!
reconsultingInterface
	| copySelf topView textView |
	copySelf := self copy.
	topView := StandardSystemView new
			model: copySelf;
			backgroundColor: Color white;
			label: 'Prolog Reconsultant';
			minimumSize: 300 @ 200.
	textView := PluggableStringHolderView
			on: copySelf
			aspect: #reconsultingTextValue 
			change: #reconsultingTextValueChange: 
			menu: #reconsultingTextMenu.
	textView
			window: (0 @ 0 extent: 300 @ 200);
			borderWidth: 2; 
			backgroundColor: Color lightYellow.
	topView addSubView: textView.
	topView  controller open! !


!PrologInterpreter methodsFor: 'private' stamp: 'nishis 6/12/1998 02:42'!
acceptWith: aText
	"force to regist aText as a contents."

	self contents: aText.
	textValue := aText.
	self changed: #clearUserEdits! !

!PrologInterpreter methodsFor: 'private' stamp: 'nishis 5/3/98 08:05'!
associations: aCollection
	"by nishis, 1998/04/12 07:34"

	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!PrologInterpreter methodsFor: 'private' stamp: 'nishis 6/12/1998 02:18'!
buttonView: baseView onAction: aAction label: label extent: extent
	| aSwitchView aSwitch |
	aSwitch := (Button new) onAction: aAction.
	aSwitchView := PluggableButtonView
		on: aSwitch
		getState: #isOff
		action: #switch.
	aSwitchView
		label: label asParagraph;
		window: (0@0 extent:  extent);
		borderWidth: 2;
			foregroundColor: Color black;
			backgroundColor: Color veryVeryLightGray.
	^aSwitchView! !

!PrologInterpreter methodsFor: 'private' stamp: 'nishis 4/27/98 04:24'!
buttonView: baseView onAction: aAction label: label extent: extent align: align targetView: targetView
	| aSwitchView kind |
	aSwitchView := 
		self 
			buttonView: baseView 
			onAction: aAction 
			label: label 
			extent: extent.
	kind := align numArgs.
	kind = 1 ifTrue: [baseView perform: align asSymbol with: aSwitchView].
	kind = 2 ifTrue: [baseView perform: align asSymbol with: aSwitchView with: targetView].
	^aSwitchView
! !

!PrologInterpreter methodsFor: 'private'!
deallocateEnv: env
	| assocList assoc nextEnv |  
	assocList := env cdr.
	[assocList consp]
		whileTrue: 
			[assoc := assocList car.
			nextEnv := assoc cdr cdr.
			assoc cdr cdr: nil.
			nextEnv consp ifTrue: [self deallocateEnv: nextEnv].
			assocList := assocList cdr]! !

!PrologInterpreter methodsFor: 'private'!
getCondition
	| condition |
	condition := Array new: 14.
	condition at: 1 put: status.
	condition at: 2 put: definition.
	condition at: 3 put: question.
	condition at: 4 put: questionEnv.
	condition at: 5 put: clause.
	condition at: 6 put: clauseEnv.
	condition at: 7 put: queue.
	condition at: 8 put: queueEnv.
	condition at: 9 put: valueEnv.
	condition at: 10 put: unbindList.
	condition at: 11 put: cutBack.
	condition at: 12 put: backTrack.
	condition at: 13 put: resolveAction.
	condition at: 14 put: definitionStack.
	^condition! !

!PrologInterpreter methodsFor: 'private'!
makeSystemPredicates
	SystemPredicates isNil
		ifTrue: 
			[self systemPredicatesNo0.
			self systemPredicatesNo1.
			self systemPredicatesNo2.
			self systemPredicatesNo3.
			self systemPredicatesNo4.
			self systemPredicatesNo5.
			self systemPredicatesNo6.
			self systemPredicatesNo7.
			self systemPredicatesNo8.
			self systemPredicatesNo9.
			SystemPredicates := systemPredicates]
		ifFalse: [systemPredicates := SystemPredicates]! !

!PrologInterpreter methodsFor: 'private'!
putCondition: condition 
	status := condition at: 1.
	definition := condition at: 2.
	question := condition at: 3.
	questionEnv := condition at: 4.
	clause := condition at: 5.
	clauseEnv := condition at: 6.
	queue := condition at: 7.
	queueEnv := condition at: 8.
	valueEnv := condition at: 9.
	unbindList := condition at: 10.
	cutBack := condition at: 11.
	backTrack := condition at: 12.
	resolveAction := condition at: 13.
	definitionStack := condition at: 14! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo0
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		!! :- builtin.
		true :- builtin.
		fail :- builtin.
		var(X) :- builtin.
		send(X,Y,Z) :- bulitin.
		send(X,Y,Z,A) :- bulitin.
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo1
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		repeat.
		repeat :- repeat.
		nonvar(X) :- var(X), !!, fail.
		nonvar(X).
		integer(X) :- send(self,integer:,[X]).
		float(X) :- send(self,float:,[X]).
		double(X) :- send(self,double:,[X]).
		fraction(X) :- send(self,fraction:,[X]).
		number(X) :- send(self,number:,[X]).
		symbol(X) :- send(self,symbol:,[X]).
		string(X) :- send(self,string:,[X]).
		list(X) :- send(self,list:,[X]).
		dotp(X) :- send(self,dotp:,[X]).
		atom(X) :- symbol(X).
		atom(X) :- nonvar(X), =(X,[]).
		atom(X) :- string(X).
		atomic(X) :- atom(X).
		atomic(X) :- number(X).
		structure(X) :- nonvar(X), not(atomic(X)).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo2
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		==(X,Y) :- send(X,=,[Y]).
		\==(X,Y) :- ==(X,Y), !!, fail.
		\==(X,Y).
		=(X,X).
		\=(X,Y) :- =(X,Y), !!, fail.
		\=(X,Y).
		>(X,Y) :- send(X,>,[Y]).
		>=(X,Y) :- send(X,>=,[Y]).
		<(X,Y) :- send(X,<,[Y]).
		=<(X,Y) :- send(X,<=,[Y]).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo3
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		+(X,Y,Z) :- send(X,+,[Y],Z).
		-(X,Y,Z) :- send(X,-,[Y],Z).
		*(X,Y,Z) :- send(X,*,[Y],Z).
		//(X,Y,Z) :- send(X,//,[Y],Z).
		/(X,Y,Z) :- send(X,/,[Y],Z).
		\\(X,Y,Z) :- send(X,\\,[Y],Z).
		is(Z,+(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,+,[Y],Z).
		is(Z,+(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,+,[Y],Z).
		is(Z,+(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,-,[Y],X).
		is(Z,+(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(Z,-,[X],Y).
		is(Z,-(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,-,[Y],Z).
		is(Z,-(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,-,[Y],Z).
		is(Z,-(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,+,[Y],X).
		is(Z,-(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(X,-,[Z],Y).
		is(Z,*(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,*,[Y],Z).
		is(Z,*(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,*,[Y],Z).
		is(Z,*(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,/,[Y],X).
		is(Z,*(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(Z,/,[X],Y).
		is(Z,/(X,Y)) :- nonvar(Z), nonvar(X), nonvar(Y), send(X,/,[Y],Z).
		is(Z,/(X,Y)) :- var(Z), nonvar(X), nonvar(Y), send(X,/,[Y],Z).
		is(Z,/(X,Y)) :- var(X), nonvar(Y), nonvar(Z), send(Z,*,[Y],X).
		is(Z,/(X,Y)) :- var(Y), nonvar(Z), nonvar(X), send(X,/,[Z],Y).
		is(X,Y) :- =(X,Y).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo4
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		listing :- send(self,userListing,[]).
		listing(X) :- send(self,userListing:,[X]).
		systemListing :- send(self,systemListing,[]).
		systemListing(X) :- send(self,systemListing:,[X]).
		editing :- send(self,editting,[]).
		consult :- send(self,consult,[]).
		consult(X) :- nonvar(X), send(self,consultFile:,[X]).
		reconsult :- send(self,reconsult,[]).
		reconsult(X) :- nonvar(X), send(self,reconsultFile:,[X]).
		saving :- send(self,saving,[]).
		saving(X) :- send(self,saving:,[X]).
		userPredicates(X) :- send(self,userPredicates,[],X).
		systemPredicates(X) :- send(self,systemPredicates,[],X).
		predicates([X|Y]) :- userPredicates(X), systemPredicates(Y).
		functor(T,F,A) :- nonvar(T), !!, send(self,functorArityOf:,[T],[F|A]).
		functor(T,F,A) :- number(F), !!, =(0,A),=(T,F).
		functor(T,F,A) :- atom(F), =<(0,A), ''~addvar''([F],A,L), =..(T,L).
		''~addvar''(L,0,M) :- !!, =(L,M).
		''~addvar''(L,NVars,M) :- -(NVars, 1, N), append(L,[FreeV],LV), ''~addvar''(LV,N,M).
		arg(Nth,S,T) :- integer(Nth), <(0,Nth), structure(S), =..(S,[F|L]), nth(L,Nth,T).
		=..(X,Y) :- send(self,univ:,[[''X''|''Y'']]).
		name(X,Y) :- atomic(X), list(Y), !!, send(self,symToList:,[X],Y).
		name(X,Y) :- atomic(X), !!, send(self,symToStr:,[X],Y).
		name(X,Y) :- var(X), !!, nonvar(Y), send(self, strToSym:,[Y],X).
		remove :- send(self,remove,[]).
		remove(X) :- send(self,remove:,[X]).
		clause(X) :- send(self,clauseSet:,[X]), repeat, send(self,clause:,[X],X).
		asserta(X) :- send(self,asserta:,[X]).
		assert(X) :- send(self,assertz:,[X]).
		assertz(X) :- send(self,assertz:,[X]).
		retract(X) :- repeat, send(self,retract:,[X],X).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo5
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		call(G) :- G.
		not(G) :- G, !!, fail.
		not(G).
		or(X,Y) :- call(X).
		or(X,Y) :- call(Y).
		and(X,Y) :- call(X), call(Y).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo6
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		read(X) :- send(self,read,[],X).
		read(X,M) :- send(self,read:,[M],X).
		write(X) :- send(self,write:,[X]).
		nl :- send(self,nl,[]).
		tab(X) :- number(X), send(self,tab:,[X]).
		clear :- send(self,clear,[]).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo7
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		clock(X) :- send({Time},millisecondClockValue,[],X).
		verbose(X) :- send(self,verbose:,[X]).
		gc :- send(self,gc,[]).
		inspect(X) :- send(X,inspect,[]).
		spy(X) :- send(self,spy:,[X]).
		nospy(X) :- send(self,nospy:,[X]).
		trace :- send(self,trace,[]).
		notrace :- send(self,notrace,[]).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo8
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		append([],X,X).
		append([A|X],Y,[A|Z]) :- append(X,Y,Z).
		member(X,[X|Y]).
		member(X,[Y|Z]) :- member(X,Z).
		reverse([],[]).
		reverse([H|T],L) :- reverse(T,Z), append(Z,[H],L).
		length(X,Y) :- send(self,length:,[X],Y).
		nth([X|Y],1,Z) :- !!, =(X,Z).
		nth([X|Y],N,Z) :- -(N,1,PN), nth(Y,PN,Z).
		printlist(L) :- send(self,listPrint:,[L]).
		lispAppend(X,Y,Z) :- send(X,append:,[Y],Z).
		lispReverse(X,Y) :- send(X,reverse,[],Y).
		lispMember(X,Y) :- send(Y,member:,[X],A), \=(A,[]).
		lispMember(X,Y,Z) :- send(Y,member:,[X],Z).
		lispAssoc(X,Y) :- send(Y,assoc:,[X],A), \=(A,[]).
		lispAssoc(X,Y,Z) :- send(Y,assoc:,[X],Z).
		lispNconc(X,Y,Z) :- send(X,nconc:,[Y],Z).
	')! !

!PrologInterpreter methodsFor: 'private'!
systemPredicatesNo9
	"PrologInterpreter flushSystemPredicates."

	self systemReconsult: (ReadStream on: '
		%
		%	User System Predicates
		%
	')! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologInterpreter class
	instanceVariableNames: ''!

!PrologInterpreter class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologInterpreter class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologInterpreter class methodsFor: 'copyright'!
version
	^'003'! !


!PrologInterpreter class methodsFor: 'class initialization'!
flushMenus
	"PrologInterpreter flushMenus."

	QuestionMenu := nil.
	EditorMenu := nil.
	PredListMenu := nil.
	PredEditMenu := nil! !

!PrologInterpreter class methodsFor: 'class initialization'!
flushOthers
	"PrologInterpreter flushOthers."

	self flushSystemPredicates! !

!PrologInterpreter class methodsFor: 'class initialization'!
flushSystemPredicates
	"PrologInterpreter flushSystemPredicates."

	SystemPredicates := nil! !

!PrologInterpreter class methodsFor: 'class initialization' stamp: 'nishis 4/21/98 02:32'!
initialize
	"PrologInterpreter initialize."

	self installMessagesForProlog! !

!PrologInterpreter class methodsFor: 'class initialization'!
installMessagesForProlog
	"PrologInterpreter installMessagesForProlog."

	| source stream |
	source := '
!!Object methodsFor: ''prolog''!!

car
	self == nil ifTrue: [^nil].
	self error: ''send message car to atom''!!

cdr
	self == nil ifTrue: [^nil].
	self error: ''send message cdr to atom''!!

cons: anObject 
	^PrologList car: self cdr: anObject!!

consp
	^false!!

isPrologEntity
	self == nil ifTrue: [^true].
	(self isKindOf: Number)
		ifTrue: [^true].
	^false!!

isPrologVariable
	^false!!

printPrologOn: aStream 
	self == nil
		ifTrue: 
			[aStream nextPutAll: ''[]''.
			^self].
	(self isKindOf: Number)
		ifTrue: 
			[self printOn: aStream.
			^self].
	aStream nextPut: ${.
	self printOn: aStream.
	aStream nextPut: $}!!

printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream!!

printPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPrologOn: aStream.
	^aStream contents!! !!
'.
	stream := ReadWriteStream
				on: source
				from: 0
				to: source size.
	stream fileIn! !

!PrologInterpreter class methodsFor: 'class initialization'!
obsolete
	self uninstallMessagesForProlog.
	super obsolete! !

!PrologInterpreter class methodsFor: 'class initialization'!
uninstallMessagesForProlog
	"PrologInterpreter uninstallMessagesForProlog."

	| target protocol organizer selectors |
	target := Object.
	protocol := #prolog.
	organizer := target organization.
	selectors := organizer listAtCategoryNamed: protocol.
	selectors do: [:selector | target removeSelector: selector].
	organizer removeCategory: protocol! !


!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 5/3/98 01:58'!
fullOpen
	"PrologInterpreter fullOpen."

	self fullOpenOn: self new! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 5/3/98 01:58'!
fullOpenOn: prologInterpreter
	"PrologInterpreter fullOpen."

	prologInterpreter fullOpen! !

!PrologInterpreter class methodsFor: 'instance creation'!
new
	^super new initialize! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 03:02'!
open
	"PrologInterpreter open."

	self openOn: self new! !

!PrologInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 03:00'!
openOn: prologInterpreter
	"PrologInterpreter open."

	prologInterpreter open! !


!PrologInterpreter class methodsFor: 'public access'!
refute: stringOrStream 
	^self new refute: stringOrStream! !

!PrologInterpreter class methodsFor: 'public access'!
refute: stringOrStream action: aBlock 
	^self new refute: stringOrStream action: aBlock! !


!PrologInterpreter class methodsFor: 'saving' stamp: 'nishis 6/13/1998 03:48'!
save
	"PrologInterpreter save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Prolog.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!PrologInterpreter class methodsFor: 'saving' stamp: 'nishis 6/13/1998 03:52'!
saveClasses
	"PrologInterpreter saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('Prolog*' 'Pluggable*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection addAll: (SystemOrganization superclassOrder: 'Pluggable-Support').
	classCollection := ChangeSet superclassOrder: classCollection.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!PrologInterpreter class methodsFor: 'examples'!
example
	"PrologInterpreter example."

	PrologInterpreter open! !

!PrologInterpreter class methodsFor: 'examples' stamp: 'nishis 5/3/98 01:58'!
example00
	"PrologInterpreter example00."

	PrologInterpreter fullOpen! !

!PrologInterpreter class methodsFor: 'examples'!
example01
	"PrologInterpreter example01."

	| string prolog result |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	likes(john,mary).    % assert fact.
	likes(john,wine).    % assert fact.
	likes(mary,wine).    % assert fact.
	likes(mary,john).    % assert fact.
	?- likes(X,Y).		   % question goal.
	?- likes(john,X), likes(mary,X). % question goal.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples'!
example02
	"PrologInterpreter example02."

	| string prolog result |
	string := '

	?- remove.	   % remove all predicates in PrologDataBase.
	on(hen,cat).
	on(cat,dog).
	on(dog,donkey).
	above(X,Y) :-
	    on(X,Y).
	above(X,Y) :-
	    on(X,Z), above(Z,Y).
	?- on(X,dog).
	?- above(X,dog).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples'!
example03
	"PrologInterpreter example03."

	| string prolog result |
	string := '

	?- remove.	% remove all predicates in PrologDataBase.
	hanoi(N) :-	% This is Hanoi Tower Prolgram.
	    move(N,left,right,center).
	    move(0,X,Y,Z) :- !!.
	move(N,A,B,C) :-
	    -(N,1,M),
	    move(M,A,C,B),
	    inform(A,B),
	    move(M,C,B,A).
	inform(X,Y) :-
	    write([move,disc,from,X,to,Y]),
	    nl.
	?- hanoi(3).	 % question goal.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples'!
example04
	"PrologInterpreter example04."

	| string prolog result |
	string := '?- append(X,Y,[a,b,c,d]).'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: 'nishis 4/21/98 02:31'!
example05
	"PrologInterpreter example05."

	| string prolog result |
	string := '

	image({Form fromUser}).
	graphicsContext({Display}).
	point({100@100}).
	?- image(X), graphicsContext(Y), point(Z), send(X,displayOn:at:,[Y,Z]).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples'!
example06
	"PrologInterpreter example06."

	| string prolog result |
	string := '

	?- send(123,+,[456],X).   % X := 123 + 456.

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples'!
example07
	"PrologInterpreter example07."

	| string prolog result |
	string := '

	?- is(X,+(3,4)).
	?- is(X,F(3,4)).

	'.
	prolog := PrologInterpreter new.
	prolog textCollector: Transcript.
	result := prolog refute: string
				action: 
					[:answer | 
					answer keys asSortedCollection
						do: 
							[:s | 
							Transcript show: s.
							Transcript show: ' = '.
							Transcript show: (answer at: s) printPrologString.
							Transcript cr].
					prolog confirm: 'All right?'].
	Transcript show: result printString; cr! !

!PrologInterpreter class methodsFor: 'examples' stamp: 'nishis 5/3/98 13:39'!
example08
	"PrologInterpreter example08."

	| anInterpreter aBlock aString |
	anInterpreter := PrologInterpreter new.
	anInterpreter contents: '?- append(X,Y,[1,2,3,4]).'.
	aBlock :=
		['?- append(X,Y,[1,2,3,4]).
X = [] ,
Y = [1,2,3,4] ;
X = [1] ,
Y = [2,3,4] ;
X = [1,2] ,
Y = [3,4] ;
X = [1,2,3] ,
Y = [4] ;
X = [1,2,3,4] ,
Y = [] ;
no'
			do:
				[:aCharacter |
				Processor yield.
				aString := String with: aCharacter.
				anInterpreter textCollector show: aString]].
	aBlock fixTemps; fork.
	anInterpreter open! !


PrologInterpreter initialize!
