'Goodies (11/18/2001 8:35:13 am)'.!


PrologScanner subclass: #PrologParser
	instanceVariableNames: 'prevMark prevToken prevTokenType failBlock compiler '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologParser commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologParser methodsFor: 'parsing' stamp: 'nishis 5/8/98 22:59'!
parse: sourceStream 
	| label string |
	^self parse: sourceStream
		ifFail: 
			[:errorMessage | 
			label := errorMessage , ' near ' , token printString.
			string := source upToEnd.
			string size > 100 ifTrue: [string := string copyFrom: 1 to: 100].
			self error: label with: (string = ''
						ifTrue: ['-- end of file --']
						ifFalse: ['--> ' , string])]! !

!PrologParser methodsFor: 'parsing'!
parse: sourceStream ifFail: aBlock
	| result |
	self init: sourceStream ifFail: aBlock.
	Cursor read showWhile: [result := self scan].
	^result! !


!PrologParser methodsFor: 'scanning'!
nextToken
	prevMark := mark.
	prevToken := token.
	prevTokenType := tokenType.
	^super nextToken! !

!PrologParser methodsFor: 'scanning'!
unNextToken
	super unNextToken.
	mark := prevMark.
	token := prevToken.
	tokenType := prevTokenType! !


!PrologParser methodsFor: 'scan'!
scan
	source atEnd ifTrue: [^#eof].
	self nextToken.
	tokenType == #eof ifTrue: [^#eof].
	tokenType == #neck ifTrue: [^true cons: self scanClause]. "resolve clause"
	self unNextToken.
	^false cons: self scanClause "assert clause"! !

!PrologParser methodsFor: 'scan'!
scanBody
	| list |
	list := nil.
	[tokenType ~~ #eof]
		whileTrue: 
			[list := self scanStructure cons: list.
			self nextToken.
			tokenType == #rightParenthesis ifTrue: [^PrologBody fromReverseList: list].
			tokenType == #period ifTrue: [^PrologBody fromReverseList: list].
			tokenType ~~ #comma ifTrue: [failBlock value: 'Syntax error']].
	failBlock value: 'Unexpected eof'! !

!PrologParser methodsFor: 'scan'!
scanClause
	| head |
	head := self scanStructure.
	self nextToken.
	tokenType == #neck ifTrue: [^PrologClause head: head body: self scanBody].
	tokenType == #comma ifTrue: [^PrologClause head: head body: self scanBody].
	tokenType == #period ifTrue: [^PrologClause head: head body: nil].
	tokenType == #rightParenthesis ifTrue: [^PrologClause head: head body: nil].
	self unNextToken.
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan'!
scanExpression
	| symbol |
	self nextToken.
	(tokenType == #eof or: [tokenType == #period])
		ifTrue: [^nil].
	tokenType == #number ifTrue: [^token].
	tokenType == #string ifTrue: [^token].
	tokenType == #object ifTrue: [^PrologObject source: token object: (self compileAndEvaluate: token)].
	tokenType == #leftBracket ifTrue: [^self scanList].
	tokenType == #leftParenthesis ifTrue: [^self scanClause].
	(tokenType == #symbol or: [tokenType == #variable])
		ifTrue: 
			[symbol := token.
			self nextToken.
			tokenType == #leftParenthesis
				ifTrue: 
					[self unNextToken.
					self unNextToken.
					^self scanStructure]
				ifFalse: 
					[self unNextToken.
					^symbol]].
	self unNextToken.
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan'!
scanList
	| expression |
	self nextToken.
	tokenType == #comma ifTrue: [self nextToken].
	tokenType == #neck ifTrue: [self nextToken].
	tokenType == #rightBracket ifTrue: [^nil].
	tokenType == #leftBracket ifTrue: [^self scanList cons: self scanList].
	tokenType == #verticalBar
		ifTrue: 
			[expression := self scanExpression.
			self nextToken.
			tokenType == #rightBracket
				ifTrue: [^expression]
				ifFalse: [failBlock value: 'Syntax error']].
	self unNextToken.
	expression := self scanExpression.
	^expression cons: self scanList! !

!PrologParser methodsFor: 'scan'!
scanStructure
	| functor terms |
	functor := self nextToken.
	(tokenType == #symbol or: [tokenType == #variable])
		ifTrue: 
			[terms := self scanTerms.
			^PrologStructure functor: functor terms: terms].
	failBlock value: 'Syntax error'! !

!PrologParser methodsFor: 'scan'!
scanTerms
	| list |
	self nextToken.
	tokenType == #leftParenthesis
		ifTrue: 
			[self nextToken.
			(tokenType == #verticalBar or: [tokenType == #rightParenthesis])
				ifTrue:
					[tokenType == #rightParenthesis
						ifTrue: [^nil].
					list := self scanExpression.
					self nextToken.
					tokenType == #rightParenthesis
						ifTrue: [^list]
						ifFalse: [failBlock value: 'Syntax error']]
				ifFalse: [self unNextToken].
			list := nil.
			[tokenType ~~ #eof]
				whileTrue: 
					[list := self scanExpression cons: list.
					self nextToken.
					token == #rightParenthesis ifTrue: [^PrologTerms fromReverseList: list].
					tokenType == #verticalBar
						ifTrue:
							[list := list reverse.
							list := list nconc: self scanExpression.
							self nextToken.
							tokenType == #rightParenthesis
								ifTrue: [^PrologTerms fromList: list]
								ifFalse: [failBlock value: 'Syntax error']].
					tokenType ~~ #comma ifTrue: [failBlock value: 'Syntax error']].
			failBlock value: 'Unexpected eof']
		ifFalse: 
			[self unNextToken.
			^nil]! !


!PrologParser methodsFor: 'private'!
compileAndEvaluate: string 
	compiler isNil ifTrue: [compiler := Compiler new].
	^compiler
		evaluate: string
		in: nil
		to: nil
		notifying: nil
		ifFail: []! !

!PrologParser methodsFor: 'private'!
init: sourceStream ifFail: aBlock 
	super on: sourceStream.
	failBlock := aBlock.
	PrologVariable setZero! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologParser class
	instanceVariableNames: ''!

!PrologParser class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologParser class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologParser class methodsFor: 'copyright'!
version
	^'003'! !
