'Goodies (11/18/2001 8:35:14 am)'.!


SequenceableCollection subclass: #LispList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Lisp'!

!LispList methodsFor: 'accessing'!
at: indexInteger put: anObject 
	^self subscriptOutOfBoundsError: indexInteger! !

!LispList methodsFor: 'accessing'!
size
	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^tally! !


!LispList methodsFor: 'testing'!
isCons
	^self null not! !

!LispList methodsFor: 'testing'!
null
	^false! !


!LispList methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:02'!
error: labelString with: contentsString
	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !


!LispList methodsFor: 'private' stamp: 'nishis 4/25/98 04:06'!
subscriptOutOfBoundsError: index 
	^self error: 'subscript out of bounds error' with: 'subscript out of bounds: ' , index printString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispList class
	instanceVariableNames: ''!

!LispList class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispList class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispList class methodsFor: 'copyright'!
version
	^'003'! !


!LispList class methodsFor: 'instance creation'!
cell
	^self subclassResponsibility! !

!LispList class methodsFor: 'instance creation'!
head: headObject 
	^self subclassResponsibility! !

!LispList class methodsFor: 'instance creation'!
head: headObject tail: tailObject 
	^self subclassResponsibility! !

!LispList class methodsFor: 'instance creation'!
list: anArray 
	"LispCons list: #(1 2 3 4)"

	| size list |
	size := anArray size.
	list := self null.
	size
		to: 1
		by: -1
		do: [:i | list := self head: (anArray at: i)
						tail: list].
	^list! !

!LispList class methodsFor: 'instance creation'!
new: anInteger 
	"LispCons new: 5"

	| newList |
	newList := self null.
	anInteger timesRepeat: [newList := self head: self null tail: newList].
	^newList! !

!LispList class methodsFor: 'instance creation'!
null
	^self subclassResponsibility! !

!LispList class methodsFor: 'instance creation'!
with: anObject 
	"LispCons with: 1"

	^self head: anObject! !

!LispList class methodsFor: 'instance creation'!
with: firstObject with: secondObject 
	"LispCons with: 1 with: 2"

	^self head: firstObject tail: (self with: secondObject)! !

!LispList class methodsFor: 'instance creation'!
with: firstObject with: secondObject with: thirdObject 
	"LispCons with: 1 with: 2 with: 3"

	^self head: firstObject tail: (self with: secondObject with: thirdObject)! !

!LispList class methodsFor: 'instance creation'!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"LispCons with: 1 with: 2 with: 3 with: 4"

	^self head: firstObject tail: (self
			with: secondObject
			with: thirdObject
			with: fourthObject)! !
