'Goodies (11/18/2001 8:35:16 am)'.!


Array variableSubclass: #LispSmallTypeTable
	instanceVariableNames: 'value0 defaultValue letterValue digitValue separatorValue '
	classVariableNames: 'TypeTable '
	poolDictionaries: ''
	category: 'Goodies-Lisp'!

!LispSmallTypeTable methodsFor: 'accessing' stamp: 'nishis 6/28/1998 09:38'!
at: index put: value 
	<primitive: 61>
	index isInteger ifFalse: [^super at: index put: value].
	(index >= 1 and: [index <= self basicSize])
		ifTrue: [^self errorImproperStore].
	index = 0 ifTrue: [^value0 := value].
	value = (self at: index) ifTrue: [^value].
	^self errorImproperStore! !

!LispSmallTypeTable methodsFor: 'accessing'!
atAllDigitsPut: value 
	digitValue := value.
	0 to: self size do: [:index | (Character value: index) isDigit ifTrue: [self at: index put: value]]! !

!LispSmallTypeTable methodsFor: 'accessing'!
atAllLettersPut: value 
	letterValue := value.
	0 to: self size do: [:index | (Character value: index) isLetter ifTrue: [self at: index put: value]]! !

!LispSmallTypeTable methodsFor: 'accessing'!
atAllPut: value 
	value0 := value.
	defaultValue := value.
	letterValue := value.
	digitValue := value.
	separatorValue := value.
	^super atAllPut: value! !

!LispSmallTypeTable methodsFor: 'accessing'!
atAllSeparatorsPut: value 
	separatorValue := value.
	0 to: self size do: [:index | (Character value: index) isSeparator ifTrue: [self at: index put: value]]! !

!LispSmallTypeTable methodsFor: 'accessing'!
atDefaultPut: value 
	defaultValue := value! !

!LispSmallTypeTable methodsFor: 'accessing' stamp: 'nishis 6/28/1998 07:03'!
basicAt: index put: value 
	<primitive: 61>
	index isInteger ifFalse: [^super basicAt: index put: value].
	(index >= 1 and: [index <= self basicSize])
		ifTrue: [^self errorImproperStore].
	^super errorSubscriptBounds: index! !


!LispSmallTypeTable methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:50'!
subscriptBoundsError: index 
	| char |
	((index between: self size + 1 and: Character characterTable size)
		or: [index = 0])
		ifFalse: [^super errorSubscriptBounds: index].
	index = 0 ifTrue: [^value0].
	char := Character value: index.
	char isLetter ifTrue: [^letterValue].
	char isSeparator ifTrue: [^separatorValue].
	char isDigit ifTrue: [^digitValue].
	^defaultValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispSmallTypeTable class
	instanceVariableNames: ''!

!LispSmallTypeTable class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispSmallTypeTable class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispSmallTypeTable class methodsFor: 'copyright'!
version
	^'003'! !


!LispSmallTypeTable class methodsFor: 'table access'!
typeTable
	| newTable |
	TypeTable isNil
		ifTrue: 
			[newTable := self new: 255 withAll: #xDefault.
			newTable atAllSeparatorsPut: #xDelimiter.
			newTable atAllDigitsPut: #xDigit.
			newTable atAllLettersPut: #xLetter.
			newTable at: $_ asInteger put: #xLetter.
			'!!%&*+,-/<=>?@\~' do: [:bin | newTable at: bin asInteger put: #xBinary].
			#(177 215 183 247) do: [:bin | newTable at: bin put: #xBinary].
			newTable at: $" asInteger put: #xDoubleQuote.
			newTable at: $$ asInteger put: #xDollar.
			newTable at: $' asInteger put: #xSingleQuote.
			newTable at: $# asInteger put: #literalQuote.
			newTable at: $( asInteger put: #leftParenthesis.
			newTable at: $) asInteger put: #rightParenthesis.
			newTable at: $. asInteger put: #period.
			newTable at: $: asInteger put: #colon.
			newTable at: $; asInteger put: #semicolon.
			newTable at: $[ asInteger put: #leftBracket.
			newTable at: $] asInteger put: #rightBracket.
			newTable at: $^ asInteger put: #upArrow.
			newTable at: $| asInteger put: #verticalBar.
			TypeTable := newTable].
	^TypeTable! !
