'Goodies (11/18/2001 8:35:17 am)'.!


PrologEntity subclass: #PrologList
	instanceVariableNames: 'carPart cdrPart '
	classVariableNames: 'PrologDotPairPrintHorizontalLevel PrologDotPairPrintVerticalLevel '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologList commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologList methodsFor: 'accessing'!
car
	^carPart! !

!PrologList methodsFor: 'accessing'!
car: carObject 
	carPart := carObject! !

!PrologList methodsFor: 'accessing'!
cdr
	^cdrPart! !

!PrologList methodsFor: 'accessing'!
cdr: cdrObject 
	cdrPart := cdrObject! !

!PrologList methodsFor: 'accessing'!
nth: anInteger 
	| count list |
	anInteger <= 0 ifTrue: [^self].
	count := 1.
	list := self.
	[list consp]
		whileTrue: 
			[count >= anInteger ifTrue: [^list car].
			count := count + 1.
			list := list cdr].
	^nil! !


!PrologList methodsFor: 'testing'!
= anObject 
	anObject consp ifFalse: [^false].
	self car = anObject car ifTrue: [^self cdr = anObject cdr].
	^false! !

!PrologList methodsFor: 'testing'!
consp
	^true! !


!PrologList methodsFor: 'functions'!
append: aPrologDotPair 
	(cdrPart consp)
		ifFalse: [^carPart cons: aPrologDotPair].
	^carPart cons: (cdrPart append: aPrologDotPair)! !

!PrologList methodsFor: 'functions'!
arity
	^2! !

!PrologList methodsFor: 'functions'!
assoc: anObject 
	| list assoc |
	list := self.
	[list consp]
		whileTrue: 
			[assoc := list car.
			anObject = assoc car ifTrue: [^assoc].
			list := list cdr].
	^nil! !

!PrologList methodsFor: 'functions'!
functor
	^PrologSymbol fromString: '.'! !

!PrologList methodsFor: 'functions'!
length
	| list count |
	list := self.
	count := 0.
	[list consp]
		whileTrue: 
			[count := count + 1.
			list := list cdr].
	^count! !

!PrologList methodsFor: 'functions'!
member: anObject 
	| list |
	list := self.
	[list consp]
		whileTrue: 
			[anObject = list car ifTrue: [^list].
			list := list cdr].
	^nil! !

!PrologList methodsFor: 'functions'!
nconc: aPrologDotPair 
	| list |
	list := self.
	[list consp]
		whileTrue: [(list cdr consp)
				ifTrue: [list := list cdr]
				ifFalse: 
					[list cdr: aPrologDotPair.
					^self]].
	^aPrologDotPair! !

!PrologList methodsFor: 'functions'!
reverse
	| list revlist mark |
	list := self.
	revlist := nil.
	[list consp]
		whileTrue: 
			[revlist == nil
				ifTrue: [revlist := mark := list car cons: revlist]
				ifFalse: [revlist := list car cons: revlist].
			list := list cdr].
	mark cdr: list.
	^revlist! !

!PrologList methodsFor: 'functions'!
structureList
	"disassemble prolog structure of myself into a list."
	^self functor cons: ((self car) cons: ((self cdr) cons: nil))! !


!PrologList methodsFor: 'converting'!
asPrologList
	| list new tail |
	new := self car cons: nil.
	tail := new.
	list := self cdr.
	[list consp]
		whileTrue: 
			[tail cdr: (list car cons: nil).
			tail := tail cdr.
			list := list cdr].
	tail cdr: list.
	^new! !


!PrologList methodsFor: 'enumerating'!
do: aBlock
	| list |
	list := self.
	[list consp] whileTrue: [
		aBlock value: list car.
		list := list cdr]! !


!PrologList methodsFor: 'printing'!
prettyPrintPrologOn: aStream 
	| head body list |
	head := self car.
	body := self cdr.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ' :- '.
			list := body.
			aStream cr; tab.
			[list cdr consp]
				whileTrue: 
					[list ~~ body
						ifTrue: 
							[aStream nextPutAll: ', '.
							aStream cr; tab].
					list car printPrologOn: aStream.
					list := list cdr].
			list ~~ self
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream cr; tab].
			list car printPrologOn: aStream].
	aStream nextPut: $.! !

!PrologList methodsFor: 'printing'!
prettyPrintPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self prettyPrintPrologOn: aStream.
	^aStream contents! !

!PrologList methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self printPrologString.
	aStream nextPutAll: ')'! !

!PrologList methodsFor: 'printing'!
printPrologOn: aStream 
	self printPrologOn: aStream level: 1! !

!PrologList methodsFor: 'printing'!
printPrologOn: aStream cdr: tail level: anInteger 
	| d count |
	d := tail.
	count := 1.
	[d consp]
		whileTrue: 
			[count >= PrologDotPairPrintHorizontalLevel
				ifTrue: 
					[aStream nextPutAll: ' ... ]'.
					^self].
			aStream nextPut: $,.
			d car consp
				ifTrue: [d car printPrologOn: aStream level: anInteger + 1]
				ifFalse: [d car printPrologOn: aStream].
			"d car printPrologOn: aStream level: anInteger + 1."
			count := count + 1.
			d := d cdr].
	d isNil
		ifTrue: [aStream nextPut: $]]
		ifFalse: 
			[aStream nextPut: $|.
			d printPrologOn: aStream.
			aStream nextPut: $]]! !

!PrologList methodsFor: 'printing'!
printPrologOn: aStream level: anInteger 
	anInteger > PrologDotPairPrintVerticalLevel
		ifTrue: 
			[aStream nextPutAll: ' ... '.
			^self].
	aStream nextPutAll: '['.
	carPart consp
		ifTrue: [carPart printPrologOn: aStream level: anInteger + 1]
		ifFalse: [carPart printPrologOn: aStream].
	self
		printPrologOn: aStream
		cdr: cdrPart
		level: anInteger! !


!PrologList methodsFor: 'private'!
car: carObject cdr: cdrObject 
	carPart := carObject.
	cdrPart := cdrObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologList class
	instanceVariableNames: ''!

!PrologList class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologList class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologList class methodsFor: 'copyright'!
version
	^'003'! !


!PrologList class methodsFor: 'class initialization'!
initialize
	"PrologList initialize"

	PrologDotPairPrintVerticalLevel := 10.
	PrologDotPairPrintHorizontalLevel := 100! !


!PrologList class methodsFor: 'instance creation'!
car: carObject cdr: cdrObject 
	^super new car: carObject cdr: cdrObject! !

!PrologList class methodsFor: 'instance creation'!
list: anArray
	| size list |
	size := anArray size.
	list := nil.
	size
		to: 1
		by: -1
		do: [:i | list := self car: (anArray at: i) cdr: list].
	^list! !


PrologList initialize!
