'Goodies (11/18/2001 8:35:17 am)'.!


PrologString subclass: #PrologSymbol
	instanceVariableNames: ''
	classVariableNames: 'PrologCut PrologFail PrologSelf PrologSend PrologSymbolTable PrologTrue PrologVar '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologSymbol commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologSymbol methodsFor: 'accessing'!
arity
	^0! !

!PrologSymbol methodsFor: 'accessing'!
functor
	^self! !


!PrologSymbol methodsFor: 'testing'!
isBuiltInPredicate
	self isPrologCut ifTrue: [^true].
	self isPrologTrue ifTrue: [^true].
	self isPrologFail ifTrue: [^true].
	self isPrologSend ifTrue: [^true].
	self isPrologVar ifTrue: [^true].
	^false! !

!PrologSymbol methodsFor: 'testing'!
isPrologCut
	^self = PrologCut! !

!PrologSymbol methodsFor: 'testing'!
isPrologFail
	^self = PrologFail! !

!PrologSymbol methodsFor: 'testing'!
isPrologSelf
	^self = PrologSelf! !

!PrologSymbol methodsFor: 'testing'!
isPrologSend
	^self = PrologSend! !

!PrologSymbol methodsFor: 'testing'!
isPrologTrue
	^self = PrologTrue! !

!PrologSymbol methodsFor: 'testing'!
isPrologVar
	^self = PrologVar! !


!PrologSymbol methodsFor: 'printing'!
printPrologOn: aStream 
	| map flag firstChar i length x |
	map := PrologCharMap symbolMap.
	flag := false.
	self do: [:each | (map at: each asInteger)
			ifFalse: [flag := true]].
	string isEmpty
		ifTrue: 
			[aStream nextPutAll: ''''.
			aStream nextPutAll: '''']
		ifFalse: 
			[firstChar := string at: 1.
			((firstChar >= $A and: [firstChar <= $Z])
				or: [flag])
				ifTrue: 
					[aStream nextPutAll: ''''.
					i := 0.
					length := string size.
					[(i := i + 1) <= length]
						whileTrue: 
							[aStream nextPut: (x := string at: i).
							x == $' ifTrue: [aStream nextPut: x]].
					aStream nextPutAll: '''']
				ifFalse: 
					[i := 0.
					length := string size.
					[(i := i + 1) <= length]
						whileTrue: 
							[aStream nextPut: (x := string at: i).
							x == $' ifTrue: [aStream nextPut: x]]]]! !

!PrologSymbol methodsFor: 'printing'!
printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologSymbol class
	instanceVariableNames: ''!

!PrologSymbol class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologSymbol class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologSymbol class methodsFor: 'copyright'!
version
	^'003'! !


!PrologSymbol class methodsFor: 'class initialization'!
initialize
	"PrologSymbol initialize"

	PrologSymbolTable := Dictionary new.
	PrologCut := self install: '!!'.
	PrologTrue := self install: 'true'.
	PrologFail := self install: 'fail'.
	PrologSend := self install: 'send'.
	PrologVar := self install: 'var'.
	PrologSelf := self install: 'self'! !


!PrologSymbol class methodsFor: 'instance creation'!
install: aString 
	| symbol key |
	symbol := PrologSymbolTable at: aString ifAbsent: [nil].
	symbol == nil
		ifTrue: 
			[key := self fromString: aString.
			symbol := self fromString: aString.
			PrologSymbolTable at: key put: symbol].
	^symbol! !

!PrologSymbol class methodsFor: 'instance creation' stamp: 'nishis 5/8/98 22:48'!
readFrom: aStream 
	| map buffer char |
	map := PrologCharMap symbolMap.
	buffer := WriteStream on: (String new: 20).
	char := aStream peek.
	char == $'
		ifTrue: 
			[aStream next.
			
			[char := aStream peek.
			char ~~ nil]
				whileTrue: 
					[char = $'
						ifTrue: 
							[aStream next.
							char := aStream peek.
							char = $' ifFalse: [^self install: buffer contents]].
					buffer nextPut: aStream next].
		Debugger
				openContext: thisContext
				label: 'Error'
				contents: 'Syntax error near $'' unmatched $''\-- end of file --' withCRs].
	(self expect: '=..' on: aStream)
		ifTrue: ["Non standard (or ad hoc) parsing patterns."
			^self install: '=..'].
	[char ~~ nil and: [map at: char asInteger]]
		whileTrue: 
			[buffer nextPut: aStream next.
			char := aStream peek].
	^self install: buffer contents! !


!PrologSymbol class methodsFor: 'constants'!
cut
	^PrologCut! !


!PrologSymbol class methodsFor: 'private'!
expect: aString on: aStream
	"If aStream contains aString at the current position, then return true and set the position of aStream to the next char of the string.
	else return false and rewind the position."

	| pos string |
	pos := aStream position.
	string := String new.
	aString size timesRepeat: [
		aStream atEnd ifFalse: [string := string , (String with: aStream next)]].
	aString = string
		ifTrue: [^true]
		ifFalse: [
			aStream position: pos.
			^false]! !


PrologSymbol initialize!
