'Goodies (11/18/2001 8:35:19 am)'.!


PluggableStringHolderModel subclass: #LispInterpreter
	instanceVariableNames: 'lispTable bindStack failBlock textValue textCollector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Lisp'!
!LispInterpreter commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Lisp
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Lisp
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Lisp.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Lisp.txt
!


!LispInterpreter methodsFor: 'initialize-release' stamp: 'nishis 4/25/98 04:08'!
initialize
	super initialize.
	lispTable := LispTable new.
	bindStack := OrderedCollection new.
	failBlock := [:errorMessage | self error: 'error' with: errorMessage].
	self initializeSubrFunctions.
	self initializeFsubrFunctions.
	self initializeExprFunctions.
	self initializeFexprFunctions.
	textCollector := TranscriptStream new! !

!LispInterpreter methodsFor: 'initialize-release'!
initializeExprFunctions
	self evaluateTopLevel: (LispParser parse: '

	% Expr Functions
	(progn

		% ++
		(defun ++ lambda (x)
			(+ x 1))

		% --
		(defun -- lambda (x)
			(- x 1))

		% assoc
		(defun assoc lambda (x a)
			(cond
				((null a) nil)
				((equal x (car (car a))) (car a))
				(t (assoc x (cdr a)))))

		% copy
		(defun copy lambda (x)
			(cond
				((null x) nil)
				(t (cons (car x) (copy (cdr x))))))

		% mapc
		(defun mapc lambda (f x)
			(cond
				((null x) nil)
				(t (progn
					(eval (cons f (cons `(car x) nil)))
					(mapc f (cdr x))))))

		% mapcar
		(defun mapcar lambda (f x)
			(cond
				((null x) nil)
				(t (cons
					(eval (cons f (cons `(car x) nil)))
					(mapcar f (cdr x))))))
			
		) % end

	')! !

!LispInterpreter methodsFor: 'initialize-release'!
initializeFexprFunctions
	self evaluateTopLevel: (LispParser parse: '

	% Expr Functions
	(progn

		% and
		(defun and nlambda (x)
			(do	(list)
				(setq list x)
				(while
					(if (null list) then nil else (eval (car list)))
					do
					(setq list (cdr list)))
				(if (null list) then t else nil)))

		% list
		(defun list nlambda (x)
			(mapcar `eval x))

		% or
		(defun or nlambda (x)
			(do	(list)
				(setq list x)
				(while
					(if (null list) then nil else (not (eval (car list))))
					do
					(setq list (cdr list)))
				(if (null list) then nil else t)))

		) % end

	')! !

!LispInterpreter methodsFor: 'initialize-release'!
initializeFsubrFunctions
	self setFsubrFunc: #(#* #fsubrMlt:).
	self setFsubrFunc: #(#+ #fsubrAdd:).
	self setFsubrFunc: #(#- #fsubrSub:).
	self setFsubrFunc: #(#/ #fsubrDiv:).
	self setFsubrFunc: #(#// #fsubrIdiv:).
	self setFsubrFunc: #(#cond #fsubrCond:).
	self setFsubrFunc: #(#defun #fsubrDefun:).
	self setFsubrFunc: #(#do #fsubrDo:).
	self setFsubrFunc: #(#if #fsubrIf:).
	self setFsubrFunc: #(#progn #fsubrProgn:).
	self setFsubrFunc: #(#quote #fsubrQuote:).
	self setFsubrFunc: #(#read #fsubrRead:).
	self setFsubrFunc: #(#repeat #fsubrRepeat:).
	self setFsubrFunc: #(#send #fsubrSend:).
	self setFsubrFunc: #(#setq #fsubrSetq:).
	self setFsubrFunc: #(#while #fsubrWhile:).
	self setFsubrFunc: #(#\\ #fsubrMod:).! !

!LispInterpreter methodsFor: 'initialize-release'!
initializeSubrFunctions
	self setSubrFunc: #(#< #subrLt: 2).
	self setSubrFunc: #(#<= #subrLe: 2).
	self setSubrFunc: #(#= #subrEqual: 2).
	self setSubrFunc: #(#== #subrEq: 2).
	self setSubrFunc: #(#> #subrGt: 2).
	self setSubrFunc: #(#>= #subrGe: 2).
	self setSubrFunc: #(#append #subrAppend: 2).
	self setSubrFunc: #(#atom #subrAtom: 1).
	self setSubrFunc: #(#car #subrCar: 1).
	self setSubrFunc: #(#cdr #subrCdr: 1).
	self setSubrFunc: #(#cons #subrCons: 2).
	self setSubrFunc: #(#consp #subrConsp: 1).
	self setSubrFunc: #(#dtpr #subrConsp: 1).
	self setSubrFunc: #(#doublep #subrDoublep: 1).
	self setSubrFunc: #(#eq #subrEq: 2).
	self setSubrFunc: #(#equal #subrEqual: 2).
	self setSubrFunc: #(#eval #subrEval: 1).
	self setSubrFunc: #(#exprs #subrExprs 0).
	self setSubrFunc: #(#fexprs #subrFexprs 0).
	self setSubrFunc: #(#floatp #subrFloatp: 1).
	self setSubrFunc: #(#fsubrs #subrFsubrs 0).
	self setSubrFunc: #(#gc #subrGc 0).
	self setSubrFunc: #(#gensym #subrGensym 0).
	self setSubrFunc: #(#getprop #subrGetprop: 2).
	self setSubrFunc: #(#integerp #subrIntegerp: 1).
	self setSubrFunc: #(#last #subrLast: 1).
	self setSubrFunc: #(#length #subrLength: 1).
	self setSubrFunc: #(#listp #subrListp: 1).
	self setSubrFunc: #(#member #subrMember: 2).
	self setSubrFunc: #(#memq #subrMemq: 2).
	self setSubrFunc: #(#nconc #subrNconc: 2).
	self setSubrFunc: #(#neq #subrNeq: 2).
	self setSubrFunc: #(#nequal #subrNequal: 2).
	self setSubrFunc: #(#not #subrNull: 1).
	self setSubrFunc: #(#nth #subrNth: 2).
	self setSubrFunc: #(#null #subrNull: 1).
	self setSubrFunc: #(#numberp #subrNumberp: 1).
	self setSubrFunc: #(#oblist #subrOblist 0).
	self setSubrFunc: #(#pp #subrPp: 1).
	self setSubrFunc: #(#princ #subrPrinc: 1).
	self setSubrFunc: #(#print #subrPrint: 1).
	self setSubrFunc: #(#putprop #subrPutprop: 3).
	self setSubrFunc: #(#remprop #subrRemprop: 2).
	self setSubrFunc: #(#reverse #subrReverse: 1).
	self setSubrFunc: #(#rplaca #subrRplaca: 2).
	self setSubrFunc: #(#rplacd #subrRplacd: 2).
	self setSubrFunc: #(#stringp #subrStringp: 1).
	self setSubrFunc: #(#subrs #subrSubrs 0).
	self setSubrFunc: #(#symbolp #subrSymbolp: 1).
	self setSubrFunc: #(#terpri #subrTerpri 0).
	self setSubrFunc: #(#~= #subrNequal: 2).
	self setSubrFunc: #(#~~ #subrNeq: 2)! !


!LispInterpreter methodsFor: 'accessing'!
textCollector
	^textCollector! !


!LispInterpreter methodsFor: 'pluggable messages' stamp: 'nishis 5/3/98 11:10'!
menu
	| collection |
	selectionMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'find...' -> #find.
			collection add: 'find again' -> #findAgain.
			collection add: 'set search string' -> #setSearchString.
			collection add: nil.
			collection add: 'do again' -> #again.
			collection add: 'undo' -> #undo.
			collection add: nil.
			collection add: 'copy' -> #copySelection.
			collection add: 'cut' -> #cut.
			collection add: 'paste' -> #paste.
			collection add: nil.
			collection add: 'do it' -> #doIt:from:.
			"collection add: 'print it' -> #printIt."
			collection add: 'inspect it' -> #inspectIt:from:.
			collection add: nil.
			collection add: 'accept' -> #accept.
			collection add: 'cancel' -> #cancel.
			collection add: nil.
			collection add: '--- lisp ---' -> #toBeIgnored.	
			collection add: 'gc' -> #subrGc.	
			collection add: 'investigate' -> #investigate.	
			selectionMenu := self makeSelectionMenu: collection].
	^ selectionMenu! !


!LispInterpreter methodsFor: 'property access'!
getprop: identifier key: key 
	| value |
	lispTable intern: identifier.
	value := lispTable getprop: identifier key: key.
	value isNil ifTrue: [^LispNil null].
	^value! !

!LispInterpreter methodsFor: 'property access'!
putprop: identifier key: key value: value 
	lispTable intern: identifier.
	^lispTable
		putprop: identifier
		key: key
		value: value! !

!LispInterpreter methodsFor: 'property access'!
remprop: identifier key: key 
	| value |
	lispTable intern: identifier.
	value := lispTable remprop: identifier key: key.
	value isNil ifTrue: [^LispNil null].
	^value! !


!LispInterpreter methodsFor: 'evaluating'!
evaluate: sExpression 
	| apval |
	(sExpression isKindOf: LispList)
		ifTrue: [^self listEvaluate: sExpression].
	(sExpression isKindOf: Symbol)
		ifTrue: 
			[sExpression = #t ifTrue: [^#t].
			lispTable intern: sExpression.
			apval := lispTable getprop: sExpression key: #apval.
			apval isNil ifTrue: [^self fatal: (self printString: sExpression)
						, ' is unbound atom'].
			^apval].
	^sExpression! !

!LispInterpreter methodsFor: 'evaluating'!
evaluateTopLevel: sExpression 
	| result |
	failBlock := 
			[:errorMessage | 
			textCollector show: errorMessage; cr.
			Cursor normal show.
			^LispNil null].
	Cursor execute showWhile: [result := self evaluate: sExpression].
	^result! !

!LispInterpreter methodsFor: 'evaluating'!
evaluateTopLevel: sExpression ifFail: aBlock 
	failBlock := aBlock.
	^self evaluate: sExpression! !

!LispInterpreter methodsFor: 'evaluating'!
listEvaluate: sExpression 
	| funcName arguList funcBody |
	sExpression null ifTrue: [^sExpression].
	funcName := sExpression head.
	arguList := sExpression tail.
	(funcName isKindOf: LispCons)
		ifTrue: 
			[funcBody := funcName.
			funcBody head = #lambda
				ifTrue: 
					[funcBody := LispCons head: #lambda tail: funcBody.
					^self exprEval: funcBody arguList: arguList].
			funcBody head = #nlambda
				ifTrue: 
					[funcBody := LispCons head: #nlambda tail: funcBody.
					^self fexprEval: funcBody arguList: arguList].
			^self fatal: 'unexpected function ' , (self printString: funcBody)].
	(funcName isKindOf: Symbol)
		ifFalse: [^self fatal: 'null function ' , (self printString: funcName)].
	funcBody := self getprop: funcName key: #fexpr.
	funcBody = LispNil null ifFalse: [^self fexprEval: funcBody arguList: arguList].
	funcBody := self getprop: funcName key: #expr.
	funcBody = LispNil null ifFalse: [^self exprEval: funcBody arguList: arguList].
	funcBody := self getprop: funcName key: #fsubr.
	funcBody = LispNil null ifFalse: [^self fsubrEval: funcBody arguList: arguList].
	funcBody := self getprop: funcName key: #subr.
	funcBody = LispNil null ifFalse: [^self subrEval: funcBody arguList: arguList].
	^self fatal: 'undefined function ' , (self printString: funcName)! !


!LispInterpreter methodsFor: 'func eval'!
exprEval: funcBody arguList: arguList 
	| expression funcName lvarList lvar result |
	expression := funcBody.
	funcName := expression head.
	expression := expression tail.
	expression := expression tail.
	lvarList := expression head.
	expression := expression tail.
	arguList length ~= lvarList length ifTrue: [^self fatal: 'too few or many arguments ' , (self printString: arguList) , ' vs ' , (self printString: lvarList) , ' for ' , funcName].
	self bindMark.
	arguList
		do: 
			[:each | 
			lvar := lvarList head.
			self bind: lvar value: (self evaluate: each).
			lvarList := lvarList tail].
	expression do: [:each | result := self evaluate: each].
	self unbind.
	^result! !

!LispInterpreter methodsFor: 'func eval'!
fexprEval: funcBody arguList: arguList 
	| expression funcName lvarList lvar result |
	expression := funcBody.
	funcName := expression head.
	expression := expression tail.
	expression := expression tail.
	lvarList := expression head.
	expression := expression tail.
	lvarList length ~= 1 ifTrue: [^self fatal: 'too few or many arguments ' , (self printString: lvarList) , ' for ' , (self printString: funcName)].
	self bindMark.
	lvar := lvarList head.
	self bind: lvar value: arguList.
	expression do: [:each | result := self evaluate: each].
	self unbind.
	^result! !

!LispInterpreter methodsFor: 'func eval'!
fsubrEval: funcBody arguList: arguList 
	| messageSelector |
	messageSelector := funcBody tail head.
	^self perform: messageSelector with: arguList! !

!LispInterpreter methodsFor: 'func eval'!
subrEval: funcBody arguList: arguList 
	| funcName messageSelector arguCount arguBuffer list |
	funcName := funcBody head.
	messageSelector := funcBody tail head.
	arguCount := funcBody tail tail head.
	arguBuffer := OrderedCollection new.
	list := arguList.
	arguCount
		timesRepeat: 
			[list null ifTrue: [^self fatal: 'too few arguments for ' , (self printString: funcName)].
			arguBuffer add: (self evaluate: list head).
			list := list tail].
	list null not ifTrue: [^self fatal: 'too mary arguments for ' , (self printString: funcName)].
	arguBuffer isEmpty
		ifTrue: [^self perform: messageSelector]
		ifFalse: [^self perform: messageSelector with: arguBuffer asArray]! !


!LispInterpreter methodsFor: 'subr functions'!
subrAppend: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for append'].
	(a2 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for append'].
	^a1 append: a2! !

!LispInterpreter methodsFor: 'subr functions'!
subrAtom: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: LispCons) ifFalse: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrCar: arguArray 
	| list |
	list := arguArray at: 1.
	(list isKindOf: LispCons)
		ifTrue: [^list head].
	(list isKindOf: LispNil)
		ifTrue: [^LispNil null].
	^self fatal: 'unexpected argument ' , (self printString: list) , ' for car'! !

!LispInterpreter methodsFor: 'subr functions'!
subrCdr: arguArray 
	| list |
	list := arguArray at: 1.
	(list isKindOf: LispCons)
		ifTrue: [^list tail].
	(list isKindOf: LispNil)
		ifTrue: [^LispNil null].
	^self fatal: 'unexpected argument ' , (self printString: list) , ' for cdr'! !

!LispInterpreter methodsFor: 'subr functions'!
subrCons: arguArray 
	^LispCons head: (arguArray at: 1)
		tail: (arguArray at: 2)! !

!LispInterpreter methodsFor: 'subr functions'!
subrConsp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: LispCons)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrDoublep: arguArray 
	| a1 |
	^self subrFloatp: arguArray
	"a1 := arguArray at: 1.
	(a1 isKindOf: Double)
		ifTrue: [^#t].
	^LispNil null"! !

!LispInterpreter methodsFor: 'subr functions'!
subrEq: arguArray 
	| bool |
	(arguArray at: 1)
		== (arguArray at: 2)
		ifTrue: [bool := #t]
		ifFalse: [bool := LispNil null].
	^bool! !

!LispInterpreter methodsFor: 'subr functions'!
subrEqual: arguArray 
	| bool |
	(arguArray at: 1)
		= (arguArray at: 2)
		ifTrue: [bool := #t]
		ifFalse: [bool := LispNil null].
	^bool! !

!LispInterpreter methodsFor: 'subr functions'!
subrEval: arguArray 
	^self evaluate: (arguArray at: 1)! !

!LispInterpreter methodsFor: 'subr functions'!
subrExprs
	| list |
	list := LispNil null.
	self subrOblist reverse do: [:id | (self getprop: id key: #expr)
			= LispNil null ifFalse: [list := LispCons head: id tail: list]].
	^list! !

!LispInterpreter methodsFor: 'subr functions'!
subrFexprs
	| list |
	list := LispNil null.
	self subrOblist reverse do: [:id | (self getprop: id key: #fexpr)
			= LispNil null ifFalse: [list := LispCons head: id tail: list]].
	^list! !

!LispInterpreter methodsFor: 'subr functions'!
subrFloatp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: Float)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrFsubrs
	| list |
	list := LispNil null.
	self subrOblist reverse do: [:id | (self getprop: id key: #fsubr)
			= LispNil null ifFalse: [list := LispCons head: id tail: list]].
	^list! !

!LispInterpreter methodsFor: 'subr functions' stamp: 'nishis 4/20/98 23:40'!
subrGc
	"ObjectMemory globalCompactingGC."
	Transcript cr; show: 'garbage collecting: ', (Smalltalk garbageCollect) asString, ' bytes are available.'.
	^#t! !

!LispInterpreter methodsFor: 'subr functions'!
subrGe: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for >='].
	(a2 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for >='].
	a1 >= a2 ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrGensym
	| clock |
	(Delay forMilliseconds: 1) wait.
	clock := Time millisecondClockValue.
	^('id' , clock printString) asSymbol! !

!LispInterpreter methodsFor: 'subr functions'!
subrGetprop: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for getprop'].
	(a2 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for getprop'].
	^self getprop: a1 key: a2! !

!LispInterpreter methodsFor: 'subr functions'!
subrGt: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for >'].
	(a2 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for >'].
	a1 > a2 ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrIntegerp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: Integer)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrLast: arguArray 
	| list |
	list := arguArray at: 1.
	(list isKindOf: LispCons)
		ifTrue: [^list last].
	^self fatal: 'unexpected argument ' , (self printString: list) , ' for last'! !

!LispInterpreter methodsFor: 'subr functions'!
subrLe: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for <='].
	(a2 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for <='].
	a1 <= a2 ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrLength: arguArray 
	| list |
	list := arguArray at: 1.
	(list isKindOf: LispCons)
		ifTrue: [^list length].
	^self fatal: 'unexpected argument ' , (self printString: list) , ' for length'! !

!LispInterpreter methodsFor: 'subr functions'!
subrListp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: LispList)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrLt: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for <'].
	(a2 isKindOf: LispList)
		ifTrue: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for <'].
	a1 < a2 ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrMember: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a2 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for member'].
	^a2 member: a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrMemq: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a2 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for memq'].
	^a2 memq: a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrNconc: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for nconc'].
	a1 nconc: a2.
	^a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrNeq: arguArray 
	| bool |
	((arguArray at: 1)
		== (arguArray at: 2)) not
		ifTrue: [bool := #t]
		ifFalse: [bool := LispNil null].
	^bool! !

!LispInterpreter methodsFor: 'subr functions'!
subrNequal: arguArray 
	| bool |
	((arguArray at: 1)
		= (arguArray at: 2)) not
		ifTrue: [bool := #t]
		ifFalse: [bool := LispNil null].
	^bool! !

!LispInterpreter methodsFor: 'subr functions'!
subrNth: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: Number)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for nth'].
	(a2 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for nth'].
	^a2 nth: a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrNull: arguArray 
	((arguArray at: 1)
		isMemberOf: LispNil)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrNumberp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: Number)
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrOblist
	| list |
	list := LispNil null.
	lispTable identifiers reverseDo: [:each | list := LispCons head: each tail: list].
	^list! !

!LispInterpreter methodsFor: 'subr functions'!
subrPp: arguArray 
	| a pretty |
	a := arguArray at: 1.
	pretty := a ppString.
	textCollector show: pretty.
	^a! !

!LispInterpreter methodsFor: 'subr functions'!
subrPrinc: arguArray 
	| a |
	a := arguArray at: 1.
	(a isKindOf: String)
		ifTrue: [textCollector show: a]
		ifFalse: [textCollector show: (self printString: a)].
	^a! !

!LispInterpreter methodsFor: 'subr functions'!
subrPrint: arguArray 
	| a |
	a := self subrPrinc: arguArray.
	textCollector cr.
	^a! !

!LispInterpreter methodsFor: 'subr functions'!
subrPutprop: arguArray 
	| a1 a2 a3 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	a3 := arguArray at: 3.
	(a1 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for putprop'].
	(a2 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for putprop'].
	^self
		putprop: a1
		key: a2
		value: a3! !

!LispInterpreter methodsFor: 'subr functions' stamp: 'nishis 4/21/98 01:22'!
subrRead
	| answer theClipboardText |
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: String new.
	answer := FillInTheBlank request: '          Please type S expression.          ' initialAnswer: ''.
	Smalltalk clipboardText: theClipboardText.
	(answer isNil or: [answer isEmpty])
		ifTrue: 
			[^LispNil null].
	^LispParser parse: (ReadStream on: answer)! !

!LispInterpreter methodsFor: 'subr functions'!
subrRemprop: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for remprop'].
	(a2 isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for remprop'].
	^self remprop: a1 key: a2! !

!LispInterpreter methodsFor: 'subr functions'!
subrReverse: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a1) , ' for reverse'].
	^a1 reverse! !

!LispInterpreter methodsFor: 'subr functions'!
subrRplaca: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for rplaca'].
	a1 rplaca: a2.
	^a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrRplacd: arguArray 
	| a1 a2 |
	a1 := arguArray at: 1.
	a2 := arguArray at: 2.
	(a1 isKindOf: LispCons)
		ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a2) , ' for rplacd'].
	a1 rplacd: a2.
	^a1! !

!LispInterpreter methodsFor: 'subr functions'!
subrStringp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	((a1 isKindOf: String)
		and: [(a1 isKindOf: Symbol) not])
		ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrSubrs
	| list |
	list := LispNil null.
	self subrOblist reverse do: [:id | (self getprop: id key: #subr)
			= LispNil null ifFalse: [list := LispCons head: id tail: list]].
	^list! !

!LispInterpreter methodsFor: 'subr functions'!
subrSymbolp: arguArray 
	| a1 |
	a1 := arguArray at: 1.
	(a1 isKindOf: Symbol) ifTrue: [^#t].
	^LispNil null! !

!LispInterpreter methodsFor: 'subr functions'!
subrTerpri
	textCollector cr.
	^#t! !


!LispInterpreter methodsFor: 'fsubr functions'!
fsubrAdd: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for +'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v + a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrCond: arguList 
	| result |
	arguList do: [:each | (self evaluate: each head)
			~= LispNil null
			ifTrue: 
				[result := LispNil null.
				(each tail isKindOf: LispCons)
					ifTrue: [each tail do: [:expr | result := self evaluate: expr]].
				^result]].
	^LispNil null! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrDefun: arguList 
	| funcName funcType |
	funcName := arguList head.
	(funcName isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected function name ' , (self printString: funcName) , ' for defun'].
	funcType := arguList tail head.
	funcType = #lambda
		ifTrue: 
			[self
				putprop: funcName
				key: #expr
				value: arguList.
			^funcName].
	funcType = #nlambda
		ifTrue: 
			[self
				putprop: funcName
				key: #fexpr
				value: arguList.
			^funcName].
	self
		putprop: funcName
		key: #expr
		value: (LispCons head: funcName tail: (LispCons head: #lambda tail: arguList tail)).
	^funcName! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrDiv: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for /'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v / a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrDo: arguList 
	| locals executions result |
	locals := arguList head.
	executions := arguList tail.
	self bindMark.
	locals do: [:lvar | self bind: lvar value: LispNil null].
	result := LispNil null.
	executions do: [:each | result := self evaluate: each].
	self unbind.
	^result! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrIdiv: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for //'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v // a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrIf: arguList 
	| predicate then list truePart falsePart bool result |
	predicate := arguList head.
	then := arguList tail head.
	list := arguList tail tail.
	truePart := LispNil null.
	falsePart := LispNil null.
	bool := true.
	list do: [:each | each = #else
			ifTrue: [bool := false]
			ifFalse: [bool
					ifTrue: [truePart := LispCons head: each tail: truePart]
					ifFalse: [falsePart := LispCons head: each tail: falsePart]]].
	then = #then ifFalse: [^self fatal: 'unexpected format for if'].
	truePart := truePart reverse.
	falsePart := falsePart reverse.
	result := LispNil null.
	(self evaluate: predicate)
		= LispNil null
		ifTrue: [falsePart do: [:each | result := self evaluate: each]]
		ifFalse: [truePart do: [:each | result := self evaluate: each]].
	^result! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrMlt: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for *'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v * a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrMod: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for \\'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v \\ a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrProgn: arguList 
	| result |
	result := LispNil null.
	arguList do: [:each | result := self evaluate: each].
	^result! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrQuote: arguList
	^arguList head! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrRead: arguList 
	| message default answer theClipboardText |
	message := '          Please type S expression.          '.
	default := String new.
	arguList length >= 1
		ifTrue: 
			[message := self evaluate: (arguList nth: 1).
			(message isKindOf: String)
				ifFalse: [message := self printString: message]].
	arguList length >= 2
		ifTrue: 
			[default := self evaluate: (arguList nth: 2).
			(default isKindOf: String)
				ifFalse: [default := self printString: default]].
	theClipboardText := Smalltalk clipboardText.
	Smalltalk clipboardText: ''.
	answer := FillInTheBlank request: message initialAnswer: default.
	Smalltalk clipboardText: theClipboardText.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^LispNil null].
	^LispParser parse: (ReadStream on: answer)! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrRepeat: arguList 
	| reverse predicate until executions result |
	reverse := arguList reverse.
	predicate := reverse head.
	until := reverse tail head.
	executions := reverse tail tail reverse.
	until = #until ifFalse: [^self fatal: 'unexpected format for repeat'].
	result := LispNil null.
	executions do: [:each | result := self evaluate: each].
	[(self evaluate: predicate)
		= LispNil null]
		whileFalse: [executions do: [:each | result := self evaluate: each]].
	^result! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrSend: arguList 
	| list receiver selector arguments result |
	list := arguList.
	receiver := self evaluate: list head.
	list := list tail.
	selector := self evaluate: list head.
	(selector isKindOf: Symbol)
		ifFalse: [^self fatal: 'unexpected selector ' , (self printString: selector) , ' for send'].
	list := list tail.
	arguments := OrderedCollection new.
	[list isKindOf: LispCons]
		whileTrue: 
			[arguments add: (self evaluate: list head).
			list := list tail].
	result := receiver perform: selector withArguments: arguments asArray.
	^result! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrSetq: arguList 
	| list a1 a2 |
	list := arguList.
	a2 := LispNil null.
	[list isKindOf: LispCons]
		whileTrue: 
			[a1 := list head.
			(a1 isKindOf: Symbol)
				ifFalse: [^self fatal: 'unexpected variable ' , (self printString: a1) , ' for setq'].
			list := list tail.
			a2 := self evaluate: list head.
			self
				putprop: a1
				key: #apval
				value: a2.
			list := list tail].
	^a2! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrSub: arguList 
	| v a |
	v := LispNil null.
	arguList
		do: 
			[:each | 
			a := self evaluate: each.
			(a isKindOf: Number)
				ifFalse: [^self fatal: 'unexpected argument ' , (self printString: a) , ' for -'].
			v = LispNil null
				ifTrue: [v := a]
				ifFalse: [v := v - a]].
	^v! !

!LispInterpreter methodsFor: 'fsubr functions'!
fsubrWhile: arguList 
	| predicate do executions result |
	predicate := arguList head.
	do := arguList tail head.
	executions := arguList tail tail.
	do = #do ifFalse: [^self fatal: 'unexpected format for while'].
	result := LispNil null.
	[(self evaluate: predicate)
		= LispNil null]
		whileFalse: [executions do: [:each | result := self evaluate: each]].
	^result! !


!LispInterpreter methodsFor: 'shallow binding'!
bind: symbol value: value 
	| saveValue assoc |
	lispTable intern: symbol.
	saveValue := lispTable getprop: symbol key: #apval.
	assoc := Association key: symbol value: saveValue.
	bindStack addLast: assoc.
	self
		putprop: symbol
		key: #apval
		value: value! !

!LispInterpreter methodsFor: 'shallow binding'!
bindMark
	| assoc |
	assoc := Association key: nil value: nil.
	bindStack addLast: assoc! !

!LispInterpreter methodsFor: 'shallow binding'!
unbind
	| assoc |
	
	[assoc := bindStack removeLast.
	assoc key notNil]
		whileTrue: [assoc value notNil
				ifTrue: [self
						putprop: assoc key
						key: #apval
						value: assoc value]
				ifFalse: [self remprop: assoc key key: #apval]]! !


!LispInterpreter methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:04'!
error: labelString with: contentsString
	self class error: labelString with: contentsString! !

!LispInterpreter methodsFor: 'error handling'!
fatal: message 
	bindStack reverseDo: [:assoc | assoc key notNil ifTrue: [assoc value notNil
				ifTrue: [self
						putprop: assoc key
						key: #apval
						value: assoc value]
				ifFalse: [self remprop: assoc key key: #apval]]].
	^failBlock value: '*** Error: ' , message! !


!LispInterpreter methodsFor: 'executing'!
execute: aStream 
	| start list end string result |
	self skipSeparators: aStream.
	start := aStream position + 1.
	list := LispParser parse: aStream.
	end := aStream position.
	string := aStream contents copyFrom: start to: end.
	textCollector show: '> ' , string.
	textCollector cr.
	result := self evaluateTopLevel: list.
	textCollector show: (self printString: result).
	textCollector cr.
	^result! !


!LispInterpreter methodsFor: 'adaptor' stamp: 'nishis 5/3/98 11:05'!
textValue
	textValue isNil ifTrue: [textValue := String new].
	^textValue! !


!LispInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 10:46'!
doIt: aText from: aController 
	| stream result |
	self acceptWith: aText.
	"see BrowserView browseFullForClass: PluggableStringHolderController method: #sendMenuMessageToModel:."
	stream := ReadStream on: aText asString.
	result := LispNil null.
	[stream atEnd]
		whileFalse: 
			[result := self execute: stream.
			self skipSeparators: stream].
	^result! !

!LispInterpreter methodsFor: 'menu messages' stamp: 'nishis 5/3/98 10:47'!
inspectIt: aText from: aController 
	| result |
	self acceptWith: aText.
	"see BrowserView browseFullForClass: PluggableStringHolderController method: #sendMenuMessageToModel:."
	result := self doIt: aText from: aController.
	result inspect.
	^result! !

!LispInterpreter methodsFor: 'menu messages'!
investigate
	self inspect! !

!LispInterpreter methodsFor: 'menu messages' stamp: 'nishis 4/25/98 03:41'!
toBeIgnored! !


!LispInterpreter methodsFor: 'interface opening' stamp: 'nishis 4/27/98 04:36'!
buttonsView: aController
	| baseView doItView inspectItView gcView width height |
	width := 250 / 4.
	height := 16.
	baseView := View new 
			model: self;
			backgroundColor: Color white;
			window: (0 @ 0 extent: 250 @ height);
			borderWidthLeft: 2 right: 2 top: 2 bottom: 0.
	doItView := self 
		buttonView: baseView 
		onAction: [self doIt: aController selection from: aController] 
		label: 'do it' 
		extent: width @ height 
		align: #addSubView:
		targetView: nil.
	inspectItView := self 
		buttonView: baseView 
		onAction: [self inspectIt: aController selection from: aController] 
		label: 'inspect it' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: doItView.
	gcView := self 
		buttonView: baseView 
		onAction: [self perform: #subrGc] 
		label: 'gc' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: inspectItView.
	self 
		buttonView: baseView 
		onAction: [self perform: #investigate] 
		label: 'investigate' 
		extent: width @ height 
		align: #addSubView:toRightOf: 
		targetView: gcView.
	^baseView
! !

!LispInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 01:55'!
fullOpen
	"LispInterpreter fullOpen."

	| topView questionView transcriptView btns |
	topView := StandardSystemView new
			model: self;
			backgroundColor: Color white;
			label: 'Lisp';
			minimumSize: 250 @ 300.
	questionView := PluggableStringHolderView
			on: self
			aspect: #contents
			change: #contents:
			menu: #menu.
	questionView
			window: (0 @ 0 extent: 250 @ 100);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	transcriptView := PluggableTextView new
			model: self textCollector;
			window: (0 @ 0 extent: 250 @ 200);
			backgroundColor: Color white;
			borderWidthLeft: 2 right: 2 top: 0 bottom: 2. 

	btns := self buttonsView: questionView controller.
	topView addSubView: btns.
	topView addSubView: questionView below: btns.
	topView addSubView: transcriptView below: questionView.
	^ topView controller open
! !

!LispInterpreter methodsFor: 'interface opening' stamp: 'nishis 5/3/98 01:55'!
open
	"LispInterpreter open."

	| topView questionView transcriptView |
	topView := StandardSystemView new
			model: self;
			backgroundColor: Color white;
			label: 'Lisp';
			minimumSize: 250 @ 300.
	questionView := PluggableStringHolderView
			on: self
			aspect: #contents
			change: #contents:
			menu: #menu.
	questionView
			window: (0 @ 0 extent: 250 @ 100);
			borderWidth: 2;
			backgroundColor: Color lightYellow.
	transcriptView := PluggableTextView new
			model: self textCollector;
			window: (0 @ 0 extent: 250 @ 200);
			backgroundColor: Color white;
			borderWidthLeft: 2 right: 2 top: 0 bottom: 2. 

	topView addSubView: questionView.
	topView addSubView: transcriptView below: questionView.
	^ topView controller open
! !


!LispInterpreter methodsFor: 'printing'!
printString: anObject 
	^self class printString: anObject! !


!LispInterpreter methodsFor: 'private' stamp: 'nishis 6/12/1998 02:43'!
acceptWith: aText
	"force to regist aText as a contents."

	self contents: aText.
	textValue := aText.
	self changed: #clearUserEdits! !

!LispInterpreter methodsFor: 'private' stamp: 'nishis 6/12/1998 02:18'!
buttonView: baseView onAction: aAction label: label extent: extent
	| aSwitchView aSwitch |
	aSwitch := (Button new) onAction: aAction.
	aSwitchView := PluggableButtonView
		on: aSwitch
		getState: #isOff
		action: #switch.
	aSwitchView
		label: label asParagraph;
		window: (0@0 extent:  extent);
		borderWidth: 2;
			foregroundColor: Color black;
			backgroundColor: Color veryVeryLightGray.
	^aSwitchView! !

!LispInterpreter methodsFor: 'private' stamp: 'nishis 4/27/98 04:34'!
buttonView: baseView onAction: aAction label: label extent: extent align: align targetView: targetView
	| aSwitchView kind |
	aSwitchView := 
		self 
			buttonView: baseView 
			onAction: aAction 
			label: label 
			extent: extent.
	kind := align numArgs.
	kind = 1 ifTrue: [baseView perform: align asSymbol with: aSwitchView].
	kind = 2 ifTrue: [baseView perform: align asSymbol with: aSwitchView with: targetView].
	^aSwitchView
! !

!LispInterpreter methodsFor: 'private'!
setFsubrFunc: bodyArray 
	self
		putprop: (bodyArray at: 1) asSymbol
		key: #fsubr
		value: (LispCons list: bodyArray)! !

!LispInterpreter methodsFor: 'private'!
setSubrFunc: bodyArray 
	self
		putprop: (bodyArray at: 1) asSymbol
		key: #subr
		value: (LispCons list: bodyArray)! !

!LispInterpreter methodsFor: 'private'!
skipSeparators: stream 
	| char |
	[stream atEnd not
		and: 
			[char := stream peek.
			(LispScannerTable scannerTable at: char asInteger)
				= #xDelimiter]]
		whileTrue: [stream next]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispInterpreter class
	instanceVariableNames: ''!

!LispInterpreter class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispInterpreter class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispInterpreter class methodsFor: 'copyright'!
version
	^'003'! !


!LispInterpreter class methodsFor: 'instance creation' stamp: 'nishis 5/3/98 01:56'!
fullOpen
	"LispInterpreter fullOpen."

	self fullOpenOn: self new! !

!LispInterpreter class methodsFor: 'instance creation' stamp: 'nishis 5/3/98 01:56'!
fullOpenOn: lispInterpreter
	"LispInterpreter fullOpen."

	lispInterpreter fullOpen! !

!LispInterpreter class methodsFor: 'instance creation'!
new
	^super new initialize! !

!LispInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 00:57'!
open
	"LispInterpreter open."

	self openOn: self new! !

!LispInterpreter class methodsFor: 'instance creation' stamp: 'nishis 4/21/98 00:57'!
openOn: lispInterpreter
	"LispInterpreter open."

	lispInterpreter open! !


!LispInterpreter class methodsFor: 'public access' stamp: 'nishis 4/25/98 04:07'!
evaluate: sExpression 
	^self new evaluateTopLevel: sExpression ifFail: [:errorMessage | self error: 'cannot evaluate:' with:  errorMessage]! !

!LispInterpreter class methodsFor: 'public access'!
evaluate: sExpression ifFail: aBlock 
	^self new evaluateTopLevel: sExpression ifFail: aBlock! !

!LispInterpreter class methodsFor: 'public access' stamp: 'nishis 4/25/98 04:07'!
evaluateFrom: aStream 
	^self new evaluateTopLevel: (LispParser parse: aStream)
		ifFail: [:errorMessage | self error: 'cannot evaluate from:' with: errorMessage]! !

!LispInterpreter class methodsFor: 'public access'!
evaluateFrom: aStream ifFail: aBlock 
	^self new evaluateTopLevel: (LispCons parse: aStream ifFail: aBlock)
		ifFail: aBlock! !


!LispInterpreter class methodsFor: 'printing'!
printString: anObject 
	"LispInterpreter printString: 'string'."
	"LispInterpreter printString: #symbol."
	"LispInterpreter printString: 123."
	"LispInterpreter printString: 123.456."
	"LispInterpreter printString: 123.456e7."
	"LispInterpreter printString: LispNil null."
	"LispInterpreter printString: nil."

	| aStream |
	aStream := WriteStream on: (String new: 32).
	(anObject isKindOf: LispCons)
		ifTrue: [anObject printOn: aStream level: 0]
		ifFalse: [LispCons new printOn: aStream object: anObject].
	^aStream contents! !


!LispInterpreter class methodsFor: 'saving' stamp: 'nishis 6/28/1998 06:59'!
save
	"LispInterpreter save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Lisp.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!LispInterpreter class methodsFor: 'saving' stamp: 'nishis 6/13/1998 03:49'!
saveClasses
	"LispInterpreter saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('Lisp*' 'Pluggable*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection addAll: (SystemOrganization superclassOrder: 'Pluggable-Support').
	classCollection := ChangeSet superclassOrder: classCollection.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!LispInterpreter class methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:04'!
error: labelString with: contentsString
	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !


!LispInterpreter class methodsFor: 'examples'!
example
	"LispInterpreter example."

	LispInterpreter open! !

!LispInterpreter class methodsFor: 'examples' stamp: 'nishis 5/3/98 01:56'!
example00
	"LispInterpreter example00."

	LispInterpreter fullOpen! !

!LispInterpreter class methodsFor: 'examples'!
example01
	"LispInterpreter example01."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	nil

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example02
	"LispInterpreter example02."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	123

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example03
	"LispInterpreter example03."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	"abc"

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example04
	"LispInterpreter example04."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(cons 3 4)

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example05
	"LispInterpreter example05."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(quote (3 4))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example06
	"LispInterpreter example06."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(car (quote (3 4)))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example07
	"LispInterpreter example07."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(cdr (quote (3 4)))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example08
	"LispInterpreter example08."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(cons (car `(1 2 3)) `(3 4))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example09
	"LispInterpreter example09."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(+ 1 2 3 4 5 6 7 8 9 10)

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example10
	"LispInterpreter example10."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(setq x 100)
		(setq y 200 z 300)
		(+ x y z))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example11
	"LispInterpreter example11."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(defun plus (x y) (+ x y))
		(plus 3 4))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example12
	"LispInterpreter example12."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(defun concat (x y) 
			(cond
				((atom x) y)
				(t (cons
						(car x)
						(concat (cdr x) y)))))
		(concat `(1 2 3) `(4 5)))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example13
	"LispInterpreter example13."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(do
		(image display point)
		(setq image {Form fromUser})
		(setq display {Display})
		(setq point {50@50})
		(send image `displayOn:at: display point))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example14
	"LispInterpreter example14."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(defun plus nlambda (x) (plus1 x))
		(defun plus1 lambda (x)
			(cond
				((null x) 0)
				(t (+ (car x) (plus1 (cdr x))))))
		(plus 1 2 3 4 5 6 7 8 9 10))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example15
	"LispInterpreter example15."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	((lambda (x y) (cons x (cons y nil))) 3 4)

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example16
	"LispInterpreter example16."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	((nlambda (x) x) 1 2 3 4 5 6 7 8 9 10)

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example17
	"LispInterpreter example17."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(setq x 100)
		(setq y 200)
		(do
			(x y)
			(setq x 10000)
			(setq y 20000)
			(send {Transcript} `cr)
			(send {Transcript} `show: (send x `printString))
			(send {Transcript} `cr)
			(send {Transcript} `show: (send y `printString)))
		(send {Transcript} `cr)
		(send {Transcript} `show: (send x `printString))
		(send {Transcript} `cr)
		(send {Transcript} `show: (send y `printString)))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example18
	"LispInterpreter example18."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(do
		(count)
		(setq count 1)
		(while
			(<= count 100)
			do
			(send {Transcript} `cr)
			(send {Transcript} `show: (send count `printString))
			(setq count (+ count 1))))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example19
	"LispInterpreter example18."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(do
		(count)
		(setq count 1)
		(repeat
			(send {Transcript} `cr)
			(send {Transcript} `show: (send count `printString))
			(setq count (+ count 1))
			until
			(<= count 100)))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples'!
example20
	"LispInterpreter example20."

	| aList |
	aList := LispInterpreter evaluateFrom: '

	(progn
		(if
			(= (send {self} `confirm: "Are you happy?") {true})
			then
			(send {Transcript} `cr)
			(send {Transcript} `show: "yes")
			else 
			(send {Transcript} `cr)
			(send {Transcript} `show: "no")))

	'.
	^aList! !

!LispInterpreter class methodsFor: 'examples' stamp: 'nishis 5/3/98 13:38'!
example21
	"LispInterpreter example21."

	| anInterpreter aBlock aString |
	anInterpreter := LispInterpreter new.
	aString := '	(progn
		(defun concat (x y) 
			(cond
				((atom x) y)
				(t (cons
						(car x)
						(concat (cdr x) y)))))
		(concat `(1 2 3) `(4 5)))
'.
	anInterpreter contents: aString.
	aBlock :=
		['> (progn
		(defun concat (x y) 
			(cond
				((atom x) y)
				(t (cons
						(car x)
						(concat (cdr x) y)))))
		(concat `(1 2 3) `(4 5)))
(1 2 3 4 5)'
			do:
				[:aCharacter |
				Processor yield.
				aString := String with: aCharacter.
				anInterpreter textCollector show: aString]].
	aBlock fixTemps; fork.
	anInterpreter open! !
