'Goodies (11/18/2001 8:35:20 am)'.!


View subclass: #ClockView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Clocks'!

!ClockView methodsFor: 'accessing' stamp: 'nishis 5/19/98 17:12'!
graphicsContext
	"Answer a graphics context for the receiver to display with.
	This is forwarded to the receiver's container."

	"^container graphicsContextFor: self"
	^Form extent: self insetDisplayBox extent depth: Display depth ! !


!ClockView methodsFor: 'controller access'!
defaultController
	^ClockController new! !


!ClockView methodsFor: 'display box accessing' stamp: 'nishis 5/20/98 22:45'!
bounds
	"(self topView width isNil or: [self topView height isNil])
		ifTrue: [^nil]."
	self viewport isNil 
		ifTrue: [^nil].
	^0 @ 0 extent: self insetDisplayBox extent! !


!ClockView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:07'!
displayOn: graphicsContext 
	| visibleAreas |
	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !

!ClockView methodsFor: 'displaying'!
displayTimeOn: graphicsContext 
	^self subclassResponsibility! !

!ClockView methodsFor: 'displaying' stamp: 'nishis 5/21/98 01:38'!
displayView
	| graphicsContext |
	graphicsContext := Form extent: self insetDisplayBox extent depth: Display depth.
	graphicsContext fillWithColor: self backgroundColor.
	self bounds notNil ifTrue: [self displayTimeOn: graphicsContext]! !


!ClockView methodsFor: 'updating' stamp: 'nishis 5/21/98 01:38'!
update: ignore 
	self displayView
! !


!ClockView methodsFor: 'bordering' stamp: 'nishis 5/19/98 14:44'!
backgroundColor
	^Color lightGray! !

!ClockView methodsFor: 'bordering' stamp: 'nishis 5/19/98 14:44'!
foregroundColor
	^Color black! !


!ClockView methodsFor: 'private' stamp: 'nishis 5/21/98 02:21'!
rotateBlock
	| block radians sin cos x y |
	block := 
			[:p :d | 
			radians := d negated degreesToRadians.
			sin := radians sin.
			cos := radians cos.
			x := p x * cos + (p y * sin).
			y := p x * sin negated + (p y * cos).
			x @ y].
	^block! !


!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 01:53'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 01:53'!
displayBoxOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
					borderWidth: lineWidth 
					borderColor: aColor 
					insideColor: aColor.
	quadrangle displayOn: graphicsContext! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 02:31'!
displayCircleOn: graphicsContext box: box lineWidth: lineWidth color: aColor 
	| aCircle aForm |
	aCircle := Circle new.
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aCircle form: aForm.
	aCircle radius: box height / 2.
	aCircle center: box center.
	aCircle displayOn: graphicsContext! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 02:35'!
displayCircleOn: graphicsContext radius: raduis center: center lineWidth: lineWidth color: aColor 
	| aCircle aForm |
	aCircle := Circle new.
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aCircle form: aForm.
	aCircle radius: raduis.
	aCircle center: center.
	aCircle displayOn: graphicsContext ! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 01:52'!
displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: lineWidth color: aColor 
	| aForm aLine |
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: graphicsContext! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/21/98 02:46'!
displayPolylineOn: graphicsContext points: points lineWidth: lineWidth color: aColor 
	| aLinearFit aForm |
	aLinearFit := LinearFit new.
	aForm := Form extent: lineWidth * 1 @ lineWidth * 1.
	aForm fillColor: aColor.
	aForm shapeFill: aColor interiorPoint: lineWidth @ lineWidth.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: graphicsContext! !

!ClockView methodsFor: 'private diplaying' stamp: 'nishis 5/23/98 01:12'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClockView class
	instanceVariableNames: ''!

!ClockView class methodsFor: 'instance creation'!
new
	self == ClockView ifTrue: [^self shouldNotImplement].
	^super new! !

!ClockView class methodsFor: 'instance creation'!
openOn: aClock 
	self openOn: aClock label: 'Clock'! !

!ClockView class methodsFor: 'instance creation' stamp: 'nishis 5/21/98 02:10'!
openOn: aClock label: aString 
	| topView subView |
	topView := ScheduledView
				model: aClock
				label: aString
				minimumSize: self minimumSize.
	subView := self new model: aClock.
	topView addSubView: subView.
	topView controller openIn: (100 @ 100 extent: (topView minimumSize - self labelOffset))! !


!ClockView class methodsFor: 'label access' stamp: 'nishis 5/19/98 17:49'!
labelOffset
	^ 0 @ (((TextStyle default copy gridForFont: 2 withLead: 0) fontAt: 2) height + 4 - 2)! !


!ClockView class methodsFor: 'private'!
minimumSize
	^self subclassResponsibility! !
