'Goodies (11/18/2001 8:35:21 am)'.!


ClockView subclass: #ClockAnalogView
	instanceVariableNames: 'cacheImage cacheTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Clocks'!

!ClockAnalogView methodsFor: 'display box accessing'!
bounds: ignore 
	cacheImage := nil! !

!ClockAnalogView methodsFor: 'display box accessing' stamp: 'nishis 5/23/98 02:11'!
computeInsetDisplayBox
	"for resizing"
	cacheImage := nil.
	^super computeInsetDisplayBox! !


!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 01:50'!
displayBackgroundImageOn: graphicsContext 
	| center radius paragraph degree x y |
	self displayBorderOn: graphicsContext 
		box: self bounds 
		lineWidth: 1 
		color: Color cyan.
	center := self bounds center.
	radius := self bounds extent // 2 - 12.
	1 to: 12 do: 
		[:number | 
		paragraph := number printString asText allBold asParagraph.
		paragraph rule: Form and.
		paragraph fillColor: self backgroundColor.
		degree := number - 3 * 30.
		x := degree degreesToRadians cos.
		y := degree degreesToRadians sin.
		paragraph displayOn: graphicsContext 
				at: center + 1 + (x @ y * radius) - (paragraph extent // 2).
		self displayBoxOn: graphicsContext 
			box: (center + (x @ y * (radius - 10)) extent: 2) 
			lineWidth: 2 
			color: self foregroundColor]! !

!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:26'!
displayLongHandOn: graphicsContext 
	| center radius minute x y points |
	center := self bounds center.
	radius := self bounds extent // 2 - 20.
	minute := cacheTime minutes.
	x := (minute * 6 - 90) degreesToRadians cos.
	y := (minute * 6 - 90) degreesToRadians sin.
	points := Array new: 5.
	points at: 1 put: center + (self rotateBlock value: x @ y * 3 asPoint value: -180).
	points at: 2 put: center + (self rotateBlock value: x @ y * 3 asPoint value: -90).
	points at: 3 put: center + (x @ y * (radius * 9 // 10) asPoint).
	points at: 4 put: center + (self rotateBlock value: x @ y * 3 asPoint value: 90).
	points at: 5 put: points first copy.
	points := points collect: [:p | p rounded].
	self displayPolylineOn: graphicsContext points: points lineWidth: 1 color: self foregroundColor
"	self displayLineOn: graphicsContext 
		from: center 
		to: center + (x @ y * (radius * 4 // 5)) 
		lineWidth: 2 
		color: self foregroundColor"! !

!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:47'!
displayPivotOn: graphicsContext 
	"self displayCircleOn: graphicsContext box: ((self bounds center extent: 0 @ 0)
				expandBy: 3) lineWidth: 3 color: Color red.
	self displayCircleOn: graphicsContext box: ((self bounds center extent: 0 @ 0)
				expandBy: 3) lineWidth: 2 color: Color blue."
	self displayCircleOn: graphicsContext radius: 3 center: self bounds center lineWidth: 3 color: self backgroundColor.
	self displayCircleOn: graphicsContext radius: 3 center: self bounds center lineWidth: 1 color: self foregroundColor.

	"graphicsContext capStyle: GraphicsContext capButt.
	graphicsContext joinStyle: GraphicsContext joinMiter.
	graphicsContext paint: self backgroundColor.
	graphicsContext lineWidth: 1.
	graphicsContext
		displayWedgeBoundedBy: ((self bounds center extent: Point zero)
				expandedBy: 3)
		startAngle: 0
		sweepAngle: 360.
	graphicsContext paint: self foregroundColor.
	graphicsContext
		displayArcBoundedBy: ((self bounds center extent: Point zero)
				expandedBy: 3)
		startAngle: 0
		sweepAngle: 360"
! !

!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:28'!
displayShortHandOn: graphicsContext 
	| center radius minute x y hour points |
	center := self bounds center.
	radius := self bounds extent // 2 - 20.
	minute := cacheTime minutes.
	hour := cacheTime hours * 5 + (minute / 12) asFloat.
	x := (hour * 6 - 90) degreesToRadians cos.
	y := (hour * 6 - 90) degreesToRadians sin.
	points := Array new: 5.
	points at: 1 put: center + (self rotateBlock value: x @ y * 3 asPoint value: -180).
	points at: 2 put: center + (self rotateBlock value: x @ y * 3 asPoint value: -90).
	points at: 3 put: center + (x @ y * (radius * 7 // 10) asPoint).
	points at: 4 put: center + (self rotateBlock value: x @ y * 3 asPoint value: 90).
	points at: 5 put: points first copy.
	points := points collect: [:p | p rounded].
	self displayPolylineOn: graphicsContext points: points lineWidth: 1 color: self foregroundColor
"	self displayLineOn: graphicsContext 
		from: center 
		to: center + (x @ y * (radius * 3 // 5)) 
		lineWidth: 4 
		color: self foregroundColor"! !

!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:22'!
displayTickHandOn: graphicsContext 
	| center radius length seconds x y |
	center := self bounds center.
	radius := self bounds extent // 2 - 20.
	length := radius * 5 // 6.
	length := radius * 10 // 10.
	seconds := cacheTime seconds.
	x := (seconds * 6 - 90) degreesToRadians cos.
	y := (seconds * 6 - 90) degreesToRadians sin.
	self displayLineOn: graphicsContext 
		from: center 
		to: center + (x @ y * length) 
		lineWidth: 1 
		color: self foregroundColor! !

!ClockAnalogView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:29'!
displayTimeOn: graphicsContext 
	| aPixmap |
	((cacheImage isNil or: [cacheTime isNil])
		or: [self model currentTime minutes ~= cacheTime minutes])
		ifTrue: 
			[cacheTime := self model currentTime.
			aPixmap := Form extent: self insetDisplayBox extent depth: Display depth.
			aPixmap fillWithColor: self backgroundColor.
			self displayBackgroundImageOn: aPixmap.
			self displayLongHandOn: aPixmap.
			self displayShortHandOn: aPixmap.
			self displayPivotOn: aPixmap.
			cacheImage := aPixmap]
		ifFalse: [cacheTime := self model currentTime].
	cacheImage displayOn: graphicsContext.
	self displayTickHandOn: graphicsContext.
	self displayOn: graphicsContext! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClockAnalogView class
	instanceVariableNames: ''!

!ClockAnalogView class methodsFor: 'private' stamp: 'nishis 5/19/98 18:31'!
minimumSize
	^100 @ 100 + self labelOffset! !
