'Goodies (11/18/2001 8:35:21 am)'.!


Object subclass: #TranscriptFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Misc'!
!TranscriptFile commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Transcript File
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Transcript File
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/TscriptF.st

Summary:

This goodies writes "printing on Transcript" to a log file.
If you do it "Transcript show:'Hello World!!'" it is appended 
to a log.  So you can get complete output when Transcript was cleared.


Installing:

FileIn this goodies and makes a class "TranscriptFile" in a 
category "Goodies-Misc". 
AND
modifies TranscriptStream>>endEntry

When you want to restore your image, please remove this class 
"TranscriptFile" from your system. Additions of TranscriptStream 
class are automatically remevoed and restored.

OR

turn on:
	do it "TranscriptFile install."
turn off:
	do it "TranscriptFile uninstall."


how to use:

You have not to mind to writing out to file, use Transcript 
usually.  Output file name style is "YYYYMMDD.log".


note:

testing at code below

Time millisecondsToRun:
	[1 to: 500 do: [:i | Transcript cr; show: i asString]]

results are
TranscriptFile not installed is	23467	(1.0)
TranscriptFile installed is		39684	(1.7)

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/TscriptF.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/TscriptF.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TranscriptFile class
	instanceVariableNames: 'endEntry '!

!TranscriptFile class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!TranscriptFile class methodsFor: 'copyright'!
system
	^'Goodies'! !

!TranscriptFile class methodsFor: 'copyright'!
version
	^'003'! !


!TranscriptFile class methodsFor: 'class initialization' stamp: 'nishis 3/28/98 05:14'!
initialize
	"TranscriptFile initialize."

	self install! !

!TranscriptFile class methodsFor: 'class initialization' stamp: 'nishis 6/28/1998 05:26'!
install
	"TranscriptFile install."

	endEntry isNil ifTrue: [endEntry := TranscriptStream sourceCodeAt: #endEntry].
	TranscriptStream compile: TranscriptFile endEntry 
		classified: 'all'! !

!TranscriptFile class methodsFor: 'class initialization'!
obsolete
	self uninstall.
	super obsolete! !

!TranscriptFile class methodsFor: 'class initialization'!
uninstall
	"TranscriptFile uninstall."

	endEntry notNil
		ifTrue: 
			[TranscriptStream compile: endEntry classified: 'all'.
			endEntry := nil]! !


!TranscriptFile class methodsFor: 'private' stamp: 'nishis 6/28/1998 05:25'!
endEntry
^ 'endEntry
	| date year month day extension string stream |
	"Display all the characters since the last endEntry, and reset the stream"
	"Enhanced by AOKI Atsushi. "
	"Modified by NISHIHARA Satoshi. "

	self contents isEmpty
		ifFalse: 
			[date := Date today.
			year := date year printString.
			month := date monthIndex printString.
			2 - month size timesRepeat: [month := ''0'' , month].
			day := date dayOfMonth printString.
			2 - day size timesRepeat: [day := ''0'' , day].
			extension := ''.log''.
			string := year , month , day , extension.
			stream := FileStream fileNamed: string.
			stream position: stream size.
			[stream nextPutAll: self contents]
				ifError: [stream close].
			stream closed ifFalse: [stream close]].
	self changed: #appendEntry.
	self reset'! !


!TranscriptFile class methodsFor: 'saving' stamp: 'nishis 6/28/1998 04:59'!
save
	"TranscriptFile save."

	| fileName classCollection aStream timeStamp saveBlock |
	fileName := 'TscriptF.st'.
	classCollection := self saveClasses.
	aStream := FileStream fileNamed: fileName asFileName.
	aStream reset.
	saveBlock := [Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]]].
	saveBlock ifError: [:err :rcvr | aStream close].
	aStream closed ifFalse: [aStream close].
	^classCollection! !

!TranscriptFile class methodsFor: 'saving' stamp: 'nishis 3/27/98 12:43'!
saveClasses
	"TranscriptFile saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*TranscriptFile*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


TranscriptFile initialize!
