'Goodies (11/18/2001 8:35:21 am)'.!


Object variableSubclass: #LispSmallCompiler
	instanceVariableNames: 'source mark prevEnd hereChar token tokenType saveComments currentComment buffer typeTable parseNode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Lisp'!

!LispSmallCompiler methodsFor: 'initialize-release'!
initScanner
	buffer := WriteStream on: (String new: 32).
	saveComments := true.
	typeTable := LispSmallTypeTable typeTable! !

!LispSmallCompiler methodsFor: 'initialize-release'!
on: inputStream 
	source := inputStream.
	hereChar := source next.
	prevEnd := 0! !

!LispSmallCompiler methodsFor: 'initialize-release'!
scan: inputStream 
	self on: inputStream.
	self scanToken! !


!LispSmallCompiler methodsFor: 'public access'!
evaluate: textOrStream in: aContext receiver: receiver notifying: aRequestor ifFail: failBlock 
	| aString |
	(textOrStream isKindOf: PositionableStream)
		ifTrue: [aString := textOrStream contents asString]
		ifFalse: [aString := textOrStream asString].
	^self compile: aString! !

!LispSmallCompiler methodsFor: 'public access'!
evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock 
	| value |
	value := nil.
	Cursor execute showWhile: [value := self
					evaluate: textOrStream
					in: aContext
					receiver: receiver
					notifying: aRequestor
					ifFail: failBlock].
	^value! !

!LispSmallCompiler methodsFor: 'public access'!
scanFieldNames: stringOrArray 
	"LispSmallCompiler new scanFieldNames: 'abc def ghi'."

	| stream |
	(stringOrArray isMemberOf: Array)
		ifTrue: [^stringOrArray].
	stringOrArray isEmpty ifTrue: [^Array new: 0].
	self scan: (ReadStream on: stringOrArray asString).
	stream := WriteStream on: (Array new: 10).
	[tokenType = #doIt]
		whileFalse: 
			[tokenType = #word ifTrue: [stream nextPut: token].
			self scanToken].
	^stream contents! !

!LispSmallCompiler methodsFor: 'public access' stamp: 'nishis 6/28/1998 05:42'!
scanPositionsFor: aSymbol inString: aString 
	"LispSmallCompiler new scanPositionsFor: #LispSmallCompiler inString: 
	'| x y | 
	LispSmallCompiler compile: x. 
	Smalltalk at: #LispSmallCompiler put: nil. 
	(LispSmallCompiler compile: x y: y). 
	LispSmallCompiler foo'"

	| positions string |
	self scan: (ReadStream on: aString).
	string := aSymbol asString.
	positions := WriteStream with: (Array new: 16).
	[tokenType = #doIt]
		whileFalse: 
			[(tokenType = #word and: [string = token])
				ifTrue: [positions nextPut: mark].
			self scanToken].
	^positions contents! !

!LispSmallCompiler methodsFor: 'public access'!
scanTokens: textOrString 
	"LispSmallCompiler new scanTokens: 
	'(LispSmallCompiler #(aaa #(bbb 123 456.7d) nil true false) 
	#[1 2 3 4 5 6 7 8 9] identifier keyword: 8r31 
	''string'' embedded.period key:word: . )'."

	| stream |
	self scan: (ReadStream on: textOrString asString).
	stream := WriteStream on: (Array new: 16).
	[tokenType = #doIt]
		whileFalse: 
			[self arrayLiteralElement.
			stream nextPut: parseNode].
	^stream contents! !


!LispSmallCompiler methodsFor: 'translating'!
compile: aString 
	| tokenArray |
	tokenArray := self scanTokens: aString.
	^self translate: tokenArray! !

!LispSmallCompiler methodsFor: 'translating'!
translate: tokenArray 
	| value receiver selector |
	tokenArray isEmpty ifTrue: [^nil].
	(tokenArray size = 1 and: [tokenArray first isKindOf: Array])
		ifTrue: 
			[value := nil.
			tokenArray do: [:each | value := self translate: each].
			^value].
	tokenArray size = 1 ifTrue: [^tokenArray first].
	receiver := tokenArray at: 1.
	selector := tokenArray at: 2.
	((receiver isKindOf: Number)
		and: [selector = #@ or: [selector = #,]])
		ifTrue: [^self translateToPoint: tokenArray].
	(((receiver = #Point and: [selector = #x:])
		or: [receiver = #Jun3dPoint and: [selector = #x:]])
		or: [receiver = #Jun2dPoint and: [selector = #x:]])
		ifTrue: [^self translateToPoint: tokenArray].
	(receiver = #ByteArray and: [selector = #fromPackedString:])
		ifTrue: [^self translateToByteArray: tokenArray].
	"(((receiver = #Image and: [selector = #extent:])
		or: [receiver = #OpaqueImage and: [selector = #basicNew]])
		or: [receiver = #CachedImage and: [selector = #on:]])
		ifTrue: [^self translateToImage: tokenArray]."
	(receiver = #Form and: [selector = #extent:])
		ifTrue: [^self translateToForm: tokenArray].
	(receiver = #Color and: [(#(#r: #h: #gray:) includes: selector)
			or: [Color colorNames includes: selector]])
		ifTrue: [^self translateToColor: tokenArray].
	^self notify: 'unexpected error'! !

!LispSmallCompiler methodsFor: 'translating' stamp: 'nishis 4/19/98 22:09'!
translateToByteArray: tokenArray 
	| aString aSelector byteArray |
	(tokenArray isKindOf: ByteArray)
		ifTrue: [^tokenArray].
	aString := tokenArray at: 1.
	aSelector := tokenArray at: 2.
"	(aSymbol = #ByteArray and: [aSelector = #fromPackedString:])
		ifFalse: [^self notify: 'unexpected error'].
	byteArray := ByteArray fromPackedString: (tokenArray at: 3)."
	((aString isKindOf: String) and: [aSelector = #asByteArray])
		ifFalse: [^self notify: 'unexpected error'].
	byteArray := aString asByteArray.
	^byteArray! !

!LispSmallCompiler methodsFor: 'translating'!
translateToColor: tokenArray 
	| symbol collection stream selector arguments color |
	symbol := tokenArray at: 1.
	symbol = #Color ifFalse: [^self notify: 'unexpected error'].
	selector := tokenArray at: 2.
	(Color colorNames includes: selector)
		ifTrue: [color := Color perform: selector]
		ifFalse: 
			[collection := OrderedCollection new.
			stream := WriteStream on: (String new: 32).
			2
				to: tokenArray size
				by: 2
				do: 
					[:index | 
					stream nextPutAll: (tokenArray at: index).
					collection add: (tokenArray at: index + 1)].
			selector := stream contents asSymbol.
			arguments := collection asArray.
			color := Color perform: selector withArguments: arguments].
	^color! !

!LispSmallCompiler methodsFor: 'translating' stamp: 'nishis 4/19/98 22:35'!
translateToForm: tokenArray 
	| aSymbol aForm extentPoint bitsPerPixel anObject byteArray |
	aSymbol := tokenArray at: 1.
	aSymbol = #Form 
		ifFalse: [^self notify: 'unexpected error'].
	extentPoint := (tokenArray at: 3) @ (tokenArray at: 5).
	bitsPerPixel := tokenArray at: 7.
	anObject := tokenArray at: 9.
	((anObject isKindOf: Array) and: [((anObject at: 1) isKindOf: String) not]) 
		ifTrue: [byteArray := anObject]
		ifFalse: [byteArray := self translateToByteArray: (tokenArray at: 9)].
	aForm := Form
				extent: extentPoint 
				depth: bitsPerPixel 
				fromArray: byteArray 
				offset: nil.
	^aForm! !

!LispSmallCompiler methodsFor: 'translating'!
translateToImage: tokenArray 
	^self shouldNotImplement
"
	| aSymbol anImage extentPoint colorDepth bitsPerPixel anObject aPalette byteArray figureImage shapeImage |
	aSymbol := tokenArray at: 1.
	(aSymbol = #Image or: [aSymbol = #OpaqueImage or: [aSymbol = #CachedImage]])
		ifFalse: [^self notify: 'unexpected error'].
	aSymbol = #Image
		ifTrue: 
			[extentPoint := (tokenArray at: 3)
						@ (tokenArray at: 5).
			colorDepth := tokenArray at: 7.
			bitsPerPixel := tokenArray at: 9.
			anObject := tokenArray at: 11.
			(anObject isKindOf: Array)
				ifTrue: 
					[aPalette := self translateToPalette: (tokenArray at: 11).
					byteArray := self translateToByteArray: (tokenArray at: 13)]
				ifFalse: 
					[aPalette := self translateToPalette: (Array with: (tokenArray at: 11)
									with: (tokenArray at: 12)).
					byteArray := self translateToByteArray: (tokenArray at: 14)].
			anImage := Image
						extent: extentPoint
						depth: colorDepth
						bitsPerPixel: bitsPerPixel
						palette: aPalette
						usingBits: byteArray].
	aSymbol = #OpaqueImage
		ifTrue: 
			[figureImage := self translateToImage: (tokenArray at: 6).
			shapeImage := self translateToImage: (tokenArray at: 11).
			anImage := OpaqueImage figure: figureImage shape: shapeImage].
	aSymbol = #CachedImage
		ifTrue: 
			[anImage := self translate: (tokenArray at: 3).
			anImage := CachedImage on: anImage].
	^anImage"! !

!LispSmallCompiler methodsFor: 'translating'!
translateToPalette: tokenArray 
	^self shouldNotImplement
"
	| aSymbol aPalette selector collection stream sort array arguments index location it |
	aSymbol := tokenArray at: 1.
	(aSymbol = #CoveragePalette or: [aSymbol = #FixedPalette or: [aSymbol = #MappedPalette or: [aSymbol = #MonoMappedPalette]]])
		ifFalse: [^self notify: 'unexpected error'].
	aSymbol = #CoveragePalette
		ifTrue: 
			[selector := tokenArray at: 2.
			(CoveragePalette constantNames includes: selector)
				ifTrue: [aPalette := CoveragePalette perform: selector]
				ifFalse: [aPalette := CoveragePalette perform: selector with: (tokenArray at: 3)]].
	aSymbol = #FixedPalette
		ifTrue: 
			[collection := OrderedCollection new.
			stream := WriteStream on: (String new: 32).
			2
				to: tokenArray size
				by: 2
				do: 
					[:indexAt | 
					stream nextPutAll: (tokenArray at: indexAt).
					collection add: (tokenArray at: indexAt + 1)].
			selector := stream contents asSymbol.
			arguments := collection asArray.
			aPalette := FixedPalette perform: selector withArguments: arguments].
	(aSymbol = #MappedPalette or: [aSymbol = #MonoMappedPalette])
		ifTrue: 
			[sort := Smalltalk at: aSymbol.
			selector := tokenArray at: 2.
			(sort constantNames includes: selector)
				ifTrue: [aPalette := sort perform: selector]
				ifFalse: 
					[array := tokenArray at: 3.
					arguments := Array new: ((array at: 1)
									at: 3).
					array := array copyFrom: 2 to: array size - 2.
					index := array
								nextIndexOf: #at:
								from: 1
								to: array size.
					[index isNil]
						whileFalse: 
							[location := array at: index + 1.
							it := array at: index + 3.
							(it isKindOf: Array)
								ifFalse: [it := Array with: (array at: index + 3)
												with: (array at: index + 4)].
							arguments at: location put: (self translateToColor: it).
							index := array
										nextIndexOf: #at:
										from: index + 1
										to: array size].
					aPalette := sort perform: selector with: arguments]].
	^aPalette"! !

!LispSmallCompiler methodsFor: 'translating'!
translateToPoint: tokenArray 
	| receiver selector arguments point |
	receiver := tokenArray at: 1.
	selector := tokenArray at: 2.
	((receiver isKindOf: Number)
		and: [selector = #@ or: [selector = #,]])
		ifTrue: 
			[2
				to: tokenArray size
				by: 2
				do: 
					[:index | 
					selector := tokenArray at: index.
					arguments := Array with: (tokenArray at: index + 1).
					(receiver respondsTo: selector)
						ifFalse: [^tokenArray].
					point := receiver perform: selector withArguments: arguments.
					receiver := point].
			^point].
	(receiver = #Point "or: [receiver = #Jun3dPoint or: [receiver = #Jun2dPoint]]")
		ifFalse: [^self notify: 'unexpected error'].
	receiver = #Point ifTrue: [point := Point x: (tokenArray at: 3)
					y: (tokenArray at: 5)].
	"receiver = #Jun3dPoint ifTrue: [point := Jun3dPoint
					x: (tokenArray at: 3)
					y: (tokenArray at: 5)
					z: (tokenArray at: 7)].
	receiver = #Jun2dPoint ifTrue: [point := Jun2dPoint x: (tokenArray at: 3)
					y: (tokenArray at: 5)]."
	^point! !


!LispSmallCompiler methodsFor: 'parsing'!
arrayLiteral
	| stream |
	stream := WriteStream on: (Array new: 16).
	[tokenType = #rightParenthesis]
		whileFalse: 
			[tokenType == #doIt ifTrue: [^self notify: 'array element or right parenthesis'].
			self arrayLiteralElement.
			stream nextPut: parseNode].
	parseNode := stream contents.
	self scanToken! !

!LispSmallCompiler methodsFor: 'parsing'!
arrayLiteralElement
	self constant ifTrue: [^self].
	tokenType = #leftParenthesis
		ifTrue: 
			[self scanToken.
			self arrayLiteral.
			^self].
	tokenType = #leftBracket
		ifTrue: 
			[self scanToken.
			self byteArrayLiteral.
			^self].
	self scanLitToken.
	parseNode := token.
	self scanToken! !

!LispSmallCompiler methodsFor: 'parsing'!
byteArrayLiteral
	| stream |
	stream := WriteStream on: (ByteArray new: 16).
	[tokenType = #rightBracket]
		whileFalse: 
			[(tokenType == #number and: [token isInteger and: [token >= 0 and: [token <= 255]]])
				ifFalse: [^self notify: '8-bit integer or right bracket'].
			stream nextPut: token.
			self scanToken].
	parseNode := stream contents.
	self scanToken! !

!LispSmallCompiler methodsFor: 'parsing'!
constant
	| size |
	tokenType == #word
		ifTrue: 
			[size := token size.
			size = 5
				ifTrue: [token = 'false'
						ifTrue: 
							[self scanToken.
							parseNode := false.
							^true]]
				ifFalse: [size = 4
						ifTrue: [token = 'true'
								ifTrue: 
									[self scanToken.
									parseNode := true.
									^true]]
						ifFalse: [size = 3 ifTrue: [token = 'nil'
									ifTrue: 
										[self scanToken.
										parseNode := nil.
										^true]]]].
			^false].
	(tokenType == #string or: [tokenType == #number or: [tokenType == #character]])
		ifTrue: 
			[parseNode := token.
			self scanToken.
			^true].
	(token == #- and: [hereChar notNil and: [hereChar isDigit]])
		ifTrue: 
			[self scanToken.
			parseNode := token negated.
			self scanToken.
			^true].
	tokenType == #literalQuote ifFalse: [^false].
	self scanToken.
	(tokenType == #word or: [tokenType == #binary or: [tokenType == #verticalBar or: [tokenType == #string]]])
		ifTrue: 
			[parseNode := token asSymbol.
			self scanToken.
			^true].
	tokenType == #keyword
		ifTrue: 
			[self scanLitKeywords.
			parseNode := token asSymbol.
			self scanToken.
			^true].
	tokenType == #leftParenthesis
		ifTrue: 
			[self scanToken.
			self arrayLiteral.
			^true].
	tokenType == #leftBracket
		ifTrue: 
			[self scanToken.
			self byteArrayLiteral.
			^true].
	^self notify: 'word, binary, keyword, (, or ['! !


!LispSmallCompiler methodsFor: 'scanning'!
scanLitKeywords
	| inKeywords t lastP lastCh |
	inKeywords := true.
	[inKeywords and: [hereChar notNil and: [(typeTable at: hereChar asInteger)
				= #xLetter]]]
		whileTrue: 
			[t := token.
			lastP := source position.
			lastCh := hereChar.
			self xLetter.
			tokenType = #keyword
				ifTrue: [token := t , token]
				ifFalse: 
					[inKeywords := false.
					token := t.
					hereChar := lastCh.
					source position: lastP.
					tokenType := #keyword]].
	token := token asSymbol! !

!LispSmallCompiler methodsFor: 'scanning'!
scanLitToken
	tokenType = #leftParenthesis
		ifTrue: 
			[self scanToken.
			self scanLitVec]
		ifFalse: [tokenType = #word
				ifTrue: [token := token asSymbol]
				ifFalse: [tokenType = #keyword
						ifTrue: [self scanLitKeywords]
						ifFalse: [(token == #- and: [hereChar notNil and: [(typeTable at: hereChar asInteger)
										= #xDigit]])
								ifTrue: 
									[self scanToken.
									token := token negated]
								ifFalse: [((token isMemberOf: Character)
										and: [tokenType ~~ #character])
										ifTrue: [token := token asSymbol]]]]]! !

!LispSmallCompiler methodsFor: 'scanning'!
scanLitVec
	| s |
	s := WriteStream on: (Array new: 16).
	[tokenType = #rightParenthesis or: [tokenType = #doIt]]
		whileFalse: 
			[self scanLitToken.
			s nextPut: token.
			self scanToken].
	token := s contents! !

!LispSmallCompiler methodsFor: 'scanning'!
scanToken
	| skipped |
	
	[hereChar == nil
		ifTrue: 
			[prevEnd := source position.
			mark := prevEnd + 1.
			tokenType := #doIt.
			^token := nil].
	skipped := 0.
	(tokenType := typeTable at: hereChar asInteger) == #xDelimiter]
		whileTrue: 
			[skipped := skipped + 1.
			hereChar := source next].
	mark := source position.
	prevEnd := mark - skipped - 1.
	tokenType == #xLetter
		ifTrue: [self xLetter]
		ifFalse: [(tokenType at: 1)
				= $x
				ifTrue: [self perform: tokenType]
				ifFalse: 
					[token := hereChar.
					hereChar := source next]].
	^token! !

!LispSmallCompiler methodsFor: 'scanning'!
step
	| c |
	c := hereChar.
	hereChar := source next.
	^c! !


!LispSmallCompiler methodsFor: 'x'!
xBinary
	| char |
	tokenType := #binary.
	char := hereChar.
	hereChar := source next.
	(hereChar notNil and: [(typeTable at: hereChar asInteger)
			= #xBinary and: [hereChar ~= $-]])
		ifTrue: [token := Symbol intern: (String with: char with: self step)]
		ifFalse: [token := Symbol internCharacter: char]! !

!LispSmallCompiler methodsFor: 'x'!
xDefault
	self notify: 'unknown character'! !

!LispSmallCompiler methodsFor: 'x'!
xDelimiter
	self scanToken! !

!LispSmallCompiler methodsFor: 'x'!
xDigit
	tokenType := #number.
	hereChar == nil ifFalse: [source skip: -1].
"	token := Number readSmalltalkSyntaxFrom: source."
	token := Number readFrom: source.
	hereChar := source next! !

!LispSmallCompiler methodsFor: 'x'!
xDollar
	token := source next.
	hereChar := source next.
	tokenType := #character! !

!LispSmallCompiler methodsFor: 'x'!
xDoubleQuote
	| savedEnd char |
	savedEnd := prevEnd.
	saveComments ifFalse: [[(char := source next) == $"]
			whileFalse: [char == nil ifTrue: [^self offEnd: 'unmatched comment quote']]]
		ifTrue: 
			[buffer reset.
			[(char := source next) == $"]
				whileFalse: 
					[char == nil ifTrue: [^self offEnd: 'unmatched comment quote'].
					buffer nextPut: char].
			currentComment == nil
				ifTrue: [currentComment := OrderedCollection with: buffer contents]
				ifFalse: [currentComment add: buffer contents].
			buffer position > 200 ifTrue: [buffer := WriteStream on: (String new: 40)]].
	hereChar := source next.
	self scanToken.
	prevEnd := savedEnd! !

!LispSmallCompiler methodsFor: 'x'!
xLetter
	| type char |
	buffer reset.
	buffer nextPut: hereChar.
	
	[char := source next.
	char notNil
		and: 
			[type := typeTable at: char asInteger.
			type == #xLetter or: [type == #xDigit]]]
		whileTrue: [buffer nextPut: char].
	type == #colon
		ifTrue: 
			[buffer nextPut: char.
			char := source next.
			tokenType := #keyword]
		ifFalse: [tokenType := #word].
	hereChar := char.
	token := buffer contents! !

!LispSmallCompiler methodsFor: 'x'!
xLitQuote
	| start |
	self step.
	self scanToken.
	tokenType = #leftParenthesis
		ifTrue: 
			[start := mark.
			self scanToken.
			self scanLitVec.
			tokenType == #doIt
				ifTrue: 
					[mark := start.
					self offEnd: 'unmatched parenthesis']]
		ifFalse: [tokenType = #word
				ifTrue: [token := token asSymbol]
				ifFalse: [tokenType = #keyword ifTrue: [self scanLitKeywords]]].
	tokenType := #literal! !

!LispSmallCompiler methodsFor: 'x'!
xSingleQuote
	| char |
	char := source next.
	buffer on: (String new: 32).
	
	[char == nil ifTrue: [^self offEnd: 'unmatched string quote'].
	char == $' and: [(char := source next) ~~ $']]
		whileFalse: 
			[buffer nextPut: char.
			char := source next].
	hereChar := char.
	token := buffer contents.
	tokenType := #string! !


!LispSmallCompiler methodsFor: 'string and character'!
separate: separateCollection dividers: dividerCollection 
	"LispSmallCompiler new separate: #(a b c d e f g h) dividers: #(d f)."

	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(dividerCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!LispSmallCompiler methodsFor: 'string and character'!
separators
	"LispSmallCompiler new separators."

	| stream |
	stream := WriteStream on: (String new: 4).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	^stream contents! !

!LispSmallCompiler methodsFor: 'string and character'!
stringMatch: string and: pattern 
	"LispSmallCompiler new stringMatch: ' Aoki' and: 'Ju*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!LispSmallCompiler methodsFor: 'string and character'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !


!LispSmallCompiler methodsFor: 'error handling' stamp: 'nishis 6/28/1998 06:02'!
error: labelString with: contentsString
	| handler |
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue:
			[handler value: labelString value: self]
		ifFalse: 
			[Debugger
				openContext: thisContext
				label: labelString
				contents: contentsString]! !

!LispSmallCompiler methodsFor: 'error handling' stamp: 'nishis 4/25/98 04:08'!
notify: string 
	self error: 'Lisp Compiler error' with: string! !

!LispSmallCompiler methodsFor: 'error handling'!
offEnd: aString 
	^self notify: aString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispSmallCompiler class
	instanceVariableNames: ''!

!LispSmallCompiler class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispSmallCompiler class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispSmallCompiler class methodsFor: 'copyright'!
version
	^'003'! !


!LispSmallCompiler class methodsFor: 'instance creation'!
new
	^(super new) initScanner; yourself! !


!LispSmallCompiler class methodsFor: 'evaluating'!
evaluate: textOrString 
	^self
		evaluate: textOrString
		for: nil
		logged: false! !

!LispSmallCompiler class methodsFor: 'evaluating'!
evaluate: textOrString for: anObject logged: logFlag 
	^self
		evaluate: textOrString
		for: anObject
		notifying: nil
		logged: logFlag! !

!LispSmallCompiler class methodsFor: 'evaluating'!
evaluate: textOrString for: anObject notifying: aController logged: logFlag 
	^self new
		evaluate: textOrString
		in: nil
		receiver: anObject
		notifying: aController
		ifFail: [^nil]! !

!LispSmallCompiler class methodsFor: 'evaluating'!
evaluate: textOrString logged: logFlag 
	^self
		evaluate: textOrString
		for: nil
		logged: logFlag! !

!LispSmallCompiler class methodsFor: 'evaluating'!
evaluate: textOrString notifying: aController logged: logFlag 
	^self
		evaluate: textOrString
		for: nil
		notifying: aController
		logged: logFlag! !


!LispSmallCompiler class methodsFor: 'examples'!
example0
	"LispSmallCompiler example0."

	| stream |
	stream := WriteStream on: Array new.
	stream nextPut: (LispSmallCompiler evaluate: '(nil)').
	stream nextPut: (LispSmallCompiler evaluate: '(true)').
	stream nextPut: (LispSmallCompiler evaluate: '(false)').
	stream contents do: [:each | Transcript cr; show: each printString].
	^stream contents! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:21'!
example1
	"LispSmallCompiler example1."

	| stream |
	stream := WriteStream on: Array new.
	stream nextPut: (LispSmallCompiler evaluate: '(123)').
	stream nextPut: (LispSmallCompiler evaluate: '(123.456)').
	stream nextPut: (LispSmallCompiler evaluate: '(123.456e7)').
	stream nextPut: (LispSmallCompiler evaluate: '(-123)').
	stream nextPut: (LispSmallCompiler evaluate: '(-123.456)').
	stream nextPut: (LispSmallCompiler evaluate: '(-123.456e7)').
	stream nextPut: (LispSmallCompiler evaluate: '(-123.456e-7)').
	stream contents do: [:each | Transcript cr; show: each printString].
	^stream contents! !

!LispSmallCompiler class methodsFor: 'examples'!
example2
	"LispSmallCompiler example2."

	| stream |
	stream := WriteStream on: Array new.
	stream nextPut: (LispSmallCompiler evaluate: '($c)').
	stream nextPut: (LispSmallCompiler evaluate: '(''string'')').
	stream nextPut: (LispSmallCompiler evaluate: '(#symbol)').
	stream contents do: [:each | Transcript cr; show: each printString].
	^stream contents! !

!LispSmallCompiler class methodsFor: 'examples'!
example3
	"LispSmallCompiler example3."

	| stream |
	stream := WriteStream on: Array new.
	stream nextPut: (LispSmallCompiler evaluate: '(123 @ 456)').
	stream nextPut: (LispSmallCompiler evaluate: '(123 , 456)').
	stream nextPut: (LispSmallCompiler evaluate: '(123 , 456 , 789)').
	stream nextPut: (LispSmallCompiler evaluate: '(Point x: 123 y: 456)').
	(Smalltalk includesKey: #Jun2dPoint) 
		ifTrue: 
			[stream nextPut: (LispSmallCompiler evaluate: '(Jun2dPoint x: 123 y: 456)')].
	(Smalltalk includesKey: #Jun3dPoint) 
		ifTrue: 
			[stream nextPut: (LispSmallCompiler evaluate: '(Jun3dPoint x: 123 y: 456 z: 789)')].
	stream contents do: [:each | Transcript cr; show: each printString].
	^stream contents! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:39'!
example4
	"LispSmallCompiler example4."

	| stream |
	stream := WriteStream on: Array new.
	stream nextPut: (LispSmallCompiler evaluate: '(Color h: 0.57 s: 0.46 v: 1.0)').
	stream nextPut: (LispSmallCompiler evaluate: '(Color r: 0.57 g: 0.46 b: 1.0)').
	stream nextPut: (LispSmallCompiler evaluate: '(Color gray: 0.7)').
	stream contents do: [:each | Transcript cr; show: each printString].
	^stream contents! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:45'!
example5
	"LispSmallCompiler example5."
	"LispSmallCompiler example5 bitEdit."

	^LispSmallCompiler evaluate: '(Form extent: 6@7 bitsPerPixel: 32  fromArray: #(127 0 0 127 0 0 127 0 0 127 0 0 127 0 0 255 255 255 0 0 255 255 255 255 255 255 127 0 0 127 0 0 127 0 0 255 255 255 0 0 127 0 0 127 0 0 255 255 255 127 0 0 127 0 0 255 255 255 0 0 127 0 0 127 0 0 255 255 255 127 0 0 127 0 0 255 255 255 0 0 127 0 0 127 0 0 255 255 255 127 0 0 127 0 0 255 255 255 0 0 127 0 0 127 0 0 255 255 255 127 0 0 127 0 0 127 0 0 0 0 127 0 0 127 0 0 127 0 0 127 0 0 127 0 0 127 0 0 0 0))'! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:47'!
example6
	"LispSmallCompiler example6 bitEdit."
	"LispSmallCompiler example6 bitEdit."

	^LispSmallCompiler evaluate: '(Form extent: 14@15 bitsPerPixel: 16  fromArray: ( ''????????????????????????????@@@@????????????@@@@????????@@@@@@C???????????<@@@C???<@@@@@@@@@@@C???<@@@@@@@@@@@C???<@@O???0@@@O???????0@@@O???????0@@@O???????????0@@@O???????0@@????@@@@????????@@@@????????@@@@????????????@@@@????????@@C???<@@@C???????<@@@C???????<@@@C???????????<@@@C???????<@@O???0@@@O???????0@@@O???????0@@@O???????????????0@@@O???0@@????????????????????????????????????????????????????????@@C???????????????????????????????????????????????????????<@@O???????????????????????????????????????????????????????0@@????????????????????????????????????????????????????????@@@@@@@@@@@@@@C???????<@@@@@@@@@@@@@@@@@@@C???<@@@@@@@@@@@@@@O???????????0@@@O???0@@@O???????????????????0@@@O???????0@@????????????@@@@????@@@@@@@@@@@@@@@@????????@@@@@@@@@@@@@@C???????????<@@@C???<@@@C???????????<@@@C???<@@@C???????<@@O???0@@@@@@@O???????????????????????0@@@O???????????????0@@'' asByteArray))'! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:49'!
example7
	"LispSmallCompiler example7."
	"LispSmallCompiler example7 bitEdit."

	^LispSmallCompiler evaluate: '(Form extent: 16@16 bitsPerPixel: 1 fromArray: #(192 16 0 0 224 56 0 0 240 56 0 0 249 255 0 0 255 255 0 0 255 255 0 0 255 254 0 0 255 254 0 0 254 254 0 0 255 239 0 0 255 199 0 0 143 199 0 0 15 0 0 0 7 128 0 0 7 128 0 0 3 0 0 0); yourself)'! !

!LispSmallCompiler class methodsFor: 'examples' stamp: 'nishis 4/25/98 04:50'!
example8
	"LispSmallCompiler example8."
	"LispSmallCompiler example8 edit."

	^LispSmallCompiler evaluate: '(Form extent: 256@64 bitsPerPixel: 8 fromArray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a'' asByteArray))'! !
