'Goodies (11/18/2001 8:35:25 am)'.!


View subclass: #GaugeView
	instanceVariableNames: 'getSelector putSelector minValue maxValue divideValue roundValue scalesLayout '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Gauge'!

!GaugeView methodsFor: 'accessing'!
dialog
	^self model dialog! !

!GaugeView methodsFor: 'accessing' stamp: 'nishis 5/4/98 22:41'!
gaugeBorder
	| box x |
	box := (0 @ 0 extent: self insetDisplayBox extent) insetBy: self defaultMargin.
	x := box left + self gaugeScalesExtent x + 13.
	^(x @ box top corner: box corner) rounded! !

!GaugeView methodsFor: 'accessing'!
gaugeScales
	^self scalesLayout first! !

!GaugeView methodsFor: 'accessing'!
gaugeScalesExtent
	^self scalesLayout last! !


!GaugeView methodsFor: 'controller accessing'!
defaultControllerClass
	^GaugeController! !


!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/15/98 00:48'!
displayBorderOn: baseForm 
	| border lightGrayForm darkGrayForm borderShape |
	border := self gaugeBorder.
	lightGrayForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: (Color gray: 0.75).
	darkGrayForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: (Color gray: 0.25).
	borderShape := LinearFit new: 3.
	borderShape 
		add: border bottomLeft;
		add: border bottomRight;
		add: border topRight.
	borderShape
		form: lightGrayForm;
		displayOn: baseForm.
	borderShape := LinearFit new: 3.
	borderShape 
		add: border topRight;
		add: border topLeft;
		add: border bottomLeft.
	borderShape
		form: darkGrayForm;
		displayOn: baseForm! !

!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:00'!
displayOn: graphicsContext
	| visibleAreas |
	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin + self gaugeBorder origin + 1
					clippingBox: rectangle]! !

!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/4/98 11:22'!
displayScalesOn: baseForm 
	| box label location point extent lineForm |
	lineForm := (Form extent: 1 @ 1) fillColor: (Color black).
	box := baseForm boundingBox insetBy: self defaultMargin.
	extent := self gaugeScalesExtent.
	self gaugeScales do: 
		[:assoc | 
		label := assoc key.
		location := assoc value.
		label := label asString asParagraph 
				foregroundColor: self foregroundColor 
				backgroundColor: self backgroundColor.
		point := box height - (box height * location).
		point := box left + (extent x - label boundingBox width) @ (point + box top).
		point := point - (0 @ (label boundingBox height // 2)).
		label displayOn: baseForm at: point rounded.
		point := box height - (box height * location).
		point := (box left @ (point + box top) + (extent x @ 0)).
		(Line from: point + (3 @ 0) to: point + (7 @ 0) withForm: lineForm)
			displayOn: baseForm]! !

!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:06'!
displayValue
	| graphicsContext |
	graphicsContext := Form extent: self gaugeBorder extent - 1 depth: Display depth.
	self displayValueOn: graphicsContext.
	self displayOn: graphicsContext! !

!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/4/98 13:47'!
displayValueOn: baseFrom 
	| value border back fore |
	value := self getValue - minValue / (maxValue - minValue).
	border := self gaugeBorder insetBy: (1 @ 1 corner: 0 @ 0).
	(baseFrom extent = self insetDisplayBox extent) 
		ifFalse: [border := 0 @ 0 extent: border extent].
	back := Quadrangle 
		region: (border origin extent: border width @ (border height - (border height * value))) rounded 
		borderWidth: 1 
		borderColor: self valueBackColor 
		insideColor: self valueBackColor.
	fore := Quadrangle 
		region: (back left @ back bottom corner: border corner) 
		borderWidth: 1 
		borderColor: self valueColor 
		insideColor: self valueColor.
	fore displayOn: baseFrom.
	back displayOn: baseFrom! !

!GaugeView methodsFor: 'displaying' stamp: 'nishis 5/21/98 02:05'!
displayView
	"GaugeModel example1."
	| graphicsContext |
	graphicsContext := Form extent: self insetDisplayBox extent depth: Display depth.
	graphicsContext fillWithColor: self backgroundColor.
	self displayBorderOn: graphicsContext.
	self displayScalesOn: graphicsContext.
	graphicsContext displayAt: self insetDisplayBox origin.
	self displayValue! !


!GaugeView methodsFor: 'adaptor'!
getValue
	^self model perform: getSelector! !

!GaugeView methodsFor: 'adaptor' stamp: 'nishis 5/4/98 09:14'!
putValue: aNumber 
	(roundValue isNil or: [roundValue = 0])
		ifTrue: [self model perform: putSelector with: aNumber]
		ifFalse: [self model perform: putSelector with: (aNumber roundTo: roundValue)]! !

!GaugeView methodsFor: 'adaptor' stamp: 'nishis 5/4/98 10:19'!
setValue: cursorPoint 
	| box value |
	box := self gaugeBorder.
	box := box translateBy: self insetDisplayBox origin.
	value := cursorPoint - box origin / box extent.
	value := 1 - value y.
	value := value * (maxValue - minValue) + minValue.
	self putValue: value! !


!GaugeView methodsFor: 'updating' stamp: 'nishis 5/15/98 00:48'!
update: aSymbol 
	aSymbol = getSelector 
		ifTrue: [self displayValue]! !


!GaugeView methodsFor: 'defaults' stamp: 'nishis 5/4/98 07:39'!
defaultMargin
	^Rectangle origin: (Point x: 10 y: 10)
		corner: (Point x: 10 y: 10)! !


!GaugeView methodsFor: 'private' stamp: 'nishis 5/4/98 11:13'!
backgroundColor
	^Color lightGray! !

!GaugeView methodsFor: 'private' stamp: 'nishis 5/4/98 11:20'!
foregroundColor
	^Color black! !

!GaugeView methodsFor: 'private'!
on: aModel get: getSymbol put: putSymbol valuesMinMaxDivideRound: anArray 
	| min max div rnd |
	min := anArray at: 1.
	max := anArray at: 2.
	div := anArray at: 3.
	rnd := anArray at: 4.
	self model: aModel.
	getSelector := getSymbol.
	putSelector := putSymbol.
	minValue := min min: max.
	maxValue := max max: min.
	divideValue := div rounded max: 1.
	roundValue := max - min min: (rnd max: 0).
	self scalesLayout! !

!GaugeView methodsFor: 'private' stamp: 'nishis 5/5/98 00:44'!
scalesLayout
	| labels increment extent value location |
	scalesLayout isNil
		ifTrue: 
			[labels := OrderedCollection new.
			increment := maxValue - minValue / divideValue.
			labels add: minValue -> 0.
			extent := minValue printString asParagraph boundingBox extent.
			value := minValue.
			location := 0.
			divideValue - 1
				timesRepeat: 
					[value := value + increment.
					location := 1 / divideValue + location.
					labels add: value -> location.
					extent := extent max: value printString asParagraph boundingBox extent].
			labels add: maxValue -> 1.
			extent := extent max: maxValue printString asParagraph boundingBox extent.
			scalesLayout := Array with: labels asArray with: extent].
	^scalesLayout! !

!GaugeView methodsFor: 'private' stamp: 'nishis 5/4/98 11:50'!
valueBackColor
	^Color gray! !

!GaugeView methodsFor: 'private' stamp: 'nishis 5/4/98 11:47'!
valueColor
	^Color veryDarkGray! !

!GaugeView methodsFor: 'private' stamp: 'nishis 5/15/98 01:05'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !


!GaugeView methodsFor: 'window access' stamp: 'nishis 5/15/98 00:13'!
defaultWindow
	^super defaultWindow! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GaugeView class
	instanceVariableNames: ''!

!GaugeView class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!GaugeView class methodsFor: 'copyright'!
system
	^'Goodies'! !

!GaugeView class methodsFor: 'copyright'!
version
	^'003'! !


!GaugeView class methodsFor: 'instance creation'!
on: aModel get: getSymbol put: putSymbol valuesMinMaxDivideRound: anArray 
	^self new
		on: aModel
		get: getSymbol
		put: putSymbol
		valuesMinMaxDivideRound: anArray! !
