'Goodies (11/18/2001 8:35:06 am)'.!


Object subclass: #ImageFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Images'!
!ImageFilter commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Image Filter
Goodies for Squeak 2.*

Utility class for filtering images.
Copyright (c) 1998 NISHIHARA Satoshi
1998/11/02

  for 
smoothing
shapening
edging
reversing
posterising
histogram stretching
gray scaling

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ImageFilter class
	instanceVariableNames: ''!

!ImageFilter class methodsFor: 'copyright' stamp: 'nishis 11/2/1998 22:29'!
copyright
	^'Copyright (C) 1998 NISHIHARA Satoshi, All Rights Reserved.'! !

!ImageFilter class methodsFor: 'copyright' stamp: 'nishis 11/2/1998 22:29'!
system
	^'Goodies'! !

!ImageFilter class methodsFor: 'copyright' stamp: 'nishis 11/2/1998 22:29'!
version
	^'001'! !


!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:47'!
flatSmooth: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter flatSmooth: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self flatSmooth: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:46'!
flatSmooth: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter flatSmooth: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color gray |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		1 to: width - 1 do: [:x | 1 to: height - 1 do: [:y | 
				gray := 0.
				gray := (self brightnessAt: (x - 1) @ (y - 1) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x    ) @ (y - 1) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x + 1) @ (y - 1) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x - 1) @ (y    ) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x    ) @ (y    ) from: anImage peeker: peeker) * 4 + gray.
				gray := (self brightnessAt: (x + 1) @ (y    ) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x - 1) @ (y + 1) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x    ) @ (y + 1) from: anImage peeker: peeker) + gray.
				gray := (self brightnessAt: (x - 1) @ (y + 1) from: anImage peeker: peeker) + gray.
				gray := gray / 12.
				gray > 1.0 ifTrue: [gray := 1.0].
				gray < 0.0 ifTrue: [gray := 0.0].
				color := 	Color gray: gray.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 10/25/1998 23:20'!
gray: grays index: index patterns: patterns locations: locations
	| startx starty graySum count position max min average gray |
	startx := (locations at: index) x.
	starty := (locations at: index) y.
	graySum := count := 0.
	position := 1.
	max := -1.
	min := 1.
	startx to: startx + 2 do: [:xx | starty to: starty + 2 do: [:yy | ((patterns at: index) at: position) 
				~= 0 ifTrue: 
					[gray := grays at: (xx + ((yy - 1) * 5)).
					graySum := graySum + gray.
					count := count + 1.
					max < gray ifTrue: [max := gray].
					min > gray ifTrue: [min := gray]].
			position := position + 1]].
	average := graySum / count.
	average > 1.0 ifTrue: [average := 1.0].
	^(max - min) @ average! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:48'!
median: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter median: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self median: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:49'!
median: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter median: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color collection |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		1 to: width - 1 do: [:x | 1 to: height - 1 do: [:y | 
				collection := (SortedCollection new: 9).
				collection add: (self brightnessAt: (x - 1) @ (y - 1) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x    ) @ (y - 1) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x + 1) @ (y - 1) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x - 1) @ (y    ) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x    ) @ (y    ) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x + 1) @ (y    ) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x - 1) @ (y + 1) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x    ) @ (y + 1) from: anImage peeker: peeker).
				collection add: (self brightnessAt: (x + 1) @ (y + 1) from: anImage peeker: peeker).
				color := 	Color gray: (collection at: 5).
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:52'!
smoothWithoutEdge: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter smoothWithoutEdge: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self smoothWithoutEdge: anImage interim: [:image | image yourself] ! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 11/2/1998 22:49'!
smoothWithoutEdge: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter smoothWithoutEdge: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker patterns grays brightness minGray gray average count result locations |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		aBlock notNil ifTrue: [count := 0].
		
		patterns := Array new: 9.
		patterns at: 1 put: #(1 1 0 1 1 1 0 1 1).
		patterns at: 2 put: #(1 1 1 1 1 1 0 1 0).
		patterns at: 3 put: #(0 1 1 1 1 1 1 1 0).
		patterns at: 4 put: #(1 1 0 1 1 1 1 1 0).
		patterns at: 5 put: #(0 1 1 1 1 1 0 1 1).
		patterns at: 6 put: #(0 1 1 1 1 1 1 1 0).
		patterns at: 7 put: #(0 1 0 1 1 1 1 1 1).
		patterns at: 8 put: #(1 1 0 1 1 1 0 1 1).
		patterns at: 9 put: #(1 1 1 1 1 1 1 1 1).
		locations := Array new: patterns size.
		locations at: 1 put: 1 @ 1.
		locations at: 2 put: 2 @ 1.
		locations at: 3 put: 3 @ 1.
		locations at: 4 put: 1 @ 2.
		locations at: 5 put: 2 @ 2.
		locations at: 6 put: 3 @ 2.
		locations at: 7 put: 1 @ 3.
		locations at: 8 put: 2 @ 3.
		locations at: 9 put: 3 @ 3.
		grays := Array new: 25.
		
		2 to: anImage width - 2 do: [:x | 2 to: anImage height - 2 do: [:y | 
				brightness := 1.
				self x: x y: y neighbours: grays image: anImage peeker: peeker.
				minGray := 1.
				1 to: patterns size do: [:i | 
					result := self gray: grays index: i patterns: patterns locations: locations.
					gray := result x.
					average := result y.
					minGray > gray 
						ifTrue: 
							[minGray := gray.
							brightness := average]].
				poker pixelAt: x @ y put: ((Color gray: brightness) closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'smoothing' stamp: 'nishis 10/25/1998 23:01'!
x: x y: y neighbours: img image: image peeker: peeker
	| index brightness |
	index := 1.
	-2 to: 2 do: [:y1 | -2 to: 2 do: [:x1 | 
			brightness := self brightnessAt: (x + x1) @ (y + y1) from: image peeker: peeker.
			img at: index put: brightness.
			index := index + 1]].
	^img
! !


!ImageFilter class methodsFor: 'sharpening' stamp: 'nishis 11/2/1998 22:54'!
sharp: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter sharp: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self sharp: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'sharpening' stamp: 'nishis 11/2/1998 23:00'!
sharp: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter sharp: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color gray |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		1 to: width - 1 do: [:x | 1 to: height - 1 do: [:y | 
				gray := 0.
				gray := gray - (self brightnessAt: (x    ) @ (y - 1) from: anImage peeker: peeker).
				gray := gray - (self brightnessAt: (x - 1) @ (y    ) from: anImage peeker: peeker).
				gray := (self brightnessAt: (x    ) @ (y    ) from: anImage peeker: peeker) * 5 + gray.
				gray := gray - (self brightnessAt: (x + 1) @ (y    ) from: anImage peeker: peeker).
				gray := gray - (self brightnessAt: (x    ) @ (y + 1) from: anImage peeker: peeker).
				gray > 1.0 ifTrue: [gray := 1.0].
				gray < 0.0 ifTrue: [gray := 0.0].
				color := 	Color gray: gray.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !


!ImageFilter class methodsFor: 'edging' stamp: 'nishis 11/2/1998 22:56'!
laplacian: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter laplacian: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self laplacian: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'edging' stamp: 'nishis 11/2/1998 23:00'!
laplacian: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter laplacian: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color gray |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		1 to: width - 1 do: [:x | 1 to: height - 1 do: [:y | 
				gray := 0.
				gray := gray - (self brightnessAt: (x    ) @ (y - 1) from: anImage peeker: peeker).
				gray := gray - (self brightnessAt: (x - 1) @ (y    ) from: anImage peeker: peeker).
				gray := (self brightnessAt: (x    ) @ (y    ) from: anImage peeker: peeker) * 4 + gray.
				gray := gray - (self brightnessAt: (x + 1) @ (y    ) from: anImage peeker: peeker).
				gray := gray - (self brightnessAt: (x    ) @ (y + 1) from: anImage peeker: peeker).
				"gray := gray abs."
				gray > 1.0 ifTrue: [gray := 1.0].
				gray < 0.0 ifTrue: [gray := 0.0].
				color := 	Color gray: 1 - gray.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'edging' stamp: 'nishis 11/2/1998 22:56'!
sobel: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter sobel: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self sobel: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'edging' stamp: 'nishis 11/2/1998 23:00'!
sobel: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter sobel: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| peeker poker width count height image color sobelHor sobelVer hValue vValue brightness |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		sobelHor := #(1  0 -1  2  0 -2  1  0 -1).
		sobelVer := #(1  2  1  0  0  0 -1 -2 -1).
		1 to: width - 1 do: [:x | 1 to: height - 1 do: [:y | 
				hValue := 0.
				vValue := 0.
				brightness := self brightnessAt: (x - 1) @ (y - 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 1) + hValue.
				vValue := brightness * (sobelVer at: 1) + vValue.
				brightness := self brightnessAt: (x    ) @ (y - 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 2) + hValue.
				vValue := brightness * (sobelVer at: 2) + vValue.
				brightness := self brightnessAt: (x + 1) @ (y - 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 3) + hValue.
				vValue := brightness * (sobelVer at: 3) + vValue.
				brightness := self brightnessAt: (x - 1) @ (y    ) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 4) + hValue.
				vValue := brightness * (sobelVer at: 4) + vValue.
				brightness := self brightnessAt: (x    ) @ (y    ) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 5) + hValue.
				vValue := brightness * (sobelVer at: 5) + vValue.
				brightness := self brightnessAt: (x + 1) @ (y    ) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 6) + hValue.
				vValue := brightness * (sobelVer at: 6) + vValue.
				brightness := self brightnessAt: (x - 1) @ (y + 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 7) + hValue.
				vValue := brightness * (sobelVer at: 7) + vValue.
				brightness := self brightnessAt: (x    ) @ (y + 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 8) + hValue.
				vValue := brightness * (sobelVer at: 8) + vValue.
				brightness := self brightnessAt: (x - 1) @ (y + 1) from: anImage peeker: peeker.
				hValue := brightness * (sobelHor at: 9) + hValue.
				vValue := brightness * (sobelVer at: 9) + vValue.
				brightness := ((hValue * hValue) + (vValue * vValue)) sqrt.
				brightness > 1.0 ifTrue: [brightness := 1.0].
				color := 	Color gray: 1 - brightness.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !


!ImageFilter class methodsFor: 'reversing' stamp: 'nishis 11/2/1998 22:58'!
makeReverse: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter makeReverse: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self makeReverse: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'reversing' stamp: 'nishis 11/2/1998 23:00'!
makeReverse: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter makeReverse: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color brightness |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		0 to: width do: [:x | 0 to: height do: [:y | 
				brightness := self brightnessAt: x @ y from: anImage peeker: peeker.
				color := 	Color gray: 1 - brightness.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !


!ImageFilter class methodsFor: 'posterising' stamp: 'nishis 11/2/1998 22:59'!
makePosterize: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter makePosterize: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self makePosterize: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'posterising' stamp: 'nishis 11/2/1998 22:59'!
makePosterize: anImage grade: grade interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter makePosterize: image grade: 32 interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color brightness posterizedColors index theGrade |
	theGrade := 2 raisedTo: (((grade abs min: 256) log: 2) rounded).
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		posterizedColors := OrderedCollection new: 256.
		1 to: theGrade do: [:i | 1 to: (256 / theGrade) do: [:j |  posterizedColors add: (256 / theGrade) * i asInteger]].
		0 to: width do: [:x | 0 to: height do: [:y | 
				"brightness := self brightnessAt: x @ y from: indexedColors peeker: peeker."
				brightness := self brightnessAt: x @ y from: anImage peeker: peeker.
				index := ((brightness * 256) asInteger) max: 1.
				brightness := posterizedColors at: index.
				color := 	Color gray: (brightness / 256).
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'posterising' stamp: 'nishis 11/2/1998 23:01'!
makePosterize: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter makePosterize: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self makePosterize: anImage grade: 16 interim: aBlock ! !


!ImageFilter class methodsFor: 'histogram stretching' stamp: 'nishis 11/2/1998 23:02'!
makeHistogramStretch: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter makeHistogramStretch: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self makeHistogramStretch: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'histogram stretching' stamp: 'nishis 11/2/1998 23:02'!
makeHistogramStretch: anImage interim: aBlock
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter makeHistogramStretch: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self makeHistogramStretch: anImage min: 80 max: 180 interim: aBlock! !

!ImageFilter class methodsFor: 'histogram stretching' stamp: 'nishis 11/2/1998 23:01'!
makeHistogramStretch: anImage min: min max: max interim: aBlock
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter makeHistogramStretch: image min: 80 max: 180 interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| image peeker poker width count height color brightness colorMap |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		colorMap := OrderedCollection new: 256.
		1 to: 256 do: [:i | colorMap add: (self stretchedValue: i low: min up: max)].
		0 to: width do: [:x | 0 to: height do: [:y | 
				brightness := self brightnessAt: x @ y from: anImage peeker: peeker.
				brightness := colorMap at: (((brightness * 256) asInteger) max: 1).
				color := 	Color gray: brightness / 256.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !

!ImageFilter class methodsFor: 'histogram stretching' stamp: 'nishis 10/25/1998 08:41'!
stretchedValue: value low: low up: up
	| val half |
	half := (up - low) / 2.
	low ~= up 
		ifTrue: [val := ((value - low) * 255 + half) / (up - low)]
		ifFalse: [(value == low) 
			ifTrue: [val := 128] 
			ifFalse: [(value < low) ifTrue: [val := 0] ifFalse: [val := 255]]].
	(val < 0) ifTrue: [val := 0].
	(val > 255) ifTrue: [val := 255].
	^val! !


!ImageFilter class methodsFor: 'gray scaling' stamp: 'nishis 11/2/1998 23:03'!
asGrayScale: anImage 
	"
	| image | 
	image := ImageFilter image. 
	image := ImageFilter asGrayScale: image. 
	ImageFilter show: image label: 'Image'.
	^image
	"

	^self asGrayScale: anImage interim: [:image | image yourself]! !

!ImageFilter class methodsFor: 'gray scaling' stamp: 'nishis 11/2/1998 23:02'!
asGrayScale: anImage interim: aBlock 
	"
	| image view | 
	image := ImageFilter image. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageFilter asGrayScale: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	view display.
	ImageFilter show: image label: 'Image'.
	^image
	"

	| peeker poker width count height image color red green blue gray |
	Cursor execute showWhile: 
		[image := Form extent: anImage extent depth: 8.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		width := anImage width - 1.
		height := anImage height - 1.
		aBlock notNil ifTrue: [count := 0].
		0 to: width do: [:x | 0 to: height do: [:y | 
				color := self colorAt: x @ y from: anImage peeker: peeker.
				red := color red.
				green := color green.
				blue := color blue.
				gray := ((blue * 28) + (77 * red) + (green * 151)) / 256.
				color := 	Color gray: gray.
				poker pixelAt: x @ y put: (color closestPixelValue8)].
			aBlock notNil 
				ifTrue: 
					[count \\ 8 = 0 ifTrue: [aBlock value: image].
					count := count + 1]]].
	^image! !


!ImageFilter class methodsFor: 'viewing' stamp: 'nishis 10/19/1998 03:55'!
show: anImage 
	"ImageFilter show: Form fromUser."

	ImageFilter show: anImage label: 'Image'.
	^anImage! !

!ImageFilter class methodsFor: 'viewing' stamp: 'nishis 10/19/1998 03:55'!
show: anImage label: label 
	"ImageFilter show: Form fromUser label: 'user image'."

	| topView aView extent |
	topView := StandardSystemView new.
	topView model: anImage.
	topView label: label.
	extent := 64 @ 64 max: (anImage extent min: Display boundingBox extent - 60 asPoint).
	topView minimumSize: extent.
	aView := FormView new.
	aView model: anImage.
	aView window: (0 @ 0 extent: anImage extent + (4@4)).
		"compensate for borders.  Should be window:viewport:"
	aView borderWidthLeft: 2 right: 2 top: 2 bottom: 2.
	topView addSubView: aView.
	topView controller open.
	^anImage! !


!ImageFilter class methodsFor: 'saving' stamp: 'nishis 11/2/1998 22:31'!
save
	"ImageFilter save."

	| fileName classCollection aStream timeStamp |
	fileName := 'ImgFiltr.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (String cr, 
							self comment asString, String cr) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!ImageFilter class methodsFor: 'saving' stamp: 'nishis 10/18/1998 21:03'!
saveClasses
	"ImageFilter saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*ImageFilter*').
	classCollection := (SystemOrganization superclassOrder: self category).
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!ImageFilter class methodsFor: 'private' stamp: 'nishis 11/1/1998 01:25'!
brightnessAt: aPoint from: image peeker: peeker
	^(self colorAt: aPoint from: image peeker: peeker) brightness! !

!ImageFilter class methodsFor: 'private' stamp: 'nishis 10/25/1998 11:18'!
colorAt: aPoint from: image peeker: peeker
	^Color colorFromPixelValue: (peeker pixelAt: aPoint) depth: image depth! !


!ImageFilter class methodsFor: 'image' stamp: 'nishis 11/2/1998 22:43'!
image
	"ImageFilter show: ImageFilter image label: 'sample'."

	(ImageFilter class selectors includes: #sampleImage) 
		ifTrue: [^ImageFilter perform: #sampleImage]
		ifFalse: [^Form fromUser]! !

!ImageFilter class methodsFor: 'image' stamp: 'nishis 11/2/1998 22:42'!
sampleImage
	"ImageFilter show: ImageFilter sampleImage label: 'sample'."

	^(Form
		extent: 150@150
		depth: 32
		fromArray: #( 
617514 550952 345627 345114 345114 345114 345114 345114 345370 346139 347165 413470 413727 413727 413983 483365 1206831 3555633 1643020 2037778 3352864 6969157 10458743 9148787 7376487 4488792 3238724 2121269 3041599 9591850 11554585 12407322 12605724 13195291 13915160 14182193 11238739 6516036 3234864 346652 9472096 15706234 16688750 12821616 4544553 1584658 5205549 278296 346652 277527 1660205 2852682 2852682 2852682 2852682 2852682 2852938 2852938 2918474 2918474 2918474 2852681 4886112 413470 413470 413470 413470 5204288 9932143 11969411 11441784 11046256 9997679 482596 275476 205838 205838 205838 206350 275732 277783 277783 277783 277783 206607 136712 136712 136712 208658 277527 277527 277527 277527 276758 275732 275732 275732 275732 139276 136712 136712 6511698 8476221 9396547 7897187 346909 346909 346909 346652 345627 345370 345370 276501 345370 481314 681257 681256 681256 612387 341269 136712 136712 139276 3821625 10188636 8608573 7622709 8084031 9531218 11440242 10912872 10456694 7703401 2256696 549414 549414 944172 1404467 2326082 1727024 136712 136712 136712 136712 9598301 6711380 347165 413470 413470 413470 552234 415778 345114 345114 345114 345114 345883 346652 347678 413727 413727 413727 413727 413727 416290 550439 550439 4209973 2694163 5850420 11443587 6787942 484646 484646 484646 484646 484646 1535540 7117172 10701594 11684631 12145179 12278045 13063450 11237970 3497010 346652 346652 346652 346652 346652 3302192 13082481 12224613 136712 136712 3362336 277527 480801 481827 871458 2058296 2852682 2852682 2852682 2852682 2852682 2852938 2852938 2786632 2786632 2589510 2589510 4292438 414239 413726 413470 413470 1266981 6452554 10385750 10317131 10184774 9340777 274707 205838 205838 205838 275732 277783 277783 277783 277783 275476 137738 136712 136712 136712 138251 277527 277527 277527 277527 277527 276245 275732 275732 275732 208145 137994 4869445 2234128 5256998 9659461 9992544 346909 346909 346909 346909 346908 345883 345370 206863 345627 681000 5078865 9674108 5136969 136712 136712 136712 136712 138507 9470568 9595723 8806207 7425587 8873546 10387298 13151375 10057304 9266762 10254427 12560784 9016437 549157 549414 1009709 2589253 998174 136712 136712 136712 5723976 9134400 8157537 413470 413470 413470 414240 552234 415265 345114 345114 346139 347165 413726 413727 413727 413727 413727 413727 413727 481826 484646 550439 550439 8612436 7556404 10520684 3570503 484646 484646 484646 484646 484646 485159 551208 6066276 10764820 11619096 11752733 11950622 8156494 346652 346652 346652 346652 346652 346652 414240 481571 11702375 12549983 136712 136712 3098909 2189097 614695 548645 343832 607517 3437375 7571035 7506270 5737306 2852682 2326082 1931067 1470260 2457924 2589509 2589510 4033880 482595 416803 416547 416034 415778 415521 3367218 8675642 9987136 10646356 205838 205838 205838 207889 277271 277783 277783 277783 277783 139532 136712 136712 136712 136712 136712 208145 277527 277527 277527 277527 277527 275988 275732 275732 275219 4739654 3221280 2168335 4994083 10316873 9857349 9143914 346909 346909 346909 346909 346908 344857 137994 206094 5332038 9987654 10448975 10912872 5921096 530954 136712 136712 8746082 9397061 9594440 9594440 7687992 9069897 10320989 11637363 10452062 9597010 10780773 10912360 10912615 10984321 482852 1009452 6590821 8024672 136712 136712 136712 8680546 9265729 9734254 413470 413470 413470 547876 2324014 3501611 1331743 413470 413727 413727 413727 413727 413727 413727 413727 413727 482596 617514 550952 550439 6588254 10119242 8476733 5603668 484646 484646 484646 484646 484647 551208 551977 551977 6915676 10633492 11160602 11293982 10649429 346652 346652 346652 346652 346652 347421 481571 548645 548645 5207108 3947818 138763 344858 2055205 3240759 2194495 1666101 608286 4353598 10644811 10171919 9319695 8732187 7827024 414239 481570 482596 2128446 2589509 2589509 2589510 4096853 482852 482852 482852 611873 1328928 2634018 5257253 10120269 10257002 205838 205838 205838 276758 277783 277783 277783 277783 208401 136712 136712 136712 136712 136712 136712 136712 275988 277527 277527 277527 277527 277014 275732 275732 2706996 2431505 2168335 2168334 6439468 10711372 10120261 9922372 9340779 346909 346909 346909 346909 276245 136712 136712 7169364 10645836 11567450 12028257 9994599 8483421 9665638 10648934 9790535 10120012 10318678 10389357 7962468 8749418 8618605 8291180 9866098 9993317 9991258 11110509 11439472 13411459 11637880 6193753 9212274 9592387 9336676 3423534 1779996 10714724 9988419 9931885 413470 413470 481314 615463 3237928 1138212 414496 413727 413727 413727 413727 413727 413727 413727 415521 483877 551721 617514 1602349 9214315 11372910 10448720 10257257 484646 484646 484646 484646 485159 551721 551977 551977 551977 9665884 10371349 10767900 11363635 4810815 346652 346652 346652 346909 414752 548645 548645 548645 548645 4878657 412445 481827 482852 482852 1600820 2457924 2523460 3702343 11364164 10499342 9909262 9057039 8139792 8020042 136712 137738 138763 535315 534803 534803 932381 4815706 4749911 4552276 4681296 5794902 6910303 11050374 10849139 5263680 137225 205838 205838 209427 277783 277783 277783 277783 208401 137738 139789 206351 136712 136712 136712 136712 136712 467469 276758 277527 277527 277527 277527 276501 275732 2640433 2431505 3616038 5328455 8154203 10059882 10060396 9862504 10583910 10191721 4811849 346909 346909 138251 136712 728332 8483421 10843468 11567444 12027996 9863271 10778196 9921859 9725255 9791047 10454123 5338447 414495 277270 138507 136712 136712 208401 2711350 9606264 12361864 12425855 12423025 10711634 10382159 10185550 9987144 9658947 10451037 9600359 10054729 10449483 11178098 413470 414752 615207 615463 483877 485672 414496 347165 347678 413727 347678 345883 347678 483108 484903 485416 551721 2455611 552234 9409390 10974035 10316619 10125926 484646 484646 485159 551465 551977 551977 551977 551977 3440198 9785648 10043413 10309149 10124374 346652 346652 346652 413983 481571 548645 548645 548645 548645 4223038 13396797 13266242 10058836 482852 482852 1272624 2457924 2457924 2523460 10124120 10171149 9515277 8663310 7680528 8150086 136712 136712 136712 136712 136712 136712 136712 5658698 9081208 346140 345370 345370 345370 208914 136712 136712 138251 206094 208658 277783 277783 277783 277270 206094 137738 136712 208914 346652 208402 136712 136712 136712 1386008 6776146 663821 208914 408342 277527 277527 277527 276245 1852456 5527372 3163188 139276 136712 136712 136712 136712 136712 7038292 10124389 9404005 6321237 2963497 4475194 10781290 10848366 11639166 12357739 11765606 10519660 10776651 10316619 9922120 10387048 208401 414495 414495 205581 136712 136712 136712 136712 209171 414495 5997148 12954255 11698270 10315848 10381130 10447181 10184265 9921604 9790534 10250825 10448715 10778704 11375732 414752 614694 615463 614182 206863 139276 206094 276501 276501 209170 10983292 9141865 137994 346140 485415 484903 1731377 11439986 10651242 9605483 11238236 10449232 10451545 5408078 550952 551721 551977 551977 551977 551977 551977 10067581 8729102 9650455 9915678 5795143 346652 413214 481058 548645 548645 548645 548645 548645 4550975 12677447 12732951 12600853 11236945 482852 482852 680487 2260288 2457924 2457924 3703626 10639673 9121548 8335117 7352336 7291687 2371618 136712 136712 136712 136712 136712 136712 8155744 11377278 346909 346396 345626 208145 136712 136712 136712 139532 206607 277014 277783 5729101 9405803 2176546 136712 136712 136712 345370 414752 347421 205838 139276 2242340 12034447 12162430 5922119 599054 2772254 407830 277271 277527 277014 274963 206094 205838 205838 137994 136712 136712 136712 136712 136712 2305825 8679517 11306076 12621941 12093280 11302737 11302995 12163709 11179131 10586224 10322282 10184516 10382410 10579790 6052426 344601 414495 347165 136712 136712 136712 136712 136712 136712 344601 414495 2516022 11245175 11104843 11105103 10973007 10381386 9856067 9856839 10382666 10711885 10843982 11113073 4552265 7046495 7962724 4017465 136712 136712 136712 1654819 277783 207632 12558728 12818036 13019537 4872515 483108 485672 943911 9081701 11965299 11638132 12029807 11043169 10131307 8950113 4162638 551977 551977 551977 551977 9217405 13416340 12753271 8204302 9256213 10317127 937761 414752 547876 548645 548645 548645 548645 548645 7698510 12740157 12403987 12338195 12272146 10385233 482852 482852 482852 1799481 2457924 2457924 2457924 9533271 8727820 8006669 7023887 5975313 6379849 136712 136712 136712 136712 136712 136712 9797995 12688251 4091205 346909 208914 136712 136712 136712 136969 140045 207889 7895390 11502435 10381639 10249798 3948851 136712 136712 206863 414239 414752 414752 277014 278296 4549191 11897452 11633768 11571322 3096864 3034398 1725216 2515242 7176788 7240021 208658 205838 205838 205838 139276 136712 136712 136712 136712 136712 136712 1057044 9732458 11370327 11632982 11566932 11369040 11301963 10913387 3816999 9140835 10651244 9469286 8943713 1653788 1335598 1534771 1400109 136712 136712 136712 136712 136712 136712 602646 2259519 2061884 7241825 10777426 10579274 11038800 10775886 10315847 10316358 10645321 10646090 10777933 10909775 10317902 8804666 10383438 10254169 140045 275988 2182956 9017981 11315342 7961698 12030582 12949106 13146230 12029552 10392183 7048804 2651965 11115389 11049332 10062953 11052911 11182196 10584165 9199170 12293752 11382417 9543548 10589815 11111023 13477248 14067837 12555636 7744525 8862485 9598291 3106615 548645 1204777 548645 1926702 3435320 6911306 12086599 12336912 12206097 12075025 12009489 11877904 10777422 482852 482852 482852 1141039 2457924 2457924 2457924 7831898 8333835 7481868 6629902 5450256 5585958 4474940 136712 136712 136712 136712 136712 9993317 11767406 11053455 278296 138251 136712 136712 136712 137994 206350 140045 3620655 11700072 10841674 10643782 3554863 136712 136712 277527 414752 414752 414752 209171 207632 8424046 11042657 11108194 11967104 5066552 8486757 11244926 11374454 10980719 8682846 667667 275732 208914 209427 208145 205838 136712 136712 136712 136712 136712 136712 136712 6907220 10850167 12027489 11369042 11111793 10455149 9731943 11110508 11368529 11171154 10513738 7376232 2984267 2984267 2189625 136712 136712 136712 136712 136712 136712 136712 1991221 10597521 13806988 11105618 10907213 10906955 10841418 10381639 10382152 11171153 10909005 10975054 11171664 10777165 9198904 10843473 12290918 1989155 413470 413470 413470 3501120 11904134 12422245 13342054 12683352 12093024 11830627 11567454 12226156 12092770 11697756 11634024 9936995 10259822 10187866 9067585 13280386 13280388 11502947 11436127 12291437 14267538 14396290 13211505 8865580 8468243 8733979 9919541 10772537 11361334 11756094 12146996 12208417 12008207 12008207 11942927 11877392 11746319 11615247 11483663 11625536 482852 482852 482852 811817 2457924 2457924 2457924 7045722 7809035 7615000 7166280 5460034 4869183 4146489 136712 136712 136712 136712 4080952 9529677 10713690 12561555 207632 136712 136712 136712 136712 139276 206350 139789 136712 8023643 11565137 11104587 6446668 136712 206094 413470 414752 414752 347421 205838 268297 6973271 12555637 12101005 11574148 9208934 10720384 11435615 11104593 11170901 9473135 277014 277014 277014 277014 277014 277014 138763 136712 136712 136712 136712 136712 136712 136712 136712 9142124 10651503 11966332 13607035 12820610 10126185 11104327 10842188 10513738 10785395 2918731 2918731 2124089 136712 136712 136712 136712 136712 136712 3423792 12102290 14398351 13739132 12224608 11498833 11169610 10710086 10381379 10185290 10776141 10448201 10580043 11106386 11041107 9594946 10584680 9141353 613925 413470 413470 413470 413470 413470 10591612 12682842 12550485 12356195 12488813 12357227 12159331 11961435 12096628 12029296 11574905 11044973 10326893 10258025 13084038 11383953 10198909 9801328 11571832 14860704 15055248 13342576 8998710 8007952 8273688 8799259 9584919 10435602 10959119 11286542 11483150 11548686 11614478 11548942 11548942 11417871 11221006 11155214 10958349 4156476 482852 482852 482852 1997116 2457924 2457924 6914393 7349770 6893077 3619886 136712 136712 136712 136712 136712 136712 601109 9143405 9068613 9924179 12296328 860178 136712 136712 136712 136712 140045 206350 206094 138763 138763 12160364 11630929 10914415 275732 345627 414239 414752 346652 206607 136712 136712 136712 7501147 11379593 13478287 10258800 10720125 12291179 11434068 9867376 413983 344345 277014 277014 277014 277014 277014 275476 137225 136712 136712 136712 136712 136712 136712 136712 530954 10718840 13475704 13344634 12225894 9406562 11368012 11763547 11434325 10841933 10784371 7837551 3765320 136712 136712 136712 136712 4147001 8944489 12425595 14136985 14134407 13277809 11895127 11170894 10775624 10709831 10644552 10710861 11039052 10580295 10975311 11435607 11436900 8549215 136712 136712 747049 547364 413470 413470 413470 413470 413470 11180150 12419414 12225124 12094314 12685935 13080177 12953993 485416 3438915 9148518 11041884 9593925 9799275 6261588 617514 617514 617514 617514 7905911 14402977 13473646 10448726 7482382 7879190 8339481 9125398 9910802 10434063 10827278 11023885 11154958 11154958 11154958 11089422 10958349 10892813 10761485 10564365 9662287 482852 482852 482852 1601845 2457923 2457924 7306842 6890506 5972747 4999484 136712 136712 136712 136712 136712 136712 1522209 11047030 9462599 10450264 10588800 136712 136712 136712 136712 137994 206350 207889 344857 344601 278296 12227442 11763030 11631190 9735278 2907693 414752 344857 205838 136712 136712 136712 136712 728844 8157541 11377798 13217428 12037267 12887431 12355684 4154944 414495 347165 278040 277014 277014 277014 277014 277014 209427 137225 136712 136712 136712 136712 136712 136712 136712 8815729 14530711 12884087 11896419 10066536 10787959 10986882 12820350 11302482 10381642 10381130 11041887 10913647 10979697 10191725 9731688 9203029 9134920 11305055 14137243 15122846 13607548 11763547 10710092 10380870 10381384 10645324 11105875 11237458 11040077 11631954 12423530 6906961 136712 136712 136712 747049 747049 546850 413470 413470 413470 413470 1135909 11244146 12751214 13739911 14003079 14001278 12363910 485416 485416 616488 6720865 10455405 9593157 8035698 552234 617514 617514 617514 617514 617514 8757365 12361609 6825227 7418642 7945239 8534806 9385745 9975055 10302221 10499085 10630157 10695693 10695693 10630157 10498829 10433293 10236429 10039820 9842700 7565902 482852 482852 1141038 2457667 2457923 8540731 6299913 5447690 6116423 136712 136712 136712 136712 136712 136712 136712 11178620 10909787 11568746 5856590 136712 136712 136712 136712 139276 206350 277783 346908 345627 4220223 12883315 12157789 11894620 11832173 11968126 10785143 1715741 136712 136712 136712 136712 205838 207889 1453852 991505 5198916 6188110 7567189 5727304 930068 1334573 2062140 2061628 1796149 937508 805152 343064 276501 275989 139789 136712 136712 136712 136712 136712 136712 136712 9930611 13804930 14397577 10067578 547362 2586429 2721096 2721096 10199164 10974033 10775886 10842450 10712406 10515285 9857612 8939342 8872778 9858642 12293233 14204061 14266766 13014125 11696979 11039569 10645069 10447691 10579534 11040855 11304027 11106642 11898474 5724230 136712 136712 136712 137481 747049 747049 747049 480289 413470 413470 413470 413470 7110491 12027494 12621174 11576969 8227435 9344627 485416 485416 551721 552234 4161611 10517600 12891541 4754261 552234 552234 617514 617514 617514 617514 3965516 7555637 6957839 7353620 7944212 8729873 9449998 9777421 9974028 10105100 10236428 10170892 10039564 10039564 9908493 9711628 9514764 9318156 9386266 6844492 482852 614438 2326081 5472853 7089945 5709577 4857354 6312774 136712 136712 136712 136712 136712 136712 136712 4278330 11765095 11569518 3752757 136712 136712 136712 137481 206350 275732 346909 346909 543516 9604969 13345923 12420706 12223327 11903615 12491904 7893086 136712 136712 136712 136712 140045 208914 208914 139020 136712 137994 273168 996885 277014 277014 604698 2454848 2918475 2918475 2918475 2918475 2061115 206863 137738 136712 136712 136712 136712 136712 136712 136712 136712 13283733 14329724 12233094 482595 482595 1733431 2721095 2721095 2721095 11377018 11433558 11566429 11501406 11238494 10251599 8741191 9267278 9858898 12227444 15849147 14463886 12619107 11433292 11236438 11630942 11565404 11500376 11435609 11763804 12487267 9996145 136712 136712 136712 137481 206607 747049 747049 747049 680487 414239 413470 413470 413470 413470 14136472 14989978 8032878 346652 346139 416290 485416 551721 552234 552234 9672052 14135179 13613723 5934685 552234 552234 552234 617514 617514 617514 4816721 7224099 6893585 7418899 8074001 8663054 9121548 9383692 9580300 9580300 9580300 9580300 9514764 9383692 9121292 8924428 8727564 8399627 8071435 7695694 1794863 1536309 7371097 5774856 4987912 4135689 5390132 136712 136712 136712 136712 136712 136712 136712 2108960 11899254 11634791 6579797 136712 136712 136712 139532 7698531 10524800 8950901 7834216 11575681 12685936 11312248 12427134 12157282 10327156 4803902 136712 136712 136712 136969 205838 208914 208914 209427 140045 136712 140302 208402 275219 277014 277014 277014 1398571 2918475 2918475 2918475 2918475 1204012 139020 136712 136712 136712 136712 136712 136712 136712 136712 11573378 12357485 15056790 10201734 482595 482595 943659 2720839 2721095 2721095 7116907 11697503 11895138 12093802 11962475 11107164 9530705 9662806 9924692 11964784 15718589 14265995 12420704 11696211 11631964 12157796 12355174 12092515 11764578 12224101 13083524 1254422 136712 136712 138251 207376 208914 747049 747049 747049 747049 679974 414239 413470 413470 413470 13086868 14926243 2057009 413214 345114 345114 414752 485672 484390 483364 3306561 13154716 14135697 11834487 7637863 552234 552234 552234 617514 617514 617514 6712912 6301966 6827793 7352336 8007182 8465676 8727820 8924428 8989963 9055499 8989964 8858892 8727820 8530956 8334348 8071948 7809291 7481099 7152906 8277817 5732176 7489845 5118727 4200712 3413768 3612948 3620402 136712 136712 136712 136712 136712 136712 5658697 11238495 10713434 10981496 4672825 4738623 6054223 12363919 13542787 12883059 13936001 13673340 13212014 11763801 12420705 11508345 8027478 3296029 136712 136712 136712 138251 206607 208914 208914 208914 277527 347165 275988 207889 208402 208914 277014 277014 277014 803358 7050089 5280350 2918475 2325056 346652 275989 136712 136712 136712 136712 136712 136712 136712 11640715 11504235 12555637 14661781 10726797 482595 482595 614181 2194495 2720839 2720839 2720839 10786939 11632223 12159337 12488817 11502180 9267791 9596501 9990742 12819837 16048325 13411460 11828569 11761491 12224103 12552813 12026726 11369566 10976348 12027236 8419943 136712 136712 137738 207120 208914 208914 680744 747049 747049 747049 747049 613412 413470 413470 413470 12562836 11643019 414752 413983 345370 345114 345114 345883 345370 345370 345370 346140 13480598 11568998 9135174 9213045 5345116 552234 552234 552234 617514 617514 7427135 6039822 6695951 7219982 7744268 8006156 8202763 8333835 8399371 8333835 8137484 8071948 7875340 7612940 7350540 7153419 6825227 6496778 6037256 5577735 5052935 4265991 3479047 3020040 2954504 5719354 136712 136712 136712 136712 136712 333833 10783095 10778205 9924694 10324849 10718325 10778970 12358514 13543045 13739910 12359546 12624777 11508610 11376766 9930605 11506294 11440502 4085795 4218149 136712 136712 137481 206607 208914 208914 208914 341013 1861685 2193726 2060859 538648 208402 208914 276245 277014 277014 277014 10980722 11633765 12292472 9737335 413983 482339 207376 207376 207376 138763 139789 8487021 11506814 10057308 10648930 12490616 15847856 10266502 482595 482595 482595 1733431 2720839 2720839 2720839 9477499 11763810 11962216 11765352 10450006 8807756 9596500 10384984 14530454 14203807 12555637 11696469 12024665 11632738 11435618 10646616 10120786 10121556 11635569 2897961 136712 138251 207889 208914 208914 208914 547620 746793 747049 747049 747049 747050 547620 413470 413470 12432791 9608315 414752 414752 346396 345114 345114 345114 345114 345627 346396 4485192 13080951 12160107 11371364 11832433 13280907 11907215 7904111 3178052 552234 552234 5402958 5251852 5842702 6498573 6891533 7153676 7415819 7546635 7677706 7546635 7481356 7219468 7088396 6825996 6563340 6366475 6038026 5644041 5249800 4724999 4199942 3478791 3020039 2954504 3019783 3150342 10917768 3160877 136712 136712 136712 5526593 9403497 10580307 10582880 9407336 9068868 9594699 10516313 12297097 7896679 205838 205838 205838 205838 205838 205838 205838 1060113 2112023 136712 139020 207889 208914 208914 208914 208914 1596462 2918474 2918474 2720583 340757 208402 208402 276245 277014 277014 277014 8552292 10776912 11303259 11768437 10720630 8356966 8944485 7964264 8555885 10330500 13087387 11834745 10649701 10188639 10846311 12227960 14663585 12235674 482595 482595 482595 1075245 2655303 2655303 2655303 6329189 11303514 11107165 10384215 8937028 8413258 9070930 11635824 14991780 13215883 11567714 11236435 11893850 10975579 10580309 9528650 8937542 8741191 10258287 136712 137738 208145 208914 208914 208914 3625783 414752 547363 680487 747049 678180 747050 746536 480032 413470 11643790 7967341 414752 414752 413470 345114 345114 345114 345114 346396 346909 8490349 11897449 11107934 10121043 11043176 13149578 13542016 12949107 12688508 11113075 10851705 6522723 5980464 4858124 5514509 5907724 6300940 6563083 6694155 6759434 6693898 6694155 6366732 6170124 5907724 5645324 5448203 5054218 4725512 4397063 3806214 3281670 3019783 2954504 2954504 3085319 9730666 12027750 12030839 8878694 6249804 9666665 10645070 10781548 9863531 10587760 10060908 8476990 9995373 5994326 275219 205838 205838 205838 205838 205838 205838 205838 205838 205581 137225 138507 207889 208914 208914 208914 208914 1728817 2918474 2918474 2918474 2588228 671260 208402 208402 275476 277014 277014 277014 4546370 10909272 10777940 10778452 10383438 9857095 9528389 7820346 9924689 12162680 12361092 10451297 10253918 10649446 11373425 12556412 14729638 13416607 413983 482595 482595 614181 2194239 2655303 2655303 6853480 10777688 10186320 9463626 8411195 7821634 8808269 11833458 15781294 12886659 11304540 10512710 10643525 10317905 9857357 8871492 8214592 8018755 5198659 138251 207889 208914 208914 208914 3099954 11637366 414752 414752 413726 342294 206351 611362 747050 679974 480289 11971984 4814413 414752 414752 413983 345114 345114 345114 345114 346139 346909 10458490 10384723 9002558 9923661 12491128 13152144 12356967 11962212 11440757 10391668 9668461 10459010 6383958 6119244 4596496 4792588 5120267 5448203 5447690 5644297 5578505 5513226 5316875 4857867 4726795 4529931 4201482 3873032 3609863 3478277 3150341 3085319 2954760 2889224 3020040 6968133 13415580 12159849 11369819 11567196 11435093 10974285 10513225 9857095 9469030 5792826 8879203 8552544 4615220 2315553 929810 206094 205838 205838 205838 205838 205838 205838 205838 139533 206350 208914 208914 208914 208914 276501 4287047 7444592 6920557 5215327 3968084 2589510 935713 208402 208402 208914 277014 277014 277014 277014 10846052 10251853 10054476 9594696 9069122 8805695 8017470 10385756 11637108 11374452 9596758 9663065 9860959 10584938 11242096 11833461 12294525 7566946 206350 412957 482595 1799481 2655303 2655303 8295792 9856328 9331527 8477249 7425076 7163191 8478790 11307370 14794913 12491386 10975062 10314561 10314304 9988170 9594443 8674114 7688507 8613468 1060120 208658 208914 208914 1654306 7239005 11639681 12093541 414752 414752 275732 137738 136712 272913 4747850 6458208 679975 6127194 413983 414752 414752 414752 346396 345114 345114 345114 345370 4877897 11635306 9857865 9265471 10647383 12952196 12824211 7437919 345370 345370 345370 345370 345370 345883 4612423 3151881 3414282 3611146 3742217 3807497 3806984 3806727 3675911 3348232 3282953 3151881 3020553 3020296 3019783 3150598 3150342 3019783 2889225 2889481 2889225 5389101 12165258 12228986 12357997 11370073 10975058 11238487 10579273 9789505 10518375 9402982 8811874 9207399 1724455 543004 1065241 274450 276501 276501 275732 275732 208914 209427 209427 275476 208914 208658 274963 208402 1332522 808228 6979680 9073246 8413256 9070669 10058077 7375466 545056 276758 208402 208402 208658 276501 277014 277014 277014 10911327 10383179 10120266 9463366 8674366 8148021 8017470 9991513 12100493 11638911 9268048 9268819 9532506 10190180 11110512 11109996 11307889 11638656 3949878 136712 275988 1334829 2655303 2655303 9473650 9329985 9265477 8609091 7622454 7360310 8609860 11306083 13345668 11371877 10382670 10249543 10052165 9658950 8870465 7753269 7490869 8610638 10391929 12890263 12035984 11506554 10911332 9988678 9725767 9396549 414752 278040 138251 137738 136712 136712 7104598 11568743 13811880 2842167 413726 414752 414752 414752 413470 345114 345114 345114 345370 9407085 11173981 9792329 9331263 10976860 11577232 2118958 345370 345370 345370 345370 345370 345883 346909 9079929 2824202 2824202 2823946 2823945 2889481 2954504 3085062 3085319 2954760 2823945 2824202 2824202 2889481 3020039 3085062 3019783 2823945 2824202 2824202 6507839 11966080 12161397 12162166 11963753 11900541 7499099 4475193 7892313 10651755 9337446 9661009 9008996 4087358 346652 346652 345883 277270 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 1400365 2523717 3769165 9073757 7886655 8478790 9004618 9794648 8485739 136712 205581 208402 208402 208402 275988 277014 277014 2575918 10449491 10120263 9923143 9463368 8477247 7687730 8215878 9602418 1124375 12430747 8870977 9530704 10715751 10452837 9662550 10977637 12821381 12360571 11111279 3423535 136712 336398 1528619 2655303 10320483 9330498 9134147 8411970 7227955 7163447 8808270 12031350 13411459 11042396 10185036 9986887 9526338 9331014 8805442 7950905 7294005 7229241 9925718 13282187 13348239 12229243 10317128 9856575 9264701 9067584 345114 139020 138251 137481 136712 136712 136712 10126449 13745831 345370 346908 414752 414752 414752 414239 345114 345114 345114 345114 10058079 11240287 10121294 9726792 10787967 345370 345370 345370 345370 345370 345370 346396 346909 346909 10124901 10191470 6378050 2693643 2693643 2693643 2758923 2823946 3020040 2889224 2693387 2628364 2693643 2889481 3019783 2889481 2693643 2693643 4601639 9864306 11045233 11766124 12030326 12426112 9273709 794385 136712 136712 531467 8484189 8871234 8805443 9534310 1328154 346652 346652 413214 346396 277014 277014 277014 277014 277014 277014 277014 277014 277014 277527 741154 2523717 2523717 2523717 7900268 7294777 7887170 9202770 10124386 10521978 136712 137481 207120 208402 208402 275220 277014 277014 5597259 9856579 9988938 9462850 8674621 8214586 9138266 5066561 136712 139276 9668465 8869691 9661776 10320992 10386532 8279870 9924947 12360574 12689536 11108182 10846822 6118218 136712 136712 6120784 9462088 9264964 8740162 7754811 6767661 7755584 9729886 12756103 13149057 10384465 9527878 9264452 9132093 9068613 8411455 7622969 7622715 8479050 10189404 11833971 12295039 11967101 10121552 9462593 8805183 8147515 206863 138251 138251 136969 136712 136712 136712 4278073 11446416 345370 345626 414239 414752 414752 414752 346652 345114 345114 345114 10190436 10319191 10384988 11048573 345370 345370 345370 345370 345370 345370 346396 346909 346909 4614983 8476473 7359543 9006165 10126963 8746084 5851965 2497806 2497805 2562829 2693387 2628364 2497806 2628364 2693643 2563085 5325877 7364432 9336163 10848367 11768695 10123101 11503724 10847081 8420202 136712 136712 136712 136712 138251 6974037 8739137 8673344 8290148 2642720 345883 413470 482596 483109 415009 345114 278040 277014 277014 277014 277014 2248492 413214 482596 415009 1532464 1197603 1728049 2523717 9207144 7294779 7426105 8610634 10717555 136712 136712 139789 208145 208402 209171 277014 277014 8748388 9724996 9659462 8870459 8411195 8942689 1648667 136712 136712 138251 9011819 8936504 8937281 9859930 10716268 9663578 8872774 10583906 12557952 11898991 10582618 10779483 8221020 136712 8811362 9067331 9133893 8608834 7622970 6965039 7886911 9729630 12756622 12887172 10319444 9199940 8870207 9066557 8805698 7753783 7096368 7096114 9531989 12492932 13347469 12162167 10121299 9529415 9067838 8476474 7884854 138251 138251 138251 136969 136712 136712 136712 136712 7632225 1659431 345883 413983 414752 414752 414752 413726 345114 345114 345114 3891519 5401934 9146743 4615499 345370 345370 345370 345370 345883 346652 346909 346909 346909 9208424 8476475 7621943 8478020 9399377 10648929 10912360 11900798 12823957 12101007 10782833 9926499 10714726 10518377 10649706 10253918 9464655 8149054 7951419 9201739 10781543 11242608 11636080 9602163 136712 136712 136712 136712 206350 208658 3953465 8804671 8739137 5400908 1522455 276501 344088 413214 483109 483109 483108 5208400 10919555 10787716 10391158 10585450 9600357 208401 139789 137738 136712 733463 2391105 2523717 8424816 7163192 7820348 9465687 10387302 7565923 136712 136712 139789 208402 208402 276245 277014 9729629 9002558 9330498 8936509 9008995 136712 136712 136712 136712 136969 10588796 10056018 9398604 9398605 9200968 8214077 9069898 9992284 10913128 10122067 9727309 9791560 9790532 9861986 9265995 8936001 8936772 8740419 7755325 7228469 7557947 9861216 12164483 12491900 10384724 9331010 8803900 9000254 8870723 8016957 7162421 6702383 8215873 11505781 12163196 11504491 10451031 9858891 8871744 8016438 7754038 138251 138251 137738 136712 136712 136712 136712 136712 7303768 7701593 477981 347165 414495 414752 414752 414239 345114 345114 345114 345627 346396 2513202 345370 345370 345370 345370 346139 346908 346909 346909 346909 2448177 9990744 8935483 8477503 9136717 9334097 9070414 7952193 10452323 12098430 12755587 11635304 10381124 10183232 9987395 9725509 9462852 8937537 8741190 8938310 9595981 10386273 11571317 11638913 136712 136712 136712 136712 206607 208914 208914 5464392 8869950 9729120 209427 208658 276758 277014 277014 481057 4548934 7434331 9597529 9861965 9403218 9072194 9594696 9664611 136712 136712 136712 538392 2258494 2523717 2523717 5015898 7032636 7557946 9729631 10980467 11836291 6052684 136712 136712 140302 208402 275732 5400139 8803899 8870204 9002047 10057569 1977375 136712 136712 136712 136712 136712 9539454 11241834 9792587 9264955 9791295 10121034 9528901 9594437 9660229 9397572 9199682 9331012 9264706 8869435 8607291 8738878 8739392 8608577 8018238 7228211 7294517 8676429 11375225 12163707 9989969 8738875 8475704 9001535 9135174 8214331 7227698 7228213 9663061 11967104 11636340 10516315 10253912 9398349 8806985 8543041 8740158 138251 138251 137482 136712 136712 136712 136712 136712 6382930 12821896 10917499 5862995 413470 414496 414752 414752 346396 345114 345627 346652 346909 2184495 345370 345370 345370 346140 346909 346909 346909 346909 346909 9405030 9002046 9132861 8739645 9529930 10319960 10123098 7886655 9135177 11374963 12230529 11437926 9724225 9789246 9790275 9528391 9463367 8609088 7162932 7228725 9794391 12230534 11506812 7368287 136712 136712 136712 206350 208914 208914 208914 9338987 8344378 8352865 208402 208402 276245 277014 277014 3825200 12295970 7623722 6967084 11439883 12623115 12163083 8677143 9398608 2437668 206350 346396 547620 2523460 2523716 2523716 4491605 7691595 8018240 9795423 11047550 10785150 9403755 2635047 136712 136712 139789 209171 9206884 8803898 8673085 8936768 6052427 136712 136712 136712 136712 136712 136712 11246730 11242094 9990482 9264956 9329975 9462335 9199422 9331267 9726539 9726795 9265730 9068096 8935999 8475192 8542013 8411198 8083004 7820346 8413510 8281668 8675913 9268565 11770241 10583389 9528646 8607546 8410427 9132865 8608833 6900275 6308140 7030835 9926494 10387562 11112054 9859671 10189407 10649959 9069646 8345664 9068866 138251 138251 137481 136712 136712 136712 136712 136712 8683112 11239774 10515024 9011558 345370 346396 413726 414496 2776100 805917 346908 346909 4942667 4810826 345370 345626 346396 346909 346909 346909 346909 346909 346139 9732454 8870462 9132348 9133890 9332552 9398858 9267016 7960929 9730400 11439986 12625031 11832688 10119241 9722942 9526592 9199426 9331268 8476733 7162677 7162935 9201998 11638652 12035218 136712 136712 136969 206607 208914 208914 208914 5794128 9529161 8541497 8352606 208402 208402 275732 277014 277014 277014 11181638 12623116 12623115 12557580 12623372 12360203 11505674 9070114 6124370 482596 482596 482596 1733432 2523460 2523460 4950361 6967353 7820860 9203286 5922385 136712 136712 136712 136712 136712 401935 7632990 9463629 8672568 8541497 9335903 136712 136712 136712 136712 136712 136712 136712 11969680 11441017 10123870 9397573 9330491 9068091 9002558 9068606 9594692 9463619 9199681 8870462 8410426 8146999 8279869 7885626 7490870 7097139 7756609 7821891 7821119 8281671 11179648 10912870 9463881 8344890 8015929 8738620 8083261 7031862 6045483 6768431 9992549 11047293 9993833 8543300 8609094 10649187 9793619 8805953 9594694 138251 138251 136969 136712 136712 136712 136712 136712 1263138 4420170 7832163 346396 345370 345370 345370 345370 2446625 2186532 346909 346909 8286813 7566174 1002269 346652 346909 346909 346909 346909 346908 345883 345114 3563579 9398866 8540980 8739645 8872517 8807237 9205341 413470 2972470 10985864 11836033 11572344 9923657 9461308 9198397 8739646 9133891 8345918 7360054 6834225 8083262 10454122 9538171 136712 137481 207120 208914 208914 208914 2509101 11836805 10122070 9265733 7630680 208402 208402 275219 277014 277014 277014 7175492 12097291 13346577 12294667 11965707 11899915 11834123 11834379 10197075 482596 482596 482596 1272624 2523460 2523460 7047527 6111790 7690048 8808786 5856591 136712 136712 136712 136712 136712 136712 9139810 8673082 8410167 8410426 6578001 136712 136712 136712 136712 136712 136712 4935233 10123098 11046258 10849136 9860695 9464137 8476732 7884596 7622194 8871744 9990223 9464393 8279610 8016441 8015671 8345406 8214077 7819575 7425588 8019778 7953474 7360569 7097140 10848882 11308402 9728342 7819061 7621426 8410172 7886141 6703153 5519395 6439724 9730660 11509640 10061426 7754299 8017214 10583393 10254685 8543552 8476987 204300 137994 136969 136712 136712 136712 136712 138507 346396 414495 414495 414495 347165 346396 346139 345627 869659 4090922 346909 2185776 8876380 8551775 5533771 346909 346909 346909 346909 347678 346140 345114 345114 345114 9469800 8541495 8410681 8346432 8675911 8290919 414496 345370 345114 8753270 11113853 10127984 10124899 9797222 9467743 8936514 8543041 7622968 6505517 7491125 10388330 5396810 139276 207889 208914 208914 208914 2311466 10587254 9991000 9135432 7361568 8749130 208402 208402 208914 276758 277014 277014 3693361 11243807 11570956 10979850 11111178 10848267 11505162 11637258 11570954 10068047 482596 482596 614181 2457924 2523460 8028778 5848876 6638132 8480077 8157549 136712 136712 136712 136712 136712 136712 3094827 9399381 8147253 8740681 2963498 136712 136712 136712 136712 136712 136712 7494731 9662806 11243643 11573894 10651242 9793616 8938051 7885621 7425328 7622194 8279612 8214333 8083005 7555894 7950649 8477504 8280381 7491122 7096880 7492924 7887425 7952703 7359797 9795678 9662806 9069640 7819318 7425077 8147771 7491384 6308913 5520169 6176812 8678229 10587256 10193271 8807241 9004620 10518883 9531986 7425071 7885108 735771 137994 136712 136712 136712 136712 136712 209171 414495 414495 414495 414495 278040 208402 206607 139020 138251 1125137 208401 4413504 8289883 7890515 8283470 9736569 7571047 413470 414239 414752 347165 345114 345114 345114 6714456 8278839 8148023 7820346 8479819 4616522 414752 346652 345114 345114 345114 345370 345370 345883 7371101 8608573 8148539 7491897 6703155 7689532 9995120 140045 208145 208914 208914 208914 7041115 10192497 10323049 10190174 7361586 8941577 9734981 208402 208402 208402 276245 277014 277014 277014 9602360 9993738 9927690 9664520 9795842 9532936 10256395 11176971 11834123 10199118 482596 482596 1601846 2457924 8154973 5782825 6966324 9334611 8618613 136712 136712 136712 136712 136712 136712 136712 8811105 8213047 9006169 136712 136712 136712 136712 136712 136712 7826013 6308912 8084291 9730402 11246214 10850936 9860696 9069894 8279606 8016691 8016437 7950906 7819577 7490611 7292979 7556151 7819835 8017468 7425589 7425590 7754812 8281668 8873546 7951416 8346689 8280383 8081977 7555890 7425078 7753529 7491128 6637364 5519911 5716520 7427650 9666153 10389616 9267787 8280894 8872775 8478019 6964779 6767144 413726 472599 401679 663309 532750 270605 209171 480545 414495 347165 275476 205581 136712 136712 136712 136712 136712 136712 136712 136712 925714 5132099 8549477 10125675 11179643 414752 414752 414752 413983 345114 345114 345114 4154177 8213306 7884598 7360056 8547417 1071399 414752 347421 345114 345114 345114 345114 345627 346908 9141349 8279869 7951420 6966068 6177325 6966327 9928554 10523008 10722958 10392961 10191470 9860448 9201999 9334359 8806984 9003846 6704671 9138696 10192422 208402 208402 208402 275732 277014 277014 277014 8879953 8483898 10325320 11510120 12892551 13154415 12099111 11439365 11439884 11374090 10330190 2582840 1141038 7244649 6242606 5848107 6703156 9137234 10261635 136712 136712 136712 136712 136712 136712 136712 5658183 7819318 8676432 136712 136712 136712 136712 136712 6841173 5586219 5849646 7098939 8677971 10061426 10718838 9664349 9004361 8476988 8542266 8344889 7819319 7556406 7490098 6898738 7293236 7293748 7097653 7229497 7163446 8018239 8479047 8479303 8148279 8411451 8082746 7950393 7687476 7227955 7490614 7425079 6703155 5651752 5454118 6375220 8152143 10127219 10323048 9400663 8807754 8544068 7227439 6438953 2918218 2588997 3050061 2315564 2450741 2720070 2588997 2457155 2257981 668952 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 136969 137738 4411199 10916474 4814157 414752 414752 414752 345883 345114 345114 345114 9004882 8146999 7754041 9010020 414752 414752 414239 345370 345114 345114 345114 346396 346909 9138522 8214076 8148284 7623227 6572082 6506032 7361598 8941659 10719360 9336160 8084035 7359540 9334357 9401436 9005647 8808009 6837012 9006857 9204744 6319678 208402 208402 208914 277014 277014 1657384 15790563 16053224 16711671 16777215 16777215 16777215 16052180 12098610 11439623 11440140 11045386 8153672 6192988 8355686 5716776 5585961 6046513 8414283 9798001 1846303 136712 136712 136712 136712 136712 136712 6380879 7556149 7227441 6971987 1319700 136712 136712 8221023 7229238 6309941 5586476 6506548 7624769 10127476 9796966 9203026 8477758 7950903 8082488 7885110 7622453 7294518 7030829 6636079 6833201 7227957 6965556 6439983 6637361 7031860 8084291 8281412 7688502 7556658 7688246 7885115 7819320 7096371 6965042 7227956 6835254 5848875 5520169 5783855 6902593 9008224 10060139 9270365 8941142 7426874 6898989 6176041 1995834 3050060 3050061 2379047 2847037 3050061 3050061 3050061 1593386 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 137994 138507 139789 206094 2641969 4484939 346909 347165 413726 413983 346652 345114 345114 804894 8611667 7884342 7885625 6518873 414752 414752 414752 346652 345114 345114 345114 346139 4942665 7753782 7819833 8016956 7360313 6112044 6506287 8810844 10195582 9278335 7109732 6714458 6189911 8421738 9137753 8545102 8084804 8021003 9401353 10125066 10260806 208402 208402 208914 276501 277014 6850414 16777199 16777205 16777208 16777200 16777199 16777195 16777203 15721654 11570688 11571212 11308043 7756059 6965812 6768176 6374447 6309426 6573370 7165248 7955278 6382165 136712 136712 136712 136712 136712 136712 8546906 7095600 7095856 8222044 8678234 8547420 7953479 7032373 6834995 5981232 7298896 7562326 8285790 9735294 10193270 8808010 8543294 8148538 7951158 7819574 7622453 6899763 6833455 6636335 6636593 6702642 6111276 5979947 6440239 7755069 8412741 8282183 7359795 7425072 7359795 7622458 7293491 6702127 6439214 6636335 6571827 5980462 5520170 5454633 5849907 7889486 9073502 8875868 8942175 8217680 7098170 6111533 2391618 2852682 2984267 2510888 3047751 3050061 3050061 3050060 1526311 136712 136712 136712 136712 136712 136712 136712 137738 138763 140045 206094 206351 206351 1393178 346652 346652 346652 346652 346652 346908 346652 345370 345114 2446896 8217421 7227956 8220765 346652 414752 414752 414752 347678 345114 345114 345114 345627 8026465 8016956 7886398 7491126 6439469 7166280 5926484 1264676 345370 345370 345370 345370 345883 7505514 9007196 8480079 7692058 10058761 10256906 11045131 11703074 10659736 208402 208402 276245 277014 12372146 16777191 16777215 16777214 16777199 16777196 16777194 16777193 16577756 12097028 12096777 11965963 11373837 6308653 6439213 6307627 7098168 7362368 6836025 6967099 8679261 5922129 136712 136712 136712 136712 5657924 8479825 6701614 8745306 8748640 6768176 6768432 6702641 8153172 6578771 2174754 136712 136712 136712 136712 1385752 6710871 9598814 8017980 7556916 7359281 7227696 6505007 6307628 6242092 6440241 6703413 5388581 4928290 5519912 7689535 9337187 8942686 8283471 7491638 7557174 7425847 7096881 6767919 6307630 6175786 6242606 6111278 5650985 5256997 5389355 7362372 7164994 6703671 6507060 8612437 8415313 6769464 4620347 3168554 2448431 2178588 4424768 4027191 4088620 3893040 2575396 465162 136712 136712 136712 137738 139533 140045 206351 206351 206351 206351 206351 3034931 1202979 414239 346652 346652 346652 346652 346652 346652 346652 345627 6648665 7031347 7030835 4941641 346396 414752 414752 414752 413983 345114 345114 345114 2118445 8677203 7490872 7820605 7294260 8088407 4088130 345370 345370 345370 345370 345626 346396 346909 8420200 7230271 5719319 9598729 9204489 9862153 10584580 11506994 14601927 10396561 208402 275220 277014 16118235 16776675 16777213 16777214 16777196 16777193 16777191 16776420 16709606 12623652 11702531 11439883 12031756 7231504 6111277 5979435 6375475 6837052 6244661 6178099 6836287 9535599 8617328 2175011 136712 6381392 8676687 7891801 8216913 8879201 7756874 6505263 6439728 7560783 2635048 136712 136712 136712 136712 136712 136712 136712 136712 2898475 9206632 7492409 6701867 6570281 6307628 6176301 6176300 6308912 6111534 5322791 4929318 6113077 6638391 6836028 8482138 9008995 8613464 6966325 6637102 6570795 6571050 6044972 5978665 5913386 5913900 5979950 5454120 5191462 5849906 6178871 6836801 7429451 7691080 7164480 7033150 2785606 2914111 2516534 2112537 3035167 1070625 1072422 7638120 9734774 6514777 139533 140045 205838 206351 206351 206351 206351 206351 206351 206351 138507 4087617 483108 483108 481314 347165 346652 346652 346652 346652 346652 346652 8812386 7162677 7624260 1658664 345370 413470 414752 414752 414752 346396 345114 345114 345114 7952965 7423795 7228725 8679258 3169080 345370 345370 345370 345370 345370 346396 346909 346909 7693137 6900791 6903302 8612615 9204488 9993739 10584576 12033616 14338242 15127230 9805708 209427 7244143 16774364 16775647 16777199 16777202 16776934 16776933 16776419 16775391 16775660 13677141 11044864 10914059 9993481 10453769 5257510 5125669 5849134 6310198 6639420 6507835 7166023 7890518 8745825 8876897 8283990 7492154 7162675 7953738 6512715 7829335 8023131 8351065 8154459 6052685 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 1585439 8484453 6043938 6175782 5913385 5913643 5979178 5914669 5519399 4927778 4534307 5126954 5520427 6375476 7362629 8481882 8416086 7230526 6703152 6570795 6439722 5782569 5650470 5518885 5585449 5848620 5322792 4797220 4534563 5126185 5982008 6969416 7296835 7625285 7560008 1594412 1727024 3101734 1061139 3034911 2184225 274963 8288867 9145705 10197115 7173220 206351 206351 206351 206351 206351 206351 206351 275219 346140 276501 345883 483108 483108 483108 482596 414752 346909 346652 346652 346652 346652 6715228 7097396 7426880 3431483 345370 413726 414752 414752 414752 413470 345114 345114 345114 7755844 6963501 7821894 3366203 345370 345370 345370 345370 345883 346908 346909 346909 5665365 7033149 5258284 7363335 8546567 9336073 10322187 10255616 12166779 14074806 15127745 16114125 12632238 14276804 16773337 16774877 16775903 16776933 16777195 16777197 16777196 16775907 16774374 14402174 10781952 10387722 9533193 9072904 4928803 4730914 5191977 5915956 5719091 5521714 6113850 7363916 7890003 7758158 6638392 7229497 7163189 8285789 6315082 7628632 7560013 8153689 8088924 2831655 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 137738 1324573 7826266 5847333 5649956 5453607 5716264 5980462 5520169 4862497 4337184 5324075 6508092 7034436 6442043 5914929 7362884 7362884 7033919 6242600 6308137 5913898 5519143 5321763 5191205 5388328 5322792 4731684 4468769 5060646 6113849 6377278 6376507 6046770 6112564 136712 2439959 2439959 136712 531211 3098396 2963755 5849652 7100488 9801845 9146478 804381 1200936 1728562 1596206 1463851 874021 414752 482596 482596 481570 415521 482596 483108 483108 483109 483109 481827 413726 346652 346652 346652 346652 8549213 6439725 6583373 871709 347165 414495 414752 414752 414239 345627 345114 4023107 6965554 6833197 7238235 345370 345370 345370 345370 346139 346909 346909 346909 346909 8155231 8086867 6114876 7100422 7889672 9401609 9861895 10124809 12430492 13877679 13546139 14005918 14795945 15586491 16640724 16774105 16774879 16314327 15457477 15193018 14534573 15521983 16774115 14994586 10584576 10125065 9401865 9072648 5520426 4796961 5191720 5652529 6508863 6508350 6442300 6310714 7496020 7169369 6184273 7889746 8351582 7892059 7165255 7562583 5453350 5585192 5783083 5133381 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 137225 4676422 7166281 5453092 5453349 5059619 5125155 5388841 5257769 4665119 4337184 4995370 6443071 6508865 6639679 7099202 7164993 6704442 5848362 6111787 5848616 5519654 5190693 5190436 5125415 5256743 5125414 4665633 3942940 4008221 4666149 5324591 6246208 6838086 5587506 1255440 2439959 136712 136712 136712 2110997 7303509 6112821 6442814 6969673 3370045 1205806 2721096 2721096 2721096 2589510 746024 482596 482596 415778 414495 414495 415009 482596 483108 483109 483109 483109 483109 415008 413214 346652 346652 7043420 8813922 8417629 7172443 3235899 2776887 940069 414752 414752 346652 345114 7566431 6439982 7427393 2840629 345370 345370 345370 346396 346909 346909 346909 346909 4155463 5718578 6310715 5325094 7100678 7297798 8481288 9072385 10060331 12364959 13417384 11507842 12034704 11837328 12230280 16245707 16773080 16774878 14535860 12493963 13152929 13546652 15258296 16772824 15718586 10124811 10190599 10059273 10716426 5388586 4928548 4402205 4730657 6771266 7891032 6969417 7891805 2897964 136712 136712 3423790 8090210 5980204 5519398 7365718 5321763 5388327 5388841 7102803 2110757 136712 136712 136712 136712 136712 136712 136712 136712 1057301 6710616 6046769 5717290 5650726 5124898 4796705 4928291 5060133 4929319 4204827 5390128 5785657 5259573 4206114 5389614 6508865 6574914 6640448 5652270 5849902 5717288 5717288 5322792 4928034 4730913 4796450 4862244 4731428 4271905 3942941 3811613 3943713 4995629 5851966 5786686 2704667 1058575 136712 136712 136712 136712 3952427 4610620 929048 2309416 344345 2062141 2721096 2721096 2721096 2194495 482596 482596 482596 415265 413983 414495 414495 415265 482596 483109 483109 483109 483109 483109 482596 414239 346652 1791017 8286557 6044969 5979177 6309429 6047286 7236184 3368767 414752 2842154 7568488 6771005 6506547 7494215 1198883 345370 345627 346396 346909 346909 346909 346909 3105084 7695197 5060392 5586992 7758355 9335816 9204745 8809736 8941056 9797691 12102302 13022112 14800331 15921380 14735032 15722464 16442830 16772309 16773336 16182228 15592677 14472372 16447467 16774628 16705231 16113614 12032028 12360457 11900172 12163083 6244630 4994851 4467999 4336414 5718837 6377795 8354416 136712 136712 136712 136712 136712 7891549 5717546 5388325 7365204 6968905 5388585 5059876 5060133 6838603 5395529 991508 136712 136712 136712 136712 465678 6053204 7168598 5389613 5652785 5652527 5256996 4927776 4599327 4468512 4534048 4469027 3745562 4008735 4798766 5458239 4602156 4995372 5653044 6114364 5324076 4995626 5191718 5520682 5323560 4994341 4665376 4402205 4205086 4336159 4336929 4337185 4271135 4074271 3548956 3613978 4667178 4470830 735254 208145 136712 136712 136712 206607 274963 207632 205838 205838 205838 603672 2125627 2721095 2721095 1338674 482596 482596 482596 415265 742692 1995834 1534771 1930298 1798969 1338673 483109 483109 483109 483109 483109 483109 481827 413214 3565121 4680778 6647897 6969417 4665890 4139806 5126959 7431511 8947313 8682090 7099713 6309684 6440756 4482114 345883 346908 346909 346909 346909 346909 4680011 8024676 6180414 5653813 4732947 9861898 10453513 10519305 10321930 10058498 10126657 11904668 12824990 15000038 9994560 4473660 15129017 16640214 16772052 16773336 15460833 11049058 3749415 13286293 16776176 16573645 15850698 11045401 11242504 11900172 12294667 11965707 9927182 4008728 3876378 4336929 7432799 136712 136712 136712 136712 206350 138251 7564641 5982519 5389354 6249550 3226155 3752246 6839120 4665634 4731940 4468770 5523259 6116428 6709334 6974305 7368549 6839892 4206371 4402978 5389871 6048829 5983293 4994854 4533533 4139290 3876635 4139292 4140319 3943453 3614490 3285784 3615006 4206884 5916729 6706505 5588795 4864298 4205339 4073497 4336925 4797475 4666147 4337183 3942426 3810842 3810844 3876636 3876892 3876892 3942942 3614748 3220247 3022870 3023129 277527 277527 140045 136712 137225 209427 277783 277783 207632 205838 205838 205838 602903 2125627 2720839 877610 482596 482596 482596 414239 742179 2522691 2918731 2918731 2918475 2918475 2260288 3897419 4420430 482339 482596 482339 482339 415521 414752 414495 414495 414495 4746060 5072974 6252116 6115654 7366231 8882805 5983035 5981748 7166537 7174227 1462563 346909 346909 346909 2185264 6318421 5784885 5785657 5786174 4996399 5850892 9335817 9927945 10650634 10585354 10781698 10389310 11575961 12430233 11973815 10062690 3943436 13748146 16574420 16771538 16773079 16248545 10326905 3416832 13617584 16509920 16376780 15587267 11374358 10979847 11571212 11702795 11505419 11702794 4864272 3876634 5983298 1386266 136712 136712 137481 206350 208914 139276 7564128 5983552 7170142 136712 136712 136712 136712 5855053 4271392 4205856 3811612 3350806 3482393 4272678 5655360 4997173 4404265 4140321 4666406 4864815 4865071 4601127 4271133 3942426 3679514 3679513 3745306 3614749 3219992 3022871 2826006 3549728 4799279 5392446 5195324 4602415 4206111 3942683 3942426 4008476 4074269 3679771 3548441 3482392 3416601 3416857 3219736 3219479 3285528 3219993 3285785 2957077 2891542 277527 277527 206094 136712 137225 277270 277783 277783 275732 205838 205838 205838 205838 735771 1797174 482596 482596 482596 482596 413470 346652 1929273 2918731 2918475 2918475 2918475 2918475 4355407 414495 414495 414495 414495 414495 414495 414495 414495 414495 414495 414495 347421 346652 346652 5794901 7832160 5391157 7760216 8025695 6969159 6969930 6384726 5794899 6908504 6114366 4337440 4205598 4271650 4601643 5392698 6640137 8809736 9730313 10190858 10453514 10848259 10323253 10984080 12167319 11509388 10986920 12236203 15128266 16311243 16772566 16773081 16775130 13881544 11644068 12696246 15982022 16245198 14995117 11571212 10848008 11439371 11571467 11111178 10979594 5522445 3811355 5132358 136712 136712 136712 206350 208914 208914 1258781 6444619 5126958 4607041 136712 136712 136712 136712 925715 5917762 3877149 3548955 3022870 2891027 2693906 4471344 4339758 4470315 3944229 4536366 4931123 4009764 3746334 3746076 3614234 3351064 3022357 3022356 3088663 3023128 2694421 2366228 2563606 3221021 3879207 4010795 4076588 3945258 3681315 3352093 3548698 3219991 3022869 3088405 3154198 2891029 2825492 2759700 2628115 2562579 2496786 2431250 2431249 2497042 277527 277527 139532 136712 137225 276501 277783 277783 277783 209170 205838 205838 205838 205838 540699 482596 482596 482596 482852 415521 413214 940071 2918475 3705426 4426072 6325092 5077334 744230 612131 414495 612131 612131 612131 414495 480545 414495 414495 414495 414495 1530403 1266721 1266977 1069856 4483378 7962463 7629913 4534563 4665891 4731426 4402205 4336669 4468254 4534305 4206111 4008732 3679769 4009249 4273696 8283912 9467401 9796105 10059274 10124810 10321668 9731627 10654859 11838869 12627612 13218977 15521474 15915714 14864314 16777204 16777203 16640980 16773848 16377297 16376264 16442828 15916493 14073752 10650884 10519305 10585099 11176458 11505674 11637003 7560457 5917762 136712 136712 136969 205838 208914 208914 208914 5529936 4207142 5852995 1912097 136712 136712 136712 136712 136712 5789005 3219736 3219992 3023127 2562834 2431506 2432021 3155486 3878692 4011051 3550500 3155228 3286556 3286299 3154456 3088919 2826006 2496785 2627857 2497042 2431763 2431506 2037264 1971728 2235156 2826778 3024672 3156001 3682344 3682344 3353637 2629141 2430992 2365456 2497041 2497041 2562834 2562834 2497041 2365457 2234128 2233872 2168335 2168336 2168336 277527 276501 137225 136712 136712 208914 277783 277783 277783 277271 207632 205838 205838 205838 205838 413214 482596 482596 482852 483108 482340 1859120 6511694 5589310 4732973 3613465 6382934 3573327 2786632 2654790 2589254 2786632 2457411 2589253 2325569 2457411 2325568 2193726 2127165 3698486 3628838 3893547 4155435 4220457 5993784 6905936 4206112 4140576 4140063 3942940 4930094 3745049 3876635 3943198 3811868 3614747 3811870 4404754 10519307 10519050 10124809 9795849 9532937 9270019 9073701 10129028 11641234 12627869 14074800 15060923 15390656 11575440 14471102 15195084 15193536 16771795 16771538 16573646 15982023 15587783 13350805 8283651 8744455 8875784 8941576 9993480 11834379 12031500 5921355 136712 137481 206607 208914 208914 208914 3230775 5195325 3747107 4866618 1386010 136712 136712 136712 136712 136712 2174756 4207662 2694164 2497299 2234128 2168592 1905935 1971728 2892314 2958365 3090466 3287330 2826521 2563093 2497043 2562834 2694677 2431506 2234127 2233870 2168336 2168592 2168336 1971472 1774349 1905935 2037778 2432794 2629915 3024930 2827293 2629142 2299663 2234127 2168334 2497813 2826779 2628885 2497298 2365456 2233871 2233871 2365714 2365970 2299921 277527 208658 136712 136712 136712 206607 277783 277783 277783 277783 275732 206350 205838 205838 205838 275476 482596 7568749 5657929 6052687 6251351 5722953 3945257 3482906 3285527 3219478 3088406 5537886 2852681 2918474 2918474 2918474 2852938 2852938 2852682 2852682 2852682 2852682 2852682 1660205 277527 346652 278296 5205549 1584658 4085032 7633498 4602158 5919560 5072462 346652 1987886 3891266 5858386 4799794 3286041 3022870 11505418 10585098 9730569 10190601 9599241 9401609 9336069 8613142 9141878 10917770 12364698 13614250 14534837 14600629 13022370 9208179 11246476 16442573 16705488 16376523 16047816 15521729 14929597 12824464 8612354 8283910 8349960 8941320 9598985 10453513 11834902 5002031 138507 207889 208914 208914 208914 2902580 4999232 2102543 2760471 4011310 2306598 136712 136712 136712 136712 136712 136712 5261892 2233872 2234129 2234384 2234385 2037263 1774349 1643020 2366485 2695708 2827551 2827293 2563608 2431507 2563092 2563091 2562835 2431249 2299920 2233871 2234129 2168336 2102800 2168593 2103056 1905678 3484968 4801343 4735549 6577754 5853773 6117460 7301991 6643804 7696748 8091508 8025458 8486009 7173740 7108204 7043436 7174509 7175791 6454120 277527 138251 136712 136712 136712 137738 275476 277783 277783 277783 277783 275732 205838 205838 205838 274707 8488801 6578004 5656131 4932153 4537651 4208946 3287587 3287328 2826006 2694163 5724235 2589510 2589510 2786632 2786632 2852938 2852938 2852682 2852682 2852682 2852682 2852682 2058296 871458 481827 480801 277527 3362336 136712 136712 6184786 6975319 2514221 346652 346652 346652 346652 346652 2250545 5661009 2957835 10650890 9336072 10059529 10125065 9993737 9796361 9861897 9335555 8286561 9931134 11444112 12956834 13877420 14009008 13482920 13877422 15587522 16310731 16179403 15916232 15455937 14864057 13877685 11574644 9992961 10322441 10322186 9993482 10321929 10716426 11113268 139020 208658 208914 208914 208914 3953216 5065282 2234643 2103057 1840142 2234900 3555896 136712 136712 136712 136712 136712 136712 5197896 2168336 2168336 2168336 2168592 2234129 2037264 1774349 1840142 2432279 2695708 3156002 3353381 4076848 4998206 5919309 6511704 7235685 7565163 9407883 9539727 9407883 9473934 9473934 9144970 8553090 8158332 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 5400665 208402 208402 208914 277014 277014 208145 136712 136712 136712 136712 136712 139532 277783 277783 277783 277783 277271 207889 205838 205838 205838 10859624 10269020 9808727 9348439 8888652 8492882 8096091 7831132 6643792 3681315 4358997 2589510 2589509 2457924 1470260 1931067 2326082 2852682 4687451 5538400 5406558 2715968 607517 343832 548645 614695 2189097 3098909 136712 136712 5526605 5597526 481571 414240 346652 346652 346652 346652 346652 346652 4612425 9006857 9204489 9927945 10716682 10848010 10979594 10650635 10058754 8482610 8484730 10260096 12101783 13153957 13614506 14009006 14732985 15653060 15916743 15850181 15390144 14798009 13943470 12167334 10717743 11045123 11045642 11176715 11045387 10650634 9336073 9076799 7041350 4806728 4872009 5461837 5262918 3089952 2102799 2103056 2234900 2103570 2169106 5001545 136712 136712 136712 136712 136712 136712 5855570 3353124 5525066 5196100 7302509 9344152 8752014 10203321 9938860 10069159 9803929 9013641 8289661 7566195 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6447714 6381921 6381921 6381921 6381921 6381921 6381921 6316128 6316128 6316128 6316128 6316128 6316128 6316128 6316128 6316128 7896698 208402 208402 208914 276501 277014 136712 136712 136712 136712 136712 136712 136712 208401 277783 277783 277783 277783 276758 205838 205838 205838 9742450 10205282 9350993 8890956 8562249 8036421 7576129 7049533 6784312 9017717 2589510 2589509 2589509 2128446 482596 481570 414239 5267279 2366743 1971985 2169621 5594705 3042112 608286 1666101 2194495 3240759 2055205 344858 138763 2241318 3106623 548645 548645 481571 347421 346652 346652 346652 346652 346652 7830344 8218376 9533193 10585098 10914058 11242506 11505676 11242507 10322194 8089438 8681583 10523012 12167576 13153956 13877677 14798265 15324608 15390145 15126972 14469557 13614249 12101790 10193511 11308289 12163345 11834124 11308298 10585098 9007368 7232263 6640391 2695437 2563350 2234128 2168335 2234128 2300177 2168849 3353382 5657167 5262152 6776163 8751237 136712 136712 136712 136712 136712 136712 11055543 9676222 9156046 9153986 9083318 10136528 10071504 9152717 8827600 8634327 7909836 8231848 6778222 6381921 6381921 6381921 6316128 6316128 6316128 6316128 6381921 6316128 6316128 6316128 6250335 6250335 6184542 6184542 6184542 6184542 6184542 6118749 6118749 6118749 6118749 6118749 6118749 6184542 6184542 6977390 208402 208402 276245 277014 136712 136712 136712 136712 136712 206351 139789 137738 208401 277783 277783 277783 277783 209427 205838 205838 137225 5005635 9810283 9548394 8233320 8035942 6787166 7049567 7903844 6982753 932381 534803 534803 535315 138763 137738 136712 8224377 7038561 6972511 6577497 6709340 8751746 3375180 2523460 2457924 1600820 482852 482852 481827 412445 3436102 548645 548645 548645 548645 414752 346909 346652 346652 346652 3432763 9337375 8941576 10190857 10848010 11176970 11833868 11834383 11703312 9599783 7827047 8615787 10325887 12035733 13022114 14074800 14600885 14272434 13811629 12890783 11246736 9076337 11045135 11570956 11834637 11703052 11505418 10781961 9664777 8744200 6049042 10198677 10067093 10396319 10593703 11976133 11912918 12242400 11585761 12308709 11848674 10798562 10206680 3755594 136712 136712 136712 136712 136712 11188154 10398407 10267855 10664923 8956097 7439009 8229561 9807819 10070479 8888773 8562125 8829143 7845577 7176580 6316387 6184542 6184542 6184542 6118749 6052956 6118749 6052956 6052956 6052956 5987163 5987163 5987163 5855577 5855577 5789784 5789784 5723991 5723991 5723991 5723991 5723991 5723991 5789784 5855577 6447714 6583145 208402 275220 277014 1254422 136712 136712 136712 208402 346652 208914 136712 137738 206094 277270 277783 277783 277783 208658 206094 138251 136712 136712 208914 345370 345370 345370 346140 7706467 5070660 136712 136712 136712 136712 136712 136712 136712 8027259 6447714 6447714 6447714 6447714 8032642 2523460 2457924 2457924 1272624 482852 482852 7178357 7961978 7764343 3372361 548645 548645 548645 548645 481571 413983 346652 346652 346652 9737033 10388234 10914057 11176971 11965964 11702795 12360723 11834385 11045124 8942368 7760474 7958114 9010286 10654338 12430492 12890528 11904404 10917253 9273202 7628882 8810254 10519302 10913802 11374091 11965709 11834380 12031499 11768331 12228620 8025151 11190966 10992053 9614262 10336969 11453912 11848671 11454945 11321561 10796764 10665693 11061218 10667492 9745350 136712 136712 136712 136712 4807758 10466225 10135485 10530507 10203859 10400984 11189212 9609667 7637683 8362431 10400467 9610953 8097465 9284305 7976921 6983844 6383215 5921372 5723991 5723991 5658198 5658198 5592405 5592405 5526612 5526612 5395026 5329233 5263440 5131854 5066061 5000268 5000268 4934475 5000268 5000268 4934475 5000268 5066061 5197647 5395026 6119005 6189156 209427 4679250 10324083 2242597 139276 205838 347421 414752 345370 136712 136712 136712 2112034 9806184 6060365 277783 277014 206607 139532 136712 136712 136712 208145 345626 346396 346909 8558687 6977621 136712 136712 136712 136712 136712 136712 2438443 7237230 6316128 6316128 6316128 7961978 3507791 2457924 2457924 2260288 680487 482852 482852 7767931 6316128 6776679 6254436 2714430 548645 548645 548645 548645 548645 481058 413214 346652 5864002 11045386 11768331 11965963 12162827 12491787 12754702 12754445 11965705 9270282 8615752 9801089 10196366 9735042 8549736 9470582 10721680 10787989 10196360 7826493 7560965 9664777 10256394 10848010 11242762 12228879 12425997 12360459 12557323 11834379 11513976 11517881 10861489 11584707 11190459 11059134 10271676 10599364 12042968 11453921 10206432 11060451 10010595 9481150 136712 136712 136712 8756362 9743788 9544378 8753323 9478856 8888005 9742797 10861278 9808846 9809876 9415376 10403807 9415887 8229307 7771587 7247800 6781586 6384514 5330011 5000268 4868682 4868682 4868682 4802889 4737096 4671303 4539717 4408131 4276545 4210752 4013373 3947580 3881787 3881787 3881787 3815994 3881787 3881787 4079166 4276545 4605510 5066061 5526612 7174257 7699831 10254682 4418119 278296 277014 414752 414752 414239 206863 136712 136712 4016434 12360514 13344841 13612140 8162143 207889 140045 136969 136712 136712 136712 208914 346909 3369018 8553793 8225625 136712 136712 136712 136712 136712 136712 6844266 6118749 6118749 6118749 6118749 7901056 2457924 2457924 2457924 1799481 482852 482852 482852 7374455 6184542 7698038 139020 3102268 4421973 548645 548645 548645 548645 548645 547876 414752 938017 11311929 11702795 11834379 11834123 12294413 12294925 11176715 8809728 8615746 12369340 13027269 14342618 15593197 14145237 14211030 15921906 12895685 16579834 13552837 8285210 9993223 11373835 11702796 12031502 12754966 12557840 12360205 12097291 12163339 11308812 9867107 12110538 12045251 9810592 10138792 10336952 9220511 10072512 9545413 9482199 10338019 9681119 9550561 9678784 136712 136712 11390926 9284779 9018297 7569566 8030382 9611992 7965108 9149639 8558532 9152977 8035530 7838407 8761303 8824525 8560325 7902133 7505061 6385038 5728407 4607327 3815994 3750201 3750201 3684408 3618615 3552822 3421236 3289650 3158064 3026478 2894892 2763306 2697513 2697513 2631720 2631720 2631720 2697513 2894892 3223857 3684408 4276545 5000268 5395026 5658198 9529678 7766887 207632 209171 414752 414752 414752 277527 136712 136712 3883821 14061376 15243852 15183986 3950128 140045 206350 137994 136712 136712 136712 138251 278296 8883293 8744490 9273426 136712 136712 136712 136712 136712 5134418 6645350 5658198 5658198 5658198 5658198 6721395 2457924 2457924 2457924 1141039 482852 482852 482852 7438966 5723991 7633013 7176563 7177844 7374967 9743257 6197870 3242057 1928245 548645 1073961 548645 3107637 10196552 9993481 10125065 10059018 9072905 7955207 7166470 6771200 9273697 11052459 11447726 15658734 15856113 16777215 15658734 16777215 12829635 15526892 11314851 9599769 10913801 11965963 12294411 12820498 12952597 12689169 11834121 11374347 10519562 9401865 8418620 13095639 13490397 12899793 11715520 10009043 10143431 9679274 8955846 8627912 9482968 9681123 8892378 9419491 10008269 7836062 9358057 9485013 9347520 8555948 8095405 7636668 7111614 8231374 9679060 6912419 7636916 7702711 5664931 6454190 9414101 6781862 7175846 7306150 7833529 6124720 4018042 2631721 2565927 2500134 2434341 2368548 2302755 2171169 2039583 1907997 1776411 1644825 1579032 1579032 1513239 1513239 1579032 1644825 1842204 2171169 2697513 3421236 4210752 4868682 5197647 10911069 7435107 268297 205838 347421 414752 414752 413470 206094 136712 7299654 15500861 16487501 9928543 136712 139789 206350 139276 136712 136712 136712 136712 207632 10715729 9723938 9332526 4080689 136712 136712 136712 136712 4608330 5134418 5397590 6580838 5526612 4934475 6065003 2457924 2457924 2457924 811817 482852 482852 482852 7041389 5330002 7571835 8163969 8624010 8690311 9216898 9544082 10333857 11714723 10461840 8154924 8681004 9074724 9073161 9664777 8941833 8020999 7363591 6706182 6640390 6771974 3424533 1388304 7108712 16776959 15461355 16777215 15724527 16777215 12895172 12438206 2636032 10321672 11702794 12360459 12425995 12557580 12294669 11176713 8743945 6574598 5852953 6975314 11059645 12307150 13622239 14149095 13161941 11256284 10471385 11323073 11388121 11192294 9285073 9943522 10075881 10140646 11585003 11059689 9162222 7709897 6716060 6649239 7569318 6912698 7175346 5794730 7969746 7180232 5005714 7637443 7900106 4348047 4083330 6713765 7240629 6781105 6057130 7504832 8163278 4874920 1777448 1447704 1381653 1315860 1315860 1250067 1118481 1052688 921102 855309 855309 789516 789516 789516 789516 855309 1052688 1315860 1907997 2631720 3421236 4144959 4539717 6645836 136712 136712 136712 206607 346652 414752 414239 345627 275732 13338715 16416830 16162666 138763 138763 206094 206350 140045 136712 136712 136712 136712 859663 11432002 10376220 9785627 9074774 601109 136712 136712 136712 136712 136712 136712 3293239 4342338 3815994 5736039 2457924 2457924 1997116 482852 482852 482852 3108164 4738891 6717297 7374455 7703674 7966331 8229749 9938831 9609620 9808276 11713444 11776936 5918758 7429128 8086792 8744200 9401865 9993225 9861898 9270537 9072905 8875784 3425298 1522201 1192970 9016198 16776959 15592941 16777215 16053492 16777215 12500670 13884882 1128193 9073930 11899915 12163341 13149720 12360464 11111178 8809993 5719814 5659440 5801570 6723701 8826525 11455431 12245194 12573139 12308436 12437983 11458032 12704742 12179442 11322855 10862561 11586030 12244467 11388909 10728928 10728930 10276085 8367056 7703473 5727628 6055830 7110596 6714805 6912952 6255024 6914248 7048915 5929913 6452406 6256835 5598897 3888274 3756178 6256568 6650552 6058163 5992111 7439555 4874665 1515319 723981 657930 657930 592137 526344 460551 460551 394758 394758 394758 328965 328965 394758 394758 526344 789516 1250067 1842204 2565927 3289650 3750201 728844 136712 136712 136712 136712 205838 344857 414752 3038506 11698775 16019248 16677951 15900783 278296 344601 344857 207889 206350 137994 136712 136712 136712 136712 10185806 10962966 10307350 10383178 1456159 136712 136712 136712 136712 136712 136712 4279108 2631720 2631720 5734244 2457924 2457923 1601845 482852 482852 482852 6388587 5928804 5732956 7638389 8162932 8554866 8688000 9281178 9611668 10203021 10924949 11975082 10328979 7034888 7100422 8809992 10387978 11110667 11373834 11111178 11045386 8154380 732694 2178841 1127177 10462878 16711166 15592941 16777215 16316664 16777215 12500671 14804704 1259785 7299337 11636746 11965966 13150234 12097548 11308299 9467402 6707475 8427656 8300693 7775371 8301971 9421212 11324852 10927291 10598090 11649252 12838902 12379369 11982315 10271199 7966909 8954063 11387886 10531810 10795496 9745130 9616880 8363468 7175336 7306409 7175352 7176126 8557520 9544664 7242944 6386612 5333932 6718926 6060219 5334187 7505871 8295638 4873631 2242431 4874404 7242179 7110592 4676768 4347549 4808870 1976651 328965 263172 263172 263172 197379 197379 197379 131586 131586 131586 131586 131586 197379 263172 460551 723723 1184274 1842204 2434341 2829099 207889 205838 136712 136712 136712 136712 1846297 12482895 13206614 15167805 16148011 16742461 16488035 4876864 345627 346908 277783 206350 139276 136712 136712 136712 136712 5589301 11158035 10502163 9987657 136712 136712 136712 136712 136712 136712 136712 4870476 1513239 1513239 4409669 2457923 2457667 1141038 482852 482852 5537123 6847342 7108961 7306343 8095352 9804670 10000010 9477272 9345425 9676687 10398349 10266524 11057318 10990222 5787945 7100679 8941576 10847754 11899916 12163086 11439882 12425482 6512398 666389 2112792 929543 11646128 16711166 15790320 16777215 16645629 16777215 12697793 15264998 1654805 3883786 9072392 11505674 11637260 12294669 11899915 11045386 8679959 9217169 11718867 10930373 9879468 10077349 11323839 10467019 12043493 12702964 14218490 13757946 11128818 10270426 8888018 6850244 8757213 10202858 8431080 9548518 8035790 7900091 6911908 6582692 7965904 7373508 7308483 10136800 10729449 8951763 8621517 6254258 7441107 6457549 4938655 6979271 7176390 5202088 3887258 4808870 6387130 6123187 4149914 2702979 5400238 2307172 131586 131586 131586 65793 65793 65793 65793 65793 65793 65793 65793 65793 131586 263172 394758 723723 1118481 1579032 1973790 208914 208914 140045 136712 136712 136712 136712 9068614 14186057 13929050 15818790 16675128 16095079 11113318 543516 346909 346909 275732 206350 137481 136712 136712 136712 3749927 11421212 10566417 3881771 136712 136712 136712 136712 136712 136712 136712 4606535 789516 789516 1842460 4292181 2326081 614438 482852 5274974 7962737 8813422 7828593 7566447 7961448 9736587 9934742 8883328 9937817 10727069 11382940 9873049 10072203 9939594 6846027 6508808 9007368 10979594 12360463 12821010 11900426 12754186 6183694 665876 2112023 862981 11580591 16776959 15790320 16777215 16579836 16777215 12632256 15528171 2049049 2113042 5916933 9730313 11308554 11899915 12228875 11374090 9862414 6781541 9879739 9028008 10473143 10272439 8758449 8756933 12177394 14939645 13955068 11588838 10340319 11915761 10792669 8954333 7577572 8367848 7511246 8495311 8295618 6056858 6516640 7966930 9150173 8425425 7242950 7438275 7110079 8359887 10067419 10201314 7504833 8887523 6717901 6255290 5333931 7373771 6977213 5859762 4808358 4742051 5859759 4412572 2768516 4084896 2702195 131845 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 131586 197379 394758 657930 921102 1184274 209427 208914 208914 205838 136969 136712 136712 136712 5128751 11436116 15292705 14716255 13079141 16483667 13472105 8682581 9665878 11499861 7888708 139532 136712 136712 136712 6377019 11024911 10966066 1910809 136712 136712 136712 136712 136712 136712 136712 3158321 328965 328965 328965 5074776 1536309 1401391 5666911 6582375 8552824 7960961 7304563 7437938 8358015 8952711 8032118 7836540 7836793 9545361 10662551 9938046 9084544 9282429 8363619 5393949 7889671 10387978 12163086 12886545 11834891 12557067 7037966 600083 2046743 862725 11580591 16777215 15921906 16777215 16250871 16777215 12369084 16185846 3034918 1260051 4669961 6574342 9861642 10913803 11571211 11768587 10256395 7043170 8436380 7188345 7447171 7114384 5732254 7177911 10534380 13432318 12841724 10607072 11393489 13560822 11651039 9154522 9224693 8694491 8888524 9874134 11058147 8096952 5265812 6321088 8360148 9543134 7505100 6583736 7503296 6716093 7701704 9478363 9085148 8294350 8754907 9677549 7373508 8688085 8884694 6451897 6650303 5728175 5399467 5990061 7109568 4018325 3492754 2109278 131588 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 131586 197379 328965 526344 657930 277527 208914 208914 208914 206607 138251 136712 136712 136712 3296029 8680263 12945244 15426604 15624497 15361840 14901290 14440226 13847577 13521444 11889482 5786165 4603437 4538667 11494210 10761999 10171919 5063988 136712 136712 136712 136712 136712 136712 2964017 921102 131586 131586 131586 3159089 4157775 6320476 7632758 8159109 8620688 7832445 7702141 6783595 6062168 7443561 7048296 7378792 8363127 9742985 10924952 9608327 9939094 9939862 10531487 7698793 6246154 9467147 11242763 12228879 11965963 12688650 8089100 337428 1980695 731140 11843506 16777215 16185078 16777215 15856113 16777215 12303291 16711678 3954996 1128462 3949583 6770949 8678921 10256649 10716938 11308299 8152065 5794915 8503737 6789245 5076853 6784159 6585259 7901639 10139125 11984127 11005430 12378342 13693173 11852513 9616847 8627910 9019857 8954316 9477322 11844835 11974624 10332119 8425423 6649794 7636683 9477338 7636425 6518463 7241670 7241926 7109824 7307970 7506124 6452930 9281505 9677806 10599150 9807587 12699897 11386606 10334185 8556496 5992628 4477851 5925550 10005222 7505346 4480419 2240607 131844 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 131586 197379 263172 328965 1861685 341013 208914 208914 208914 206607 137481 136712 136712 4218149 4085795 12875345 12875860 11433814 12089430 11957587 12873804 13394232 12993042 12599313 12205584 11812112 11561288 11692871 10499342 9909262 9527111 333833 136712 136712 136712 136712 136712 3553335 65793 65793 65793 65793 65793 3490359 8290430 8027014 8423812 7767416 7242096 6060889 5076549 6258776 7898490 7571825 8229495 9083004 9740166 9870484 10201503 10990256 11122093 11844794 12174275 6511920 6048772 8809993 10650890 11768587 11900171 10060044 730899 1980183 533505 12435643 16777215 16316664 16777215 15395562 16777215 12040119 16777215 5006917 1062155 3688724 8677382 8349704 9007368 9204232 7823877 6379571 7572398 8694735 10665432 9743569 10861022 12438258 11978998 10336505 11717630 11201005 10731736 11982589 10932459 7839945 7506875 6978734 7373747 7965624 9607879 11187165 11054051 12306681 12109812 8755155 9477851 5727664 6189243 6979526 5729201 7175110 6648255 10137319 9545703 8031442 9676777 11849465 12504559 13621242 14214911 13162747 12633080 10793963 5268391 2241404 5597354 9740509 8228300 3821975 2044522 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 65793 131586 131586 2918474 1596462 208914 208914 208914 208914 207889 139020 136712 2112023 1060113 205838 205838 205838 205838 205838 205838 205838 7560771 12215104 11877135 11483663 11089934 10057809 10766116 9515277 8610122 4802099 136712 136712 136712 2108961 6776932 65793 65793 65793 65793 131586 3753025 8093569 8486798 7896188 7832692 7439727 6914662 6586715 7502454 8685713 9208452 9273717 9537393 11642526 10789555 10265266 10988211 11581624 10660512 11582133 11714235 10396577 9143917 5062673 5916929 8217601 11045385 11308554 2176274 1717271 599041 12435900 16711422 15921906 16777215 14013909 16579836 11250603 16777215 5401163 865034 4739603 9926663 8546821 7297281 5916423 7695696 15461877 11646423 10140392 12637430 12700145 13094646 13689343 13557501 11255798 12113662 12778750 10141913 7771070 9220323 7375545 6387109 6386593 6977190 8820677 8491464 9083100 9542878 12505592 15266047 12896501 12502519 13225463 10924521 7899596 6058425 6912450 7175112 7176912 11388921 11385840 11647982 14345727 14872831 14411517 13884671 14345983 12832505 11975925 12438519 6846647 2834053 4610463 7635397 8162508 4084892 2043746 66051 65793 65793 65793 65793 65792 65792 66048 66048 66048 66048 65792 65792 65795 2918474 2918474 1728817 208914 208914 208914 208914 207889 138507 137225 205581 205838 205838 205838 205838 205838 205838 205838 205838 275219 6580548 11428674 10761485 10905159 10579790 9331530 9525825 7352336 7298378 4671802 5723719 5325876 4341565 65793 65793 65793 197378 2895141 6644831 8485250 8422547 7567230 7503995 8096124 8619665 8816277 8618901 8288900 8286308 9662792 11706237 10920356 9868185 9933986 10722473 9670289 9013885 10859163 10464135 8818051 12698569 10789530 8617570 7827014 5984270 7168009 2702097 1651479 599299 12172472 16448250 15329769 16777215 12961221 16119285 10395294 16645117 5401164 865034 4016660 5589509 5524246 8616533 10525835 15658739 15987956 13489387 12442109 13096443 12898297 11977462 11649266 12109299 10005990 12245244 13302015 11787994 9218992 10598364 9214408 6319518 7306670 7700671 9214680 9676260 9345245 9279961 9742561 14872573 14740223 13290748 15200767 15593215 13489917 9938404 10334185 8491989 8886239 7769569 8887258 9609180 12699886 14937599 16318463 15596799 15333631 15265791 12370675 11649014 12304888 7702214 3097224 3426447 7702731 8688851 5137065 1582151 131587 65793 65793 65793 65792 65792 66048 66048 66048 66048 65792 65792 65795 4819541 6654813 7441760 4482880 276501 208914 208914 208914 208914 206350 139533 205838 205838 205838 205838 205838 205838 205838 206094 929810 2315553 4680241 9401168 9463884 5856820 9068618 8006669 7023887 5975313 4926225 3679502 2890505 4735808 65793 65793 65793 1973271 6314820 7893092 8750737 7764100 7632517 8421781 8883356 8750486 8816532 8487568 7303546 6643031 8020020 9664842 10848351 10654329 8481878 8811618 6903101 7630145 7633719 7507235 8094826 12698049 13422030 13027271 12697792 3555634 860421 1650963 1782549 665092 12764098 16184821 14869218 16382713 12566463 15461355 10395550 15987187 6584927 1061384 2178840 1321738 4543041 13487055 14935012 15790321 15724785 9740991 11322608 12046332 11457791 11456767 9545687 10727137 8821975 7909109 8903416 10015940 9482926 11847655 12108778 8489141 7965121 8229847 7571144 7900106 9085918 10859757 9017045 11187430 15399167 14740479 13030398 13554429 14538751 13621502 13818367 11124724 9743337 10597878 8360664 7899082 7570119 10071009 13424633 15530751 15004671 16252415 15660287 12372729 9806561 10134754 9147860 4413600 2177405 6255800 7833543 6123957 1581375 65793 65793 65793 65792 65792 65792 65792 65792 65792 65793 65793 65793 7744525 8862485 9127708 10380862 7961427 808228 1332522 208402 274963 208658 208914 275476 209427 209427 208914 275732 275732 276501 276501 274450 1065241 543004 1855013 9855816 8740681 8871753 9132094 6629902 5450256 5058843 3285004 2823944 4801344 65793 65793 1052682 5658185 7633249 7961475 8553357 7500668 8355983 8686492 8685979 8752027 8619664 7961216 7763839 8353911 8879217 8219480 10850405 8484192 7098413 7688475 7493402 6907923 8752661 9148434 8619883 14013653 14474460 14013653 13684944 4937032 597508 1584914 1782549 729859 14013652 15329513 14277338 16250615 12434621 15527148 11053224 15329257 8557181 1061128 2178585 1191435 5332303 13355467 15263976 16185078 16448508 5006475 6525654 8835839 6003924 4944547 5800635 7511008 7910139 5819135 6147560 7514241 7708330 9875155 10268376 8818111 8886235 10729716 9675741 8885715 8954072 8361175 8424912 8227530 11450601 14015743 12369397 11780342 11779829 14673407 14280447 12503036 10796021 11914495 12243191 9478878 8426198 9084639 9084893 11451629 14676223 15328510 16185599 15005695 11912433 8755155 8491217 13161980 7440064 1717629 3623561 7899336 5530791 527383 65793 65793 65792 65792 65792 65792 65792 65792 65793 65793 65793 8668715 8468243 8733979 9258780 10905409 3899979 2523717 1400365 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277270 345883 346652 346652 4347958 8937289 8402973 8281674 8546124 5985349 3291950 4803648 5456953 3420721 65793 197378 5923135 5925721 8685948 7434878 8224133 8224389 8422029 8553363 8687003 8094095 7237492 7829373 9276560 9408406 8356752 8816018 9143682 7101007 8612179 6508084 8023854 9802286 9277735 5857556 4017206 9213834 13094085 14146520 13488589 4215856 728839 1518866 1650963 1124618 10396830 10002327 10594208 10331804 8489087 10199962 7568241 10791331 6978661 1455630 2047256 1323277 3955515 12632257 14475227 13489355 9478284 2769982 2053778 3573707 2970747 1655676 3311829 3580119 4688065 5358782 7125105 6656635 5933460 6850739 5993892 5003914 6977723 9281510 9280984 8359370 9345750 7175104 7504843 7965900 6780859 8294351 9607386 11517172 10137066 11517940 13359101 11781112 10792175 11058173 13427198 10795753 9413604 10728433 9544675 6454212 9347298 13226490 14605820 14739198 14347519 10729448 6387378 8623055 12043256 6518189 1584750 5071010 6188722 5136807 131586 65792 65795 65795 65541 65541 65795 65795 65793 65793 65793 8802104 8007952 8273688 8799259 8685407 2523717 2523717 2523717 741154 277527 277014 277014 277014 277014 277014 277014 277014 277014 277014 346396 413214 346652 346652 1328154 9198918 7349770 6497547 7036233 531467 136712 136712 597007 5067599 657929 4344620 3887172 6781273 8684165 8224398 7631999 8092545 8355979 8619405 8355978 8422547 8290189 9737634 9803168 7368565 8817561 9145499 8289415 9536903 8943729 7695202 7956270 8224052 8489525 4676146 1255949 1124874 1979929 2834982 3887158 2242840 1188878 1453329 1585170 1650964 1256205 1453328 1387790 862469 1454353 1388815 1520143 1651986 1915413 2047512 2046999 1783318 2376742 3360046 2636834 1914390 1257995 1784873 4301265 4229309 4614551 4617650 5746921 5224086 7125337 6332753 5210195 5078629 4880261 5929896 5993633 4609669 6715580 7637720 6913215 5663402 6057391 5990059 6977724 6980038 5137065 5596331 6517690 7242181 9017562 8623321 10136556 11125753 9411804 9214952 10270459 11188975 10204394 7902173 8030925 6059716 5007031 6913738 9087722 10792933 13949175 14609407 10337780 5468084 5401524 8560099 7175084 2768515 5596583 7175870 4214915 131586 65795 65795 65541 65541 65795 65795 65793 65793 65793 10121307 7482382 7879190 9596750 2523717 1728049 1197603 1532464 415009 482596 413214 2313000 277014 277014 277014 277014 278040 345114 415009 483109 482596 413470 345883 2642720 7759949 6890506 5972747 5526851 138251 136712 136712 136712 136712 4673863 4216131 4350027 8357229 8750482 8026762 7763846 8290445 7961736 8224390 8816272 8948891 9737380 7698566 9079441 8947857 9145499 8289158 9933210 8417904 8616055 8943729 7498318 7437634 7637569 3755049 2112792 2443036 2311450 1916438 1585682 3231026 1321488 1585427 1782804 1783317 1914902 1652753 2047511 11843759 9279109 1850900 2113816 2179353 2179865 2179609 2179096 1915415 4552272 992011 1718035 2377244 2970146 2311198 3838642 5876164 5608111 6005712 7782621 9557160 10874241 8302946 4220501 5014897 6525096 8690888 8820932 7174569 8164047 7704277 6256830 5927088 5925549 6253485 5595813 5400753 5926582 7635139 7372994 5137582 7241671 7044292 8363499 10536187 6913457 6517428 5929162 5730229 8361683 6913728 6386876 7241677 5533118 4810422 6919912 7644120 8034519 10529504 12374525 9614829 5140914 5141177 10401513 10201304 3229065 6517430 8161991 1646647 65541 65541 65546 65546 65544 65544 65795 65795 65792 10714728 6825227 7418642 8487519 2523717 2391105 733463 136712 137738 139789 208401 10118217 11034433 10445896 9987658 9922891 5139265 483108 483109 483109 413214 344088 276501 1522455 5004351 6299913 5447690 3164465 208658 206350 136712 136712 136712 136712 5860194 6388314 8881786 8158347 8553620 8027534 8422804 7764358 8159113 8750737 9014421 8618636 8882320 9868962 9277339 6841965 9275270 9275015 6904917 7891817 7959412 6911073 7047236 8626262 3951917 1585938 929289 1916438 2311451 1981210 2379817 1320720 1650963 1717524 1914646 2112535 1587471 2704931 13749708 11054754 2114072 2179608 2311194 2245658 2179609 2179097 1783573 5276017 1386515 2113048 1587217 1193225 1915670 4290668 5412227 4951158 5150069 6794905 8499360 9354149 6526102 3238277 3763586 4878219 7637688 9148869 8489661 8361174 7900877 5729974 6124980 6912185 6977976 6714550 6386618 6452154 7504324 7900108 6322110 8096976 8359892 7772131 9352693 6521287 6914244 7836889 4479891 5202073 6320820 5398954 6913735 7308241 6650824 7309529 7579112 5797818 8761068 8493269 11323647 9942770 4677530 5732028 12175614 8228807 2110329 6122669 8097227 987679 65541 65546 65546 65544 65544 65795 65795 65792 10978411 5906185 7419162 5015125 2523717 2523717 2258494 538392 136712 136712 136712 10313540 10039564 10039564 9908493 9711628 10176039 7955017 4809278 481057 277014 277014 276758 208658 209427 7424568 4857354 4215356 208914 208914 206607 136712 136712 136712 136712 8623727 8485998 8356237 8224913 8093582 8026757 7369855 8685205 8883614 8355980 9539482 9869478 7566724 6710373 7826267 9668471 5851194 6968380 5458992 5464383 6720845 7444809 8036694 6785613 3490856 7700842 4215864 1650963 2376492 1919265 1386768 1651219 1783573 1915414 2047512 2245146 1719059 2572831 2704928 2048535 2311450 2311450 2311450 2179865 2179097 1980950 6986679 3429727 926739 5464902 7306599 4152910 6264940 5344608 4423779 5016450 6855814 7114398 9282755 8428997 7518690 4822462 4349318 4873610 6057113 6846396 7307977 7439553 7109566 7899077 6976949 5727142 6780342 8754901 7044287 6649016 8228305 8096978 9083613 9676261 8098267 7835100 7640036 8561387 9218017 6978479 5858972 6649527 6715324 6451386 8623323 9149414 8557783 10271220 8033748 9414885 8892923 5863873 8032976 7834568 4216983 4480681 8623056 7044284 2373755 7306942 5134727 592145 14 14 12 525844 65541 65541 66048 10055761 8016449 7290406 4425041 2523716 2523716 2523460 547620 346396 206350 2501919 10241319 9580300 9514764 9383692 9121292 8924428 8727564 9059873 3297072 277014 277014 276245 208402 208402 6773320 4135689 5920071 208914 208914 208914 206350 136712 136712 136712 6320218 8816244 8092811 7237757 6448234 7433840 8025727 9342876 8488600 8618639 10790067 8159892 7303035 8484464 9076079 6245948 7953211 6641470 4213278 4351786 6067521 7052613 7972439 7116626 7565657 16777215 11643808 4087372 5867627 2706483 1387024 1717267 1914902 1981207 2113304 1784850 2442270 12172723 9740174 2048279 2180120 2311450 2311450 2179866 2179353 1849365 7513037 6727648 4159122 13023398 16580092 6125926 8239015 6855824 4487819 5078689 7180453 6192552 6979248 8558283 11267327 8508920 7640004 5531026 4872842 6846909 7044296 7635645 9410770 11516397 9016014 5990830 6056872 8425165 6912445 5530539 8819153 10201061 7503562 8753878 10332655 9477615 10007295 10799103 8888013 7569329 7371439 7766977 8163537 7700937 8293330 10859509 10400495 8097745 9809903 10532588 8822239 5337018 4940712 7374798 7307974 4216476 3887512 6847420 6649783 3031168 8623313 2435909 14 262418 12 12 65541 65541 66048 9200709 11046266 6304028 4883540 2523460 2523460 1733432 482596 482596 482596 6186566 9055499 8989964 8858892 8727820 8530956 8334348 8071948 8805958 277014 277014 277014 275732 208402 208402 6379592 3413768 2954760 3952699 208914 208914 208914 206607 136969 136712 136712 9079924 8158591 6711923 7235948 8552836 8552582 8487311 7500414 8617349 10264236 7830412 9011590 10327707 8222590 7035989 6182456 3689511 3562797 4356923 5212233 5542210 7975003 8562279 8748908 16774626 8686466 7049092 8101524 4283471 1387025 1717268 1915157 1981463 2113304 1784850 2244635 12829117 10331543 1917206 2180120 2311450 2311194 2245402 2244633 1915158 7052482 6727390 6204367 10066569 16777200 7832189 8300746 6589619 3365762 4153222 6059421 4876178 4349842 7573448 10676222 9428214 7707595 5993119 5925019 9610484 8558560 7767998 7371963 9214166 8753353 7110332 6386605 8490444 7898823 5792940 8817869 12108278 7964624 6187957 11186670 11583487 11126783 11258362 8096701 7175087 8095420 8424649 8030669 8489935 8753621 9939688 11452152 8492253 6385597 10006253 10202863 7110336 4809388 5795252 6979272 6125501 4742821 4217506 4611233 6386866 2769282 6649780 592415 920097 18 65555 65542 65542 66048 9200964 10519660 6373168 6651226 2523460 2523460 1272624 482596 482596 482596 8874060 8399371 8333835 8137484 8071948 7875340 7612940 7350540 5922372 277014 277014 277014 275219 208402 208402 5789512 3020040 2954504 5324082 1917224 208914 208914 208914 207120 137481 136712 7371113 8355707 7433588 6973806 7433329 7630971 6249312 7237237 10132378 10395043 8618896 9539480 10263468 9210260 8287868 5397830 4023363 3698236 5670496 5604443 5475152 7906670 8231546 9998463 13154213 12303280 7969685 9218474 5269600 1387024 1717267 1915158 1981463 2047768 2245146 1916437 1653008 1982742 2114327 2311450 2311450 2311450 2245402 2244889 1915158 6000821 5608907 5416923 13552312 16311501 9802382 7245500 5273767 2246250 2572906 3360369 3164279 3759255 6721493 9823999 8707060 5866933 5203861 6451107 9083371 8228831 6847669 5926062 5925039 5925032 5992371 6717381 7701181 9082323 8161480 9278421 11450865 9741542 7769564 9149412 10139381 10471423 10076671 6848182 5727638 6385320 8028865 7833291 7240641 8292556 9346782 9807845 10005227 10004196 9017561 7703257 7243467 6387908 4216480 6650561 6322108 5861557 5598642 3625888 5401519 4743329 2769541 4872582 3157059 722973 18 65542 65542 66048 9989451 9794134 9534314 6974805 2523460 2457924 614181 482596 482596 8022862 7546635 7677706 7546635 7481356 7219468 7088396 6825996 7354657 3166001 277014 277014 276758 208914 208402 208402 5854022 2954504 3019783 3150342 6974569 1786665 208914 208914 208914 207889 139276 4609350 8224112 6972494 5853774 6906460 6051925 6381662 8622477 11053466 10461089 9276043 10261657 8552588 9275023 9144462 8030601 6654843 5143383 8559507 8233106 8629643 9020555 9544342 9603711 9997180 13355458 7441801 10204344 5729639 1452817 1717268 1915157 1981463 2047768 1719057 2507805 13881806 10923680 1982486 2245656 2311450 2311450 2245402 2179353 2113304 4026776 4032703 5541552 15921370 10324862 9605006 6189207 6189212 5400212 5071255 4020895 3628717 3234992 4750814 7983613 8448249 4553904 5137811 7701938 8030916 10203127 6978231 8362193 8821712 7175868 5793967 8231662 7899848 8292803 8360654 7899338 8688851 10730226 11651839 9742836 9612795 9941754 10730489 8757468 6845866 6910635 6451635 9019099 9413343 8030669 8228818 9018846 9543905 9675230 10334697 9742311 7571662 5992117 5532593 5599418 7903452 7046598 6519744 4809377 3099284 4941490 4086173 3559054 4540003 2893889 525341 65544 65544 66048 9990480 9465426 8611919 8747369 2457924 1601846 482596 482596 7498319 6563083 6694155 6759434 6693898 6694155 6366732 6170124 5907724 7425850 277014 277014 277014 276245 208402 208402 208402 5787716 2954504 3085319 5194814 2832697 6058084 5401947 208914 208914 208914 208145 140045 7832177 5659728 5922639 6776912 5593678 6320494 9018255 10658453 10461085 11509143 10460582 7829890 9341067 9079174 9213596 8165521 8690836 10137004 10138798 9416607 9216919 8160638 13286827 13749437 11708569 10529187 10993602 5729127 1452817 1717524 1915157 1981463 2113304 1719314 2704673 10462361 8227960 2179865 2245656 2311450 2311450 2245402 2179353 2113048 3237514 4953293 12042174 9407882 13618627 13288893 6517398 7964083 9214923 8625882 5930432 4679338 3562150 6131944 8640255 7196667 3964604 5269910 7964597 7963573 10071030 7175362 8360650 10467813 9478361 6516912 6255810 8032990 7241658 8032204 8031698 6386610 8426192 11847157 9940720 8821486 9610737 10532334 11649784 10793960 10069723 8031175 7966411 11058162 10860270 9215195 9347809 8753366 9082842 7899596 9216743 10268907 8887766 7572687 6454464 6321855 6981066 8827903 6323390 3493773 2705299 7506898 3691156 1781861 788513 21 65544 65544 66048 9792587 9004361 7887168 9992036 6390370 1141038 2319669 6776398 5120267 5448203 5447690 5644297 5578505 5513226 5316875 4857867 4726795 6176815 277014 277014 277014 275732 208402 208402 208402 4469285 3020040 4534825 2632750 4281423 4610382 4217163 6452848 6913656 6257257 6323821 6454377 6124648 5269340 6255204 5860452 5269600 6848886 8952719 10069147 11249825 10918554 9605791 9276042 9932417 9341311 9543322 9873829 10005415 8823439 9151378 8888468 7639685 5272407 9406071 16711658 9604995 8490373 9087654 4545363 1387280 1717524 1849366 1981463 2113560 2245146 1259019 4217144 3757362 1720082 2311450 2311450 2311450 2245402 2179353 2113560 3170692 6794215 8359839 10589582 16777198 9603722 6253718 6254500 7307450 7572171 7113677 6850247 5073326 6854377 9624063 8179195 5344465 6651822 6649761 5462153 8359906 6320316 5727908 7109561 7766208 7701698 6320564 5531053 5597356 6518970 6715327 6124213 5926322 7570887 8558549 7637200 8886754 9741797 9412311 10135779 9413854 8953814 7372994 8556240 10594789 10925036 10005477 7569609 9280478 8688853 6188985 8295382 10465513 8426200 9478883 7899858 5795765 6652110 6128600 6783168 3033482 3956650 7838165 1982850 527659 65560 65544 65544 66048 10318415 9069638 8347977 8608061 10067335 4878158 5391413 3414282 3611146 3742217 3807497 3806984 3806727 3675911 3348232 3282953 3151881 4600871 1064991 277014 277014 208914 208402 208402 4412224 2889225 4140322 3158063 1977904 4413516 4808532 4479820 4546644 3035704 2050600 3233087 3627847 5140322 5863783 6980481 6389367 7506296 7505795 8560013 10661278 10918797 8353918 8420468 10067321 10592645 10592138 9410437 9345939 9084562 7574129 7114607 6588277 5144661 4160061 6185808 14404022 12304039 5014098 4552277 2836789 1518608 1717524 1849623 2046999 2179097 1587472 3231274 14013392 11054753 2311196 2114328 2311450 2311450 2245658 2113817 2113561 3434123 6533618 6061731 14601144 15193280 6975366 7112640 6720200 2967685 4151447 5863612 6522057 5139636 5405391 8438524 7715574 6789601 7967939 6059683 4016247 6912192 7637970 5137313 4280206 3819401 5991596 7570882 6714550 5333157 4676000 4478367 5992888 6255290 5005744 5663399 7242432 8097487 8755415 7306174 6713783 6255033 7571143 7702474 7174590 7766981 8885461 8820438 6846140 7636685 10662893 8097226 6979008 9214681 11056111 9543649 9479397 7704017 5663925 4678065 6520779 6655186 3039913 7250148 5933505 926035 22 65544 65544 66048 9660744 9398862 8347462 8542267 9267789 9468005 2824202 2824202 2823946 2823945 2889481 2954504 3085062 3085319 2954760 2823945 2824202 2824202 3691579 277014 276501 208914 208402 208402 5722693 4470317 3815479 461068 4020052 4282186 4347978 3824190 2642470 2904370 3627585 3890252 4547928 5403490 7441539 8097162 7769976 6913399 5798506 7771504 10855562 8946539 8553299 9475665 10133110 10460809 8750690 6911578 8294769 8164474 6128212 5472080 4946004 4751690 3631928 4089669 9141874 14077880 4353091 3239231 2839346 1848345 2572320 2441247 2376220 2245147 1916437 2375966 9608597 7833719 2114327 2311707 2508573 2574623 2837283 3034151 2508075 3896994 5876196 4283506 14863801 8419702 4083833 6392527 6657491 2970254 2703993 4086689 4548531 4415918 5207752 8962813 8174072 7184617 7443147 5928102 5401249 6385586 10400757 7768521 4807578 3228291 3623305 5859754 6715320 6318767 4083095 3031690 5137321 7175877 7108804 3491462 6254763 7899336 7635139 6385849 5136296 6057398 7570376 7373510 5793713 5397924 5662381 6916044 8098775 7833802 9873127 10333925 7308994 6714296 8820435 10400745 8887773 8624049 7834544 4809132 5400754 6321596 5207494 3168153 6787022 4356282 395283 65793 65793 65792 9528385 9200968 8347461 8476219 9464656 8346172 9531738 6311228 2693643 2693643 2693643 2758923 2823946 3020040 2889224 2693387 2628364 2693643 5659210 277014 276245 208402 208402 5792082 4998979 2105119 65793 2833476 4216140 4479566 3692349 3364910 4285251 5071957 5204064 6255217 6847356 7307651 8687508 8623241 6913651 5402209 4682576 9019761 9476972 8687447 9279047 9542491 10264178 9211234 7765603 6781534 7771245 7441774 6194515 5406289 6261346 5143378 4091465 5669227 4874831 9275255 5140312 4489046 4819025 5007436 10067351 9870229 9936790 9673617 9871252 6978420 2517389 2710382 7502961 8818563 9607824 10199705 10725793 11580847 5144478 4889818 3565200 3293265 9011577 3951986 5208256 3037080 3099522 4350114 4281481 5269153 6060224 5337027 4811963 7445994 7646711 5673186 6260430 5862831 7120105 7114185 9937892 9215464 5465004 4282009 4478352 5202596 6123440 7043254 6516917 3689620 4478879 6254516 7636173 5465518 6123429 8688077 6252974 5530539 5532595 6913731 8557779 7965133 6780866 4347035 5662896 6980550 8889824 9677022 8818899 8752588 7834824 6780601 7240637 9084372 7704215 209427 5337966 6321595 5926840 6058169 5664704 3892405 3494290 5930953 3101833 65793 65793 65792 10121809 8937794 8215362 8409910 9398092 8741187 8541492 8477247 9533541 8021846 5325620 2497806 2497805 2562829 2693387 2628364 2497806 2628364 4866098 277014 275220 208402 5924957 3158063 65793 65793 526861 4545124 5070167 4808275 4020546 5465950 6847353 6583927 7241088 9014164 8950425 8293519 9280916 6386792 4350799 4089669 6392415 9217126 9216096 8885082 9280365 10135422 9278820 8160862 8096633 7375470 6850152 6522474 6194787 5274194 5341522 5078612 5013340 5736551 6197354 5076565 4486480 5342811 6199141 6584421 11974070 12368828 13092551 13158344 13487053 10791081 3377083 3501457 10197659 11842741 12960965 13684688 13947860 14868962 5999273 4027039 3100531 2242906 3424866 4479888 5339332 3956127 4282511 6059706 6914236 6321580 6322362 6192078 5205947 6061769 9026558 7318516 7906788 6850500 7119851 7252459 7239594 8493038 5532863 4875174 6189225 7176380 7176380 7898816 9015752 6715577 5531055 6847942 7966928 8295121 8558026 10924773 8621515 7833029 8032974 7375562 8491987 8555982 8883923 8162254 8032211 8491726 9938657 10070495 8752845 8883663 7833028 6649016 8162249 7703194 208402 275220 277014 10134739 5794996 5992889 7111365 5798087 2641044 5335470 3890853 264205 65793 65792 10055758 9201221 8479301 8279095 9530190 8609858 8212269 7489065 9596495 8279607 8213819 9204059 8282961 9336675 8022107 8218455 8088412 7496020 6973540 3823940 209427 4017987 789772 65793 65793 65793 2239285 5333090 5529948 5662051 5727586 6648691 7636102 7175809 8555152 8884631 8622230 8032394 8294520 4545363 3826504 5144399 6721367 8035408 9347422 8753770 9149314 10134916 9016165 8030820 7046503 6719591 6192996 5536611 5274464 4946260 5079380 5671266 5999715 6655856 6327151 4947540 5275735 7444093 8168844 7766393 12237498 12961221 13816530 13750737 13684944 12105912 3635616 3497338 10461087 12237498 13882323 14803425 15000804 16250871 6847886 3297399 2177115 1781079 1911391 3361158 4744100 4612260 5269158 6980291 7508186 7047112 4676246 5402296 4350640 4547241 9350895 10800383 11458814 9549295 6921183 6923755 5728149 7641577 6126786 6452907 8097225 9214675 8622538 8754648 9344457 9411279 8030157 7637460 8427473 8492493 9676763 12109556 11912947 11847666 11122921 8952791 8426196 8227788 9607640 10725344 11518197 10925801 10594271 10134494 8489932 9674971 10463715 8095687 7637405 208402 208402 276245 277014 8229030 6846396 6714811 7506378 7243724 3166364 3429532 5269673 1517647 65793 65792 9858125 9990484 8150083 8081972 8872260 8149308 8475441 7686701 8674107 8674107 7752493 8609859 6833196 8279868 6440497 6437925 6375219 5190948 4736322 4081216 4279365 65793 65793 65793 65793 197381 3820120 4938321 5727589 6187882 5334110 6649205 6911608 6517625 7373191 7833742 7044992 8231817 5136972 4218708 5801061 6328145 6720836 8626005 8425309 8491879 8820340 8952426 8754794 6979671 6060630 5863527 5799270 5275231 5339488 6391922 7247750 6853497 6918256 7639685 7179905 6787960 7443076 8231565 7576708 8291456 12434877 13750737 14606046 14606046 14474460 13027014 3298411 3361638 10790052 12961221 14737632 15592941 15790320 16711422 7700366 3230320 2307160 2702187 6061761 5800130 3954837 4019349 5729706 6914748 6719702 6917332 3690894 4216731 4284587 4415660 7704278 11587327 11524351 9549553 5604035 5081552 5404341 7771863 7967690 9150164 9609687 10860006 10135519 9147334 9279434 9806811 9740250 8293580 8688083 9608917 10135775 10991595 11584754 12571384 11646954 10924263 10071269 8293838 9806557 9476058 10463969 11056869 10463195 10526939 7963332 8623320 10990308 9741507 208402 208402 208914 276501 277014 4943719 7636933 9739734 8558035 7242695 5926581 2180245 2574214 3427723 131846 65792 10319188 10319707 8544842 8409912 9463880 8214588 8673333 7621166 9134661 8081973 7555114 8411452 6702125 7753524 6703154 6701352 7493954 4862496 5196616 65793 65793 65793 65793 65793 65793 922651 3887698 5266778 5268063 4414798 5006682 6188654 6122867 5336195 6125969 6585233 6454915 7901818 4807755 5731439 6328160 6983256 7245650 8756845 7571312 7244889 7704934 6981720 6323035 5863765 5930590 5798245 5075803 4946009 5142879 6983296 7640974 6851964 6653814 7507589 7771789 7510155 6984318 6260847 5275487 7633271 12829635 14145495 15198183 15198183 15000804 13487565 5532803 5071485 11184810 13290186 15132390 16053492 16316664 16777215 8883867 4873093 4016758 4151189 7051496 6264796 4288688 5467555 6782128 6913971 6588112 8235507 4615083 4018313 4612260 4876214 6126028 9416954 10542335 9162486 5343686 4946103 4286892 5995708 8096965 9214669 9149647 10467306 10335469 10596070 10200795 8556481 9411283 9082070 8096466 8753872 9674708 10201310 10203362 10466277 10593758 10791395 10796015 9544160 10662376 9939428 8294604 9150164 7766973 7370936 7306427 6913733 9016019 6256762 208402 208402 208914 277014 277014 1262630 9084110 8754123 9412050 7110332 7898565 4679604 1455984 2243450 1120300 65792 10384465 10254937 8676681 8804412 9858639 8477763 8475956 7949873 9265474 7621421 7555372 9201738 6965553 8542523 6637876 6569509 6308653 5322018 5393479 65793 65793 65793 65793 65793 65793 2108728 4544339 5463644 4019784 4415052 5531232 5202792 4809075 4152955 6060180 6323354 6783888 6650985 5663332 6784891 7641960 7374446 8166000 8031852 6915435 6851935 7113576 6324055 4482883 5076562 5406296 4681042 5272930 5011550 3764294 5078624 5735785 5472097 5273697 6259313 6260850 5539689 4948069 4486503 3960682 8093568 13092807 14540253 15461355 15592941 15461355 14145495 8296633 6783388 11513775 13684944 15592941 16514043 16579836 16777215 10396333 6713245 5991082 5073072 7315685 6988251 3429512 5007523 6914238 6059698 5467049 7310803 6126010 4872847 5991845 6389196 5468611 7114985 10807294 9892607 7385830 6125223 4215939 4479380 6847165 7239082 6846380 7506120 8757474 10400239 9478364 7371958 9938395 10398175 9018338 7308235 7373247 8622800 9083340 8492494 9344975 9214406 9677768 10993371 10661593 10136797 8821204 9677279 7306679 4609688 5859757 7111621 9082833 208402 208402 208402 275732 277014 277014 277014 9086680 7967953 8162753 7570365 7571139 9413343 3696805 1782894 1581899 131587 9726282 10123097 8873548 8410168 9858639 8675655 8475700 7950129 9331266 7884336 7490094 9267534 6505261 8279095 6769461 6043939 6769461 5585960 5393737 65793 65793 65793 65793 65793 263431 4214619 4609614 4741717 4808020 5465179 4610399 3755611 3557990 5269895 6914459 6060695 6126975 5272927 6190708 7246454 7573354 6782825 7639147 7570804 7573880 7704950 8754823 7375468 5008209 5470565 5800296 5405027 5142368 4551509 4026955 4816219 4686163 4617551 4616021 5143158 4094317 3700838 4357762 5474188 5015457 6977665 13355979 14803425 15921906 15987699 15856113 13948116 9151423 6846354 11447982 14079702 15987699 16777215 16777215 16777215 9606307 8623315 8559587 6718917 8562917 7970521 3494281 3427720 4808855 4546203 4217494 5203108 7243976 6518962 7110832 7902170 6849485 7836650 10540031 11599103 10149879 6850742 5005451 5333911 7177937 5990825 4608651 4478358 6057909 7899852 8491729 9149402 12439291 11188196 8688853 7243987 7706330 7110068 7569080 8096198 8622276 140045 208145 208914 208914 208914 7506067 11977453 10069209 8622281 6123186 6847932 8820152 208402 208402 208402 276245 277014 277014 277014 8496597 6915007 8362706 8359625 6189741 9412569 7640012 2112886 2044009 4545359 9726796 10057047 8610120 8541753 9529417 8346689 8410164 8213044 10056790 7950132 8016696 9266244 7360825 7818029 7164217 5912866 6439981 5717289 5721413 65793 65793 65793 65793 65793 1119260 4281429 3558716 4478287 5530465 4609884 3492186 3229025 4480894 6124945 4942216 4747669 5473681 4418393 5402210 7377519 6585702 8098434 8293771 8952212 8427656 9215380 9150350 7900032 6781814 6257782 6063220 5076073 4092283 4750465 6129021 6392710 4554613 4224366 4289124 5342874 5343645 5278898 5279423 5278912 5410238 4810108 12763842 13619151 14935011 14869218 15658734 11251121 8688824 6515082 10132124 13027014 14540253 15132390 15263976 15658734 7503259 8625108 9942004 9547753 7047101 5533093 4678041 6719949 5138856 2836098 3428490 4348566 7375820 8099798 6650800 6389185 6980812 8757488 10076927 11266303 10479359 6659028 5009058 5861019 7703496 6518713 4610455 5398689 6187951 8031440 9808362 9280213 11387122 10072799 8952532 8953828 9943800 8426438 8754894 10004703 8885711 4938593 139276 207889 208914 208914 208914 2444087 10662360 11515878 7504059 6188977 8557235 208402 208402 208914 276758 277014 277014 3235149 7116502 5532069 9547760 9348570 6255535 6981833 8755655 4284320 5534851 482596 10716524 9991253 7952444 8673081 9660487 8478274 8607797 7884334 8871228 8016183 8740932 9134402 7624767 7950387 7295803 6175782 7097653 5585961 5786434 65793 65793 65793 65793 131587 1778474 3887945 3426876 4544341 4872542 4148319 3886696 3954039 5138569 4283521 3100535 4223637 5870743 4483412 6191472 7836036 8033417 8820631 8952475 8756371 7902849 8626826 7968632 8096909 6913661 5732464 4749184 3634061 4226209 4686489 5866889 5932943 4949674 4687282 4687286 6460609 7642567 7051459 6064824 5473458 5800618 5727346 13553357 15527148 16514043 16448250 16777215 13750738 6450328 5133427 11184810 14408410 16645629 16777215 16777215 16777215 7042708 6585269 7901908 8624851 7635890 5793177 5004952 5863876 5864130 5140403 5270690 5006232 6914239 8362722 7243459 6717118 6651591 7178456 8233717 9487613 10345471 8435691 5206438 6192557 7177400 5926819 6189737 8293321 8622034 7177162 8690139 9346003 8425157 7440325 8164044 7240646 8228572 9215958 11256563 11651831 10529756 9412019 136712 137481 207120 208914 208914 208914 2247224 10071513 6912686 5596327 7965858 208402 208402 275219 277014 277014 277014 5799037 6327509 5072549 7506378 9415660 7901387 8033747 8228282 8165548 482596 482596 7432792 10715233 9070670 8935480 9791301 8346688 8476212 8081969 8805177 7358507 7622194 9199936 7361596 7950130 8019268 5913637 6768174 5585447 5916731 65793 65793 65793 65793 131843 3359309 3952711 4543567 4346455 3950939 4543081 4676473 4939649 5005955 4019835 4085371 4880282 6001558 4943712 6389106 7770249 7836039 7440257 7376259 7048567 6589288 7444326 6192732 6388850 4942435 4945279 3241111 2848419 3636126 3241090 3436139 3699581 5145776 5541047 4490419 6262970 6853567 6260400 6325938 6326453 5929374 7371398 14739435 16777215 16777215 16777215 16711423 14540253 5134979 4673127 11316396 15001062 16777215 16777215 16777215 16777215 8227500 6913717 6650027 7571124 7372461 5924511 5398688 5861554 6717638 7377114 8034005 7966403 7635639 7704021 6849480 7177158 6915534 6652873 7443429 7971830 10474237 9552623 5797289 8433642 8760282 6784439 6716329 9017037 10069224 8032989 6387388 7372215 6780084 5136805 6453689 5860789 6715322 8557777 10466021 11324156 10003159 11057122 136712 136712 136969 206607 208914 208914 208914 5206126 6978734 6847416 8426155 208402 208402 275732 277014 277014 277014 9284038 6457544 6586051 7772112 8953814 8560096 9417713 8359354 5602679 482596 482596 136712 10256488 8544841 9132858 9134142 8544324 8738871 8015921 9133885 8083518 7687470 8805436 7558975 7423789 8478274 6111018 6372903 5322018 5785403 789516 65793 65793 65793 263430 4216416 4411979 5462880 4213083 3819101 4346738 5070204 5859203 5202821 5071493 4808578 5208216 6066579 4089428 4352337 5800291 6192487 5796709 5864805 5799270 5603171 5536604 5473110 5142615 4547939 4684182 3176353 4292778 4556168 4092748 3565655 3238775 5801912 5605296 4225700 5800876 4747931 4877717 6718893 7046575 5991561 7033411 9072994 9928048 10849921 12034969 16777214 15066598 6055562 5660279 12633028 14408410 10783614 10586235 10454392 10453876 7495518 7437478 8293041 8294586 7898810 6254249 5004184 6123181 7241657 7306687 8227011 10528477 11254265 8691946 7110327 7834829 8296154 7836373 7507412 7377634 9419519 9682685 8759518 9482989 10145020 9553402 7247303 6716073 7765699 8954350 6191551 5398941 5398949 4347803 4545178 5071777 6716089 8953047 10003420 10728693 9938400 10533618 6977668 136712 136712 136712 206350 208914 208914 208914 9018033 9939429 9479094 208402 208402 276245 277014 277014 3563596 10729705 8167128 8689874 9746159 7308218 6059189 8034521 9413845 2176046 206350 346396 136712 8747882 8347719 9133374 10384464 8741705 8344114 8015919 9002813 7622708 7425072 9002301 8151111 6767404 8347461 6374448 6767917 5782312 5653044 1776154 65793 65793 65793 1515048 4413791 4806224 4607320 3030099 3425633 3755633 4675448 4938875 4480385 4545920 3494006 5144477 4685179 3364417 3629641 5275224 5600096 5337698 5866593 5797995 5206369 4352844 5211732 5734236 5269613 4815254 5474223 7117495 6460307 6719615 7179165 6983087 7705272 6260138 5207453 6914467 5663632 5598611 6717090 4802646 7421473 6566680 6172179 6040848 5842701 5579011 7028261 13946314 7831455 6712707 9471872 4725763 5645834 5974543 5974543 6040336 6566679 7224353 6381431 7503534 8227517 6780589 5267870 6913208 7373498 6977462 7830714 10790880 12833791 10665204 9083343 8427223 9084897 9018847 8625118 8297186 9482749 12246015 12775167 8690901 9152484 10209534 8961784 5209786 4477055 6584244 7114447 6914493 5927599 5731514 5663912 5399193 6386096 8294604 9478102 9215448 11387638 12111357 11187677 136712 136712 136712 136712 206607 208914 208914 5468783 12175359 11715043 209427 208658 276758 277014 277014 481057 4814693 7507868 9742814 8032719 6320554 4611229 6782655 8558010 136712 136712 136712 138507 4738623 9071700 9264702 9726792 8675913 8278064 7949870 9002041 7820600 8608830 8937022 9137490 7031346 8544325 6242862 6767659 5717033 5059875 1973789 65793 65793 65793 2766661 4216402 3950914 2765892 2833241 3426152 4281716 3887473 3032943 2968435 2967664 3166584 5212070 4222310 4417121 4483167 5800296 5732203 5667686 5470307 5665893 4417105 4090186 5405798 7901576 7243393 6851487 7707320 9152446 9020594 9019310 8887477 8098482 8689332 7702955 7110563 8096426 7898277 7963561 5921386 6764574 6961439 6896159 6961696 6961951 7093537 7421475 5578753 8743514 7437725 6120571 5191206 5582102 6764575 7093280 7158817 7093281 7093024 7290144 7225126 4474988 7438258 6846123 6253731 7438777 7044790 6912949 8227527 10398181 11978750 10992882 9414363 8625883 8689881 8623574 8690395 8954085 9612276 11587070 12841215 10139365 8294859 9942513 12313855 7053531 3359603 3490418 7638227 10009329 7638974 5862070 7045565 7045305 7043766 7831483 8162243 7833535 9017304 9478881 9610462 9609656 136712 136712 136712 136712 206350 208658 3561807 9544167 10267623 5470580 1522455 276501 344088 413214 483109 483109 483108 4751469 8166072 6979480 6979744 7834555 8163242 208401 139789 137738 208658 139020 9534053 9001789 9989965 8346947 8541749 8081710 8738872 7819574 8740160 7950129 9006161 6834997 8017209 6638390 6964525 6638649 5519655 3947065 65793 65793 131587 3228240 3625284 2965046 2963532 3096672 3294825 3820910 3230315 2967406 2968176 3296113 4746642 5736099 3762292 4155510 4418399 5472352 5205601 5339238 4812381 4614737 4614483 5667177 8230036 10003369 8887968 8428450 8559795 9873346 10202308 8821174 7242400 7505829 8558003 8294324 7438502 7963042 9606070 8882344 5518631 6961441 7355425 7289889 7224353 7224353 7487010 7552801 6566425 6504235 5924747 5592945 4006677 5582360 6830366 7290401 7421218 7421218 7421218 7487010 7815715 5259075 7767735 7634867 7896753 8883394 8161982 8097477 8886224 9742309 10466811 9216990 8099790 8100049 8558293 8360400 8820952 9546223 9019883 9614327 11789055 10206954 8623563 10072295 11850237 10011380 5992871 5464467 7438523 9875181 8099020 5531037 7110843 7045051 5991598 5464221 6320555 5991343 6122158 6254255 7242173 10005733 7372947 136712 136712 136712 136712 138251 5664637 6255544 7242949 7902887 2642720 345883 413470 482596 483109 415009 345114 278040 277014 277014 277014 277014 2052406 413214 482596 415009 7632220 8552297 9666668 9396032 10450002 8609349 8673334 7949355 9265469 8215104 9069123 7752494 9136974 7296063 8214333 7888199 6503717 5914668 5585961 3552307 65793 65793 461067 3229269 3230523 2832703 3095894 3359843 3097445 3952750 3426925 3492979 4216185 4547466 5208220 4420757 2974854 3304078 3436640 4025660 4350294 5272935 5995634 6125933 7505283 8294546 9545129 9939629 9611428 9280418 8689582 9019067 9017522 7505058 6326192 6920129 7572141 6780313 5859466 7108253 9344438 6843785 5911323 7290144 7552801 7552801 7552801 7553058 7815458 7618338 6173467 5713688 4995385 4933205 3874833 5188119 6830367 7552801 7749922 7815458 7815458 7749922 7947042 6634018 8884915 9936072 10132167 10527440 9410507 9345486 8952788 9216738 9677550 9611233 8821721 9084632 10333929 10400236 10664691 11321853 10466803 9020913 10999807 10472174 8031678 8688847 10402293 9946363 7113921 7111863 7438257 9609953 7506124 5268637 7836878 7966919 5661857 4544409 5202328 4806549 4543898 5530276 7439037 9611482 8624594 7636122 728852 136712 136712 531467 7570325 6255538 6979778 8490932 1328154 346652 346652 413214 346396 277014 277014 277014 277014 277014 277014 277014 277014 277014 277527 741154 9989447 10977116 8939083 9659204 11436895 8017982 8607541 8081454 8935736 8279609 9265987 7819057 9728338 7559233 7424818 7098681 6503462 6439724 5190946 5064773 65793 65793 723983 3754327 3294522 2831683 2701654 3293794 4148844 4149874 3098474 3690355 5399171 5270930 4091794 3369872 2909063 3107736 3764829 4089157 5401702 6783098 7835020 7900815 9345954 9477282 9479336 8887963 9479831 9476762 8096923 7836333 7900585 6980517 7181760 6984636 5269644 4807550 5004159 6256805 6190234 3816527 6239260 7355681 7552801 7552801 7487008 7816231 8012838 7487008 5911067 5384984 4470071 3945533 3415055 4794646 6699038 7618594 8670511 8736561 8802354 8868146 8012838 7158559 8817061 9935816 9936329 9936844 8883907 8489155 8623569 9019357 9874399 10926056 10202341 10595557 11911413 12044796 11849981 11716602 11649013 10597365 10799615 10077167 6453683 7177413 8759796 9488381 7049676 6518434 6385309 8425424 7571680 5731268 8628210 8230343 7109034 6388666 5729441 5268647 6846900 9278151 10398428 11255527 10071775 8228556 8621758 6319485 4083793 7242133 11255771 8490403 7703233 9148076 4549979 346652 346652 345883 277270 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 10581326 11964010 9465682 10119241 11238483 8215359 8804148 8476210 8738612 8345916 9199678 7620909 8938050 7887682 7490611 7755839 5978402 6636587 4993310 4998980 65793 65793 1119776 3821397 2767921 3292494 3161949 2767965 3689065 2571875 3361134 3952498 5138056 4612221 3496574 3235201 4946329 4750236 5996670 6257270 7899792 8819349 8359312 7571850 9016987 9543076 8887195 8428433 8822415 9150098 6847872 6784669 7704750 7442094 7244976 6586791 4610685 5137289 6848939 4812443 3492461 3222841 6305053 7224353 7421217 7421217 7158045 8671541 8605231 7224094 5714202 5122583 4009002 3156276 3283983 4531733 6501917 7684645 11697503 12223334 11960675 11894881 8342061 7815201 5791617 6714278 6386087 6978225 6714029 7108534 7704531 8230613 9148612 10399453 10597095 10989801 11581682 11978232 11716599 10005988 10136033 10399214 10600446 9879798 5929396 5598891 7181537 9488638 7707601 5794199 5200779 7241144 8164076 6850783 7180513 7109031 9938647 9281747 6386602 7704793 9546209 12108518 11712483 11581671 11386091 9084373 7702725 7371195 9280210 9414878 12110335 9806281 7832473 8688036 9873860 1659437 543004 1065241 274450 276501 276501 275732 275732 208914 209427 209427 275476 208914 208658 274963 11040847 11832167 9532246 10382670 11434834 8478273 8541492 8410160 9067578 7885882 9002557 8148280 9200451 8742989 7293232 8413254 6438953 6636330 5454118 5459272 65793 65793 1515565 3033414 2373171 3226705 3096670 2373720 2702944 2834788 3820913 3887473 4353421 4349303 3891846 4611196 7574184 6653856 7441560 8426390 9214112 8950681 8950422 8623000 8359056 7965067 7374980 7376260 8363409 8428427 7110781 6784669 7770542 8427185 8228270 7175067 5991056 7311798 8494786 4414079 2965865 3288633 6305052 7027231 7158559 7158559 7158559 7421730 7618594 7158815 5648409 5451287 4342622 4278115 3546127 4400403 6304795 7224353 7882024 7947560 7882023 7816230 7552802 8078116 3817829 4543371 4674957 5070233 5464736 7373250 8428768 7112391 6648223 7505853 8296141 8623572 8623062 8754646 9282525 7770058 7506374 8559068 9811194 10011130 6653118 6189739 7510494 10407935 8234968 5399696 5399182 6649261 6782926 7308999 6782139 7568814 11714281 11517672 7834561 8296416 8887774 10663129 9214921 9016011 9608408 8755669 8887511 10531051 10793959 9808084 10992115 10201314 7766168 5663049 8425631 7571339 4550459 2315553 929810 206094 205838 205838 205838 205838 205838 205838 205838 139533 206350 208914 11106129 11765863 9532247 10316877 10711627 8609601 9067835 8476209 9132858 8280638 9199165 8805696 9067318 8347204 7095853 8148794 6241832 7227697 6506032 6116429 65793 65793 2305084 3033416 2833990 2832462 2570327 2307927 3294309 4412018 4083311 3625587 4157834 4414068 4151675 5728384 8689578 7244195 7901081 8819352 8622753 8688026 8950682 8950939 7767688 6388339 6191986 6456440 7902603 8623758 8227984 7308189 8753836 9608369 9082287 8687530 7833254 8428221 7899564 5200511 4413829 3749442 5845275 6567454 6699038 6699038 6699038 7158561 7093024 6699038 5649185 6316920 9607883 10267873 4803943 4071957 5910810 6896159 7289888 7093024 7027488 7093024 7027231 7487265 3882854 5594260 6055322 5859745 5531046 8097232 9151202 6453429 5003913 5138336 5598635 6323135 6126016 5729967 5862318 5599406 5796791 6783947 9416181 10668284 9281484 8360641 9482475 9945855 6392271 4610694 5597587 7044786 7177933 6386346 7898291 10793179 12702460 11781612 9018058 7241409 7111890 7638479 5727380 6252708 7043005 8096463 9347021 9016998 6583414 9149099 9083861 10069456 8293540 9280948 9346751 7111882 10203859 5405809 275219 205838 205838 205838 205838 205838 205838 205838 205838 205581 137225 138507 10447172 11634277 10057562 9856583 11239000 9464394 8409650 9528640 9002041 9465168 9331009 8871744 9792588 8939595 7491898 8673080 7097140 7095851 5848360 6442301 65793 65794 2963783 3229009 3689042 2635341 2372948 3425122 4739952 5398394 4280686 4613514 4285561 3820132 5398651 7109010 8624041 7835812 8425623 8621206 8360359 8557217 6915716 7111555 6520444 5074784 5535080 6127988 7310979 8492430 8490644 8095895 9541552 9014955 8491700 9477558 9345975 9149623 8094628 6318484 6322342 5203601 4871286 6120840 5262948 7104897 6980507 6521220 7372920 8686219 10333622 10201275 10333646 10070224 7898030 5264754 4868702 5066082 5329256 4736606 4736866 5592437 4802924 4868967 6779555 7041959 6778785 6714023 6253997 7899852 7570632 5136281 5004170 4479893 4874657 5994169 5599161 4480154 4546459 4481183 4809896 5731005 8363498 10535677 10400220 10006230 9876462 8628974 4549792 4347776 5926293 7177414 8691158 5925537 8095669 10595032 11255799 10399974 9344713 9081293 8622553 7768008 6385060 8293829 8884427 8489387 2702135 136712 136712 136712 5069658 8556709 8691425 7504568 9149336 8424907 9017551 8886995 10728150 6848641 205838 205838 205838 205838 205838 205838 205838 1060113 2112023 136712 11567707 12292721 9267274 9988168 10975572 9004102 8672820 10054726 8409392 9398603 8738616 8805951 9725507 9662288 7756354 8541750 7820603 7030057 6702381 5915444 2105376 263173 2964300 3029833 3820623 2832208 3030620 5199984 5068658 3951981 3557737 5535381 4281964 4673383 7568528 8096163 8360869 7901600 8490387 8753825 8229032 7441066 5275506 5405288 4811617 3694663 4681306 5997936 6458729 7375222 7176066 8161948 8884139 7766952 7571889 8885681 8884652 8160930 7107999 6386338 6783149 6388647 5729696 6123687 7372202 9741004 10468834 10931674 10864335 11648970 11780300 10532545 9810120 9872319 9277617 9016504 8689598 7701167 6779557 5990554 5859992 6254753 6319782 6254242 7307190 6911148 6187679 5924511 5662892 6586057 4742809 3753327 4477835 4479125 4677540 5665461 4612257 4215955 4743588 4677791 4678053 5270970 7705313 10074109 10466269 10401503 10534389 8758497 6980785 7901110 8161969 6715838 7636931 6715566 7766968 8819140 9083088 9345745 9738446 10461916 10529252 9477329 10266847 11518186 12109280 136712 136712 136712 136712 136712 333833 9478594 9150682 8756190 9412032 10727119 9871823 9940191 10070756 8097989 9150149 10266564 9477300 7439265 9017515 8820658 6582673 4085795 4218149 136712 10975574 11174756 9268303 10053448 11567711 9004619 8607286 9001526 8277808 9003329 8212273 8344884 8343857 9464396 8151368 7555883 8281152 6636072 7360306 6111017 4407358 592397 2962758 3030092 3755088 3687001 4410726 5527922 4608366 3031652 3690096 6389139 5595767 6318977 7373464 7441061 7243936 6980496 6650496 6652574 4879510 4486297 4093567 4484953 3824457 3957839 5405035 6589049 7314041 6652274 6780545 7636379 7833510 7110822 6386843 6582676 6647696 6515601 5992097 5926559 6913959 7177387 7241902 8161718 9675204 11451093 12110047 12111839 11453650 11055814 11778511 11715025 11191253 10925003 10855875 10990283 10597587 8754370 8160949 8753081 9083070 8951488 8293048 7570353 7044019 5727904 5464733 5794988 6388674 7312610 4349592 3687533 5069457 4939420 4611487 5269930 4875176 4743075 5532583 6058923 5730220 5863102 8888808 10796536 11254753 11453164 11455228 10467304 11122901 11584993 11121620 9739476 9871570 10728665 10530773 9609935 8227779 9674693 6329473 10004431 9281236 9148108 8950221 9807062 5201763 136712 136712 136712 136712 136712 136712 5398884 11321319 11258620 9743053 4215113 4215634 5070944 10728145 8691156 6585000 7110836 7241657 5991336 5860008 6056871 7372170 6649956 3296029 136712 11172694 11306597 8676679 9659204 10843731 9268559 8607287 9002555 8541492 9004872 8475957 9002556 8146736 10320218 8282953 7161902 8938309 6900018 7096365 6242603 5919308 592397 3225413 3556181 4147796 4739427 4673383 4608876 4740464 4149103 5398654 6651793 5859452 5794440 5533839 6260390 5930138 4811113 4154219 3566220 2056580 2385804 3568014 4681837 5138264 5995380 6325117 6850175 7639692 7638931 7570836 7307417 6912925 6057617 5135229 4806009 5266569 5924499 5466525 6189984 8293554 8754104 8622782 10530253 12042194 12437205 12241627 12110298 10532292 9215159 10530510 11715034 11848670 11385553 10790593 10791622 10531284 8952776 9477315 10924496 10858446 10069706 9345985 8292534 6451366 4938902 5071001 5663146 6979782 8694004 6586556 5530252 6911913 6255274 5006499 5796017 6519738 5730222 5993647 6585524 6716344 7835856 10927601 12637430 12635371 12833784 12635898 11582692 12501470 13027557 13158631 14277114 13950197 13426931 13162993 11781095 8495527 1927738 1536309 7971745 8164039 7240116 5858469 6714022 136712 136712 136712 136712 136712 136712 136712 1978664 11056086 10665968 5597297 136712 136712 136712 139532 6124922 7374740 6324868 5207667 7308445 5267864 7438472 7898525 4873117 6781824 3096639 10515021 10976347 9202256 9396288 10778195 9005390 8146222 9067577 8212273 9136459 8475959 8870969 8015664 9332036 9138003 6768687 8279608 6374189 7227695 5913897 6376251 1184792 3817288 4409431 3883858 4345441 3621212 4082536 4149099 5003124 5332857 5733009 4545140 3887736 3762060 5144739 4486280 2971185 2643280 2515844 2647176 3370643 4552342 6126212 7307909 7638415 6126969 5403247 6128014 7444659 6784419 5136770 5135485 5463679 5266559 4609659 5136015 6188958 6715815 8556725 10134982 11054537 11450063 11977686 11845845 10533078 8957646 9086403 7837877 6918579 8101828 9415887 10336213 10335695 9740988 9213622 9017281 8490688 10134470 11055311 9937347 8885692 8358582 8029362 6977449 6057377 5728155 6056358 8490702 10335480 8229835 7109287 7700654 7307442 5993135 6717886 7441090 7176891 6783164 6322612 7111100 10005988 11717107 12242665 12899310 13094897 11778017 10986960 11315662 12105688 13158122 14606330 13687024 12571882 12635882 8037012 482852 614438 2326081 5608823 8294339 6582187 4280986 7570604 136712 136712 136712 136712 136712 136712 136712 3492169 6649000 8490948 3162689 136712 136712 136712 137481 206350 275732 346909 346909 543516 6519413 5925523 3754113 4412822 8033456 6780569 9792070 10452317 9268048 9330751 10843986 9925977 8080945 9790528 7883052 9004621 7621166 8673333 7818798 8542008 8413510 6966839 9134660 6637362 7030059 5980203 5848620 3158581 3882826 3686480 2831175 3226966 2832469 2701913 3491431 4345968 4543600 5536659 4479346 3624305 3830423 3961496 3699070 2709040 2641978 3631237 5535640 6587042 6784419 7440284 7441041 6521984 5076090 3632264 3305874 5604005 6125461 4741753 5068920 5923457 5990796 5795736 6124449 7111091 8492218 9936827 10334157 10070988 10133692 9020617 8497871 6724277 5344425 5802162 6327222 7248832 6985652 7640756 8298180 8890562 9151407 8163496 7372459 7504050 9410239 10330566 8949946 7964593 7963825 8753594 9279423 8818619 7700400 7436722 9543121 11058680 8822485 6188960 6976675 6649257 5730481 6256822 6584753 6584243 7376592 7638985 7835596 9217765 9611741 10006737 11978982 11975389 10526919 10856396 10921933 10988241 11714022 12503532 11120598 10200783 7707285 482852 482852 1141038 2457667 2457923 8360634 6122407 4149657 6715027 136712 136712 136712 136712 136712 136712 136712 8692167 4743832 6320292 4543835 136712 136712 136712 136712 139276 206350 277783 346908 345627 3038790 5005463 4017801 5398942 7900877 8622756 10318158 10056275 8741704 9002043 10449226 8346434 8212531 9659714 7817772 8608576 7884337 8542005 7556142 9001789 8677194 6901561 8542781 7229755 6635302 6834481 5124640 5394771 3554120 2436417 2502729 3029332 2964311 2241361 4017519 3821166 5002348 6060177 5333623 5269123 5339029 4486039 4355726 4614498 4284244 6127000 7506595 7506852 7047078 6521497 5535868 4419442 3568017 3042963 2976657 5404571 5465989 4675703 5332605 5924229 6320280 6848680 6980790 6651570 6124447 6718384 7511496 6195637 5730199 6067134 6331316 5208957 5275273 5933494 7443386 9284032 9546672 9217710 8231869 8103370 8366020 7639216 6451611 7963577 9146819 9869505 9607360 8820156 8753337 9804226 10001604 9737920 9738178 10002377 10596312 10663915 9480419 7440061 6712986 5793435 5137315 5663405 5532333 5072043 8363236 9151195 7570366 7504058 7306157 8228791 11386075 11646165 9804479 10859475 10727122 9082314 9610201 9741519 9541826 9348015 482852 482852 482852 1601845 2457923 2457924 7051152 6977715 6517681 5398638 136712 136712 136712 136712 136712 136712 1325860 8758474 5007263 5794976 7636646 136712 136712 136712 136712 137994 206350 207889 344857 344601 278296 7833782 6583211 6977969 8098987 2711345 10055245 10320478 8346690 8739130 10516306 8544068 8213558 10187085 7094821 9267274 8146737 8607542 7555628 9265732 8874318 7164733 7884079 7098425 6307109 6966068 5585446 5526614 3225926 2041920 3751767 3687259 3227739 3292763 4346996 4610164 6252408 6781584 5926013 7175054 6715537 5798555 6193310 7374228 7241091 7637408 6587038 5996190 5799839 5077910 4092046 3238794 3173781 4093084 5799584 6519450 4873850 4807035 5005705 5203342 5665953 5995944 5273516 3760788 3367061 4092330 4553645 4288157 5079224 6657457 8099497 7900578 7375786 7508667 8821437 9938368 10532801 9547963 8691647 9021641 8956876 8888250 8358572 10265552 10659794 10790347 10397642 9544131 8556216 8948662 9342650 10000578 10988237 11056338 10465492 10071005 9743076 7768512 6843801 5792666 6057641 7701949 8688589 7439039 9151457 9940446 8951493 7764649 7566754 8292784 10728148 10792403 9673671 10006484 9413066 8556480 8951237 8622269 8817593 4029273 482852 482852 482852 1997116 2457924 2457924 7052684 9082056 9806035 4214865 136712 136712 136712 136712 136712 136712 601109 8626097 7111354 6781358 8425407 728853 136712 136712 136712 136712 140045 206350 206094 138763 138763 9148869 8490947 8425132 275732 345627 10186572 10057048 8083515 9068091 9857603 8610117 8278838 10122321 7291686 8807494 8015665 9067577 7884849 8871491 8940111 7296319 7358766 7952959 5847587 7031602 5585705 5920083 2567486 2896452 4409435 3621465 3620955 4542568 4740468 5725810 6318713 7043470 6189188 7438224 7305616 7046046 7308444 8161689 7833229 6322059 4944015 4878997 5667996 6588067 4682904 5077149 6390437 7048363 8033196 6913435 5400457 5664915 4876949 4484763 3758986 3300233 2382735 2249864 4288675 6194869 7507380 7311804 7379386 7833765 9936822 10465477 9282239 9018819 8555951 9674945 10140106 8299701 9216961 10134720 9940425 9479098 9673653 10791375 10857426 9672899 8687288 7372715 6386337 6910884 7173286 8093871 9673922 9677002 8492993 8360394 8624597 7440315 6976669 7503539 8819394 11383769 13093610 11845080 10728920 11782883 11648726 10856643 10528958 10989256 12305632 11648227 11189737 11059950 9348813 9740488 9279429 8556997 9280958 482852 482852 482852 811817 2457924 2457924 2457924 7645332 11186654 11122656 9609133 7240324 6845309 6056560 136712 136712 136712 136712 4018512 7901384 6846379 8096944 207632 136712 136712 136712 136712 139276 206350 139789 136712 6517117 7372465 7569589 5267304 136712 206094 10647124 9859669 8412224 9133370 10515790 9071181 8410680 9200450 7687215 8938311 7359537 8870455 7818798 7225896 8805696 7691333 7096622 8281409 6044967 7096622 5914412 6049091 1909812 3488332 3620435 2831952 3358295 5067627 5595255 6383993 6252924 7108748 6518920 7832719 7436172 7111581 6323094 6586001 6388858 5664365 5729921 6520472 7571875 8820651 7573162 7966891 8950960 8886962 8098988 6518936 6650522 6717342 4877460 5598845 6650510 5602213 4486565 4812441 8557748 11120840 10925259 9940940 8820917 8751783 9936826 10334664 9019581 8293036 7898018 8690366 8761810 7576763 8689330 9544900 8561583 7113358 7373460 7962791 8489920 6515879 5069459 4280451 4937867 5793689 4937610 4344963 5990300 7374775 7112119 7374275 7901900 8033473 8162738 9412550 10857939 12105693 13356005 13422048 11388113 3372366 548645 1205550 548645 1928248 3307597 6526080 11191263 10271216 9349592 8952773 7767223 8164296 8496570 482852 482852 482852 1141039 2457924 2457924 2457924 8038297 10200275 10464473 12044008 11517154 9674702 6056564 136712 136712 136712 136712 136712 8624069 6057640 6783635 278296 138251 136712 136712 136712 137994 206350 140045 2570548 6386331 5727644 5134484 2833723 136712 136712 9791818 10188633 8083260 9462077 10515794 8281666 8080943 9660483 7490091 9134918 7096109 8673591 8279862 7095595 8542780 8217420 6308395 8609859 5913640 6964781 5849391 6379859 2041140 2962504 2173764 1911365 3094868 5856623 6385276 6384249 6646652 6978446 6782092 8161679 7699584 5926527 5271949 5469839 6126965 6453104 7436678 8753825 9412009 9872301 8361899 8098988 9345456 9148849 7770539 7044765 8424100 8754860 8821426 136712 136712 9938095 9020350 9149877 11383744 11843530 11254480 10270412 9151420 8360108 8557489 9018810 9018038 8753836 8030378 8164552 8041426 6592936 6457225 7707796 5733487 3693390 3426894 3949419 6846644 5925805 4149129 3950715 5003145 5858968 4279425 3029104 4673930 7307957 7966657 9215959 9809372 10005968 9873095 10201804 11187414 10858198 10990031 11778773 11780572 938277 414752 547876 548645 548645 548645 548645 548645 6132363 8035274 6455479 6189739 8493003 8761792 482852 482852 482852 1799481 2457924 2457924 2457924 7836572 8029377 9280210 10927846 9742801 7044241 136712 136712 136712 136712 136712 136712 7308198 5663909 2777671 346909 208914 136712 136712 136712 136969 140045 207889 5072489 4939404 3623043 3293564 3096640 136712 136712 9199682 10187858 7688501 9067576 9924174 8545096 8015920 9462074 7884593 9201478 6963753 8213041 8147761 6963754 9069124 8217164 6703409 7819569 6044969 6701609 5388583 5784116 3290949 1844795 1385017 1385278 2962768 4739177 4150386 3687256 4805228 6584462 6518666 7111822 7702659 5333865 5599112 5666708 6981504 7767170 9080983 9673891 9872810 9805228 8228777 7770538 9149615 8886447 8295087 8886444 10266035 10004151 8425107 136712 136712 136712 9478055 9741238 11252161 11055816 10203851 9613252 9218240 8885422 8358825 8161704 8951217 9148082 7899307 7115191 5340566 4815495 6986652 7644295 6258540 5204835 3953238 4278640 7306937 7834824 5992611 5858708 6251925 7765420 7172770 6251671 7305128 9280456 9542860 10462424 11253214 11384787 10462664 9608390 10005462 9808338 10071238 10925525 9937870 5537649 346652 413214 481058 548645 548645 548645 548645 548645 3768158 8956106 7375549 9677790 9813196 482852 482852 680487 2260288 2457924 2457924 3376465 6649499 6846647 8560357 7443665 6716068 2307376 136712 136712 136712 136712 136712 136712 6517898 6651299 346909 346396 345626 208145 136712 136712 136712 139532 206607 277014 277783 4088925 5861249 1717545 136712 136712 9792075 9990995 7951673 9002042 9596238 8083518 8279351 9725761 7885108 9068866 7622452 8870970 8542519 7161645 9792847 8216905 6571825 7622194 7032120 6570540 6374960 4993310 3554120 1581623 1187382 1385019 1845315 2045274 2046557 1055791 1384766 5007757 5074572 4222856 6651770 4939862 5400693 5534608 7636880 8818322 9409946 9344414 9279653 8753320 8688042 8557996 8755629 8557486 8886193 9939383 10793142 11253436 4872274 136712 136712 136712 136712 9543342 10070983 9874362 8888231 8624805 9084596 9146798 8554150 7502489 7371935 8292265 9083323 7903923 5795718 6060958 8826050 9220519 9087143 9086380 8426404 7503264 9672636 11319512 10728396 10200772 9936833 10726345 10593734 9081534 9675210 10333133 9871310 10463198 10726874 9411005 8490943 8429017 8097724 7372453 7701938 8561626 7904211 8232112 346652 346652 346652 413983 481571 548645 548645 548645 548645 3899225 10269140 9611981 7839908 482852 482852 1272624 2457924 2457924 2523460 7509922 6584491 5662107 6193351 4483246 6716323 136712 136712 136712 136712 136712 136712 136712 5267561 7179424 346140 345370 345370 345370 208914 136712 136712 138251 206094 208658 277783 277783 277783 277270 206094 137738 9924174 9990999 7951414 9395771 9793875 7819576 8279091 9396541 7621679 8673594 7687473 8870456 8806722 7162930 8870458 8546127 6638389 7884594 7032633 6965039 6374961 4861467 4869206 1515318 1253430 1384761 1385021 2308959 2112086 858153 924212 3297660 3038853 1659246 4682611 5864539 4282455 4679296 6323085 7307391 7306621 7504269 7176347 6059929 7900581 8820396 8097962 8689327 9937588 10004150 10529206 11515319 136712 136712 136712 136712 136712 3820872 9809594 8889254 8427930 7703441 7965597 8226982 7963811 8160162 8228015 9412033 10201285 9609917 8490412 8687798 10203338 9022124 8823212 9678015 10070462 9608376 10462150 12237272 12698837 11384527 9740739 9938887 9017284 7899067 7965372 8294073 7965634 8492750 8032189 6320022 6585006 8362705 6123679 5399444 5796276 7576032 6589645 6719422 3829080 346652 346652 346652 346909 414752 548645 548645 548645 548645 3897946 412445 481827 482852 482852 1600820 2457924 2523460 3244371 8100292 6850237 5729692 5071772 5796784 7834539 136712 137738 138763 535315 534803 534803 932381 8099484 8559023 7178895 6982799 8164771 7639200 8821442 8952766 4346968 137225 205838 205838 209427 277783 277783 277783 277783 208401 9266502 9991255 8806466 9527099 8937794 7556657 8213041 9528386 7096109 8475442 7819058 9134398 8215355 6965295 8147507 8940369 7230524 7358766 6571567 6504489 6243116 5058845 5066583 1515316 1647417 1582140 1450299 2308442 2768470 1121328 1385537 2045015 1720680 2118267 3503243 6195817 4414017 3363166 2974584 3628863 3035189 3103061 3170944 2121602 4814741 6849954 6390692 7573163 9674930 9805491 9410994 10397615 136712 136712 136712 136712 136712 136712 9413537 8363664 8691098 8492183 8162965 7769764 8229546 9544379 9808323 10070724 9937853 9149621 8884910 10134467 10794707 8168372 7837099 9216443 9675452 8885169 9409983 10527697 10658758 8817846 5925532 5006235 6190520 6980294 6453691 5335466 5336494 5469095 5400981 5070470 5467814 4808595 4412807 5466785 6520772 7441356 7244230 7177147 8033448 346652 346652 346652 346652 346652 347421 481571 548645 548645 3897691 2900539 138763 344858 2055205 3240759 2194495 1666101 608286 3701340 8893906 6329034 6452126 8623811 8363948 414239 481570 482596 2128446 2589509 2589509 2589510 9808324 7965882 8228803 8229061 7702205 6453683 6124465 6652344 5335713 5531526 205838 205838 205838 276758 277783 277783 277783 277783 9463367 9398603 7687729 9198647 9332297 7753779 8081711 9527869 7951418 9002559 7688246 9265984 9333836 7558201 7884078 8215873 7296061 7030057 7031602 6767403 6177582 4861983 5789275 1778742 2436418 1844541 1647935 2373206 2898258 1450298 1583175 2109519 1781585 3233150 3633550 4683901 4087868 2244153 1595507 1398089 1526036 1065514 1135721 1662336 2778761 4091281 4946075 4945820 6127009 7440550 7375272 7703193 136712 136712 136712 136712 136712 136712 7242361 6916726 7967628 8952990 8689055 7836076 8230576 9019053 8361117 6782590 6585467 6847873 8425378 9412548 10202832 7969466 7770288 8820145 8688046 6910615 7568299 7372225 5265805 5266318 3951491 3491460 5203369 7901398 7901654 5206713 4876197 4413831 5399435 7570095 8295881 6322345 5532321 7111094 9609936 10200017 10593489 10857682 10332369 7443857 346652 346652 346652 346652 346652 346652 414240 481571 7377303 7701921 136712 136712 3098909 2189097 614695 548645 343832 607517 3177812 6528656 6527886 5412470 2852682 2326082 1931067 1470260 2457924 2589509 2589510 5083759 7701939 7571378 7111096 6782389 5992621 4875426 4809633 4415133 2507649 3559559 205838 205838 205838 207889 277271 277783 277783 277783 9331781 9925203 7819572 8936245 8345655 7490349 8146991 9659710 7951417 8936763 7557689 9265729 8674623 8347202 8278322 8150594 7559234 7162157 6769202 6109475 7098682 4993569 5986136 2304314 2765381 1713468 2305094 2898520 2371658 2107973 2043469 3227485 3490141 3820661 3893626 2843244 3630397 1654300 1131554 1726029 2053171 1460262 1923177 2712970 2778247 3303307 4551573 3960726 2845072 3435667 3502488 5404289 136712 136712 136712 136712 136712 136712 4216132 4810327 5007964 6454653 6782092 7374746 4613469 208914 208914 208914 208658 139020 7241117 7769269 8885440 8096444 8295362 7966648 6584219 5003393 6713763 6715842 4083076 3950970 5069969 5727384 6056611 8492237 8821460 6583461 4939154 5135496 6713753 9739717 10990034 10267855 9017795 10530255 11583450 11976411 12434396 12763358 11976928 11516889 10139065 3172681 346652 346652 346652 346652 346652 2843702 9018525 7570325 136712 136712 3362336 277527 480801 481827 871458 2058296 2852682 2852682 2852682 2852682 2852682 2852938 2852938 2786632 2786632 2589510 2589510 9348032 6452389 5597341 5796007 6059954 5203619 4151446 4414621 3822998 2572927 5535367 274707 205838 205838 205838 275732 277783 277783 277783 9792331 9728337 7425072 8935734 8805689 7753522 8014892 9659197 7688503 9331265 7885884 8739645 8543294 7557944 8081199 8808011 7230269 6701608 7427390 6176040 5979172 5256740 5985361 1975093 2568260 1844796 2304834 3425379 2371910 2699852 2832214 3292509 3358556 3030115 4157053 2911865 3305806 2378267 1523736 1919551 2578531 2250077 2645362 3500171 3237513 3368842 4354454 3501714 2188684 1794695 1795727 5276298 136712 136712 136712 136712 136712 136712 2308134 3561530 2773299 3890774 6125181 2969665 208914 208914 208914 207889 138507 3754313 5990806 6319256 6976414 7635379 8100302 7114429 5010852 5140377 6452639 7570622 7437487 6122395 7175337 7963825 7964340 8624585 9084877 7963818 7042978 7240610 8029610 9804482 11382736 11778005 11318226 11713750 11782108 11846876 12237528 12302040 11910619 12109023 12042980 11714781 9283754 5537899 2646591 346652 6588290 9873347 8097469 8690068 4151598 1584658 5205549 278296 346652 277527 1660205 2852682 2852682 2852682 2852682 2852682 2852938 2852938 2918474 2918474 2918474 2852681 6987660 8820163 5005976 4217233 5401766 5993903 6519467 6388896 6454434 6191521 6126739 482596 275476 205838 205838 205838 206350 275732 277783 277783 9332294 9728598 7359278 8869684 8607798 8081973 8015149 9594175 8478017 8739130 7754811 8344113 8213299 7557946 7423785 8214844 6901047 6176038 7754811 5979433 6373415 5191203 6050896 1580849 2436159 2042173 2371142 3030620 2305603 2502215 2897491 2700887 2108751 1845321 3170437 3111557 2318155 3759928 2639920 2969916 2773309 2708557 2842491 3106438 2909318 2778504 3369614 2911118 2122345 1596508 2319226 4290153 2242602 136712 136712 136712 136712 136712 1321242 4811342 3496769 5665136 3429959 208914 208914 208914 206607 137481 136712 6714242 5595282 5595022 5463953 6190253 7182037 6853312 5539513 6458297 7637420 9081527 9607882 8162751 8227258 7765939 6846121 7967689 8691919 9281466 9874121 9742017 9543870 9345218 10199496 10856908 10594762 11254228 11453402 11451607 11711187 11711186 11779545 11977954 11320293 10070222 9280954 9281726 8623288 7768243 7045809 7505846 6717105 6650808 9215940 6191424 4220457 4155435 3893547 3628838 3698486 2127165 2193726 2325568 2457411 2325569 2589253 2457411 2786632 2589254 2654790 2786632 3902809 9743291 5203354 5862051 7440309 8098227 1925433 482340 483108 482852 482596 482596 413214 205838 205838 205838 205838 207632 277271 277783 9331782 9859668 7621938 9132598 8739128 8410422 8146734 9659969 8149566 8870201 7754810 8870459 9003330 8544579 7621423 8938052 7690305 6307623 8149568 5716518 6438693 5322533 5851454 1449004 2173499 2041916 2305348 2372434 2042433 1581886 2240076 2240335 1385797 1450561 2575224 3304577 2840677 5798505 4414291 3495494 2641459 2708559 3368062 3106440 2515844 2318979 2712967 2648203 3172960 3696456 4615264 4221515 6060127 136712 136712 136712 136712 136712 2044452 6652273 4350801 5599844 208914 208914 208914 205838 136969 136712 136712 6780569 5070221 5266834 4807570 5600181 6656977 6523057 5076643 5535396 7374768 7239325 6779039 6320295 6583469 7240881 6913455 8098755 8492992 9345725 10070735 9413310 9675457 9477061 9608132 9871047 9741256 10531536 10532817 9939147 10331851 10660301 10530517 10861029 9744352 7900858 6648213 6188694 7241385 6782638 6782128 7373750 7439287 7439544 9674678 9083796 4615482 1069856 1266977 1266721 1530403 414495 414495 414495 414495 480545 414495 612131 612131 612131 414495 612131 744230 7052933 8301981 4887657 3968859 2918475 940071 413214 415521 482852 482596 482596 482596 540699 205838 205838 205838 205838 209170 277783 8870972 9530706 7819060 8804406 8804662 8212787 8146992 9856576 7426357 8409908 8214589 8081458 8016175 8544063 6898471 8871486 7887683 6439209 7097138 6111791 6438950 5849132 5785147 1383211 1646898 2041402 2239298 2241105 1713724 1450297 2174795 2371919 1517386 2306384 3688556 5271693 5007742 6259074 4874075 3232576 2772791 3563115 4155005 3434116 2318723 2712454 3500428 3435664 3828837 5075041 5797486 4483412 5667420 992278 136712 136712 136712 136712 5399384 5730408 6586479 1259551 208914 208914 206350 136712 136712 136712 5464685 4280707 4610188 4874134 4544919 5205168 5801667 5273764 3627137 3690613 4809098 5204627 4741253 4479118 5005721 6913709 7639489 7638197 7306405 7109029 7571128 6977697 8424366 9411009 9542081 9082302 8886205 9216710 8887493 8427713 8886723 8753344 8294859 8890337 8825311 7242675 6120587 6910867 8295586 6851208 7376021 8557239 8358838 8885665 8623028 6189731 8164486 6850700 346652 346652 347421 414495 414495 414495 414495 414495 414495 414495 414495 414495 414495 414495 6133366 2918475 2918475 2918475 2918475 2918731 1929273 346652 413470 482596 482596 482596 482596 1797174 735771 205838 205838 205838 205838 275732 8608572 9793363 7621683 8739128 8673589 8475445 8409395 9528382 7886393 8673079 7622707 8081455 7490602 8873029 6832678 8476727 7953734 6637616 7293744 5519396 6767658 5848876 5323564 2501432 1383212 2304572 2501697 3161691 1779258 2172992 2502732 2701141 2504022 4081505 5133420 5795210 4874621 5536388 4876880 2441773 3363650 3824212 3498360 2908550 2580868 3171719 4812688 5075603 4549747 4746589 4417620 3629891 3696962 6125667 136712 136712 136712 136712 7833729 4153930 6651758 139276 208914 206350 137481 136712 136712 1320990 6253967 3885694 4608906 5399713 5796272 5404588 5470630 5075610 3889281 3298681 4550800 5996699 5663374 6255008 7045041 6848171 7771332 7374258 5728146 5070994 5730468 5794710 5727636 6714277 6977706 6845607 6517668 7043754 7307700 8098236 7966907 7176630 6783685 7378910 8101849 8163257 7769489 2317627 346909 346909 346909 1462822 7111540 7176110 5861286 5464982 9150121 9544395 10463684 9876406 7313546 6656382 414495 414495 414495 414752 415521 482339 482339 482596 482339 5869171 5082728 2260288 2918475 2918475 2918731 2918731 2522691 742179 414239 482596 482596 482596 877610 2720839 2125627 602903 205838 205838 205838 207632 9200449 9004618 7819059 8476727 8542004 8343857 8804664 10055241 7820346 8146479 8280638 8278578 7622447 9004615 7359536 8739126 7887426 6505257 6570535 5849134 6504744 6375476 5521714 3685190 1580335 2962242 2896965 3621209 2831172 2896456 2897233 3161433 3555934 4672869 5001577 4675707 3890304 4155521 5471599 2375716 3297346 3298111 2644069 2514548 3433859 6587547 7176846 6584964 6520969 6389618 5141848 3040053 4487498 4814162 7046769 4084038 3688507 7044212 4680028 3103802 6256744 138251 206350 136712 136712 136712 136712 7176840 4809588 4414321 5008000 5335439 5402261 4613769 5335944 6323616 5994661 5409452 5938093 6125696 6122633 6319512 6913448 6518694 6058920 5531803 5072280 5073052 5664160 5467038 4085130 4675208 5532063 5465497 5136531 5399446 5794209 6189734 6058919 5336231 5733057 6327766 8429770 5012075 346909 346909 346909 346909 346908 345883 4287578 7373749 7439540 6713502 9544134 10531006 11056331 12044254 12372709 13292520 13490404 9941938 6393723 4750687 413214 481827 483109 483109 483109 483109 483109 483109 1338673 1798969 1930298 1534771 1995834 742692 415265 482596 482596 482596 1338674 2721095 2721095 2125627 603672 205838 205838 205838 9529414 9004361 8082229 9133886 8608054 8540977 9661258 9593663 7754296 8343858 8214588 8738873 7688499 8938564 7163187 8607541 8808268 6637360 7227950 5980205 5978403 5782825 4927775 3553084 2106933 3422020 3159365 3555157 3686481 2962505 2963025 3687517 3621725 3489113 4015459 3292768 3954301 4286598 5667974 3890237 3428160 3495234 2905428 6257793 5729132 465679 136712 136712 136712 136712 992279 5335641 7048055 5271903 4548179 5467998 8097417 8031878 4483670 3300927 6060393 136712 136712 136712 136712 136712 7571602 5338243 5468031 5797507 6062731 4943482 3757669 4150386 6388385 7310257 6917823 7252174 5607591 5139331 5137543 5268364 5598615 5401240 4349582 3690626 4940695 5270687 4939142 4150148 3887239 5333911 6519469 6453421 5663903 5137557 4742544 3953547 3361928 3428752 4484274 6918082 2909514 346909 346909 346909 346909 346396 345627 345370 1133863 8688310 8425146 8159662 8756645 2908206 414752 4225368 11845836 14080487 13687529 12832752 13357296 12766931 2054962 346652 414239 482596 483109 483109 483109 483109 483109 482596 415265 414495 414495 413983 415265 482596 482596 482596 2194495 2721096 2721096 2721096 2062141 344345 2310451 929307 9331261 9267533 7949873 9330492 8213552 8409133 9398086 9462852 8148797 8475443 8937795 8409908 7359535 8280634 6571051 8080684 7689016 6769459 7557172 6112047 6241060 5651495 4796447 3355443 2830140 3356741 2961473 3028814 3226447 2435906 2765389 3817819 3094869 2765647 3293538 3554908 4412020 4417932 3763078 4617560 3298109 3363394 5532000 992022 136712 136712 136712 136712 136712 136712 136712 136712 2243372 7309438 4416853 4219729 4877659 7308148 4483665 3562568 6584947 3030323 136712 136712 3032126 7572635 5533588 7178415 7505065 7833509 7178151 5927315 4808064 5663378 7046320 6914473 6919868 8238549 5605543 4022657 4024718 5213105 5278641 4746132 3427704 2704742 3495022 4086902 3821694 3230591 3755906 5334163 6256554 6256045 5663907 5137818 4546713 3954841 3758489 4021919 4943527 3697754 346909 346909 346909 346909 346396 345370 345370 345370 2710593 8029099 8225456 8886946 345114 346652 414752 414752 1071657 3633229 4224088 9021106 10598095 10597822 7181718 346652 346652 413214 415008 483109 483109 483109 483109 483108 482596 415009 414495 414495 415778 482596 482596 746024 2589510 2721096 2721096 2721096 1205806 3041859 5201284 5794716 9462591 8872258 8081459 9396801 8475957 8738098 9595466 8607799 8280638 8080684 8345914 8804152 8346687 8609600 6308139 8146992 7952701 7361083 7096108 6506290 5781795 5914925 5059360 5196616 2895417 3159362 2566971 2962505 2436674 1909302 2568266 2962766 2568269 2436939 3489888 3489626 3752802 3428988 3502987 4357750 6456682 4021576 137225 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 4677200 3760202 3892560 4023373 7439734 7308412 7176060 7111302 7110545 5860211 7243670 8628123 7177601 6257039 7703451 8623012 8096416 6912660 5859209 6188950 8296643 7837121 6716836 7577791 8437724 5279407 4023177 4684193 6598356 6138834 4621224 3038582 2511439 5339498 6587255 5598859 4414598 5269654 5138840 4086159 4349079 4874396 5400225 6190000 6914238 7375815 6916290 7837624 346909 346909 346909 346909 346139 345370 345370 345370 345370 7244692 7766443 8489394 4616795 345114 345627 414239 414752 414752 414495 347165 871709 5799275 5410523 6002116 346652 346652 346652 346652 413726 481827 483109 483109 483108 483108 482596 415521 481570 482596 482596 414752 874021 1463851 1596206 1728562 1200936 738846 7439996 7043712 5661580 9133884 8938050 8410423 8804665 8673850 8804147 9068865 8279091 8082490 8015151 8543293 8475187 8806980 8346687 7558716 8081456 7951930 7229754 7031087 6637875 5518881 6309940 4796446 5065030 1710881 2896190 1975349 2831430 2239296 1843252 2502473 2699594 2371405 2502734 3686751 3489883 2897489 2636131 3237514 3106433 6653570 1127965 137738 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 2570282 6980467 7704451 7440768 8227971 6910566 8425367 5730957 6188680 6717863 6787762 7574915 7505281 6912900 6452093 6977673 6980000 6129577 4876686 5073297 6390444 6259630 5861271 6722740 7189712 6202048 5339037 5470372 6067905 5413061 3967925 3175289 4555111 7841409 10401437 9084306 7767705 7506609 5408184 4287644 4547734 5334427 5991848 7965627 9083334 8558536 7179713 5275253 346909 346909 346908 345883 345370 345370 345370 345370 3302733 8430283 7902143 8295610 345114 345114 345114 413470 414752 414752 414752 413726 345370 2777421 5148114 3571140 5473673 346652 346652 346652 346652 346909 414752 482596 483108 483108 483108 345883 276501 346140 275219 206351 206351 206351 206351 206351 206351 206351 4873828 6716033 7372909 8804664 8083258 8871229 9463879 7950128 8869683 9727051 8345398 8082743 8014894 8477502 8212272 9792845 9004874 7492410 8080428 8675653 6769203 7426102 7559235 6045484 5980204 5125154 5590601 921363 2369846 1646126 2107710 2107967 1975354 2305351 2436166 2633548 2897489 3555161 3291476 2634318 2963031 3889796 3104130 3562361 7309703 1454111 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 5663078 7638413 8362131 8688782 8491384 7173993 9017768 7046046 5991821 7902374 8496302 7176818 6123888 5994610 4678751 5005936 6520740 6130610 4880026 4878737 4546691 4743559 5334407 5469855 7908043 6129060 5992341 7050426 8237513 7119544 5804212 5540530 6721695 7771548 5338981 209427 6914942 7178665 6724290 7056078 7448260 7314347 6787219 8362395 8820899 7372450 7110566 346909 346909 346396 345370 345370 345370 345370 345370 3171403 8168132 7120343 6457779 5402255 345114 345114 345114 346396 414752 414752 414752 413470 345370 1594161 5867456 4947900 8758722 346652 346652 346652 346652 346652 346652 347165 481314 483108 483108 3104334 138507 206351 206351 206351 206351 206351 206351 206351 205838 140045 139533 4873573 4673880 8936510 8609343 8542266 9135687 7885106 8804405 9595207 7885105 7753262 8212269 7951675 8344116 9069380 8938824 7032375 7949873 8609601 7559490 6965554 7098428 5781798 5716519 5191460 5721928 328967 1646122 1449004 1515316 2305089 2238524 2567748 2634057 3028560 3423575 3621468 2567496 2766163 2699598 3951469 4088970 3362927 4811395 7046277 2439726 136712 136712 136712 136712 136712 136712 136712 136712 2702647 7704227 6521239 5667462 7507341 9018767 8689307 8293005 9083054 5727851 136712 2176813 7767935 6781308 7510412 7180931 5466737 7110301 7176608 6387090 5860234 4742016 4940433 5664413 6453150 7243177 6256537 6389409 7643579 8367817 7840960 7904702 7445441 7313323 7969437 277014 275220 208402 6060920 4944785 6133679 8958127 7181194 5207909 5406051 5733741 5338987 6719355 346909 346396 345626 345370 345370 345370 345370 4158051 7510716 5936071 5674443 4553386 5538730 1724977 345114 345114 345114 413983 414752 414752 414752 346396 5734255 9348044 9086677 7180944 345627 346652 346652 346652 346652 346652 346652 346652 414239 1202979 2708803 206351 206351 206351 206351 206351 140045 139533 137738 136712 136712 136712 465162 2575396 8740158 8806465 9002817 8610117 7884849 8672562 10056530 8148276 7686956 8541233 8215359 7883822 8805436 9332812 6769202 7818800 8478271 8283214 6702895 6506289 5716518 6045740 5059618 5918278 65794 987676 1449001 1778229 2436675 2172732 2369855 2567493 2502729 2699853 3029332 2567497 3094874 3225687 3358297 4085374 3232634 3759225 5142158 6390669 4874329 1123609 136712 136712 136712 136712 2044715 6058873 7507620 6127261 5864605 5010838 8164747 8822953 6588572 7967141 5267034 136712 136712 136712 136712 5465185 9349802 8692897 6849157 7043984 6845329 5661570 5399684 5728916 6453416 6128302 6058645 6122895 6980516 6785701 5996686 6062491 6127780 6719657 7050164 6329003 6919563 277014 276245 208402 208402 5666670 6593923 9549447 7441749 5270840 4614968 5075022 5469537 6457713 345883 345370 345370 345370 345370 1133862 5011566 6521241 5336978 5076900 4749746 5673166 6854565 345627 345114 345114 345114 347678 414752 414752 414752 346652 10795461 9414092 9875412 2383167 345114 345370 346652 346908 346652 346652 346652 346652 346652 1393178 206351 206351 206094 140045 138763 137738 136712 136712 136712 136712 136712 136712 136712 1526311 9002815 7819315 8476472 9466197 7621164 8803377 9595977 7490861 7686954 8409390 8938565 7620908 8476726 8083773 7558975 7358507 8148021 8151112 6504745 7097913 5914155 6374445 5191977 5588797 65793 790293 1580074 1777713 2107711 1975864 1778488 1844541 1976127 1713215 2239818 3093839 3028822 2633806 2567752 3358819 3756671 3429753 4679812 5209734 4222036 5665895 6519162 6716811 6193044 6193817 4418959 4615824 4944273 6455965 7112861 6719389 7374466 6521246 6456995 6981273 136712 136712 136712 136712 136712 136712 6057841 8299691 6456704 5662576 5069685 4212842 4806781 6124192 6585266 6263746 5864349 6388374 6522786 6654104 7045003 7504794 7308966 6652067 5928083 5998769 4682853 277014 276501 208914 208402 208402 8956543 8823654 9478492 9213527 8819059 8425597 7966080 8362633 6194283 6325354 6193768 7573631 7835525 6323315 3629910 4812147 5797764 4483470 3499678 3371951 4027236 346139 345114 345114 345114 346652 414752 414752 414752 6259837 7579856 4354956 6129057 739617 345114 345114 346652 413983 413726 347165 346909 3565649 2314039 206094 139789 138507 137994 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 1593386 8477758 8609087 9463111 9597269 7621423 8869171 9924173 7293482 7752748 8343084 8872259 8081712 8937533 8150081 8084805 7161386 8279863 7690559 6702124 7754813 5651240 6835512 5520683 5390646 65793 197380 1580072 1448748 2042431 1844020 1712437 2041406 2041404 2174023 2502731 3291732 2897230 2502218 2370889 3028309 3621735 3229291 3625845 4286340 4155766 5206123 5071195 3822155 3364687 3629417 4155001 3629425 6126474 136712 136712 1254679 5927545 5338520 5733275 5137770 136712 136712 136712 136712 136712 136712 1649955 8431028 6391942 5005155 3951974 3884391 7309458 5736571 7835833 5933504 6061476 7112355 6586533 6389926 7241886 8030892 7965620 6848170 6784173 8496065 1328679 277014 277014 208914 208402 208402 5733230 7314065 6982254 7243112 8033159 7771785 8298114 10335380 10727309 9807227 9018743 8887164 8755311 7044422 4941354 5663809 4085570 2705993 1588292 3895184 346909 346396 345114 345114 345114 345370 414239 414752 414752 6192035 3312038 2785673 4423310 345114 345114 345114 345883 414752 414752 414752 4290654 9608372 4084816 137738 136969 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 136712 668952 2257981 7819572 8016437 8541752 9070412 8147510 8804150 10713945 7226919 8015919 8342827 8345660 7226150 9266758 6900274 8742734 7096106 8543293 7821889 6439467 6833966 5848360 6110504 4731168 5588538 855309 65793 1053468 1448744 1976123 1712689 2040888 1909560 1975869 2437452 3028815 2765387 2436934 2765136 2436939 3423320 3225943 3095645 3228263 3953530 4087679 5007482 4744823 3363667 3430464 3628629 3035720 5400669 136712 136712 136712 136712 136712 5340570 4155529 4676702 136712 136712 136712 136712 136712 136712 136712 7639455 7180187 5992572 4478833 4805753 6854023 1141038 2518340 7705501 7176358 7504548 6782113 6453920 7044515 7702960 6584227 6188182 6454702 7510716 277014 277014 277014 275732 208402 208402 208402 7117747 5145243 5276058 5932684 5340796 4552544 5342054 8365448 9417354 9154676 10796416 12306040 11119942 9079322 6450709 6386464 4547116 2969914 5800328 346908 345627 345114 345114 345114 345114 347421 414752 940072 4745626 3108533 2656956 2191492 3172176 345114 345114 345114 413983 414752 414752 414752 7769770 7110565 6780815 4938850 860437 136712 136712 136712 136712 136712 136712 136712 136712 205581 275476 347165 414495 7819829 7885107 8541494 9464141 7555887 8804409 9858893 7358251 7950125 8277804 9003588 7358508 9529674 7689787 8545097 7359278 8279092 8281927 6373674 6505001 5717289 6111017 5454633 5258028 1907996 65793 461068 1580331 2042171 1646896 2304829 1974834 1910334 2568006 2896973 2304579 2502470 2502478 2896720 3357013 3752026 3488855 3818082 4872313 5071490 5071231 4874366 3364717 3692637 4416612 6716789 136712 136712 136712 136712 136712 136712 6127510 4351366 6913421 136712 136712 136712 136712 136712 136712 136712 6255229 6981543 7439519 6584471 8624552 2457924 1601846 482596 482596 7574426 6518945 6255770 6057103 6254745 7046322 5138325 4017009 4086164 6265016 277014 277014 277014 276245 208402 208402 208402 7116460 5540280 4818352 4489113 3633512 4618323 4813649 208914 208914 208914 208145 140045 9351249 6917162 7244599 10531940 7242821 5862746 6522489 345883 345370 345370 345114 345114 345114 346652 414752 3369297 3228791 4811693 4950991 6065347 6722188 345114 345114 345114 347165 414752 414239 413470 5471350 6652310 6328253 7047579 6978668 3429448 208401 1125137 138251 139020 206607 208402 278040 414495 414495 414495 414495 8543552 8082484 8344886 8806981 7884336 9528391 9662030 7293482 8147761 8606770 8345917 7884338 9463874 8215874 8742219 6964006 8871484 8215620 6571311 7031346 5585445 5913382 5323046 4664861 2500133 65793 131586 1580072 2042168 1449515 2040884 1777456 2304833 2633800 3029074 2568267 2897229 3292248 3357269 3948889 3949662 4344418 5001833 5726072 6254471 5859459 4938360 3887732 4480639 7506077 136712 136712 136712 136712 136712 136712 2636338 6780045 5729680 6915234 2571319 136712 136712 136712 136712 136712 136712 6451064 7636900 8031915 7636126 8298657 2523460 2457924 614181 482596 482596 7706783 5860241 5069435 4214653 4677783 2835829 2108749 3163264 5740733 2907976 277014 277014 276758 208914 208402 208402 6786721 5277102 3504808 2520990 4817270 1655846 208914 208914 208914 207889 139276 3954749 5934172 6522986 8099964 10205342 9349513 9084817 8886684 6716293 5662587 6518407 6582923 5006949 345114 345370 414496 5928833 5462664 6254759 6519466 9017281 10334402 345114 345114 345114 346140 347678 346909 346909 346909 346909 5209446 8033165 5927043 1858102 346909 4090922 869659 345627 346139 346396 347165 414495 414495 414495 346396 8411708 7819311 9727309 7425586 8278836 9134660 10188890 7556912 8410675 8344112 9004617 6964009 9857860 8216132 8413253 7095850 8476985 8018754 6702898 8084805 6046253 5978918 5717292 4927261 3157806 65793 65793 395018 2107190 1647409 2041141 1580334 2304317 2963280 2897227 3818330 3291728 4411238 3949143 4409439 4475491 4935785 5462385 5923191 5528953 5134716 4675449 4346739 4807291 4938588 136712 136712 136712 136712 136712 136712 5925737 6253957 5533314 4944003 6914957 136712 136712 136712 136712 136712 136712 5004125 6319758 5924743 5529213 6591107 2523460 2523460 1272624 482596 482596 482596 6651269 3555683 3097720 2967937 2046053 2568527 4937362 5535908 5141870 277014 277014 277014 275219 208402 208402 5472651 2782879 1536156 4098214 1656107 208914 208914 208914 207120 137481 136712 7440253 8954017 7837082 6524565 6198412 7119481 10732956 6977611 2439489 992055 2309211 2839160 1722990 5073529 2316091 413470 6256279 7044262 7307433 5004162 5992613 7638970 3171402 345114 345883 346908 346909 346909 346909 346909 346652 1002269 6918554 6322827 346909 346909 2186532 2446625 345370 345370 345370 345370 346396 4152393 2579770 868894 8609602 7819313 10188632 7622708 8673337 9530190 9663061 7754291 8344626 8475442 9398602 7292973 9529157 8940370 7952960 7292973 7818284 7031860 6965812 7096881 5848619 5650210 5914412 4796705 3552564 65793 65793 65793 1514275 1910581 2106930 1646128 1909301 2436163 3555931 3883604 3949139 3619666 4015449 4409951 4673382 4475746 4804715 5332341 4146784 3422035 4213610 5202046 7174284 136712 136712 136712 136712 136712 136712 136712 8030358 5926539 5271424 5863808 6127217 401935 136712 136712 136712 136712 136712 4610136 6058386 5202306 4938616 4426082 2523460 2523460 1733432 482596 482596 482596 4615524 3100040 3822722 4149880 4017007 4084089 5271961 5928861 7706281 277014 277014 277014 275732 208402 208402 4948878 1404822 1994370 3826504 208914 208914 208914 206607 136969 136712 136712 6849908 6390147 4816782 2912903 2121576 3968648 7653024 5546583 2906390 933665 1332576 1598600 2451848 1391961 4089478 5997709 2705516 3559549 4215417 2769776 2112877 3099004 6191249 346139 346909 346909 346909 346909 346909 346396 345626 345370 4683108 4616800 346909 346908 805917 2776100 414496 413726 346396 345370 4346440 65793 65793 4147778 9469287 7621422 9859154 7425071 8673336 9201225 8215358 7557171 8475956 8343857 8609344 7555890 7686187 8150851 8085059 6964265 8937791 8085575 6374189 7557430 6375475 5584675 5651240 5059619 5393480 65793 65793 4278190081 723982 2041654 1777965 2040885 2106935 2172474 3554903 3555152 3883089 3487820 2896458 5331056 4542054 4015709 4147559 4477291 3687000 3357262 4146528 4542062 6647680 136712 136712 136712 136712 136712 136712 4806232 5595003 6057612 5927303 7046024 209171 139789 136712 136712 2176301 6979976 6519170 5400440 5006723 5731476 6389146 4164447 2523716 2523716 2523460 547620 346396 206350 2044716 6585763 5400982 6125470 5929375 4944284 4155282 5471399 6066363 2447942 277014 277014 276245 208402 208402 5145487 2913435 6195861 208914 208914 208914 206350 136712 136712 136712 4809553 1988641 2253406 1796757 1332342 538196 3112852 5616807 4167533 3241527 1988400 1462588 1462628 2054264 1325395 2051185 2181230 1060946 1979736 2440294 2310255 2967667 3629465 6257544 346909 346909 346909 346909 346909 346140 345370 345370 345370 2120248 346909 346652 345627 345114 346396 414752 414752 414496 413470 3299904 4081729 2303011 3490102 208402 8285784 9200450 7490863 8541493 9134918 7819830 7360308 8410422 9002044 8280895 7752754 8607030 7229493 8676426 7622193 8148277 8216906 6571826 7623479 6244147 5387297 5519395 4862241 4933443 65793 65793 4278190081 131587 1842984 1976374 2171439 2304570 2172471 2435394 3554387 3291212 2698304 2699332 4936302 4542056 3488593 4080993 4475492 4277852 4277854 4541541 4212582 5463913 136712 136712 136712 136712 136712 1649700 6582148 5791351 6778760 6188168 4614492 275732 208402 140302 136712 136712 4610650 6322060 4937836 5268089 6387086 7373723 4886376 2523717 2523717 2258494 538392 136712 136712 136712 8491685 6849452 6194607 5867700 3831718 4291750 5275270 3502172 481057 277014 277014 276758 208658 209427 5278376 4094625 4483682 208914 208914 206607 136712 136712 136712 136712 4485963 1069331 1137232 1203065 1129042 930123 2186364 2850205 5021872 4362640 3046009 1858373 2578782 3039363 2576499 2576247 2313070 1915738 2179175 2508402 3098737 5008283 6917300 2054966 346909 346909 346909 346908 346139 345370 345370 345370 345370 2054712 346396 345627 345114 345114 345114 414239 414752 414752 414495 347165 477981 5203779 4345661 208402 2245160 9863273 7818800 8278319 8674108 7555630 7754294 8212789 9594180 8346174 7161132 9792845 7097909 7886910 7424815 7227175 7361082 6704183 7886138 7296321 5453089 5519396 5059363 4999237 65793 65793 4278190081 4278190081 789777 1844533 1843755 2040884 1975092 3357005 6055278 3291726 2106422 3356491 4541538 4278888 3818330 4080732 4080221 4606560 5462128 5067890 4015971 6055799 136969 136712 136712 136712 136712 6714498 5201275 5858432 5858172 6253954 277014 276245 208402 208402 139789 136712 136712 5794671 6252674 6253443 6320525 6126757 7511196 2523717 2391105 733463 136712 137738 139789 208401 8032672 6850980 5735576 5604502 5278105 3438430 483108 483109 483109 413214 344088 276501 1522455 3894882 2585242 3175582 3037001 208658 206350 136712 136712 136712 136712 5077114 1070382 1401691 1662844 1460582 2179934 2246249 1918314 2252425 4290976 3568027 2712722 3306141 3570345 2910614 2513797 2381952 2449807 2251656 1588832 2242642 3559288 4879012 7047831 346909 346909 346909 346652 345883 345370 345370 345370 345370 2842440 4944496 3498064 2842185 345114 345114 345114 413726 414752 414752 414752 413983 345883 1199139 4016705 208658 208402 5333065 8544071 8935736 8542264 7752750 7754294 7752752 8672820 8873032 7753008 9595207 7953217 8479050 7227182 7950385 6703152 6440496 7227951 5980976 5321759 5585446 4533533 5722444 65793 65793 4278190081 4278190081 197379 1579814 1975857 1185315 1909555 5660260 136712 5397855 4474712 3882835 4212312 3818079 4146783 3818328 3290444 4344168 5133935 4937079 4082023 5859697 138251 136712 136712 1320735 6450815 4017000 4148073 4345714 3424868 5597552 277014 277014 209171 208402 208145 139789 136712 136712 8492718 6191258 4746128 3561341 6389654 2523717 1728049 1197603 1532464 415009 482596 413214 1855539 277014 277014 277014 277014 278040 345114 415009 483109 482596 413470 345883 2642720 5146506 1731474 1862546 4353648 138251 136712 136712 136712 136712 4944250 2913159 1661241 2386798 2382202 2772329 3232629 2974608 2182258 1981018 2377070 3103114 3235730 2907019 1919862 1720168 1588325 1326186 1659526 1658235 1258327 3432341 3698602 2051452 3302478 346909 346909 346396 345370 345370 345370 345370 345370 345370 6198182 1853540 2177113 5993105 345114 345114 345114 346652 414752 414752 414752 414239 345626 345370 4213828 208914 208402 208402 8024668 9199166 9200965 7818285 8148276 7818288 8804663 9728339 7949875 9199166 8808015 8347979 7425330 8213559 8611148 6769718 7294518 6704443 5387810 5388326 4994082 5589828 65793 65793 4278190081 4278190081 131586 526602 2041398 1316898 2369846 4479568 136712 136712 4148041 5857133 3817553 3553875 3751513 3423058 2632768 3686238 3687262 4016231 4410733 6714752 139276 136712 3885900 5793146 4016488 4674159 3423577 3423840 3291993 3956048 277014 277014 275220 208402 208402 207120 137481 136712 7439002 5206938 5078691 3696008 4416905 7379857 2523717 2523717 2523717 741154 277527 277014 277014 277014 277014 277014 277014 277014 277014 277014 346396 413214 346652 346652 1328154 5277077 1665675 1534606 5339261 531467 136712 136712 597523 5733000 4226464 2517622 2120242 2252889 2182495 2244444 2706028 2644873 1915999 1782353 2179692 2772092 2508920 1587041 993357 1190739 1388635 1454945 2048373 2838662 2971534 5211839 3765672 4022135 346909 346909 346396 345370 345370 345370 345370 345370 345370 6259864 4487852 3892614 3359329 5006468 345114 345114 345114 345114 414239 414752 414752 414752 346908 345370 3224882 275219 208402 208402 4544319 9133115 9200966 7621420 8345141 7818030 8673591 8478272 7555886 9332039 8149827 7295291 7293489 7884592 7228982 6439981 7096621 6967100 5650468 5190946 4862240 5852483 65793 65793 4278190081 4278190081 4278190081 4278190081 1119517 1777708 4541779 2655303 1528619 336398 136712 2504495 5659754 3882834 3751510 4212314 3882834 3554390 4015716 3357528 4278373 7371664 861462 6515827 4476259 4279400 4871024 4410732 3555161 3753060 5068402 2050865 277014 277014 275988 208402 208402 208402 205581 136712 6123130 5667490 6656432 5933999 5472166 7705256 3573333 2523717 1400365 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277014 277270 345883 346652 346652 3039301 5273715 2385764 5602694 6656670 4878201 2902086 4680048 5736869 3963045 3634574 2121295 1922594 1659181 1456706 1322314 2113635 2049907 1585235 1716306 1849186 1849186 1585243 1124175 1189967 1453144 1519710 1387869 2441336 4087967 4749750 6331336 3039620 4677732 346909 345883 345370 345370 345370 345370 345370 1528111 5861767 3362946 4417951 3763841 1123646 5140603 345370 345114 345114 345114 413470 414752 414752 414752 413726 1658923 3225139 275732 208402 208402 208402 10452577 8938307 7292457 8475957 7751466 9199935 8873286 8939084 9927264 8812387 9206378 8286042 9398090 8282184 7098426 7031086 6572597 5650725 5519140 5059361 5983556 65793 65793 4278190081 4278190081 4278190081 4278190081 131587 1909553 5861993 2655303 2655303 1334829 275988 136712 2635825 6119790 3685199 3949143 4673631 4541022 4278113 3488342 3882583 6317953 6976647 4279135 4015707 5265265 5923451 4673394 3555161 3686498 5199731 277014 277014 277014 276501 208658 208402 208402 276758 545056 5340530 5075356 5866665 5866920 7049387 6065539 808228 1332522 208402 274963 208658 208914 275476 209427 209427 208914 275732 275732 276501 276501 274450 1065241 543004 1396774 5143129 5730652 5928811 6917794 4946333 3436953 4291232 3437724 2781595 2453919 2649723 1726782 1857057 1920300 2113353 2111319 2770029 2442612 1651804 1517898 1781850 1847901 1782108 1716317 1847649 1453406 1518940 1453405 1585250 2638713 4944552 6460350 730948 4352864 345883 345370 345370 345370 345370 345370 4286049 4281972 1321042 1912415 4094371 3040116 2768471 3434323 345370 345114 345114 345114 346396 414752 414752 414752 413983 3168830 679975 276501 208402 208402 208402 10520172 8345914 7292970 8212528 8014893 9469285 6384725 1457184 208914 208914 208658 994327 9268565 8216647 7164733 7360307 6901559 6045740 5782825 4928290 5522488 65793 65793 65793 65793 65793 65793 65793 526603 5669225 2655303 2655303 1799481 482595 412957 206350 4741204 3882320 3751763 3686228 3685716 3422032 3291217 2830670 3686491 4476522 4211805 4212321 4476010 4870772 4148854 3226202 3028561 5594227 277014 277014 277014 277014 208914 208402 208402 935713 2589510 3574358 4559462 5806973 6134147 3698261 276501 208914 208914 208914 208914 206350 139533 205838 205838 205838 205838 205838 205838 205838 206094 929810 2315553 4222003 6718821 7439733 5334334 6979962 5470619 4552603 3699353 3765404 2584213 1928340 1863063 2846328 2580555 2776882 3036736 2969173 2901850 2902375 2969471 3433625 2052475 1452358 1385536 1649488 1913438 2045539 1913695 1782369 1651039 1518941 1650528 4220059 3432339 1520479 4878464 4680304 4810355 4742752 4808553 4808826 3164790 1058889 925503 925764 1847125 3961505 4284540 5795961 346909 346139 345114 345114 345114 345114 413983 414752 414752 2711099 4214597 480289 277014 209171 208402 208402 9667693 7753778 7227178 8080430 9137493 2771246 208914 208914 208914 207889 138251 4474937 7752491 7821889 6835255 6767656 7427130 5914154 5519396 4731168 5455923 65793 65793 65793 65793 65793 65793 65793 657931 4817246 2655303 2655303 2194239 614181 482595 482595 413983 4936032 3554127 3685972 3225679 2699081 3094095 2699596 3028821 4015970 4080736 3422549 3554652 3753838 3096937 3161692 3489627 5068139 3496520 277014 277014 277014 275476 208402 208402 671260 2588228 2918474 2918474 2918474 1728817 208914 208914 208914 208914 207889 138507 137225 205581 205838 205838 205838 205838 205838 205838 205838 205838 275219 4617302 6850167 6914433 9610144 8821902 6717303 6194584 3896215 6258317 4217437 5140861 5014176 2977946 3895932 4090974 3827528 3038009 2447149 2314299 2114125 2180459 3238299 2581392 1197166 1194590 1456478 1390941 1650512 2045529 1848410 1452620 1188937 1190229 2245754 1523316 1721981 1260388 3494768 4289888 4612202 4546679 3559804 3435928 1652815 926013 1188927 2306905 4353184 3954812 5207151 346909 346396 345114 345114 345114 345114 413470 414752 414752 3759942 4214597 413470 277014 275219 208402 208402 9011306 8477501 7424556 9069900 3099184 208914 208914 208914 208145 137738 136712 8680288 7883821 7557947 7163962 6372644 7492153 5979690 5979691 4599583 4797734 1710618 65793 65793 65793 65793 65793 65793 65793 4357974 2655303 2655303 2655303 1075245 482595 482595 482595 5727594 2698819 3620177 3357008 2962509 3160143 3357268 5397871 6125430 5929587 5665902 5529962 5862773 6783114 5991549 4015711 4476001 5926766 277014 277014 277014 276245 208402 208402 340757 2720583 2918474 2918474 1596462 208914 208914 208914 208914 207889 139020 136712 2112023 1060113 205838 205838 205838 205838 205838 205838 205838 4876885 6981497 6322549 5664872 5468519 8098423 6192756 3366739 5994625 4019022 136712 136712 136712 2111280 6062741 4289151 4418914 3301695 2381610 1922337 1723935 1259561 1191220 1525614 2780314 1201283 1661831 2519712 1331574 1392735 1853805 1719386 1058109 1057345 863313 2051712 1326700 994637 1192535 1453911 4420704 552234 552234 2193734 5084031 5931647 3626355 3430006 2373721 3891088 4216957 2908485 346396 345627 345114 345114 345114 345114 346396 414752 414752 4217929 4214597 413470 277014 275732 208402 208402 9011049 8806723 7556658 6054989 208914 208914 208914 207889 138251 136712 2240290 8479563 7818284 7755839 7163447 6109728 6965809 5584932 5848105 4994083 4402204 3157806 65793 65793 65793 65793 65793 65793 65793 5009240 2720839 2720839 2720839 1733431 482595 482595 482595 5534055 2829891 3027784 3093579 2764873 5331305 5332832 139789 138763 207376 207376 207376 482339 413983 6982278 6123137 4806255 5793652 277014 277014 277014 276245 208914 208402 538648 2060859 2193726 1861685 341013 208914 208914 208914 206607 137481 136712 136712 4218149 4085795 4943706 4878168 5469274 6258026 6389098 6323562 6258029 5008991 6059119 6912377 5204832 6454887 6652779 3234374 2842450 5668745 333833 136712 136712 136712 136712 136712 5537920 2316088 1923104 2186786 2318368 1790485 1062938 994605 1261152 2847138 1531790 1663887 2588077 1860490 1198698 1525862 1192005 993855 1059140 1390946 2843285 1324629 1320775 1786229 1524843 4808324 617514 617514 552234 552234 552234 3309141 5406584 2834779 4610686 5991558 346140 345370 345370 345370 345883 345114 345114 345370 413983 414752 4214854 4081986 413470 277014 276245 208402 208402 9731685 8872774 8482906 208914 208914 208914 207120 137738 136712 136712 6184528 7293485 7818283 7229751 7230010 6505258 6702122 6243118 5979689 5191206 4599582 3420978 65793 65793 65793 65793 65793 65793 65793 4676173 2720839 2720839 2720839 2194495 614181 482595 482595 5599847 3224646 2961990 3093578 5791596 136712 136712 136712 136712 136712 136712 136712 275989 346652 2325056 2918475 4361311 4949096 737565 277014 277014 277014 208914 208402 207889 275988 347165 277527 208914 208914 208914 206607 138251 136712 136712 136712 3296029 5861705 6652254 2971190 3825739 4746333 4680283 4943196 6059887 6454386 6783602 4019270 3163190 3294255 4878155 1526301 1462067 3427393 136712 136712 136712 136712 136712 136712 3296316 1923105 1463062 2055204 2253087 4750144 4489555 4087643 1457238 2185088 2190232 1928601 2715806 2516363 1131619 1062225 863302 994634 1587547 1655405 1392490 2246518 1981046 2778527 2772338 3492730 6590345 617514 617514 617514 552234 552234 552234 5932406 4542565 3096673 6583940 2189627 483364 484390 485672 414752 345114 345114 413214 1268010 2105632 3620153 413470 277014 277014 208914 865561 9729111 8345916 5923660 208914 208914 207376 138251 136712 136712 991508 8613981 7359280 7884847 7426615 7032889 5913637 6373673 5914152 6307882 5191205 4599584 5262150 65793 65793 65793 65793 65793 65793 65793 789516 4553815 2721095 2721095 2720839 943659 482595 482595 5469028 2830143 3028039 5528169 136712 136712 136712 136712 136712 136712 136712 136712 139020 1204012 2918475 2918475 2918475 2918475 1398571 277014 277014 277014 275219 208402 140302 136712 140045 209427 208914 208914 205838 136969 136712 136712 136712 3032111 6521172 2707756 7112814 7638128 5797734 6850422 5011805 5603171 6456171 4744783 139532 136712 136712 136712 3690810 1395985 3761719 1387035 136712 136712 136712 136712 136712 136712 136712 4025404 1791769 2384417 3042591 6132832 1536309 1467699 4946546 1459299 1990527 1660797 2054270 1394021 867161 1064796 996171 1124672 1060175 1127516 2707587 3233939 4481423 6918057 5598081 6257298 7112866 3767899 617514 617514 617514 552234 552234 552234 3898201 6517636 2897995 4414540 552234 552234 551721 485416 416290 346139 346652 3759942 65793 2434854 413470 277014 341268 1259029 8352861 8738612 9333840 3427892 208914 206607 137481 136712 136712 136712 7893603 6506289 7096366 7884077 8413510 6572082 5716516 7032374 6374960 5715745 5848877 4599582 3947321 65793 65793 65793 65793 65793 65793 65793 65793 4345414 2721095 2721095 2721095 1733431 482595 482595 5925224 2435386 5396838 136712 136712 136712 136712 136712 136712 136712 136712 137738 206863 2061115 2918475 2918475 2918475 2918475 2454848 604698 277014 277014 996885 273168 137994 136712 139020 208914 208914 140045 136712 136712 136712 136712 4612679 5799505 7442280 3364665 4088139 7310201 7178344 543516 346909 346909 275732 206350 137481 136712 136712 136712 2374441 2841646 2249763 2703151 136712 136712 136712 136712 136712 136712 136712 5141073 2252318 2582299 3895594 4623447 2326081 614438 482852 4423273 1856094 1199722 937066 936037 1068398 1001315 1061191 795703 795451 1717598 3560325 6451608 8950950 8360865 5728640 4678796 3560570 5401729 2849098 617514 617514 617514 617514 552234 552234 2914121 3950401 2500903 2650175 552234 551721 485416 485416 4218698 3889221 4214597 65793 65793 3759429
)
		offset: 0@0)! !
